#!/usr/bin/env python

#
# Generated by generateDS.py.
#

import sys
import getopt
from xml.dom import minidom
from xml.dom import Node

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

#def quote_xml(inStr):
#    s1 = inStr
#    s1 = s1.replace('&', '&amp;')
#    s1 = s1.replace('<', '&lt;')
#    s1 = s1.replace('"', '&quot;')
#    return s1

def quote_xml(inStr):
    s1 = inStr
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_attrib(inStr):
    #This code is taken from generateDS-1.12b.tar - official site 
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('"', '&quot;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1


#
# Data representation classes.
#

class resultType:
    subclass = None
    def __init__(self, status='', errcode=None, errtext=None):
        self.status = status
        self.errcode = errcode
        self.errtext = errtext
    def factory(*args_, **kwargs_):
        if resultType.subclass:
            return resultType.subclass(*args_, **kwargs_)
        else:
            return resultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getErrcode(self): return self.errcode
    def setErrcode(self, value): self.errcode = value
    def getErrtext(self): return self.errtext
    def setErrtext(self, value): self.errtext = value
    def export(self, outfile, level, name_='resultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='resultType'):
        pass
    def exportChildren(self, outfile, level, name_='resultType'):
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.errcode is not None:
            showIndent(outfile, level)
            outfile.write('<errcode>%s</errcode>\n' % quote_xml(self.getErrcode()))
        if self.errtext is not None:
            showIndent(outfile, level)
            outfile.write('<errtext>%s</errtext>\n' % quote_xml(self.getErrtext()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errcode':
            errcode_ = ''
            for text__content_ in child_.childNodes:
                errcode_ += text__content_.nodeValue
            self.errcode = errcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errtext':
            errtext_ = ''
            for text__content_ in child_.childNodes:
                errtext_ += text__content_.nodeValue
            self.errtext = errtext_
# end class resultType


class NoneType:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if NoneType.subclass:
            return NoneType.subclass(*args_, **kwargs_)
        else:
            return NoneType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='NoneType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='NoneType'):
        pass
    def exportChildren(self, outfile, level, name_='NoneType'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class NoneType


class resultFilterType(resultType):
    subclass = None
    def __init__(self, filter_id=None, id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.filter_id = filter_id
        self.id = id
    def factory(*args_, **kwargs_):
        if resultFilterType.subclass:
            return resultFilterType.subclass(*args_, **kwargs_)
        else:
            return resultFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter_id(self): return self.filter_id
    def setFilter_id(self, value): self.filter_id = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='resultFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='resultFilterType'):
        resultType.exportAttributes(self, outfile, level, name_='resultFilterType')
    def exportChildren(self, outfile, level, name_='resultFilterType'):
        if self.filter_id is not None:
            showIndent(outfile, level)
            outfile.write('<filter-id>%s</filter-id>\n' % quote_xml(self.getFilter_id()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter-id':
            filter_id_ = ''
            for text__content_ in child_.childNodes:
                filter_id_ += text__content_.nodeValue
            self.filter_id = filter_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class resultFilterType


class DesciptorOperatorInputType:
    subclass = None
    def __init__(self, get_domain_physical_hosting=None, get_client_permissions=None, get_domain_user_permissions=None, get_client_limits=None, get_domain_limits=None):
        if get_domain_physical_hosting is None:
            self.get_domain_physical_hosting = []
        else:
            self.get_domain_physical_hosting = get_domain_physical_hosting
        if get_client_permissions is None:
            self.get_client_permissions = []
        else:
            self.get_client_permissions = get_client_permissions
        if get_domain_user_permissions is None:
            self.get_domain_user_permissions = []
        else:
            self.get_domain_user_permissions = get_domain_user_permissions
        if get_client_limits is None:
            self.get_client_limits = []
        else:
            self.get_client_limits = get_client_limits
        if get_domain_limits is None:
            self.get_domain_limits = []
        else:
            self.get_domain_limits = get_domain_limits
    def factory(*args_, **kwargs_):
        if DesciptorOperatorInputType.subclass:
            return DesciptorOperatorInputType.subclass(*args_, **kwargs_)
        else:
            return DesciptorOperatorInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet_domain_physical_hosting(self): return self.get_domain_physical_hosting
    def setGet_domain_physical_hosting(self, value): self.get_domain_physical_hosting = value
    def addGet_domain_physical_hosting(self, value): self.get_domain_physical_hosting.append(value)
    def insertGet_domain_physical_hosting(self, index, value): self.get_domain_physical_hosting[index] = value
    def getGet_client_permissions(self): return self.get_client_permissions
    def setGet_client_permissions(self, value): self.get_client_permissions = value
    def addGet_client_permissions(self, value): self.get_client_permissions.append(value)
    def insertGet_client_permissions(self, index, value): self.get_client_permissions[index] = value
    def getGet_domain_user_permissions(self): return self.get_domain_user_permissions
    def setGet_domain_user_permissions(self, value): self.get_domain_user_permissions = value
    def addGet_domain_user_permissions(self, value): self.get_domain_user_permissions.append(value)
    def insertGet_domain_user_permissions(self, index, value): self.get_domain_user_permissions[index] = value
    def getGet_client_limits(self): return self.get_client_limits
    def setGet_client_limits(self, value): self.get_client_limits = value
    def addGet_client_limits(self, value): self.get_client_limits.append(value)
    def insertGet_client_limits(self, index, value): self.get_client_limits[index] = value
    def getGet_domain_limits(self): return self.get_domain_limits
    def setGet_domain_limits(self, value): self.get_domain_limits = value
    def addGet_domain_limits(self, value): self.get_domain_limits.append(value)
    def insertGet_domain_limits(self, index, value): self.get_domain_limits[index] = value
    def export(self, outfile, level, name_='DesciptorOperatorInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesciptorOperatorInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DesciptorOperatorInputType'):
        for get_domain_physical_hosting_ in self.getGet_domain_physical_hosting():
            get_domain_physical_hosting_.export(outfile, level)
        for get_client_permissions_ in self.getGet_client_permissions():
            get_client_permissions_.export(outfile, level)
        for get_domain_user_permissions_ in self.getGet_domain_user_permissions():
            get_domain_user_permissions_.export(outfile, level)
        for get_client_limits_ in self.getGet_client_limits():
            get_client_limits_.export(outfile, level)
        for get_domain_limits_ in self.getGet_domain_limits():
            get_domain_limits_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-domain-physical-hosting':
            obj_ = get_domain_physical_hosting.factory()
            obj_.build(child_)
            self.get_domain_physical_hosting.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-client-permissions':
            obj_ = get_client_permissions.factory()
            obj_.build(child_)
            self.get_client_permissions.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-domain-user-permissions':
            obj_ = get_domain_user_permissions.factory()
            obj_.build(child_)
            self.get_domain_user_permissions.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-client-limits':
            obj_ = get_client_limits.factory()
            obj_.build(child_)
            self.get_client_limits.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-domain-limits':
            obj_ = get_domain_limits.factory()
            obj_.build(child_)
            self.get_domain_limits.append(obj_)
# end class DesciptorOperatorInputType


class DesciptorOperatorOutputType:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DesciptorOperatorOutputType.subclass:
            return DesciptorOperatorOutputType.subclass(*args_, **kwargs_)
        else:
            return DesciptorOperatorOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='DesciptorOperatorOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesciptorOperatorOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DesciptorOperatorOutputType'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class DesciptorOperatorOutputType


class ExtensionType:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ExtensionType.subclass:
            return ExtensionType.subclass(*args_, **kwargs_)
        else:
            return ExtensionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='ExtensionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ExtensionType'):
        pass
    def exportChildren(self, outfile, level, name_='ExtensionType'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class ExtensionType


class ObjectDescriptor:
    subclass = None
    def __init__(self, property=None, bind=None):
        if property is None:
            self.property = []
        else:
            self.property = property
        if bind is None:
            self.bind = []
        else:
            self.bind = bind
    def factory(*args_, **kwargs_):
        if ObjectDescriptor.subclass:
            return ObjectDescriptor.subclass(*args_, **kwargs_)
        else:
            return ObjectDescriptor(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def getBind(self): return self.bind
    def setBind(self, value): self.bind = value
    def addBind(self, value): self.bind.append(value)
    def insertBind(self, index, value): self.bind[index] = value
    def export(self, outfile, level, name_='ObjectDescriptor'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ObjectDescriptor'):
        pass
    def exportChildren(self, outfile, level, name_='ObjectDescriptor'):
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
        for bind_ in self.getBind():
            bind_.export(outfile, level, name_='bind')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = PropertyDescriptor.factory()
            obj_.build(child_)
            self.property.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bind':
            obj_ = BindType.factory()
            obj_.build(child_)
            self.bind.append(obj_)
# end class ObjectDescriptor


class PropertyDescriptor:
    subclass = None
    def __init__(self, name='', ttype='', enum=None, default_value=None, writable_by=None, label=None, hint=None, extension=None):
        self.name = name
        self.ttype = ttype
        if enum is None:
            self.enum = []
        else:
            self.enum = enum
        self.default_value = default_value
        if writable_by is None:
            self.writable_by = []
        else:
            self.writable_by = writable_by
        self.label = label
        self.hint = hint
        self.extension = extension
    def factory(*args_, **kwargs_):
        if PropertyDescriptor.subclass:
            return PropertyDescriptor.subclass(*args_, **kwargs_)
        else:
            return PropertyDescriptor(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getEnum(self): return self.enum
    def setEnum(self, value): self.enum = value
    def addEnum(self, value): self.enum.append(value)
    def insertEnum(self, index, value): self.enum[index] = value
    def getDefault_value(self): return self.default_value
    def setDefault_value(self, value): self.default_value = value
    def getWritable_by(self): return self.writable_by
    def setWritable_by(self, value): self.writable_by = value
    def addWritable_by(self, value): self.writable_by.append(value)
    def insertWritable_by(self, index, value): self.writable_by[index] = value
    def getLabel(self): return self.label
    def setLabel(self, value): self.label = value
    def getHint(self): return self.hint
    def setHint(self, value): self.hint = value
    def getExtension(self): return self.extension
    def setExtension(self, value): self.extension = value
    def export(self, outfile, level, name_='PropertyDescriptor'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PropertyDescriptor'):
        pass
    def exportChildren(self, outfile, level, name_='PropertyDescriptor'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        for enum_ in self.getEnum():
            enum_.export(outfile, level, name_='enum')
        if self.default_value is not None:
            showIndent(outfile, level)
            outfile.write('<default-value>%s</default-value>\n' % quote_xml(self.getDefault_value()))
        for writable_by_ in self.getWritable_by():
            showIndent(outfile, level)
            outfile.write('<writable-by>%s</writable-by>\n' % quote_xml(writable_by_))
        if self.label is not None:
            showIndent(outfile, level)
            outfile.write('<label>%s</label>\n' % quote_xml(self.getLabel()))
        if self.hint is not None:
            showIndent(outfile, level)
            outfile.write('<hint>%s</hint>\n' % quote_xml(self.getHint()))
        if self.extension is not None:
            self.extension.export(outfile, level, name_='extension')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enum':
            obj_ = EnumElementType.factory()
            obj_.build(child_)
            self.enum.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'default-value':
            default_value_ = ''
            for text__content_ in child_.childNodes:
                default_value_ += text__content_.nodeValue
            self.default_value = default_value_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'writable-by':
            writable_by_ = ''
            for text__content_ in child_.childNodes:
                writable_by_ += text__content_.nodeValue
            self.addWritable_by(writable_by_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'label':
            label_ = ''
            for text__content_ in child_.childNodes:
                label_ += text__content_.nodeValue
            self.label = label_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hint':
            hint_ = ''
            for text__content_ in child_.childNodes:
                hint_ += text__content_.nodeValue
            self.hint = hint_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'extension':
            obj_ = ExtensionType.factory()
            obj_.build(child_)
            self.setExtension(obj_)
# end class PropertyDescriptor


class EnumElementType:
    subclass = None
    def __init__(self, value='', label=None, hint=None):
        self.value = value
        self.label = label
        self.hint = hint
    def factory(*args_, **kwargs_):
        if EnumElementType.subclass:
            return EnumElementType.subclass(*args_, **kwargs_)
        else:
            return EnumElementType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def getLabel(self): return self.label
    def setLabel(self, value): self.label = value
    def getHint(self): return self.hint
    def setHint(self, value): self.hint = value
    def export(self, outfile, level, name_='EnumElementType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='EnumElementType'):
        pass
    def exportChildren(self, outfile, level, name_='EnumElementType'):
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
        if self.label is not None:
            showIndent(outfile, level)
            outfile.write('<label>%s</label>\n' % quote_xml(self.getLabel()))
        if self.hint is not None:
            showIndent(outfile, level)
            outfile.write('<hint>%s</hint>\n' % quote_xml(self.getHint()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'label':
            label_ = ''
            for text__content_ in child_.childNodes:
                label_ += text__content_.nodeValue
            self.label = label_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hint':
            hint_ = ''
            for text__content_ in child_.childNodes:
                hint_ += text__content_.nodeValue
            self.hint = hint_
# end class EnumElementType


class BindType:
    subclass = None
    def __init__(self, ref='', relevant=None, read_only=0):
        self.ref = ref
        if relevant is None:
            self.relevant = []
        else:
            self.relevant = relevant
        self.read_only = read_only
    def factory(*args_, **kwargs_):
        if BindType.subclass:
            return BindType.subclass(*args_, **kwargs_)
        else:
            return BindType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getRef(self): return self.ref
    def setRef(self, value): self.ref = value
    def getRelevant(self): return self.relevant
    def setRelevant(self, value): self.relevant = value
    def addRelevant(self, value): self.relevant.append(value)
    def insertRelevant(self, index, value): self.relevant[index] = value
    def getRead_only(self): return self.read_only
    def setRead_only(self, value): self.read_only = value
    def export(self, outfile, level, name_='BindType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BindType'):
        pass
    def exportChildren(self, outfile, level, name_='BindType'):
        showIndent(outfile, level)
        outfile.write('<ref>%s</ref>\n' % quote_xml(self.getRef()))
        for relevant_ in self.getRelevant():
            relevant_.export(outfile, level, name_='relevant')
        showIndent(outfile, level)
        outfile.write('<read-only>%d</read-only>\n' % self.getRead_only())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ref':
            ref_ = ''
            for text__content_ in child_.childNodes:
                ref_ += text__content_.nodeValue
            self.ref = ref_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'relevant':
            obj_ = RelevantType.factory()
            obj_.build(child_)
            self.relevant.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'read-only':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.read_only = ival_
# end class BindType


class RelevantType:
    subclass = None
    def __init__(self, name='', value=None, read_only=None):
        self.name = name
        self.value = value
        self.read_only = read_only
    def factory(*args_, **kwargs_):
        if RelevantType.subclass:
            return RelevantType.subclass(*args_, **kwargs_)
        else:
            return RelevantType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def getRead_only(self): return self.read_only
    def setRead_only(self, value): self.read_only = value
    def export(self, outfile, level, name_='RelevantType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='RelevantType'):
        pass
    def exportChildren(self, outfile, level, name_='RelevantType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.value is not None:
            showIndent(outfile, level)
            outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
        if self.read_only is not None:
            showIndent(outfile, level)
            outfile.write('<read-only>%d</read-only>\n' % self.getRead_only())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'read-only':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.read_only = ival_
# end class RelevantType


class PropertyValueType:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if PropertyValueType.subclass:
            return PropertyValueType.subclass(*args_, **kwargs_)
        else:
            return PropertyValueType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='PropertyValueType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PropertyValueType'):
        pass
    def exportChildren(self, outfile, level, name_='PropertyValueType'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class PropertyValueType


class buttonDataType:
    subclass = None
    def __init__(self, code='', ttype='', name='', name_id='', group_name='', group_name_id='', href='', js_onclick=None, enabled='', new_window=None, tabindex=None, conhelp_id=None, conhelp=None, icon_url=None):
        self.code = code
        self.ttype = ttype
        self.name = name
        self.name_id = name_id
        self.group_name = group_name
        self.group_name_id = group_name_id
        self.href = href
        self.js_onclick = js_onclick
        self.enabled = enabled
        self.new_window = new_window
        self.tabindex = tabindex
        self.conhelp_id = conhelp_id
        self.conhelp = conhelp
        self.icon_url = icon_url
    def factory(*args_, **kwargs_):
        if buttonDataType.subclass:
            return buttonDataType.subclass(*args_, **kwargs_)
        else:
            return buttonDataType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCode(self): return self.code
    def setCode(self, value): self.code = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getName_id(self): return self.name_id
    def setName_id(self, value): self.name_id = value
    def getGroup_name(self): return self.group_name
    def setGroup_name(self, value): self.group_name = value
    def getGroup_name_id(self): return self.group_name_id
    def setGroup_name_id(self, value): self.group_name_id = value
    def getHref(self): return self.href
    def setHref(self, value): self.href = value
    def getJs_onclick(self): return self.js_onclick
    def setJs_onclick(self, value): self.js_onclick = value
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getNew_window(self): return self.new_window
    def setNew_window(self, value): self.new_window = value
    def getTabindex(self): return self.tabindex
    def setTabindex(self, value): self.tabindex = value
    def getConhelp_id(self): return self.conhelp_id
    def setConhelp_id(self, value): self.conhelp_id = value
    def getConhelp(self): return self.conhelp
    def setConhelp(self, value): self.conhelp = value
    def getIcon_url(self): return self.icon_url
    def setIcon_url(self, value): self.icon_url = value
    def export(self, outfile, level, name_='buttonDataType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='buttonDataType'):
        pass
    def exportChildren(self, outfile, level, name_='buttonDataType'):
        showIndent(outfile, level)
        outfile.write('<code>%s</code>\n' % quote_xml(self.getCode()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<name_id>%s</name_id>\n' % quote_xml(self.getName_id()))
        showIndent(outfile, level)
        outfile.write('<group_name>%s</group_name>\n' % quote_xml(self.getGroup_name()))
        showIndent(outfile, level)
        outfile.write('<group_name_id>%s</group_name_id>\n' % quote_xml(self.getGroup_name_id()))
        showIndent(outfile, level)
        outfile.write('<href>%s</href>\n' % quote_xml(self.getHref()))
        if self.js_onclick is not None:
            showIndent(outfile, level)
            outfile.write('<js_onclick>%s</js_onclick>\n' % quote_xml(self.getJs_onclick()))
        showIndent(outfile, level)
        outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        if self.new_window is not None:
            showIndent(outfile, level)
            outfile.write('<new_window>%s</new_window>\n' % quote_xml(self.getNew_window()))
        if self.tabindex is not None:
            showIndent(outfile, level)
            outfile.write('<tabindex>%s</tabindex>\n' % quote_xml(self.getTabindex()))
        if self.conhelp_id is not None:
            showIndent(outfile, level)
            outfile.write('<conhelp_id>%s</conhelp_id>\n' % quote_xml(self.getConhelp_id()))
        if self.conhelp is not None:
            showIndent(outfile, level)
            outfile.write('<conhelp>%s</conhelp>\n' % quote_xml(self.getConhelp()))
        if self.icon_url is not None:
            showIndent(outfile, level)
            outfile.write('<icon_url>%s</icon_url>\n' % quote_xml(self.getIcon_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'code':
            code_ = ''
            for text__content_ in child_.childNodes:
                code_ += text__content_.nodeValue
            self.code = code_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name_id':
            name_id_ = ''
            for text__content_ in child_.childNodes:
                name_id_ += text__content_.nodeValue
            self.name_id = name_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'group_name':
            group_name_ = ''
            for text__content_ in child_.childNodes:
                group_name_ += text__content_.nodeValue
            self.group_name = group_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'group_name_id':
            group_name_id_ = ''
            for text__content_ in child_.childNodes:
                group_name_id_ += text__content_.nodeValue
            self.group_name_id = group_name_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'href':
            href_ = ''
            for text__content_ in child_.childNodes:
                href_ += text__content_.nodeValue
            self.href = href_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'js_onclick':
            js_onclick_ = ''
            for text__content_ in child_.childNodes:
                js_onclick_ += text__content_.nodeValue
            self.js_onclick = js_onclick_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'new_window':
            new_window_ = ''
            for text__content_ in child_.childNodes:
                new_window_ += text__content_.nodeValue
            self.new_window = new_window_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'tabindex':
            tabindex_ = ''
            for text__content_ in child_.childNodes:
                tabindex_ += text__content_.nodeValue
            self.tabindex = tabindex_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'conhelp_id':
            conhelp_id_ = ''
            for text__content_ in child_.childNodes:
                conhelp_id_ += text__content_.nodeValue
            self.conhelp_id = conhelp_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'conhelp':
            conhelp_ = ''
            for text__content_ in child_.childNodes:
                conhelp_ += text__content_.nodeValue
            self.conhelp = conhelp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'icon_url':
            icon_url_ = ''
            for text__content_ in child_.childNodes:
                icon_url_ += text__content_.nodeValue
            self.icon_url = icon_url_
# end class buttonDataType


class PleskLimitType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if PleskLimitType.subclass:
            return PleskLimitType.subclass(*args_, **kwargs_)
        else:
            return PleskLimitType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='PleskLimitType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PleskLimitType'):
        pass
    def exportChildren(self, outfile, level, name_='PleskLimitType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class PleskLimitType


class PleskPermissionType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if PleskPermissionType.subclass:
            return PleskPermissionType.subclass(*args_, **kwargs_)
        else:
            return PleskPermissionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='PleskPermissionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PleskPermissionType'):
        pass
    def exportChildren(self, outfile, level, name_='PleskPermissionType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class PleskPermissionType


class domainDatasetType:
    subclass = None
    def __init__(self, gen_info=None, hosting=None, limits=None, stat=None, prefs=None, user=None, disk_usage=None, performance=None):
        self.gen_info = gen_info
        self.hosting = hosting
        self.limits = limits
        self.stat = stat
        self.prefs = prefs
        self.user = user
        self.disk_usage = disk_usage
        self.performance = performance
    def factory(*args_, **kwargs_):
        if domainDatasetType.subclass:
            return domainDatasetType.subclass(*args_, **kwargs_)
        else:
            return domainDatasetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getHosting(self): return self.hosting
    def setHosting(self, value): self.hosting = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getPrefs(self): return self.prefs
    def setPrefs(self, value): self.prefs = value
    def getUser(self): return self.user
    def setUser(self, value): self.user = value
    def getDisk_usage(self): return self.disk_usage
    def setDisk_usage(self, value): self.disk_usage = value
    def getPerformance(self): return self.performance
    def setPerformance(self, value): self.performance = value
    def export(self, outfile, level, name_='domainDatasetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainDatasetType'):
        pass
    def exportChildren(self, outfile, level, name_='domainDatasetType'):
        if self.gen_info is not None:
            self.gen_info.export(outfile, level, name_='gen_info')
        if self.hosting is not None:
            self.hosting.export(outfile, level, name_='hosting')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.stat is not None:
            self.stat.export(outfile, level, name_='stat')
        if self.prefs is not None:
            self.prefs.export(outfile, level, name_='prefs')
        if self.user is not None:
            self.user.export(outfile, level, name_='user')
        if self.disk_usage is not None:
            self.disk_usage.export(outfile, level, name_='disk_usage')
        if self.performance is not None:
            showIndent(outfile, level)
            outfile.write('<performance>%s</performance>\n' % quote_xml(self.getPerformance()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen_info':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setGen_info(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hosting':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setHosting(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setStat(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefs':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setPrefs(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'user':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setUser(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disk_usage':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDisk_usage(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'performance':
            performance_ = ''
            for text__content_ in child_.childNodes:
                performance_ += text__content_.nodeValue
            self.performance = performance_
# end class domainDatasetType


class setGenSetupType:
    subclass = None
    def __init__(self, status=None, name=None, owner_id=None, owner_login=None, ip_address=None, guid=None):
        self.status = status
        self.name = name
        self.owner_id = owner_id
        self.owner_login = owner_login
        self.ip_address = ip_address
        self.guid = guid
    def factory(*args_, **kwargs_):
        if setGenSetupType.subclass:
            return setGenSetupType.subclass(*args_, **kwargs_)
        else:
            return setGenSetupType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def export(self, outfile, level, name_='setGenSetupType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='setGenSetupType'):
        pass
    def exportChildren(self, outfile, level, name_='setGenSetupType'):
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
        if self.ip_address is not None:
            showIndent(outfile, level)
            outfile.write('<ip_address>%s</ip_address>\n' % quote_xml(self.getIp_address()))
        if self.guid is not None:
            self.guid.export(outfile, level, name_='guid')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip_address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setGuid(obj_)
# end class setGenSetupType


class domainGenInfoType:
    subclass = None
    def __init__(self, cr_date='', name='', ascii_name='', status='', real_size='', owner_id=None, owner_login=None, dns_ip_address=None, htype='', guid=''):
        self.cr_date = cr_date
        self.name = name
        self.ascii_name = ascii_name
        self.status = status
        self.real_size = real_size
        self.owner_id = owner_id
        self.owner_login = owner_login
        self.dns_ip_address = dns_ip_address
        self.htype = htype
        self.guid = guid
    def factory(*args_, **kwargs_):
        if domainGenInfoType.subclass:
            return domainGenInfoType.subclass(*args_, **kwargs_)
        else:
            return domainGenInfoType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCr_date(self): return self.cr_date
    def setCr_date(self, value): self.cr_date = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getAscii_name(self): return self.ascii_name
    def setAscii_name(self, value): self.ascii_name = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getReal_size(self): return self.real_size
    def setReal_size(self, value): self.real_size = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def getDns_ip_address(self): return self.dns_ip_address
    def setDns_ip_address(self, value): self.dns_ip_address = value
    def getHtype(self): return self.htype
    def setHtype(self, value): self.htype = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def export(self, outfile, level, name_='domainGenInfoType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainGenInfoType'):
        pass
    def exportChildren(self, outfile, level, name_='domainGenInfoType'):
        showIndent(outfile, level)
        outfile.write('<cr_date>%s</cr_date>\n' % quote_xml(self.getCr_date()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<ascii-name>%s</ascii-name>\n' % quote_xml(self.getAscii_name()))
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        showIndent(outfile, level)
        outfile.write('<real_size>%s</real_size>\n' % quote_xml(self.getReal_size()))
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
        if self.dns_ip_address is not None:
            showIndent(outfile, level)
            outfile.write('<dns_ip_address>%s</dns_ip_address>\n' % quote_xml(self.getDns_ip_address()))
        showIndent(outfile, level)
        outfile.write('<htype>%s</htype>\n' % quote_xml(self.getHtype()))
        showIndent(outfile, level)
        outfile.write('<guid>%s</guid>\n' % quote_xml(self.getGuid()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cr_date':
            cr_date_ = ''
            for text__content_ in child_.childNodes:
                cr_date_ += text__content_.nodeValue
            self.cr_date = cr_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ascii-name':
            ascii_name_ = ''
            for text__content_ in child_.childNodes:
                ascii_name_ += text__content_.nodeValue
            self.ascii_name = ascii_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'real_size':
            real_size_ = ''
            for text__content_ in child_.childNodes:
                real_size_ += text__content_.nodeValue
            self.real_size = real_size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dns_ip_address':
            dns_ip_address_ = ''
            for text__content_ in child_.childNodes:
                dns_ip_address_ += text__content_.nodeValue
            self.dns_ip_address = dns_ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'htype':
            htype_ = ''
            for text__content_ in child_.childNodes:
                htype_ += text__content_.nodeValue
            self.htype = htype_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            guid_ = ''
            for text__content_ in child_.childNodes:
                guid_ += text__content_.nodeValue
            self.guid = guid_
# end class domainGenInfoType


class domainUserGet:
    subclass = None
    def __init__(self, enabled=None, cname=None, pname=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, multiply_login=None, perms=None):
        self.enabled = enabled
        self.cname = cname
        self.pname = pname
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.multiply_login = multiply_login
        self.perms = perms
    def factory(*args_, **kwargs_):
        if domainUserGet.subclass:
            return domainUserGet.subclass(*args_, **kwargs_)
        else:
            return domainUserGet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getMultiply_login(self): return self.multiply_login
    def setMultiply_login(self, value): self.multiply_login = value
    def getPerms(self): return self.perms
    def setPerms(self, value): self.perms = value
    def export(self, outfile, level, name_='domainUserGet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainUserGet'):
        pass
    def exportChildren(self, outfile, level, name_='domainUserGet'):
        if self.enabled is not None:
            showIndent(outfile, level)
            outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        if self.pname is not None:
            showIndent(outfile, level)
            outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.multiply_login is not None:
            showIndent(outfile, level)
            outfile.write('<multiply_login>%s</multiply_login>\n' % quote_xml(self.getMultiply_login()))
        if self.perms is not None:
            self.perms.export(outfile, level, name_='perms')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'multiply_login':
            multiply_login_ = ''
            for text__content_ in child_.childNodes:
                multiply_login_ += text__content_.nodeValue
            self.multiply_login = multiply_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'perms':
            obj_ = domainPerms.factory()
            obj_.build(child_)
            self.setPerms(obj_)
# end class domainUserGet


class domainUserSet:
    subclass = None
    def __init__(self, enabled=None, password=None, cname=None, pname=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, multiply_login=None, perms=None):
        self.enabled = enabled
        self.password = password
        self.cname = cname
        self.pname = pname
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.multiply_login = multiply_login
        self.perms = perms
    def factory(*args_, **kwargs_):
        if domainUserSet.subclass:
            return domainUserSet.subclass(*args_, **kwargs_)
        else:
            return domainUserSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getMultiply_login(self): return self.multiply_login
    def setMultiply_login(self, value): self.multiply_login = value
    def getPerms(self): return self.perms
    def setPerms(self, value): self.perms = value
    def export(self, outfile, level, name_='domainUserSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainUserSet'):
        pass
    def exportChildren(self, outfile, level, name_='domainUserSet'):
        if self.enabled is not None:
            showIndent(outfile, level)
            outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        if self.pname is not None:
            showIndent(outfile, level)
            outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.multiply_login is not None:
            showIndent(outfile, level)
            outfile.write('<multiply_login>%s</multiply_login>\n' % quote_xml(self.getMultiply_login()))
        if self.perms is not None:
            self.perms.export(outfile, level, name_='perms')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'multiply_login':
            multiply_login_ = ''
            for text__content_ in child_.childNodes:
                multiply_login_ += text__content_.nodeValue
            self.multiply_login = multiply_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'perms':
            obj_ = domainPerms.factory()
            obj_.build(child_)
            self.setPerms(obj_)
# end class domainUserSet


class domainPrefs:
    subclass = None
    def __init__(self, www=None, stat_ttl=None):
        self.www = www
        self.stat_ttl = stat_ttl
    def factory(*args_, **kwargs_):
        if domainPrefs.subclass:
            return domainPrefs.subclass(*args_, **kwargs_)
        else:
            return domainPrefs(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getWww(self): return self.www
    def setWww(self, value): self.www = value
    def getStat_ttl(self): return self.stat_ttl
    def setStat_ttl(self, value): self.stat_ttl = value
    def export(self, outfile, level, name_='domainPrefs'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainPrefs'):
        pass
    def exportChildren(self, outfile, level, name_='domainPrefs'):
        if self.www is not None:
            showIndent(outfile, level)
            outfile.write('<www>%s</www>\n' % quote_xml(self.getWww()))
        if self.stat_ttl is not None:
            showIndent(outfile, level)
            outfile.write('<stat_ttl>%s</stat_ttl>\n' % quote_xml(self.getStat_ttl()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'www':
            www_ = ''
            for text__content_ in child_.childNodes:
                www_ += text__content_.nodeValue
            self.www = www_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat_ttl':
            stat_ttl_ = ''
            for text__content_ in child_.childNodes:
                stat_ttl_ += text__content_.nodeValue
            self.stat_ttl = stat_ttl_
# end class domainPrefs


class domainLimits:
    subclass = None
    def __init__(self, overuse=None, limit=None):
        self.overuse = overuse
        if limit is None:
            self.limit = []
        else:
            self.limit = limit
    def factory(*args_, **kwargs_):
        if domainLimits.subclass:
            return domainLimits.subclass(*args_, **kwargs_)
        else:
            return domainLimits(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getOveruse(self): return self.overuse
    def setOveruse(self, value): self.overuse = value
    def getLimit(self): return self.limit
    def setLimit(self, value): self.limit = value
    def addLimit(self, value): self.limit.append(value)
    def insertLimit(self, index, value): self.limit[index] = value
    def export(self, outfile, level, name_='domainLimits'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainLimits'):
        pass
    def exportChildren(self, outfile, level, name_='domainLimits'):
        if self.overuse is not None:
            showIndent(outfile, level)
            outfile.write('<overuse>%s</overuse>\n' % quote_xml(self.getOveruse()))
        for limit_ in self.getLimit():
            limit_.export(outfile, level, name_='limit')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'overuse':
            overuse_ = ''
            for text__content_ in child_.childNodes:
                overuse_ += text__content_.nodeValue
            self.overuse = overuse_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limit':
            obj_ = PleskLimitType.factory()
            obj_.build(child_)
            self.limit.append(obj_)
# end class domainLimits


class domainPhHostingSet:
    subclass = None
    def __init__(self, property=None, ip_address=''):
        if property is None:
            self.property = []
        else:
            self.property = property
        self.ip_address = ip_address
    def factory(*args_, **kwargs_):
        if domainPhHostingSet.subclass:
            return domainPhHostingSet.subclass(*args_, **kwargs_)
        else:
            return domainPhHostingSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def export(self, outfile, level, name_='domainPhHostingSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainPhHostingSet'):
        pass
    def exportChildren(self, outfile, level, name_='domainPhHostingSet'):
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
        showIndent(outfile, level)
        outfile.write('<ip_address>%s</ip_address>\n' % quote_xml(self.getIp_address()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = PleskPhysHOstingPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip_address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
# end class domainPhHostingSet


class domainPhHostingGet:
    subclass = None
    def __init__(self, property=None):
        if property is None:
            self.property = []
        else:
            self.property = property
    def factory(*args_, **kwargs_):
        if domainPhHostingGet.subclass:
            return domainPhHostingGet.subclass(*args_, **kwargs_)
        else:
            return domainPhHostingGet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def export(self, outfile, level, name_='domainPhHostingGet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainPhHostingGet'):
        pass
    def exportChildren(self, outfile, level, name_='domainPhHostingGet'):
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = PleskPhysHOstingPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
# end class domainPhHostingGet


class domainFFHostingBase:
    subclass = None
    def __init__(self, dest_url=''):
        self.dest_url = dest_url
    def factory(*args_, **kwargs_):
        if domainFFHostingBase.subclass:
            return domainFFHostingBase.subclass(*args_, **kwargs_)
        else:
            return domainFFHostingBase(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDest_url(self): return self.dest_url
    def setDest_url(self, value): self.dest_url = value
    def export(self, outfile, level, name_='domainFFHostingBase'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainFFHostingBase'):
        pass
    def exportChildren(self, outfile, level, name_='domainFFHostingBase'):
        showIndent(outfile, level)
        outfile.write('<dest_url>%s</dest_url>\n' % quote_xml(self.getDest_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dest_url':
            dest_url_ = ''
            for text__content_ in child_.childNodes:
                dest_url_ += text__content_.nodeValue
            self.dest_url = dest_url_
# end class domainFFHostingBase


class domainSFHostingBase:
    subclass = None
    def __init__(self, dest_url=''):
        self.dest_url = dest_url
    def factory(*args_, **kwargs_):
        if domainSFHostingBase.subclass:
            return domainSFHostingBase.subclass(*args_, **kwargs_)
        else:
            return domainSFHostingBase(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDest_url(self): return self.dest_url
    def setDest_url(self, value): self.dest_url = value
    def export(self, outfile, level, name_='domainSFHostingBase'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainSFHostingBase'):
        pass
    def exportChildren(self, outfile, level, name_='domainSFHostingBase'):
        showIndent(outfile, level)
        outfile.write('<dest_url>%s</dest_url>\n' % quote_xml(self.getDest_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dest_url':
            dest_url_ = ''
            for text__content_ in child_.childNodes:
                dest_url_ += text__content_.nodeValue
            self.dest_url = dest_url_
# end class domainSFHostingBase


class domainBTPhHosting:
    subclass = None
    def __init__(self, ftp_login='', ftp_password='', fp_admin_login=None, fp_admin_password=None, shell=None):
        self.ftp_login = ftp_login
        self.ftp_password = ftp_password
        self.fp_admin_login = fp_admin_login
        self.fp_admin_password = fp_admin_password
        self.shell = shell
    def factory(*args_, **kwargs_):
        if domainBTPhHosting.subclass:
            return domainBTPhHosting.subclass(*args_, **kwargs_)
        else:
            return domainBTPhHosting(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFtp_login(self): return self.ftp_login
    def setFtp_login(self, value): self.ftp_login = value
    def getFtp_password(self): return self.ftp_password
    def setFtp_password(self, value): self.ftp_password = value
    def getFp_admin_login(self): return self.fp_admin_login
    def setFp_admin_login(self, value): self.fp_admin_login = value
    def getFp_admin_password(self): return self.fp_admin_password
    def setFp_admin_password(self, value): self.fp_admin_password = value
    def getShell(self): return self.shell
    def setShell(self, value): self.shell = value
    def export(self, outfile, level, name_='domainBTPhHosting'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainBTPhHosting'):
        pass
    def exportChildren(self, outfile, level, name_='domainBTPhHosting'):
        showIndent(outfile, level)
        outfile.write('<ftp_login>%s</ftp_login>\n' % quote_xml(self.getFtp_login()))
        showIndent(outfile, level)
        outfile.write('<ftp_password>%s</ftp_password>\n' % quote_xml(self.getFtp_password()))
        if self.fp_admin_login is not None:
            showIndent(outfile, level)
            outfile.write('<fp_admin_login>%s</fp_admin_login>\n' % quote_xml(self.getFp_admin_login()))
        if self.fp_admin_password is not None:
            showIndent(outfile, level)
            outfile.write('<fp_admin_password>%s</fp_admin_password>\n' % quote_xml(self.getFp_admin_password()))
        if self.shell is not None:
            showIndent(outfile, level)
            outfile.write('<shell>%s</shell>\n' % quote_xml(self.getShell()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_login':
            ftp_login_ = ''
            for text__content_ in child_.childNodes:
                ftp_login_ += text__content_.nodeValue
            self.ftp_login = ftp_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_password':
            ftp_password_ = ''
            for text__content_ in child_.childNodes:
                ftp_password_ += text__content_.nodeValue
            self.ftp_password = ftp_password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fp_admin_login':
            fp_admin_login_ = ''
            for text__content_ in child_.childNodes:
                fp_admin_login_ += text__content_.nodeValue
            self.fp_admin_login = fp_admin_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fp_admin_password':
            fp_admin_password_ = ''
            for text__content_ in child_.childNodes:
                fp_admin_password_ += text__content_.nodeValue
            self.fp_admin_password = fp_admin_password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shell':
            shell_ = ''
            for text__content_ in child_.childNodes:
                shell_ += text__content_.nodeValue
            self.shell = shell_
# end class domainBTPhHosting


class domainBTHostingOp:
    subclass = None
    def __init__(self, vrt_hst=None, std_fwd=None, frm_fwd=None):
        self.vrt_hst = vrt_hst
        self.std_fwd = std_fwd
        self.frm_fwd = frm_fwd
    def factory(*args_, **kwargs_):
        if domainBTHostingOp.subclass:
            return domainBTHostingOp.subclass(*args_, **kwargs_)
        else:
            return domainBTHostingOp(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getStd_fwd(self): return self.std_fwd
    def setStd_fwd(self, value): self.std_fwd = value
    def getFrm_fwd(self): return self.frm_fwd
    def setFrm_fwd(self, value): self.frm_fwd = value
    def export(self, outfile, level, name_='domainBTHostingOp'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainBTHostingOp'):
        pass
    def exportChildren(self, outfile, level, name_='domainBTHostingOp'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level)
        if self.std_fwd is not None:
            self.std_fwd.export(outfile, level)
        if self.frm_fwd is not None:
            self.frm_fwd.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = vrt_hst.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'std_fwd':
            obj_ = std_fwd.factory()
            obj_.build(child_)
            self.setStd_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'frm_fwd':
            obj_ = frm_fwd.factory()
            obj_.build(child_)
            self.setFrm_fwd(obj_)
# end class domainBTHostingOp


class domainHostingAgentGet:
    subclass = None
    def __init__(self, vrt_hst=None, std_fwd=None, frm_fwd=None, none=None):
        self.vrt_hst = vrt_hst
        self.std_fwd = std_fwd
        self.frm_fwd = frm_fwd
        self.none = none
    def factory(*args_, **kwargs_):
        if domainHostingAgentGet.subclass:
            return domainHostingAgentGet.subclass(*args_, **kwargs_)
        else:
            return domainHostingAgentGet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getStd_fwd(self): return self.std_fwd
    def setStd_fwd(self, value): self.std_fwd = value
    def getFrm_fwd(self): return self.frm_fwd
    def setFrm_fwd(self, value): self.frm_fwd = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='domainHostingAgentGet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainHostingAgentGet'):
        pass
    def exportChildren(self, outfile, level, name_='domainHostingAgentGet'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level)
        if self.std_fwd is not None:
            self.std_fwd.export(outfile, level)
        if self.frm_fwd is not None:
            self.frm_fwd.export(outfile, level)
        if self.none is not None:
            showIndent(outfile, level)
            outfile.write('<none>%s</none>\n' % quote_xml(self.getNone()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = vrt_hst.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'std_fwd':
            obj_ = std_fwd.factory()
            obj_.build(child_)
            self.setStd_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'frm_fwd':
            obj_ = frm_fwd.factory()
            obj_.build(child_)
            self.setFrm_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            none_ = ''
            for text__content_ in child_.childNodes:
                none_ += text__content_.nodeValue
            self.none = none_
# end class domainHostingAgentGet


class domainHostingAgentSet:
    subclass = None
    def __init__(self, vrt_hst=None, std_fwd=None, frm_fwd=None, none=None):
        self.vrt_hst = vrt_hst
        self.std_fwd = std_fwd
        self.frm_fwd = frm_fwd
        self.none = none
    def factory(*args_, **kwargs_):
        if domainHostingAgentSet.subclass:
            return domainHostingAgentSet.subclass(*args_, **kwargs_)
        else:
            return domainHostingAgentSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getStd_fwd(self): return self.std_fwd
    def setStd_fwd(self, value): self.std_fwd = value
    def getFrm_fwd(self): return self.frm_fwd
    def setFrm_fwd(self, value): self.frm_fwd = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='domainHostingAgentSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainHostingAgentSet'):
        pass
    def exportChildren(self, outfile, level, name_='domainHostingAgentSet'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level)
        if self.std_fwd is not None:
            self.std_fwd.export(outfile, level)
        if self.frm_fwd is not None:
            self.frm_fwd.export(outfile, level)
        if self.none is not None:
            showIndent(outfile, level)
            outfile.write('<none>%s</none>\n' % quote_xml(self.getNone()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = vrt_hst.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'std_fwd':
            obj_ = std_fwd.factory()
            obj_.build(child_)
            self.setStd_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'frm_fwd':
            obj_ = frm_fwd.factory()
            obj_.build(child_)
            self.setFrm_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            none_ = ''
            for text__content_ in child_.childNodes:
                none_ += text__content_.nodeValue
            self.none = none_
# end class domainHostingAgentSet


class domainHostingOpSet:
    subclass = None
    def __init__(self, vrt_hst=None, std_fwd=None, frm_fwd=None, none=None):
        self.vrt_hst = vrt_hst
        self.std_fwd = std_fwd
        self.frm_fwd = frm_fwd
        self.none = none
    def factory(*args_, **kwargs_):
        if domainHostingOpSet.subclass:
            return domainHostingOpSet.subclass(*args_, **kwargs_)
        else:
            return domainHostingOpSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getStd_fwd(self): return self.std_fwd
    def setStd_fwd(self, value): self.std_fwd = value
    def getFrm_fwd(self): return self.frm_fwd
    def setFrm_fwd(self, value): self.frm_fwd = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='domainHostingOpSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainHostingOpSet'):
        pass
    def exportChildren(self, outfile, level, name_='domainHostingOpSet'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level)
        if self.std_fwd is not None:
            self.std_fwd.export(outfile, level)
        if self.frm_fwd is not None:
            self.frm_fwd.export(outfile, level)
        if self.none is not None:
            showIndent(outfile, level)
            outfile.write('<none>%s</none>\n' % quote_xml(self.getNone()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = vrt_hst.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'std_fwd':
            obj_ = std_fwd.factory()
            obj_.build(child_)
            self.setStd_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'frm_fwd':
            obj_ = frm_fwd.factory()
            obj_.build(child_)
            self.setFrm_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            none_ = ''
            for text__content_ in child_.childNodes:
                none_ += text__content_.nodeValue
            self.none = none_
# end class domainHostingOpSet


class domainHostingOpGet:
    subclass = None
    def __init__(self, vrt_hst=None, std_fwd=None, frm_fwd=None, none=None):
        self.vrt_hst = vrt_hst
        self.std_fwd = std_fwd
        self.frm_fwd = frm_fwd
        self.none = none
    def factory(*args_, **kwargs_):
        if domainHostingOpGet.subclass:
            return domainHostingOpGet.subclass(*args_, **kwargs_)
        else:
            return domainHostingOpGet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getStd_fwd(self): return self.std_fwd
    def setStd_fwd(self, value): self.std_fwd = value
    def getFrm_fwd(self): return self.frm_fwd
    def setFrm_fwd(self, value): self.frm_fwd = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='domainHostingOpGet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainHostingOpGet'):
        pass
    def exportChildren(self, outfile, level, name_='domainHostingOpGet'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level, name_='vrt_hst')
        if self.std_fwd is not None:
            self.std_fwd.export(outfile, level)
        if self.frm_fwd is not None:
            self.frm_fwd.export(outfile, level)
        if self.none is not None:
            showIndent(outfile, level)
            outfile.write('<none>%s</none>\n' % quote_xml(self.getNone()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = domainPhHostingGet.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'std_fwd':
            obj_ = std_fwd.factory()
            obj_.build(child_)
            self.setStd_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'frm_fwd':
            obj_ = frm_fwd.factory()
            obj_.build(child_)
            self.setFrm_fwd(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            none_ = ''
            for text__content_ in child_.childNodes:
                none_ += text__content_.nodeValue
            self.none = none_
# end class domainHostingOpGet


class domainStat:
    subclass = None
    def __init__(self, traffic='', subdom='', wu='', box='', redir='', mg='', resp='', maillists='', db='', webapps='', traffic_prevday=''):
        self.traffic = traffic
        self.subdom = subdom
        self.wu = wu
        self.box = box
        self.redir = redir
        self.mg = mg
        self.resp = resp
        self.maillists = maillists
        self.db = db
        self.webapps = webapps
        self.traffic_prevday = traffic_prevday
    def factory(*args_, **kwargs_):
        if domainStat.subclass:
            return domainStat.subclass(*args_, **kwargs_)
        else:
            return domainStat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTraffic(self): return self.traffic
    def setTraffic(self, value): self.traffic = value
    def getSubdom(self): return self.subdom
    def setSubdom(self, value): self.subdom = value
    def getWu(self): return self.wu
    def setWu(self, value): self.wu = value
    def getBox(self): return self.box
    def setBox(self, value): self.box = value
    def getRedir(self): return self.redir
    def setRedir(self, value): self.redir = value
    def getMg(self): return self.mg
    def setMg(self, value): self.mg = value
    def getResp(self): return self.resp
    def setResp(self, value): self.resp = value
    def getMaillists(self): return self.maillists
    def setMaillists(self, value): self.maillists = value
    def getDb(self): return self.db
    def setDb(self, value): self.db = value
    def getWebapps(self): return self.webapps
    def setWebapps(self, value): self.webapps = value
    def getTraffic_prevday(self): return self.traffic_prevday
    def setTraffic_prevday(self, value): self.traffic_prevday = value
    def export(self, outfile, level, name_='domainStat'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainStat'):
        pass
    def exportChildren(self, outfile, level, name_='domainStat'):
        showIndent(outfile, level)
        outfile.write('<traffic>%s</traffic>\n' % quote_xml(self.getTraffic()))
        showIndent(outfile, level)
        outfile.write('<subdom>%s</subdom>\n' % quote_xml(self.getSubdom()))
        showIndent(outfile, level)
        outfile.write('<wu>%s</wu>\n' % quote_xml(self.getWu()))
        showIndent(outfile, level)
        outfile.write('<box>%s</box>\n' % quote_xml(self.getBox()))
        showIndent(outfile, level)
        outfile.write('<redir>%s</redir>\n' % quote_xml(self.getRedir()))
        showIndent(outfile, level)
        outfile.write('<mg>%s</mg>\n' % quote_xml(self.getMg()))
        showIndent(outfile, level)
        outfile.write('<resp>%s</resp>\n' % quote_xml(self.getResp()))
        showIndent(outfile, level)
        outfile.write('<maillists>%s</maillists>\n' % quote_xml(self.getMaillists()))
        showIndent(outfile, level)
        outfile.write('<db>%s</db>\n' % quote_xml(self.getDb()))
        showIndent(outfile, level)
        outfile.write('<webapps>%s</webapps>\n' % quote_xml(self.getWebapps()))
        showIndent(outfile, level)
        outfile.write('<traffic_prevday>%s</traffic_prevday>\n' % quote_xml(self.getTraffic_prevday()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic':
            traffic_ = ''
            for text__content_ in child_.childNodes:
                traffic_ += text__content_.nodeValue
            self.traffic = traffic_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdom':
            subdom_ = ''
            for text__content_ in child_.childNodes:
                subdom_ += text__content_.nodeValue
            self.subdom = subdom_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'wu':
            wu_ = ''
            for text__content_ in child_.childNodes:
                wu_ += text__content_.nodeValue
            self.wu = wu_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'box':
            box_ = ''
            for text__content_ in child_.childNodes:
                box_ += text__content_.nodeValue
            self.box = box_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'redir':
            redir_ = ''
            for text__content_ in child_.childNodes:
                redir_ += text__content_.nodeValue
            self.redir = redir_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mg':
            mg_ = ''
            for text__content_ in child_.childNodes:
                mg_ += text__content_.nodeValue
            self.mg = mg_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'resp':
            resp_ = ''
            for text__content_ in child_.childNodes:
                resp_ += text__content_.nodeValue
            self.resp = resp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maillists':
            maillists_ = ''
            for text__content_ in child_.childNodes:
                maillists_ += text__content_.nodeValue
            self.maillists = maillists_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'db':
            db_ = ''
            for text__content_ in child_.childNodes:
                db_ += text__content_.nodeValue
            self.db = db_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webapps':
            webapps_ = ''
            for text__content_ in child_.childNodes:
                webapps_ += text__content_.nodeValue
            self.webapps = webapps_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic_prevday':
            traffic_prevday_ = ''
            for text__content_ in child_.childNodes:
                traffic_prevday_ += text__content_.nodeValue
            self.traffic_prevday = traffic_prevday_
# end class domainStat


class domainPerms:
    subclass = None
    def __init__(self, permission=None):
        if permission is None:
            self.permission = []
        else:
            self.permission = permission
    def factory(*args_, **kwargs_):
        if domainPerms.subclass:
            return domainPerms.subclass(*args_, **kwargs_)
        else:
            return domainPerms(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPermission(self): return self.permission
    def setPermission(self, value): self.permission = value
    def addPermission(self, value): self.permission.append(value)
    def insertPermission(self, index, value): self.permission[index] = value
    def export(self, outfile, level, name_='domainPerms'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='domainPerms'):
        pass
    def exportChildren(self, outfile, level, name_='domainPerms'):
        for permission_ in self.getPermission():
            permission_.export(outfile, level, name_='permission')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permission':
            obj_ = PleskPermissionType.factory()
            obj_.build(child_)
            self.permission.append(obj_)
# end class domainPerms


class trafficType:
    subclass = None
    def __init__(self, date='', http_in='', http_out='', ftp_in='', ftp_out='', smtp_in='', smtp_out='', pop3_imap_in='', pop3_imap_out=''):
        self.date = date
        self.http_in = http_in
        self.http_out = http_out
        self.ftp_in = ftp_in
        self.ftp_out = ftp_out
        self.smtp_in = smtp_in
        self.smtp_out = smtp_out
        self.pop3_imap_in = pop3_imap_in
        self.pop3_imap_out = pop3_imap_out
    def factory(*args_, **kwargs_):
        if trafficType.subclass:
            return trafficType.subclass(*args_, **kwargs_)
        else:
            return trafficType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDate(self): return self.date
    def setDate(self, value): self.date = value
    def getHttp_in(self): return self.http_in
    def setHttp_in(self, value): self.http_in = value
    def getHttp_out(self): return self.http_out
    def setHttp_out(self, value): self.http_out = value
    def getFtp_in(self): return self.ftp_in
    def setFtp_in(self, value): self.ftp_in = value
    def getFtp_out(self): return self.ftp_out
    def setFtp_out(self, value): self.ftp_out = value
    def getSmtp_in(self): return self.smtp_in
    def setSmtp_in(self, value): self.smtp_in = value
    def getSmtp_out(self): return self.smtp_out
    def setSmtp_out(self, value): self.smtp_out = value
    def getPop3_imap_in(self): return self.pop3_imap_in
    def setPop3_imap_in(self, value): self.pop3_imap_in = value
    def getPop3_imap_out(self): return self.pop3_imap_out
    def setPop3_imap_out(self, value): self.pop3_imap_out = value
    def export(self, outfile, level, name_='trafficType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='trafficType'):
        pass
    def exportChildren(self, outfile, level, name_='trafficType'):
        showIndent(outfile, level)
        outfile.write('<date>%s</date>\n' % quote_xml(self.getDate()))
        showIndent(outfile, level)
        outfile.write('<http_in>%s</http_in>\n' % quote_xml(self.getHttp_in()))
        showIndent(outfile, level)
        outfile.write('<http_out>%s</http_out>\n' % quote_xml(self.getHttp_out()))
        showIndent(outfile, level)
        outfile.write('<ftp_in>%s</ftp_in>\n' % quote_xml(self.getFtp_in()))
        showIndent(outfile, level)
        outfile.write('<ftp_out>%s</ftp_out>\n' % quote_xml(self.getFtp_out()))
        showIndent(outfile, level)
        outfile.write('<smtp_in>%s</smtp_in>\n' % quote_xml(self.getSmtp_in()))
        showIndent(outfile, level)
        outfile.write('<smtp_out>%s</smtp_out>\n' % quote_xml(self.getSmtp_out()))
        showIndent(outfile, level)
        outfile.write('<pop3_imap_in>%s</pop3_imap_in>\n' % quote_xml(self.getPop3_imap_in()))
        showIndent(outfile, level)
        outfile.write('<pop3_imap_out>%s</pop3_imap_out>\n' % quote_xml(self.getPop3_imap_out()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'date':
            date_ = ''
            for text__content_ in child_.childNodes:
                date_ += text__content_.nodeValue
            self.date = date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http_in':
            http_in_ = ''
            for text__content_ in child_.childNodes:
                http_in_ += text__content_.nodeValue
            self.http_in = http_in_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http_out':
            http_out_ = ''
            for text__content_ in child_.childNodes:
                http_out_ += text__content_.nodeValue
            self.http_out = http_out_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_in':
            ftp_in_ = ''
            for text__content_ in child_.childNodes:
                ftp_in_ += text__content_.nodeValue
            self.ftp_in = ftp_in_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_out':
            ftp_out_ = ''
            for text__content_ in child_.childNodes:
                ftp_out_ += text__content_.nodeValue
            self.ftp_out = ftp_out_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'smtp_in':
            smtp_in_ = ''
            for text__content_ in child_.childNodes:
                smtp_in_ += text__content_.nodeValue
            self.smtp_in = smtp_in_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'smtp_out':
            smtp_out_ = ''
            for text__content_ in child_.childNodes:
                smtp_out_ += text__content_.nodeValue
            self.smtp_out = smtp_out_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pop3_imap_in':
            pop3_imap_in_ = ''
            for text__content_ in child_.childNodes:
                pop3_imap_in_ += text__content_.nodeValue
            self.pop3_imap_in = pop3_imap_in_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pop3_imap_out':
            pop3_imap_out_ = ''
            for text__content_ in child_.childNodes:
                pop3_imap_out_ += text__content_.nodeValue
            self.pop3_imap_out = pop3_imap_out_
# end class trafficType


class webStat2:
    subclass = None
    def __init__(self, awstats=None, webalizer=None, protected=None, none=None):
        self.awstats = awstats
        self.webalizer = webalizer
        self.protected = protected
        self.none = none
    def factory(*args_, **kwargs_):
        if webStat2.subclass:
            return webStat2.subclass(*args_, **kwargs_)
        else:
            return webStat2(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAwstats(self): return self.awstats
    def setAwstats(self, value): self.awstats = value
    def getWebalizer(self): return self.webalizer
    def setWebalizer(self, value): self.webalizer = value
    def getProtected(self): return self.protected
    def setProtected(self, value): self.protected = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='webStat2'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='webStat2'):
        pass
    def exportChildren(self, outfile, level, name_='webStat2'):
        if self.awstats is not None:
            showIndent(outfile, level)
            outfile.write('<awstats>%s</awstats>\n' % quote_xml(self.getAwstats()))
        if self.webalizer is not None:
            showIndent(outfile, level)
            outfile.write('<webalizer>%s</webalizer>\n' % quote_xml(self.getWebalizer()))
        if self.protected is not None:
            showIndent(outfile, level)
            outfile.write('<protected>%d</protected>\n' % self.getProtected())
        if self.none is not None:
            showIndent(outfile, level)
            outfile.write('<none>%s</none>\n' % quote_xml(self.getNone()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'awstats':
            awstats_ = ''
            for text__content_ in child_.childNodes:
                awstats_ += text__content_.nodeValue
            self.awstats = awstats_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webalizer':
            webalizer_ = ''
            for text__content_ in child_.childNodes:
                webalizer_ += text__content_.nodeValue
            self.webalizer = webalizer_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'protected':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.protected = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            none_ = ''
            for text__content_ in child_.childNodes:
                none_ += text__content_.nodeValue
            self.none = none_
# end class webStat2


class DomainPerformanceType:
    subclass = None
    def __init__(self, bandwidth=None, max_connections=None):
        self.bandwidth = bandwidth
        self.max_connections = max_connections
    def factory(*args_, **kwargs_):
        if DomainPerformanceType.subclass:
            return DomainPerformanceType.subclass(*args_, **kwargs_)
        else:
            return DomainPerformanceType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getBandwidth(self): return self.bandwidth
    def setBandwidth(self, value): self.bandwidth = value
    def getMax_connections(self): return self.max_connections
    def setMax_connections(self, value): self.max_connections = value
    def export(self, outfile, level, name_='DomainPerformanceType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainPerformanceType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainPerformanceType'):
        if self.bandwidth is not None:
            showIndent(outfile, level)
            outfile.write('<bandwidth>%s</bandwidth>\n' % quote_xml(self.getBandwidth()))
        if self.max_connections is not None:
            showIndent(outfile, level)
            outfile.write('<max_connections>%s</max_connections>\n' % quote_xml(self.getMax_connections()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'bandwidth':
            bandwidth_ = ''
            for text__content_ in child_.childNodes:
                bandwidth_ += text__content_.nodeValue
            self.bandwidth = bandwidth_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'max_connections':
            max_connections_ = ''
            for text__content_ in child_.childNodes:
                max_connections_ += text__content_.nodeValue
            self.max_connections = max_connections_
# end class DomainPerformanceType


class PleskPhysHOstingPropertyType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if PleskPhysHOstingPropertyType.subclass:
            return PleskPhysHOstingPropertyType.subclass(*args_, **kwargs_)
        else:
            return PleskPhysHOstingPropertyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='PleskPhysHOstingPropertyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PleskPhysHOstingPropertyType'):
        pass
    def exportChildren(self, outfile, level, name_='PleskPhysHOstingPropertyType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class PleskPhysHOstingPropertyType


class certResultType(resultType):
    subclass = None
    def __init__(self, name='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.name = name
    def factory(*args_, **kwargs_):
        if certResultType.subclass:
            return certResultType.subclass(*args_, **kwargs_)
        else:
            return certResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='certResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='certResultType'):
        resultType.exportAttributes(self, outfile, level, name_='certResultType')
    def exportChildren(self, outfile, level, name_='certResultType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        resultType.buildChildren(self, child_, nodeName_)
# end class certResultType


class CertificateResponseType:
    subclass = None
    def __init__(self, install=None, remove=None, generate=None):
        if install is None:
            self.install = []
        else:
            self.install = install
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
        if generate is None:
            self.generate = []
        else:
            self.generate = generate
    def factory(*args_, **kwargs_):
        if CertificateResponseType.subclass:
            return CertificateResponseType.subclass(*args_, **kwargs_)
        else:
            return CertificateResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getInstall(self): return self.install
    def setInstall(self, value): self.install = value
    def addInstall(self, value): self.install.append(value)
    def insertInstall(self, index, value): self.install[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def getGenerate(self): return self.generate
    def setGenerate(self, value): self.generate = value
    def addGenerate(self, value): self.generate.append(value)
    def insertGenerate(self, index, value): self.generate[index] = value
    def export(self, outfile, level, name_='CertificateResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CertificateResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='CertificateResponseType'):
        for install_ in self.getInstall():
            install_.export(outfile, level)
        for remove_ in self.getRemove():
            remove_.export(outfile, level)
        for generate_ in self.getGenerate():
            generate_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install':
            obj_ = install.factory()
            obj_.build(child_)
            self.install.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = remove.factory()
            obj_.build(child_)
            self.remove.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'generate':
            obj_ = generate.factory()
            obj_.build(child_)
            self.generate.append(obj_)
# end class CertificateResponseType


class clientDatasetType:
    subclass = None
    def __init__(self, gen_info=None, stat=None, permissions=None, limits=None, ippool=None):
        self.gen_info = gen_info
        self.stat = stat
        self.permissions = permissions
        self.limits = limits
        self.ippool = ippool
    def factory(*args_, **kwargs_):
        if clientDatasetType.subclass:
            return clientDatasetType.subclass(*args_, **kwargs_)
        else:
            return clientDatasetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getIppool(self): return self.ippool
    def setIppool(self, value): self.ippool = value
    def export(self, outfile, level, name_='clientDatasetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientDatasetType'):
        pass
    def exportChildren(self, outfile, level, name_='clientDatasetType'):
        if self.gen_info is not None:
            showIndent(outfile, level)
            outfile.write('<gen_info>%s</gen_info>\n' % quote_xml(self.getGen_info()))
        if self.stat is not None:
            showIndent(outfile, level)
            outfile.write('<stat>%s</stat>\n' % quote_xml(self.getStat()))
        if self.permissions is not None:
            showIndent(outfile, level)
            outfile.write('<permissions>%s</permissions>\n' % quote_xml(self.getPermissions()))
        if self.limits is not None:
            self.limits.export(outfile, level)
        if self.ippool is not None:
            showIndent(outfile, level)
            outfile.write('<ippool>%s</ippool>\n' % quote_xml(self.getIppool()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen_info':
            gen_info_ = ''
            for text__content_ in child_.childNodes:
                gen_info_ += text__content_.nodeValue
            self.gen_info = gen_info_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            stat_ = ''
            for text__content_ in child_.childNodes:
                stat_ += text__content_.nodeValue
            self.stat = stat_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            permissions_ = ''
            for text__content_ in child_.childNodes:
                permissions_ += text__content_.nodeValue
            self.permissions = permissions_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = limits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool':
            ippool_ = ''
            for text__content_ in child_.childNodes:
                ippool_ += text__content_.nodeValue
            self.ippool = ippool_
# end class clientDatasetType


class clientData:
    subclass = None
    def __init__(self, gen_info=None, stat=None, permissions=None, limits=None, ippool=None, sbnet_user=None):
        self.gen_info = gen_info
        self.stat = stat
        self.permissions = permissions
        self.limits = limits
        self.ippool = ippool
        self.sbnet_user = sbnet_user
    def factory(*args_, **kwargs_):
        if clientData.subclass:
            return clientData.subclass(*args_, **kwargs_)
        else:
            return clientData(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getIppool(self): return self.ippool
    def setIppool(self, value): self.ippool = value
    def getSbnet_user(self): return self.sbnet_user
    def setSbnet_user(self, value): self.sbnet_user = value
    def export(self, outfile, level, name_='clientData'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientData'):
        pass
    def exportChildren(self, outfile, level, name_='clientData'):
        if self.gen_info is not None:
            self.gen_info.export(outfile, level, name_='gen_info')
        if self.stat is not None:
            self.stat.export(outfile, level, name_='stat')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.ippool is not None:
            self.ippool.export(outfile, level, name_='ippool')
        if self.sbnet_user is not None:
            showIndent(outfile, level)
            outfile.write('<sbnet-user>%s</sbnet-user>\n' % quote_xml(self.getSbnet_user()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen_info':
            obj_ = clientGetGenInfo.factory()
            obj_.build(child_)
            self.setGen_info(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            obj_ = clientStatType.factory()
            obj_.build(child_)
            self.setStat(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = clientLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool':
            obj_ = ipPoolType.factory()
            obj_.build(child_)
            self.setIppool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sbnet-user':
            sbnet_user_ = ''
            for text__content_ in child_.childNodes:
                sbnet_user_ += text__content_.nodeValue
            self.sbnet_user = sbnet_user_
# end class clientData


class clientPerms:
    subclass = None
    def __init__(self, permission=None):
        if permission is None:
            self.permission = []
        else:
            self.permission = permission
    def factory(*args_, **kwargs_):
        if clientPerms.subclass:
            return clientPerms.subclass(*args_, **kwargs_)
        else:
            return clientPerms(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPermission(self): return self.permission
    def setPermission(self, value): self.permission = value
    def addPermission(self, value): self.permission.append(value)
    def insertPermission(self, index, value): self.permission[index] = value
    def export(self, outfile, level, name_='clientPerms'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientPerms'):
        pass
    def exportChildren(self, outfile, level, name_='clientPerms'):
        for permission_ in self.getPermission():
            permission_.export(outfile, level, name_='permission')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permission':
            obj_ = PleskPermissionType.factory()
            obj_.build(child_)
            self.permission.append(obj_)
# end class clientPerms


class clientAddGenInfo:
    subclass = None
    def __init__(self, cname=None, pname='', login='', passwd='', status=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, locale=None, owner_id=None, owner_login=None):
        self.cname = cname
        self.pname = pname
        self.login = login
        self.passwd = passwd
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if clientAddGenInfo.subclass:
            return clientAddGenInfo.subclass(*args_, **kwargs_)
        else:
            return clientAddGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPasswd(self): return self.passwd
    def setPasswd(self, value): self.passwd = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='clientAddGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientAddGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='clientAddGenInfo'):
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        showIndent(outfile, level)
        outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<passwd>%s</passwd>\n' % quote_xml(self.getPasswd()))
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.locale is not None:
            showIndent(outfile, level)
            outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'passwd':
            passwd_ = ''
            for text__content_ in child_.childNodes:
                passwd_ += text__content_.nodeValue
            self.passwd = passwd_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class clientAddGenInfo


class clientSetGenInfo:
    subclass = None
    def __init__(self, cname=None, pname=None, login=None, passwd=None, status=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, locale=None, guid=None):
        self.cname = cname
        self.pname = pname
        self.login = login
        self.passwd = passwd
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
        self.guid = guid
    def factory(*args_, **kwargs_):
        if clientSetGenInfo.subclass:
            return clientSetGenInfo.subclass(*args_, **kwargs_)
        else:
            return clientSetGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPasswd(self): return self.passwd
    def setPasswd(self, value): self.passwd = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def export(self, outfile, level, name_='clientSetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientSetGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='clientSetGenInfo'):
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        if self.pname is not None:
            showIndent(outfile, level)
            outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        if self.login is not None:
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        if self.passwd is not None:
            showIndent(outfile, level)
            outfile.write('<passwd>%s</passwd>\n' % quote_xml(self.getPasswd()))
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.locale is not None:
            showIndent(outfile, level)
            outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
        if self.guid is not None:
            self.guid.export(outfile, level, name_='guid')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'passwd':
            passwd_ = ''
            for text__content_ in child_.childNodes:
                passwd_ += text__content_.nodeValue
            self.passwd = passwd_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setGuid(obj_)
# end class clientSetGenInfo


class clientGetGenInfo:
    subclass = None
    def __init__(self, cr_date='', cname='', pname='', login='', status='', phone='', fax='', email='', address='', city='', state='', pcode='', country='', locale='', password=None, password_type=None, guid=None, owner_id=None, owner_login=None):
        self.cr_date = cr_date
        self.cname = cname
        self.pname = pname
        self.login = login
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
        self.password = password
        self.password_type = password_type
        self.guid = guid
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if clientGetGenInfo.subclass:
            return clientGetGenInfo.subclass(*args_, **kwargs_)
        else:
            return clientGetGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCr_date(self): return self.cr_date
    def setCr_date(self, value): self.cr_date = value
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='clientGetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientGetGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='clientGetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<cr_date>%s</cr_date>\n' % quote_xml(self.getCr_date()))
        showIndent(outfile, level)
        outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        showIndent(outfile, level)
        outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        showIndent(outfile, level)
        outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        showIndent(outfile, level)
        outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        showIndent(outfile, level)
        outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        showIndent(outfile, level)
        outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        showIndent(outfile, level)
        outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        showIndent(outfile, level)
        outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        showIndent(outfile, level)
        outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        showIndent(outfile, level)
        outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        showIndent(outfile, level)
        outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password_type>%s</password_type>\n' % quote_xml(self.getPassword_type()))
        if self.guid is not None:
            showIndent(outfile, level)
            outfile.write('<guid>%s</guid>\n' % quote_xml(self.getGuid()))
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cr_date':
            cr_date_ = ''
            for text__content_ in child_.childNodes:
                cr_date_ += text__content_.nodeValue
            self.cr_date = cr_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password_type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            guid_ = ''
            for text__content_ in child_.childNodes:
                guid_ += text__content_.nodeValue
            self.guid = guid_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class clientGetGenInfo


class clientLimits:
    subclass = None
    def __init__(self, resource_policy=None, limit=None):
        self.resource_policy = resource_policy
        if limit is None:
            self.limit = []
        else:
            self.limit = limit
    def factory(*args_, **kwargs_):
        if clientLimits.subclass:
            return clientLimits.subclass(*args_, **kwargs_)
        else:
            return clientLimits(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResource_policy(self): return self.resource_policy
    def setResource_policy(self, value): self.resource_policy = value
    def getLimit(self): return self.limit
    def setLimit(self, value): self.limit = value
    def addLimit(self, value): self.limit.append(value)
    def insertLimit(self, index, value): self.limit[index] = value
    def export(self, outfile, level, name_='clientLimits'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientLimits'):
        pass
    def exportChildren(self, outfile, level, name_='clientLimits'):
        if self.resource_policy is not None:
            self.resource_policy.export(outfile, level)
        for limit_ in self.getLimit():
            limit_.export(outfile, level, name_='limit')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'resource-policy':
            obj_ = resource_policy.factory()
            obj_.build(child_)
            self.setResource_policy(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limit':
            obj_ = PleskLimitType.factory()
            obj_.build(child_)
            self.limit.append(obj_)
# end class clientLimits


class clientStatType:
    subclass = None
    def __init__(self, active_domains='', subdomains='', disk_space='', postboxs='', redirects='', mail_groups='', mail_resps='', mail_lists='', web_users='', data_bases='', webapps='', traffic='', traffic_prevday=''):
        self.active_domains = active_domains
        self.subdomains = subdomains
        self.disk_space = disk_space
        self.postboxs = postboxs
        self.redirects = redirects
        self.mail_groups = mail_groups
        self.mail_resps = mail_resps
        self.mail_lists = mail_lists
        self.web_users = web_users
        self.data_bases = data_bases
        self.webapps = webapps
        self.traffic = traffic
        self.traffic_prevday = traffic_prevday
    def factory(*args_, **kwargs_):
        if clientStatType.subclass:
            return clientStatType.subclass(*args_, **kwargs_)
        else:
            return clientStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getActive_domains(self): return self.active_domains
    def setActive_domains(self, value): self.active_domains = value
    def getSubdomains(self): return self.subdomains
    def setSubdomains(self, value): self.subdomains = value
    def getDisk_space(self): return self.disk_space
    def setDisk_space(self, value): self.disk_space = value
    def getPostboxs(self): return self.postboxs
    def setPostboxs(self, value): self.postboxs = value
    def getRedirects(self): return self.redirects
    def setRedirects(self, value): self.redirects = value
    def getMail_groups(self): return self.mail_groups
    def setMail_groups(self, value): self.mail_groups = value
    def getMail_resps(self): return self.mail_resps
    def setMail_resps(self, value): self.mail_resps = value
    def getMail_lists(self): return self.mail_lists
    def setMail_lists(self, value): self.mail_lists = value
    def getWeb_users(self): return self.web_users
    def setWeb_users(self, value): self.web_users = value
    def getData_bases(self): return self.data_bases
    def setData_bases(self, value): self.data_bases = value
    def getWebapps(self): return self.webapps
    def setWebapps(self, value): self.webapps = value
    def getTraffic(self): return self.traffic
    def setTraffic(self, value): self.traffic = value
    def getTraffic_prevday(self): return self.traffic_prevday
    def setTraffic_prevday(self, value): self.traffic_prevday = value
    def export(self, outfile, level, name_='clientStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientStatType'):
        pass
    def exportChildren(self, outfile, level, name_='clientStatType'):
        showIndent(outfile, level)
        outfile.write('<active_domains>%s</active_domains>\n' % quote_xml(self.getActive_domains()))
        showIndent(outfile, level)
        outfile.write('<subdomains>%s</subdomains>\n' % quote_xml(self.getSubdomains()))
        showIndent(outfile, level)
        outfile.write('<disk_space>%s</disk_space>\n' % quote_xml(self.getDisk_space()))
        showIndent(outfile, level)
        outfile.write('<postboxs>%s</postboxs>\n' % quote_xml(self.getPostboxs()))
        showIndent(outfile, level)
        outfile.write('<redirects>%s</redirects>\n' % quote_xml(self.getRedirects()))
        showIndent(outfile, level)
        outfile.write('<mail_groups>%s</mail_groups>\n' % quote_xml(self.getMail_groups()))
        showIndent(outfile, level)
        outfile.write('<mail_resps>%s</mail_resps>\n' % quote_xml(self.getMail_resps()))
        showIndent(outfile, level)
        outfile.write('<mail_lists>%s</mail_lists>\n' % quote_xml(self.getMail_lists()))
        showIndent(outfile, level)
        outfile.write('<web_users>%s</web_users>\n' % quote_xml(self.getWeb_users()))
        showIndent(outfile, level)
        outfile.write('<data_bases>%s</data_bases>\n' % quote_xml(self.getData_bases()))
        showIndent(outfile, level)
        outfile.write('<webapps>%s</webapps>\n' % quote_xml(self.getWebapps()))
        showIndent(outfile, level)
        outfile.write('<traffic>%s</traffic>\n' % quote_xml(self.getTraffic()))
        showIndent(outfile, level)
        outfile.write('<traffic_prevday>%s</traffic_prevday>\n' % quote_xml(self.getTraffic_prevday()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'active_domains':
            active_domains_ = ''
            for text__content_ in child_.childNodes:
                active_domains_ += text__content_.nodeValue
            self.active_domains = active_domains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdomains':
            subdomains_ = ''
            for text__content_ in child_.childNodes:
                subdomains_ += text__content_.nodeValue
            self.subdomains = subdomains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disk_space':
            disk_space_ = ''
            for text__content_ in child_.childNodes:
                disk_space_ += text__content_.nodeValue
            self.disk_space = disk_space_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'postboxs':
            postboxs_ = ''
            for text__content_ in child_.childNodes:
                postboxs_ += text__content_.nodeValue
            self.postboxs = postboxs_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'redirects':
            redirects_ = ''
            for text__content_ in child_.childNodes:
                redirects_ += text__content_.nodeValue
            self.redirects = redirects_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_groups':
            mail_groups_ = ''
            for text__content_ in child_.childNodes:
                mail_groups_ += text__content_.nodeValue
            self.mail_groups = mail_groups_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_resps':
            mail_resps_ = ''
            for text__content_ in child_.childNodes:
                mail_resps_ += text__content_.nodeValue
            self.mail_resps = mail_resps_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_lists':
            mail_lists_ = ''
            for text__content_ in child_.childNodes:
                mail_lists_ += text__content_.nodeValue
            self.mail_lists = mail_lists_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'web_users':
            web_users_ = ''
            for text__content_ in child_.childNodes:
                web_users_ += text__content_.nodeValue
            self.web_users = web_users_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'data_bases':
            data_bases_ = ''
            for text__content_ in child_.childNodes:
                data_bases_ += text__content_.nodeValue
            self.data_bases = data_bases_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webapps':
            webapps_ = ''
            for text__content_ in child_.childNodes:
                webapps_ += text__content_.nodeValue
            self.webapps = webapps_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic':
            traffic_ = ''
            for text__content_ in child_.childNodes:
                traffic_ += text__content_.nodeValue
            self.traffic = traffic_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic_prevday':
            traffic_prevday_ = ''
            for text__content_ in child_.childNodes:
                traffic_prevday_ += text__content_.nodeValue
            self.traffic_prevday = traffic_prevday_
# end class clientStatType


class ipPoolType:
    subclass = None
    def __init__(self, ip=None):
        if ip is None:
            self.ip = []
        else:
            self.ip = ip
    def factory(*args_, **kwargs_):
        if ipPoolType.subclass:
            return ipPoolType.subclass(*args_, **kwargs_)
        else:
            return ipPoolType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def addIp(self, value): self.ip.append(value)
    def insertIp(self, index, value): self.ip[index] = value
    def export(self, outfile, level, name_='ipPoolType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ipPoolType'):
        pass
    def exportChildren(self, outfile, level, name_='ipPoolType'):
        for ip_ in self.getIp():
            ip_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = ip.factory()
            obj_.build(child_)
            self.ip.append(obj_)
# end class ipPoolType


class ipPoolOperateType:
    subclass = None
    def __init__(self, client_id='', ip_address=None):
        self.client_id = client_id
        if ip_address is None:
            self.ip_address = []
        else:
            self.ip_address = ip_address
    def factory(*args_, **kwargs_):
        if ipPoolOperateType.subclass:
            return ipPoolOperateType.subclass(*args_, **kwargs_)
        else:
            return ipPoolOperateType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def addIp_address(self, value): self.ip_address.append(value)
    def insertIp_address(self, index, value): self.ip_address[index] = value
    def export(self, outfile, level, name_='ipPoolOperateType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ipPoolOperateType'):
        pass
    def exportChildren(self, outfile, level, name_='ipPoolOperateType'):
        showIndent(outfile, level)
        outfile.write('<client_id>%s</client_id>\n' % quote_xml(self.getClient_id()))
        for ip_address_ in self.getIp_address():
            showIndent(outfile, level)
            outfile.write('<ip_address>%s</ip_address>\n' % quote_xml(ip_address_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client_id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip_address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.addIp_address(ip_address_)
# end class ipPoolOperateType


class poolOperationResult(resultType):
    subclass = None
    def __init__(self, ip_address=None, client_id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.ip_address = ip_address
        self.client_id = client_id
    def factory(*args_, **kwargs_):
        if poolOperationResult.subclass:
            return poolOperationResult.subclass(*args_, **kwargs_)
        else:
            return poolOperationResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def export(self, outfile, level, name_='poolOperationResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='poolOperationResult'):
        resultType.exportAttributes(self, outfile, level, name_='poolOperationResult')
    def exportChildren(self, outfile, level, name_='poolOperationResult'):
        if self.ip_address is not None:
            showIndent(outfile, level)
            outfile.write('<ip_address>%s</ip_address>\n' % quote_xml(self.getIp_address()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client_id>%s</client_id>\n' % quote_xml(self.getClient_id()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip_address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client_id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        resultType.buildChildren(self, child_, nodeName_)
# end class poolOperationResult


class operationResult(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if operationResult.subclass:
            return operationResult.subclass(*args_, **kwargs_)
        else:
            return operationResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='operationResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='operationResult'):
        resultType.exportAttributes(self, outfile, level, name_='operationResult')
    def exportChildren(self, outfile, level, name_='operationResult'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class operationResult


class ClientResponseType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None, ippool_add_ip=None, ippool_del_ip=None, cform_buttons_list=None, get_limit_descriptor=None, get_permission_descriptor=None, convert_to_reseller=None, change_owner=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if ippool_add_ip is None:
            self.ippool_add_ip = []
        else:
            self.ippool_add_ip = ippool_add_ip
        if ippool_del_ip is None:
            self.ippool_del_ip = []
        else:
            self.ippool_del_ip = ippool_del_ip
        if cform_buttons_list is None:
            self.cform_buttons_list = []
        else:
            self.cform_buttons_list = cform_buttons_list
        if get_limit_descriptor is None:
            self.get_limit_descriptor = []
        else:
            self.get_limit_descriptor = get_limit_descriptor
        if get_permission_descriptor is None:
            self.get_permission_descriptor = []
        else:
            self.get_permission_descriptor = get_permission_descriptor
        if convert_to_reseller is None:
            self.convert_to_reseller = []
        else:
            self.convert_to_reseller = convert_to_reseller
        if change_owner is None:
            self.change_owner = []
        else:
            self.change_owner = change_owner
    def factory(*args_, **kwargs_):
        if ClientResponseType.subclass:
            return ClientResponseType.subclass(*args_, **kwargs_)
        else:
            return ClientResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getIppool_add_ip(self): return self.ippool_add_ip
    def setIppool_add_ip(self, value): self.ippool_add_ip = value
    def addIppool_add_ip(self, value): self.ippool_add_ip.append(value)
    def insertIppool_add_ip(self, index, value): self.ippool_add_ip[index] = value
    def getIppool_del_ip(self): return self.ippool_del_ip
    def setIppool_del_ip(self, value): self.ippool_del_ip = value
    def addIppool_del_ip(self, value): self.ippool_del_ip.append(value)
    def insertIppool_del_ip(self, index, value): self.ippool_del_ip[index] = value
    def getCform_buttons_list(self): return self.cform_buttons_list
    def setCform_buttons_list(self, value): self.cform_buttons_list = value
    def addCform_buttons_list(self, value): self.cform_buttons_list.append(value)
    def insertCform_buttons_list(self, index, value): self.cform_buttons_list[index] = value
    def getGet_limit_descriptor(self): return self.get_limit_descriptor
    def setGet_limit_descriptor(self, value): self.get_limit_descriptor = value
    def addGet_limit_descriptor(self, value): self.get_limit_descriptor.append(value)
    def insertGet_limit_descriptor(self, index, value): self.get_limit_descriptor[index] = value
    def getGet_permission_descriptor(self): return self.get_permission_descriptor
    def setGet_permission_descriptor(self, value): self.get_permission_descriptor = value
    def addGet_permission_descriptor(self, value): self.get_permission_descriptor.append(value)
    def insertGet_permission_descriptor(self, index, value): self.get_permission_descriptor[index] = value
    def getConvert_to_reseller(self): return self.convert_to_reseller
    def setConvert_to_reseller(self, value): self.convert_to_reseller = value
    def addConvert_to_reseller(self, value): self.convert_to_reseller.append(value)
    def insertConvert_to_reseller(self, index, value): self.convert_to_reseller[index] = value
    def getChange_owner(self): return self.change_owner
    def setChange_owner(self, value): self.change_owner = value
    def addChange_owner(self, value): self.change_owner.append(value)
    def insertChange_owner(self, index, value): self.change_owner[index] = value
    def export(self, outfile, level, name_='ClientResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientResponseType'):
        for add_ in self.getAdd():
            add_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for del_ in self.getDel():
            del_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for ippool_add_ip_ in self.getIppool_add_ip():
            ippool_add_ip_.export(outfile, level)
        for ippool_del_ip_ in self.getIppool_del_ip():
            ippool_del_ip_.export(outfile, level)
        for cform_buttons_list_ in self.getCform_buttons_list():
            cform_buttons_list_.export(outfile, level)
        for get_limit_descriptor_ in self.getGet_limit_descriptor():
            get_limit_descriptor_.export(outfile, level)
        for get_permission_descriptor_ in self.getGet_permission_descriptor():
            get_permission_descriptor_.export(outfile, level)
        for convert_to_reseller_ in self.getConvert_to_reseller():
            convert_to_reseller_.export(outfile, level)
        for change_owner_ in self.getChange_owner():
            change_owner_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = add.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ddel.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool_add_ip':
            obj_ = ippool_add_ip.factory()
            obj_.build(child_)
            self.ippool_add_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool_del_ip':
            obj_ = ippool_del_ip.factory()
            obj_.build(child_)
            self.ippool_del_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cform_buttons_list':
            obj_ = cform_buttons_list.factory()
            obj_.build(child_)
            self.cform_buttons_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-limit-descriptor':
            obj_ = get_limit_descriptor.factory()
            obj_.build(child_)
            self.get_limit_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-permission-descriptor':
            obj_ = get_permission_descriptor.factory()
            obj_.build(child_)
            self.get_permission_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'convert-to-reseller':
            obj_ = convert_to_reseller.factory()
            obj_.build(child_)
            self.convert_to_reseller.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'change-owner':
            obj_ = change_owner.factory()
            obj_.build(child_)
            self.change_owner.append(obj_)
# end class ClientResponseType


class DatabaseServer:
    subclass = None
    def __init__(self, host=None, port=None):
        self.host = host
        self.port = port
    def factory(*args_, **kwargs_):
        if DatabaseServer.subclass:
            return DatabaseServer.subclass(*args_, **kwargs_)
        else:
            return DatabaseServer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getPort(self): return self.port
    def setPort(self, value): self.port = value
    def export(self, outfile, level, name_='DatabaseServer'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServer'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseServer'):
        if self.host is not None:
            showIndent(outfile, level)
            outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        if self.port is not None:
            showIndent(outfile, level)
            outfile.write('<port>%s</port>\n' % quote_xml(self.getPort()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'port':
            port_ = ''
            for text__content_ in child_.childNodes:
                port_ += text__content_.nodeValue
            self.port = port_
# end class DatabaseServer


class DatabaseServerDescription(DatabaseServer):
    subclass = None
    def __init__(self, ttype='', admin='', password=None, host=None, port=None):
        DatabaseServer.__init__(self, host, port)
        self.ttype = ttype
        self.admin = admin
        self.password = password
    def factory(*args_, **kwargs_):
        if DatabaseServerDescription.subclass:
            return DatabaseServerDescription.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerDescription(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def export(self, outfile, level, name_='DatabaseServerDescription'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerDescription'):
        DatabaseServer.exportAttributes(self, outfile, level, name_='DatabaseServerDescription')
    def exportChildren(self, outfile, level, name_='DatabaseServerDescription'):
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<admin>%s</admin>\n' % quote_xml(self.getAdmin()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        DatabaseServer.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        DatabaseServer.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            admin_ = ''
            for text__content_ in child_.childNodes:
                admin_ += text__content_.nodeValue
            self.admin = admin_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        DatabaseServer.buildChildren(self, child_, nodeName_)
# end class DatabaseServerDescription


class DatabaseServerDescriptionOpt(DatabaseServer):
    subclass = None
    def __init__(self, admin=None, password=None, host=None, port=None):
        DatabaseServer.__init__(self, host, port)
        self.admin = admin
        self.password = password
    def factory(*args_, **kwargs_):
        if DatabaseServerDescriptionOpt.subclass:
            return DatabaseServerDescriptionOpt.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerDescriptionOpt(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def export(self, outfile, level, name_='DatabaseServerDescriptionOpt'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerDescriptionOpt'):
        DatabaseServer.exportAttributes(self, outfile, level, name_='DatabaseServerDescriptionOpt')
    def exportChildren(self, outfile, level, name_='DatabaseServerDescriptionOpt'):
        if self.admin is not None:
            showIndent(outfile, level)
            outfile.write('<admin>%s</admin>\n' % quote_xml(self.getAdmin()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        DatabaseServer.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        DatabaseServer.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            admin_ = ''
            for text__content_ in child_.childNodes:
                admin_ += text__content_.nodeValue
            self.admin = admin_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        DatabaseServer.buildChildren(self, child_, nodeName_)
# end class DatabaseServerDescriptionOpt


class DatabaseServerAddParam:
    subclass = None
    def __init__(self, host='', port='', ttype='', admin='', password=None):
        self.host = host
        self.port = port
        self.ttype = ttype
        self.admin = admin
        self.password = password
    def factory(*args_, **kwargs_):
        if DatabaseServerAddParam.subclass:
            return DatabaseServerAddParam.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerAddParam(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getPort(self): return self.port
    def setPort(self, value): self.port = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def export(self, outfile, level, name_='DatabaseServerAddParam'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerAddParam'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseServerAddParam'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        showIndent(outfile, level)
        outfile.write('<port>%s</port>\n' % quote_xml(self.getPort()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<admin>%s</admin>\n' % quote_xml(self.getAdmin()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'port':
            port_ = ''
            for text__content_ in child_.childNodes:
                port_ += text__content_.nodeValue
            self.port = port_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            admin_ = ''
            for text__content_ in child_.childNodes:
                admin_ += text__content_.nodeValue
            self.admin = admin_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
# end class DatabaseServerAddParam


class DatabaseServerResultType(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if DatabaseServerResultType.subclass:
            return DatabaseServerResultType.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='DatabaseServerResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerResultType'):
        resultType.exportAttributes(self, outfile, level, name_='DatabaseServerResultType')
    def exportChildren(self, outfile, level, name_='DatabaseServerResultType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class DatabaseServerResultType


class DatabaseServerResultType2(resultType):
    subclass = None
    def __init__(self, ttype=None, id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.ttype = ttype
        self.id = id
    def factory(*args_, **kwargs_):
        if DatabaseServerResultType2.subclass:
            return DatabaseServerResultType2.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerResultType2(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='DatabaseServerResultType2'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerResultType2'):
        resultType.exportAttributes(self, outfile, level, name_='DatabaseServerResultType2')
    def exportChildren(self, outfile, level, name_='DatabaseServerResultType2'):
        if self.ttype is not None:
            showIndent(outfile, level)
            outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class DatabaseServerResultType2


class DatabaseServerResponseType:
    subclass = None
    def __init__(self, add=None, set=None, ddel=None, set_default=None, get=None, get_supported_types=None, get_default=None, get_local=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set_default is None:
            self.set_default = []
        else:
            self.set_default = set_default
        if get is None:
            self.get = []
        else:
            self.get = get
        if get_supported_types is None:
            self.get_supported_types = []
        else:
            self.get_supported_types = get_supported_types
        if get_default is None:
            self.get_default = []
        else:
            self.get_default = get_default
        if get_local is None:
            self.get_local = []
        else:
            self.get_local = get_local
    def factory(*args_, **kwargs_):
        if DatabaseServerResponseType.subclass:
            return DatabaseServerResponseType.subclass(*args_, **kwargs_)
        else:
            return DatabaseServerResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet_default(self): return self.set_default
    def setSet_default(self, value): self.set_default = value
    def addSet_default(self, value): self.set_default.append(value)
    def insertSet_default(self, index, value): self.set_default[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getGet_supported_types(self): return self.get_supported_types
    def setGet_supported_types(self, value): self.get_supported_types = value
    def addGet_supported_types(self, value): self.get_supported_types.append(value)
    def insertGet_supported_types(self, index, value): self.get_supported_types[index] = value
    def getGet_default(self): return self.get_default
    def setGet_default(self, value): self.get_default = value
    def addGet_default(self, value): self.get_default.append(value)
    def insertGet_default(self, index, value): self.get_default[index] = value
    def getGet_local(self): return self.get_local
    def setGet_local(self, value): self.get_local = value
    def addGet_local(self, value): self.get_local.append(value)
    def insertGet_local(self, index, value): self.get_local[index] = value
    def export(self, outfile, level, name_='DatabaseServerResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseServerResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseServerResponseType'):
        for add_ in self.getAdd():
            add_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for del_ in self.getDel():
            del_.export(outfile, level)
        for set_default_ in self.getSet_default():
            set_default_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for get_supported_types_ in self.getGet_supported_types():
            get_supported_types_.export(outfile, level)
        for get_default_ in self.getGet_default():
            get_default_.export(outfile, level)
        for get_local_ in self.getGet_local():
            get_local_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = add.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ddel.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default':
            obj_ = set_default.factory()
            obj_.build(child_)
            self.set_default.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-types':
            obj_ = get_supported_types.factory()
            obj_.build(child_)
            self.get_supported_types.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-default':
            obj_ = get_default.factory()
            obj_.build(child_)
            self.get_default.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-local':
            obj_ = get_local.factory()
            obj_.build(child_)
            self.get_local.append(obj_)
# end class DatabaseServerResponseType


class DatabaseOutputType:
    subclass = None
    def __init__(self, add_db=None, del_db=None, set_default_user=None, get_default_user=None, get_db=None, add_db_user=None, del_db_user=None, get_db_users=None, set_db_user=None):
        if add_db is None:
            self.add_db = []
        else:
            self.add_db = add_db
        if del_db is None:
            self.del_db = []
        else:
            self.del_db = del_db
        if set_default_user is None:
            self.set_default_user = []
        else:
            self.set_default_user = set_default_user
        if get_default_user is None:
            self.get_default_user = []
        else:
            self.get_default_user = get_default_user
        if get_db is None:
            self.get_db = []
        else:
            self.get_db = get_db
        if add_db_user is None:
            self.add_db_user = []
        else:
            self.add_db_user = add_db_user
        if del_db_user is None:
            self.del_db_user = []
        else:
            self.del_db_user = del_db_user
        if get_db_users is None:
            self.get_db_users = []
        else:
            self.get_db_users = get_db_users
        if set_db_user is None:
            self.set_db_user = []
        else:
            self.set_db_user = set_db_user
    def factory(*args_, **kwargs_):
        if DatabaseOutputType.subclass:
            return DatabaseOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_db(self): return self.add_db
    def setAdd_db(self, value): self.add_db = value
    def addAdd_db(self, value): self.add_db.append(value)
    def insertAdd_db(self, index, value): self.add_db[index] = value
    def getDel_db(self): return self.del_db
    def setDel_db(self, value): self.del_db = value
    def addDel_db(self, value): self.del_db.append(value)
    def insertDel_db(self, index, value): self.del_db[index] = value
    def getSet_default_user(self): return self.set_default_user
    def setSet_default_user(self, value): self.set_default_user = value
    def addSet_default_user(self, value): self.set_default_user.append(value)
    def insertSet_default_user(self, index, value): self.set_default_user[index] = value
    def getGet_default_user(self): return self.get_default_user
    def setGet_default_user(self, value): self.get_default_user = value
    def addGet_default_user(self, value): self.get_default_user.append(value)
    def insertGet_default_user(self, index, value): self.get_default_user[index] = value
    def getGet_db(self): return self.get_db
    def setGet_db(self, value): self.get_db = value
    def addGet_db(self, value): self.get_db.append(value)
    def insertGet_db(self, index, value): self.get_db[index] = value
    def getAdd_db_user(self): return self.add_db_user
    def setAdd_db_user(self, value): self.add_db_user = value
    def addAdd_db_user(self, value): self.add_db_user.append(value)
    def insertAdd_db_user(self, index, value): self.add_db_user[index] = value
    def getDel_db_user(self): return self.del_db_user
    def setDel_db_user(self, value): self.del_db_user = value
    def addDel_db_user(self, value): self.del_db_user.append(value)
    def insertDel_db_user(self, index, value): self.del_db_user[index] = value
    def getGet_db_users(self): return self.get_db_users
    def setGet_db_users(self, value): self.get_db_users = value
    def addGet_db_users(self, value): self.get_db_users.append(value)
    def insertGet_db_users(self, index, value): self.get_db_users[index] = value
    def getSet_db_user(self): return self.set_db_user
    def setSet_db_user(self, value): self.set_db_user = value
    def addSet_db_user(self, value): self.set_db_user.append(value)
    def insertSet_db_user(self, index, value): self.set_db_user[index] = value
    def export(self, outfile, level, name_='DatabaseOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseOutputType'):
        for add_db_ in self.getAdd_db():
            add_db_.export(outfile, level, name_='add-db')
        for del_db_ in self.getDel_db():
            del_db_.export(outfile, level, name_='del-db')
        for set_default_user_ in self.getSet_default_user():
            set_default_user_.export(outfile, level, name_='set-default-user')
        for get_default_user_ in self.getGet_default_user():
            get_default_user_.export(outfile, level, name_='get-default-user')
        for get_db_ in self.getGet_db():
            get_db_.export(outfile, level, name_='get-db')
        for add_db_user_ in self.getAdd_db_user():
            add_db_user_.export(outfile, level, name_='add-db-user')
        for del_db_user_ in self.getDel_db_user():
            del_db_user_.export(outfile, level, name_='del-db-user')
        for get_db_users_ in self.getGet_db_users():
            get_db_users_.export(outfile, level, name_='get-db-users')
        for set_db_user_ in self.getSet_db_user():
            set_db_user_.export(outfile, level, name_='set-db-user')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-db':
            obj_ = DatabaseAddDBOutputType.factory()
            obj_.build(child_)
            self.add_db.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-db':
            obj_ = DatabaseDelDBOutputType.factory()
            obj_.build(child_)
            self.del_db.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default-user':
            obj_ = DatabaseSetDBOutputType.factory()
            obj_.build(child_)
            self.set_default_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-default-user':
            obj_ = DatabaseGetDefaultUserOutputType.factory()
            obj_.build(child_)
            self.get_default_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-db':
            obj_ = DatabaseGetDBOutputType.factory()
            obj_.build(child_)
            self.get_db.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-db-user':
            obj_ = DatabaseAddDBUserOutputType.factory()
            obj_.build(child_)
            self.add_db_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-db-user':
            obj_ = DatabaseDelDBUserOutputType.factory()
            obj_.build(child_)
            self.del_db_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-db-users':
            obj_ = DatabaseGetDBUsersOutputType.factory()
            obj_.build(child_)
            self.get_db_users.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-db-user':
            obj_ = DatabaseSetDBUserOutputtype.factory()
            obj_.build(child_)
            self.set_db_user.append(obj_)
# end class DatabaseOutputType


class DatabaseAddDBOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseAddDBOutputType.subclass:
            return DatabaseAddDBOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseAddDBOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DatabaseAddDBOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseAddDBOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseAddDBOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DatabaseAddDBOutputType


class DatabaseDelDBOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseDelDBOutputType.subclass:
            return DatabaseDelDBOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseDelDBOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DatabaseDelDBOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseDelDBOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseDelDBOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DatabaseDelDBOutputType


class DatabaseGetDBOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseGetDBOutputType.subclass:
            return DatabaseGetDBOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseGetDBOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DatabaseGetDBOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseGetDBOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseGetDBOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DatabaseGetDBOutputType


class DatabaseAddDBUserOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseAddDBUserOutputType.subclass:
            return DatabaseAddDBUserOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseAddDBUserOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DatabaseAddDBUserOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseAddDBUserOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseAddDBUserOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DatabaseAddDBUserOutputType


class DatabaseDelDBUserOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseDelDBUserOutputType.subclass:
            return DatabaseDelDBUserOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseDelDBUserOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DatabaseDelDBUserOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseDelDBUserOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseDelDBUserOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DatabaseDelDBUserOutputType


class DatabaseGetDBUsersOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseGetDBUsersOutputType.subclass:
            return DatabaseGetDBUsersOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseGetDBUsersOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DatabaseGetDBUsersOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseGetDBUsersOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseGetDBUsersOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DatabaseGetDBUsersOutputType


class DatabaseSetDBUserOutputtype:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseSetDBUserOutputtype.subclass:
            return DatabaseSetDBUserOutputtype.subclass(*args_, **kwargs_)
        else:
            return DatabaseSetDBUserOutputtype(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DatabaseSetDBUserOutputtype'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseSetDBUserOutputtype'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseSetDBUserOutputtype'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DatabaseSetDBUserOutputtype


class DatabaseSetDBOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseSetDBOutputType.subclass:
            return DatabaseSetDBOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseSetDBOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DatabaseSetDBOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseSetDBOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseSetDBOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DatabaseSetDBOutputType


class DatabaseGetDefaultUserOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DatabaseGetDefaultUserOutputType.subclass:
            return DatabaseGetDefaultUserOutputType.subclass(*args_, **kwargs_)
        else:
            return DatabaseGetDefaultUserOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DatabaseGetDefaultUserOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DatabaseGetDefaultUserOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DatabaseGetDefaultUserOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DatabaseGetDefaultUserOutputType


class dnsRecord:
    subclass = None
    def __init__(self, domain_id=None, domain_alias_id=None, ttype='', host='', value='', opt=None):
        self.domain_id = domain_id
        self.domain_alias_id = domain_alias_id
        self.ttype = ttype
        self.host = host
        self.value = value
        self.opt = opt
    def factory(*args_, **kwargs_):
        if dnsRecord.subclass:
            return dnsRecord.subclass(*args_, **kwargs_)
        else:
            return dnsRecord(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_alias_id(self): return self.domain_alias_id
    def setDomain_alias_id(self, value): self.domain_alias_id = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def getOpt(self): return self.opt
    def setOpt(self, value): self.opt = value
    def export(self, outfile, level, name_='dnsRecord'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='dnsRecord'):
        pass
    def exportChildren(self, outfile, level, name_='dnsRecord'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain_id>%s</domain_id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_alias_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain_alias_id>%s</domain_alias_id>\n' % quote_xml(self.getDomain_alias_id()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
        if self.opt is not None:
            showIndent(outfile, level)
            outfile.write('<opt>%s</opt>\n' % quote_xml(self.getOpt()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_alias_id':
            domain_alias_id_ = ''
            for text__content_ in child_.childNodes:
                domain_alias_id_ += text__content_.nodeValue
            self.domain_alias_id = domain_alias_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'opt':
            opt_ = ''
            for text__content_ in child_.childNodes:
                opt_ += text__content_.nodeValue
            self.opt = opt_
# end class dnsRecord


class SOAType:
    subclass = None
    def __init__(self, ttl=None, refresh=None, retry=None, expire=None, minimum=None):
        self.ttl = ttl
        self.refresh = refresh
        self.retry = retry
        self.expire = expire
        self.minimum = minimum
    def factory(*args_, **kwargs_):
        if SOAType.subclass:
            return SOAType.subclass(*args_, **kwargs_)
        else:
            return SOAType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTtl(self): return self.ttl
    def setTtl(self, value): self.ttl = value
    def getRefresh(self): return self.refresh
    def setRefresh(self, value): self.refresh = value
    def getRetry(self): return self.retry
    def setRetry(self, value): self.retry = value
    def getExpire(self): return self.expire
    def setExpire(self, value): self.expire = value
    def getMinimum(self): return self.minimum
    def setMinimum(self, value): self.minimum = value
    def export(self, outfile, level, name_='SOAType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SOAType'):
        pass
    def exportChildren(self, outfile, level, name_='SOAType'):
        if self.ttl is not None:
            showIndent(outfile, level)
            outfile.write('<ttl>%s</ttl>\n' % quote_xml(self.getTtl()))
        if self.refresh is not None:
            showIndent(outfile, level)
            outfile.write('<refresh>%s</refresh>\n' % quote_xml(self.getRefresh()))
        if self.retry is not None:
            showIndent(outfile, level)
            outfile.write('<retry>%s</retry>\n' % quote_xml(self.getRetry()))
        if self.expire is not None:
            showIndent(outfile, level)
            outfile.write('<expire>%s</expire>\n' % quote_xml(self.getExpire()))
        if self.minimum is not None:
            showIndent(outfile, level)
            outfile.write('<minimum>%s</minimum>\n' % quote_xml(self.getMinimum()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ttl':
            ttl_ = ''
            for text__content_ in child_.childNodes:
                ttl_ += text__content_.nodeValue
            self.ttl = ttl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'refresh':
            refresh_ = ''
            for text__content_ in child_.childNodes:
                refresh_ += text__content_.nodeValue
            self.refresh = refresh_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'retry':
            retry_ = ''
            for text__content_ in child_.childNodes:
                retry_ += text__content_.nodeValue
            self.retry = retry_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'expire':
            expire_ = ''
            for text__content_ in child_.childNodes:
                expire_ += text__content_.nodeValue
            self.expire = expire_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'minimum':
            minimum_ = ''
            for text__content_ in child_.childNodes:
                minimum_ += text__content_.nodeValue
            self.minimum = minimum_
# end class SOAType


class aclResultType(resultType):
    subclass = None
    def __init__(self, host=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        if host is None:
            self.host = []
        else:
            self.host = host
    def factory(*args_, **kwargs_):
        if aclResultType.subclass:
            return aclResultType.subclass(*args_, **kwargs_)
        else:
            return aclResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def addHost(self, value): self.host.append(value)
    def insertHost(self, index, value): self.host[index] = value
    def export(self, outfile, level, name_='aclResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='aclResultType'):
        resultType.exportAttributes(self, outfile, level, name_='aclResultType')
    def exportChildren(self, outfile, level, name_='aclResultType'):
        for host_ in self.getHost():
            showIndent(outfile, level)
            outfile.write('<host>%s</host>\n' % quote_xml(host_))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.addHost(host_)
        resultType.buildChildren(self, child_, nodeName_)
# end class aclResultType


class resultOpType(resultType):
    subclass = None
    def __init__(self, domain_id=None, domain_alias_id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.domain_id = domain_id
        self.domain_alias_id = domain_alias_id
    def factory(*args_, **kwargs_):
        if resultOpType.subclass:
            return resultOpType.subclass(*args_, **kwargs_)
        else:
            return resultOpType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_alias_id(self): return self.domain_alias_id
    def setDomain_alias_id(self, value): self.domain_alias_id = value
    def export(self, outfile, level, name_='resultOpType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='resultOpType'):
        resultType.exportAttributes(self, outfile, level, name_='resultOpType')
    def exportChildren(self, outfile, level, name_='resultOpType'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain_id>%s</domain_id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_alias_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain_alias_id>%s</domain_alias_id>\n' % quote_xml(self.getDomain_alias_id()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_alias_id':
            domain_alias_id_ = ''
            for text__content_ in child_.childNodes:
                domain_alias_id_ += text__content_.nodeValue
            self.domain_alias_id = domain_alias_id_
        resultType.buildChildren(self, child_, nodeName_)
# end class resultOpType


class DNSResponseType:
    subclass = None
    def __init__(self, add_rec=None, get_rec=None, del_rec=None, get_acl=None, add_to_acl=None, remove_from_acl=None, switch=None, add_master_server=None, get_master_server=None, del_master_server=None, get=None, set=None, enable=None, disable=None, enable_remote_dns=None, disable_remote_dns=None, get_status_remote_dns=None, set_recursion=None, get_recursion=None, get_supported_recursion=None):
        if add_rec is None:
            self.add_rec = []
        else:
            self.add_rec = add_rec
        if get_rec is None:
            self.get_rec = []
        else:
            self.get_rec = get_rec
        if del_rec is None:
            self.del_rec = []
        else:
            self.del_rec = del_rec
        if get_acl is None:
            self.get_acl = []
        else:
            self.get_acl = get_acl
        if add_to_acl is None:
            self.add_to_acl = []
        else:
            self.add_to_acl = add_to_acl
        if remove_from_acl is None:
            self.remove_from_acl = []
        else:
            self.remove_from_acl = remove_from_acl
        if switch is None:
            self.switch = []
        else:
            self.switch = switch
        if add_master_server is None:
            self.add_master_server = []
        else:
            self.add_master_server = add_master_server
        if get_master_server is None:
            self.get_master_server = []
        else:
            self.get_master_server = get_master_server
        if del_master_server is None:
            self.del_master_server = []
        else:
            self.del_master_server = del_master_server
        if get is None:
            self.get = []
        else:
            self.get = get
        if set is None:
            self.set = []
        else:
            self.set = set
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if enable_remote_dns is None:
            self.enable_remote_dns = []
        else:
            self.enable_remote_dns = enable_remote_dns
        if disable_remote_dns is None:
            self.disable_remote_dns = []
        else:
            self.disable_remote_dns = disable_remote_dns
        if get_status_remote_dns is None:
            self.get_status_remote_dns = []
        else:
            self.get_status_remote_dns = get_status_remote_dns
        if set_recursion is None:
            self.set_recursion = []
        else:
            self.set_recursion = set_recursion
        if get_recursion is None:
            self.get_recursion = []
        else:
            self.get_recursion = get_recursion
        if get_supported_recursion is None:
            self.get_supported_recursion = []
        else:
            self.get_supported_recursion = get_supported_recursion
    def factory(*args_, **kwargs_):
        if DNSResponseType.subclass:
            return DNSResponseType.subclass(*args_, **kwargs_)
        else:
            return DNSResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_rec(self): return self.add_rec
    def setAdd_rec(self, value): self.add_rec = value
    def addAdd_rec(self, value): self.add_rec.append(value)
    def insertAdd_rec(self, index, value): self.add_rec[index] = value
    def getGet_rec(self): return self.get_rec
    def setGet_rec(self, value): self.get_rec = value
    def addGet_rec(self, value): self.get_rec.append(value)
    def insertGet_rec(self, index, value): self.get_rec[index] = value
    def getDel_rec(self): return self.del_rec
    def setDel_rec(self, value): self.del_rec = value
    def addDel_rec(self, value): self.del_rec.append(value)
    def insertDel_rec(self, index, value): self.del_rec[index] = value
    def getGet_acl(self): return self.get_acl
    def setGet_acl(self, value): self.get_acl = value
    def addGet_acl(self, value): self.get_acl.append(value)
    def insertGet_acl(self, index, value): self.get_acl[index] = value
    def getAdd_to_acl(self): return self.add_to_acl
    def setAdd_to_acl(self, value): self.add_to_acl = value
    def addAdd_to_acl(self, value): self.add_to_acl.append(value)
    def insertAdd_to_acl(self, index, value): self.add_to_acl[index] = value
    def getRemove_from_acl(self): return self.remove_from_acl
    def setRemove_from_acl(self, value): self.remove_from_acl = value
    def addRemove_from_acl(self, value): self.remove_from_acl.append(value)
    def insertRemove_from_acl(self, index, value): self.remove_from_acl[index] = value
    def getSwitch(self): return self.switch
    def setSwitch(self, value): self.switch = value
    def addSwitch(self, value): self.switch.append(value)
    def insertSwitch(self, index, value): self.switch[index] = value
    def getAdd_master_server(self): return self.add_master_server
    def setAdd_master_server(self, value): self.add_master_server = value
    def addAdd_master_server(self, value): self.add_master_server.append(value)
    def insertAdd_master_server(self, index, value): self.add_master_server[index] = value
    def getGet_master_server(self): return self.get_master_server
    def setGet_master_server(self, value): self.get_master_server = value
    def addGet_master_server(self, value): self.get_master_server.append(value)
    def insertGet_master_server(self, index, value): self.get_master_server[index] = value
    def getDel_master_server(self): return self.del_master_server
    def setDel_master_server(self, value): self.del_master_server = value
    def addDel_master_server(self, value): self.del_master_server.append(value)
    def insertDel_master_server(self, index, value): self.del_master_server[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getEnable_remote_dns(self): return self.enable_remote_dns
    def setEnable_remote_dns(self, value): self.enable_remote_dns = value
    def addEnable_remote_dns(self, value): self.enable_remote_dns.append(value)
    def insertEnable_remote_dns(self, index, value): self.enable_remote_dns[index] = value
    def getDisable_remote_dns(self): return self.disable_remote_dns
    def setDisable_remote_dns(self, value): self.disable_remote_dns = value
    def addDisable_remote_dns(self, value): self.disable_remote_dns.append(value)
    def insertDisable_remote_dns(self, index, value): self.disable_remote_dns[index] = value
    def getGet_status_remote_dns(self): return self.get_status_remote_dns
    def setGet_status_remote_dns(self, value): self.get_status_remote_dns = value
    def addGet_status_remote_dns(self, value): self.get_status_remote_dns.append(value)
    def insertGet_status_remote_dns(self, index, value): self.get_status_remote_dns[index] = value
    def getSet_recursion(self): return self.set_recursion
    def setSet_recursion(self, value): self.set_recursion = value
    def addSet_recursion(self, value): self.set_recursion.append(value)
    def insertSet_recursion(self, index, value): self.set_recursion[index] = value
    def getGet_recursion(self): return self.get_recursion
    def setGet_recursion(self, value): self.get_recursion = value
    def addGet_recursion(self, value): self.get_recursion.append(value)
    def insertGet_recursion(self, index, value): self.get_recursion[index] = value
    def getGet_supported_recursion(self): return self.get_supported_recursion
    def setGet_supported_recursion(self, value): self.get_supported_recursion = value
    def addGet_supported_recursion(self, value): self.get_supported_recursion.append(value)
    def insertGet_supported_recursion(self, index, value): self.get_supported_recursion[index] = value
    def export(self, outfile, level, name_='DNSResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='DNSResponseType'):
        for add_rec_ in self.getAdd_rec():
            add_rec_.export(outfile, level)
        for get_rec_ in self.getGet_rec():
            get_rec_.export(outfile, level)
        for del_rec_ in self.getDel_rec():
            del_rec_.export(outfile, level)
        for get_acl_ in self.getGet_acl():
            get_acl_.export(outfile, level)
        for add_to_acl_ in self.getAdd_to_acl():
            add_to_acl_.export(outfile, level)
        for remove_from_acl_ in self.getRemove_from_acl():
            remove_from_acl_.export(outfile, level)
        for switch_ in self.getSwitch():
            switch_.export(outfile, level)
        for add_master_server_ in self.getAdd_master_server():
            add_master_server_.export(outfile, level)
        for get_master_server_ in self.getGet_master_server():
            get_master_server_.export(outfile, level)
        for del_master_server_ in self.getDel_master_server():
            del_master_server_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for enable_ in self.getEnable():
            enable_.export(outfile, level)
        for disable_ in self.getDisable():
            disable_.export(outfile, level)
        for enable_remote_dns_ in self.getEnable_remote_dns():
            enable_remote_dns_.export(outfile, level, name_='enable-remote-dns')
        for disable_remote_dns_ in self.getDisable_remote_dns():
            disable_remote_dns_.export(outfile, level, name_='disable-remote-dns')
        for get_status_remote_dns_ in self.getGet_status_remote_dns():
            get_status_remote_dns_.export(outfile, level, name_='get-status-remote-dns')
        for set_recursion_ in self.getSet_recursion():
            set_recursion_.export(outfile, level, name_='set-recursion')
        for get_recursion_ in self.getGet_recursion():
            get_recursion_.export(outfile, level, name_='get-recursion')
        for get_supported_recursion_ in self.getGet_supported_recursion():
            get_supported_recursion_.export(outfile, level, name_='get-supported-recursion')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add_rec':
            obj_ = add_rec.factory()
            obj_.build(child_)
            self.add_rec.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_rec':
            obj_ = get_rec.factory()
            obj_.build(child_)
            self.get_rec.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del_rec':
            obj_ = del_rec.factory()
            obj_.build(child_)
            self.del_rec.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_acl':
            obj_ = get_acl.factory()
            obj_.build(child_)
            self.get_acl.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add_to_acl':
            obj_ = add_to_acl.factory()
            obj_.build(child_)
            self.add_to_acl.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove_from_acl':
            obj_ = remove_from_acl.factory()
            obj_.build(child_)
            self.remove_from_acl.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'switch':
            obj_ = switch.factory()
            obj_.build(child_)
            self.switch.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add_master_server':
            obj_ = add_master_server.factory()
            obj_.build(child_)
            self.add_master_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_master_server':
            obj_ = get_master_server.factory()
            obj_.build(child_)
            self.get_master_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del_master_server':
            obj_ = del_master_server.factory()
            obj_.build(child_)
            self.del_master_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = enable.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = disable.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable-remote-dns':
            obj_ = DNSEnableRemoteDNS.factory()
            obj_.build(child_)
            self.enable_remote_dns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable-remote-dns':
            obj_ = DNSDisableRemoteDNS.factory()
            obj_.build(child_)
            self.disable_remote_dns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status-remote-dns':
            obj_ = DNSGetStatusRemoteDNS.factory()
            obj_.build(child_)
            self.get_status_remote_dns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-recursion':
            obj_ = DNSSetRecursionOutputType.factory()
            obj_.build(child_)
            self.set_recursion.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-recursion':
            obj_ = DNSGetRecursionOutputType.factory()
            obj_.build(child_)
            self.get_recursion.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-recursion':
            obj_ = DNSGetSupportedRecursionOutputType.factory()
            obj_.build(child_)
            self.get_supported_recursion.append(obj_)
# end class DNSResponseType


class DNSEnableRemoteDNS:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSEnableRemoteDNS.subclass:
            return DNSEnableRemoteDNS.subclass(*args_, **kwargs_)
        else:
            return DNSEnableRemoteDNS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSEnableRemoteDNS'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSEnableRemoteDNS'):
        pass
    def exportChildren(self, outfile, level, name_='DNSEnableRemoteDNS'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSEnableRemoteDNS


class DNSDisableRemoteDNS:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSDisableRemoteDNS.subclass:
            return DNSDisableRemoteDNS.subclass(*args_, **kwargs_)
        else:
            return DNSDisableRemoteDNS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSDisableRemoteDNS'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSDisableRemoteDNS'):
        pass
    def exportChildren(self, outfile, level, name_='DNSDisableRemoteDNS'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSDisableRemoteDNS


class DNSGetStatusRemoteDNS:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSGetStatusRemoteDNS.subclass:
            return DNSGetStatusRemoteDNS.subclass(*args_, **kwargs_)
        else:
            return DNSGetStatusRemoteDNS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSGetStatusRemoteDNS'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSGetStatusRemoteDNS'):
        pass
    def exportChildren(self, outfile, level, name_='DNSGetStatusRemoteDNS'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSGetStatusRemoteDNS


class DNSSetRecursionOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSSetRecursionOutputType.subclass:
            return DNSSetRecursionOutputType.subclass(*args_, **kwargs_)
        else:
            return DNSSetRecursionOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSSetRecursionOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSSetRecursionOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DNSSetRecursionOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSSetRecursionOutputType


class DNSGetRecursionOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSGetRecursionOutputType.subclass:
            return DNSGetRecursionOutputType.subclass(*args_, **kwargs_)
        else:
            return DNSGetRecursionOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSGetRecursionOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSGetRecursionOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DNSGetRecursionOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSGetRecursionOutputType


class DNSGetSupportedRecursionOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DNSGetSupportedRecursionOutputType.subclass:
            return DNSGetSupportedRecursionOutputType.subclass(*args_, **kwargs_)
        else:
            return DNSGetSupportedRecursionOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DNSGetSupportedRecursionOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DNSGetSupportedRecursionOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DNSGetSupportedRecursionOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DNSGetSupportedRecursionOutputType


class DomainResponseType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None, cform_buttons_list=None, get_traffic=None, set_traffic=None, get_limit_descriptor=None, get_permission_descriptor=None, get_physical_hosting_descriptor=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if cform_buttons_list is None:
            self.cform_buttons_list = []
        else:
            self.cform_buttons_list = cform_buttons_list
        if get_traffic is None:
            self.get_traffic = []
        else:
            self.get_traffic = get_traffic
        if set_traffic is None:
            self.set_traffic = []
        else:
            self.set_traffic = set_traffic
        if get_limit_descriptor is None:
            self.get_limit_descriptor = []
        else:
            self.get_limit_descriptor = get_limit_descriptor
        if get_permission_descriptor is None:
            self.get_permission_descriptor = []
        else:
            self.get_permission_descriptor = get_permission_descriptor
        if get_physical_hosting_descriptor is None:
            self.get_physical_hosting_descriptor = []
        else:
            self.get_physical_hosting_descriptor = get_physical_hosting_descriptor
    def factory(*args_, **kwargs_):
        if DomainResponseType.subclass:
            return DomainResponseType.subclass(*args_, **kwargs_)
        else:
            return DomainResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getCform_buttons_list(self): return self.cform_buttons_list
    def setCform_buttons_list(self, value): self.cform_buttons_list = value
    def addCform_buttons_list(self, value): self.cform_buttons_list.append(value)
    def insertCform_buttons_list(self, index, value): self.cform_buttons_list[index] = value
    def getGet_traffic(self): return self.get_traffic
    def setGet_traffic(self, value): self.get_traffic = value
    def addGet_traffic(self, value): self.get_traffic.append(value)
    def insertGet_traffic(self, index, value): self.get_traffic[index] = value
    def getSet_traffic(self): return self.set_traffic
    def setSet_traffic(self, value): self.set_traffic = value
    def addSet_traffic(self, value): self.set_traffic.append(value)
    def insertSet_traffic(self, index, value): self.set_traffic[index] = value
    def getGet_limit_descriptor(self): return self.get_limit_descriptor
    def setGet_limit_descriptor(self, value): self.get_limit_descriptor = value
    def addGet_limit_descriptor(self, value): self.get_limit_descriptor.append(value)
    def insertGet_limit_descriptor(self, index, value): self.get_limit_descriptor[index] = value
    def getGet_permission_descriptor(self): return self.get_permission_descriptor
    def setGet_permission_descriptor(self, value): self.get_permission_descriptor = value
    def addGet_permission_descriptor(self, value): self.get_permission_descriptor.append(value)
    def insertGet_permission_descriptor(self, index, value): self.get_permission_descriptor[index] = value
    def getGet_physical_hosting_descriptor(self): return self.get_physical_hosting_descriptor
    def setGet_physical_hosting_descriptor(self, value): self.get_physical_hosting_descriptor = value
    def addGet_physical_hosting_descriptor(self, value): self.get_physical_hosting_descriptor.append(value)
    def insertGet_physical_hosting_descriptor(self, index, value): self.get_physical_hosting_descriptor[index] = value
    def export(self, outfile, level, name_='DomainResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainResponseType'):
        for add_ in self.getAdd():
            add_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for del_ in self.getDel():
            del_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for cform_buttons_list_ in self.getCform_buttons_list():
            cform_buttons_list_.export(outfile, level)
        for get_traffic_ in self.getGet_traffic():
            get_traffic_.export(outfile, level)
        for set_traffic_ in self.getSet_traffic():
            set_traffic_.export(outfile, level)
        for get_limit_descriptor_ in self.getGet_limit_descriptor():
            get_limit_descriptor_.export(outfile, level)
        for get_permission_descriptor_ in self.getGet_permission_descriptor():
            get_permission_descriptor_.export(outfile, level)
        for get_physical_hosting_descriptor_ in self.getGet_physical_hosting_descriptor():
            get_physical_hosting_descriptor_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = add.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ddel.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cform_buttons_list':
            obj_ = cform_buttons_list.factory()
            obj_.build(child_)
            self.cform_buttons_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_traffic':
            obj_ = get_traffic.factory()
            obj_.build(child_)
            self.get_traffic.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set_traffic':
            obj_ = set_traffic.factory()
            obj_.build(child_)
            self.set_traffic.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-limit-descriptor':
            obj_ = get_limit_descriptor.factory()
            obj_.build(child_)
            self.get_limit_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-permission-descriptor':
            obj_ = get_permission_descriptor.factory()
            obj_.build(child_)
            self.get_permission_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-physical-hosting-descriptor':
            obj_ = get_physical_hosting_descriptor.factory()
            obj_.build(child_)
            self.get_physical_hosting_descriptor.append(obj_)
# end class DomainResponseType


class Settings:
    subclass = None
    def __init__(self, status=None, pref=None, manage_dns=None):
        self.status = status
        self.pref = pref
        self.manage_dns = manage_dns
    def factory(*args_, **kwargs_):
        if Settings.subclass:
            return Settings.subclass(*args_, **kwargs_)
        else:
            return Settings(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPref(self): return self.pref
    def setPref(self, value): self.pref = value
    def getManage_dns(self): return self.manage_dns
    def setManage_dns(self, value): self.manage_dns = value
    def export(self, outfile, level, name_='Settings'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='Settings'):
        pass
    def exportChildren(self, outfile, level, name_='Settings'):
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.pref is not None:
            self.pref.export(outfile, level)
        if self.manage_dns is not None:
            showIndent(outfile, level)
            outfile.write('<manage-dns>%s</manage-dns>\n' % quote_xml(self.getManage_dns()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pref':
            obj_ = pref.factory()
            obj_.build(child_)
            self.setPref(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'manage-dns':
            manage_dns_ = ''
            for text__content_ in child_.childNodes:
                manage_dns_ += text__content_.nodeValue
            self.manage_dns = manage_dns_
# end class Settings


class aliasResultType(resultType):
    subclass = None
    def __init__(self, id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if aliasResultType.subclass:
            return aliasResultType.subclass(*args_, **kwargs_)
        else:
            return aliasResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='aliasResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='aliasResultType'):
        resultType.exportAttributes(self, outfile, level, name_='aliasResultType')
    def exportChildren(self, outfile, level, name_='aliasResultType'):
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class aliasResultType


class DomainAliasResponseType:
    subclass = None
    def __init__(self, create=None, rename=None, get=None, delete=None, set=None, get_supported_services=None):
        if create is None:
            self.create = []
        else:
            self.create = create
        if rename is None:
            self.rename = []
        else:
            self.rename = rename
        if get is None:
            self.get = []
        else:
            self.get = get
        if delete is None:
            self.delete = []
        else:
            self.delete = delete
        if set is None:
            self.set = []
        else:
            self.set = set
        if get_supported_services is None:
            self.get_supported_services = []
        else:
            self.get_supported_services = get_supported_services
    def factory(*args_, **kwargs_):
        if DomainAliasResponseType.subclass:
            return DomainAliasResponseType.subclass(*args_, **kwargs_)
        else:
            return DomainAliasResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCreate(self): return self.create
    def setCreate(self, value): self.create = value
    def addCreate(self, value): self.create.append(value)
    def insertCreate(self, index, value): self.create[index] = value
    def getRename(self): return self.rename
    def setRename(self, value): self.rename = value
    def addRename(self, value): self.rename.append(value)
    def insertRename(self, index, value): self.rename[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDelete(self): return self.delete
    def setDelete(self, value): self.delete = value
    def addDelete(self, value): self.delete.append(value)
    def insertDelete(self, index, value): self.delete[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet_supported_services(self): return self.get_supported_services
    def setGet_supported_services(self, value): self.get_supported_services = value
    def addGet_supported_services(self, value): self.get_supported_services.append(value)
    def insertGet_supported_services(self, index, value): self.get_supported_services[index] = value
    def export(self, outfile, level, name_='DomainAliasResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainAliasResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainAliasResponseType'):
        for create_ in self.getCreate():
            create_.export(outfile, level)
        for rename_ in self.getRename():
            rename_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for delete_ in self.getDelete():
            delete_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for get_supported_services_ in self.getGet_supported_services():
            get_supported_services_.export(outfile, level, name_='get-supported-services')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create':
            obj_ = create.factory()
            obj_.build(child_)
            self.create.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rename':
            obj_ = rename.factory()
            obj_.build(child_)
            self.rename.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete':
            obj_ = delete.factory()
            obj_.build(child_)
            self.delete.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-services':
            obj_ = DAGetSupportedServicesOutputType.factory()
            obj_.build(child_)
            self.get_supported_services.append(obj_)
# end class DomainAliasResponseType


class DAGetSupportedServicesOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DAGetSupportedServicesOutputType.subclass:
            return DAGetSupportedServicesOutputType.subclass(*args_, **kwargs_)
        else:
            return DAGetSupportedServicesOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DAGetSupportedServicesOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DAGetSupportedServicesOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DAGetSupportedServicesOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DAGetSupportedServicesOutputType


class EventLogResponseType:
    subclass = None
    def __init__(self, get=None, get_events=None, get_last_id=None):
        if get is None:
            self.get = []
        else:
            self.get = get
        if get_events is None:
            self.get_events = []
        else:
            self.get_events = get_events
        if get_last_id is None:
            self.get_last_id = []
        else:
            self.get_last_id = get_last_id
    def factory(*args_, **kwargs_):
        if EventLogResponseType.subclass:
            return EventLogResponseType.subclass(*args_, **kwargs_)
        else:
            return EventLogResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getGet_events(self): return self.get_events
    def setGet_events(self, value): self.get_events = value
    def addGet_events(self, value): self.get_events.append(value)
    def insertGet_events(self, index, value): self.get_events[index] = value
    def getGet_last_id(self): return self.get_last_id
    def setGet_last_id(self, value): self.get_last_id = value
    def addGet_last_id(self, value): self.get_last_id.append(value)
    def insertGet_last_id(self, index, value): self.get_last_id[index] = value
    def export(self, outfile, level, name_='EventLogResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='EventLogResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='EventLogResponseType'):
        for get_ in self.getGet():
            get_.export(outfile, level)
        for get_events_ in self.getGet_events():
            get_events_.export(outfile, level)
        for get_last_id_ in self.getGet_last_id():
            get_last_id_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_events':
            obj_ = get_events.factory()
            obj_.build(child_)
            self.get_events.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-last-id':
            obj_ = get_last_id.factory()
            obj_.build(child_)
            self.get_last_id.append(obj_)
# end class EventLogResponseType


class IpResponseType:
    subclass = None
    def __init__(self, add=None, get=None, set=None, ddel=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if set is None:
            self.set = []
        else:
            self.set = set
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
    def factory(*args_, **kwargs_):
        if IpResponseType.subclass:
            return IpResponseType.subclass(*args_, **kwargs_)
        else:
            return IpResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def export(self, outfile, level, name_='IpResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='IpResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='IpResponseType'):
        for add_ in self.getAdd():
            add_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level)
        for set_ in self.getSet():
            set_.export(outfile, level)
        for del_ in self.getDel():
            del_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = add.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ddel.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
# end class IpResponseType


class mailnameType:
    subclass = None
    def __init__(self, id=None, name='', cp_access=None, mailbox=None, redirect=None, mailgroup=None, group=None, alias=None, autoresponders=None, repository=None, password=None, password_type=None, antivir=None, permissions=None):
        self.id = id
        self.name = name
        self.cp_access = cp_access
        self.mailbox = mailbox
        self.redirect = redirect
        self.mailgroup = mailgroup
        if group is None:
            self.group = []
        else:
            self.group = group
        if alias is None:
            self.alias = []
        else:
            self.alias = alias
        self.autoresponders = autoresponders
        self.repository = repository
        self.password = password
        self.password_type = password_type
        self.antivir = antivir
        self.permissions = permissions
    def factory(*args_, **kwargs_):
        if mailnameType.subclass:
            return mailnameType.subclass(*args_, **kwargs_)
        else:
            return mailnameType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getCp_access(self): return self.cp_access
    def setCp_access(self, value): self.cp_access = value
    def getMailbox(self): return self.mailbox
    def setMailbox(self, value): self.mailbox = value
    def getRedirect(self): return self.redirect
    def setRedirect(self, value): self.redirect = value
    def getMailgroup(self): return self.mailgroup
    def setMailgroup(self, value): self.mailgroup = value
    def getGroup(self): return self.group
    def setGroup(self, value): self.group = value
    def addGroup(self, value): self.group.append(value)
    def insertGroup(self, index, value): self.group[index] = value
    def getAlias(self): return self.alias
    def setAlias(self, value): self.alias = value
    def addAlias(self, value): self.alias.append(value)
    def insertAlias(self, index, value): self.alias[index] = value
    def getAutoresponders(self): return self.autoresponders
    def setAutoresponders(self, value): self.autoresponders = value
    def getRepository(self): return self.repository
    def setRepository(self, value): self.repository = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def getAntivir(self): return self.antivir
    def setAntivir(self, value): self.antivir = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def export(self, outfile, level, name_='mailnameType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='mailnameType'):
        pass
    def exportChildren(self, outfile, level, name_='mailnameType'):
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.cp_access is not None:
            self.cp_access.export(outfile, level)
        if self.mailbox is not None:
            self.mailbox.export(outfile, level)
        if self.redirect is not None:
            self.redirect.export(outfile, level)
        if self.mailgroup is not None:
            self.mailgroup.export(outfile, level)
        for group_ in self.getGroup():
            showIndent(outfile, level)
            outfile.write('<group>%s</group>\n' % quote_xml(group_))
        for alias_ in self.getAlias():
            showIndent(outfile, level)
            outfile.write('<alias>%s</alias>\n' % quote_xml(alias_))
        if self.autoresponders is not None:
            self.autoresponders.export(outfile, level)
        if self.repository is not None:
            self.repository.export(outfile, level)
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password_type>%s</password_type>\n' % quote_xml(self.getPassword_type()))
        if self.antivir is not None:
            showIndent(outfile, level)
            outfile.write('<antivir>%s</antivir>\n' % quote_xml(self.getAntivir()))
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cp_access':
            obj_ = cp_access.factory()
            obj_.build(child_)
            self.setCp_access(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mailbox':
            obj_ = mailbox.factory()
            obj_.build(child_)
            self.setMailbox(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'redirect':
            obj_ = redirect.factory()
            obj_.build(child_)
            self.setRedirect(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mailgroup':
            obj_ = mailgroup.factory()
            obj_.build(child_)
            self.setMailgroup(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'group':
            group_ = ''
            for text__content_ in child_.childNodes:
                group_ += text__content_.nodeValue
            self.addGroup(group_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'alias':
            alias_ = ''
            for text__content_ in child_.childNodes:
                alias_ += text__content_.nodeValue
            self.addAlias(alias_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'autoresponders':
            obj_ = autoresponders.factory()
            obj_.build(child_)
            self.setAutoresponders(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'repository':
            obj_ = repository.factory()
            obj_.build(child_)
            self.setRepository(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password_type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'antivir':
            antivir_ = ''
            for text__content_ in child_.childNodes:
                antivir_ += text__content_.nodeValue
            self.antivir = antivir_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = MailUserPermission.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
# end class mailnameType


class MailPreferences:
    subclass = None
    def __init__(self, nonexistent_user=None, webmail=None, spam_protect_sign=None):
        self.nonexistent_user = nonexistent_user
        self.webmail = webmail
        self.spam_protect_sign = spam_protect_sign
    def factory(*args_, **kwargs_):
        if MailPreferences.subclass:
            return MailPreferences.subclass(*args_, **kwargs_)
        else:
            return MailPreferences(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getNonexistent_user(self): return self.nonexistent_user
    def setNonexistent_user(self, value): self.nonexistent_user = value
    def getWebmail(self): return self.webmail
    def setWebmail(self, value): self.webmail = value
    def getSpam_protect_sign(self): return self.spam_protect_sign
    def setSpam_protect_sign(self, value): self.spam_protect_sign = value
    def export(self, outfile, level, name_='MailPreferences'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailPreferences'):
        pass
    def exportChildren(self, outfile, level, name_='MailPreferences'):
        if self.nonexistent_user is not None:
            self.nonexistent_user.export(outfile, level)
        if self.webmail is not None:
            showIndent(outfile, level)
            outfile.write('<webmail>%s</webmail>\n' % quote_xml(self.getWebmail()))
        if self.spam_protect_sign is not None:
            showIndent(outfile, level)
            outfile.write('<spam-protect-sign>%s</spam-protect-sign>\n' % quote_xml(self.getSpam_protect_sign()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'nonexistent-user':
            obj_ = nonexistent_user.factory()
            obj_.build(child_)
            self.setNonexistent_user(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webmail':
            webmail_ = ''
            for text__content_ in child_.childNodes:
                webmail_ += text__content_.nodeValue
            self.webmail = webmail_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spam-protect-sign':
            spam_protect_sign_ = ''
            for text__content_ in child_.childNodes:
                spam_protect_sign_ += text__content_.nodeValue
            self.spam_protect_sign = spam_protect_sign_
# end class MailPreferences


class MailUserPermission:
    subclass = None
    def __init__(self, permission=None):
        if permission is None:
            self.permission = []
        else:
            self.permission = permission
    def factory(*args_, **kwargs_):
        if MailUserPermission.subclass:
            return MailUserPermission.subclass(*args_, **kwargs_)
        else:
            return MailUserPermission(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPermission(self): return self.permission
    def setPermission(self, value): self.permission = value
    def addPermission(self, value): self.permission.append(value)
    def insertPermission(self, index, value): self.permission[index] = value
    def export(self, outfile, level, name_='MailUserPermission'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailUserPermission'):
        pass
    def exportChildren(self, outfile, level, name_='MailUserPermission'):
        for permission_ in self.getPermission():
            permission_.export(outfile, level, name_='permission')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permission':
            obj_ = PleskPermissionType.factory()
            obj_.build(child_)
            self.permission.append(obj_)
# end class MailUserPermission


class operationresultType(resultType):
    subclass = None
    def __init__(self, mailname=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.mailname = mailname
    def factory(*args_, **kwargs_):
        if operationresultType.subclass:
            return operationresultType.subclass(*args_, **kwargs_)
        else:
            return operationresultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMailname(self): return self.mailname
    def setMailname(self, value): self.mailname = value
    def export(self, outfile, level, name_='operationresultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='operationresultType'):
        resultType.exportAttributes(self, outfile, level, name_='operationresultType')
    def exportChildren(self, outfile, level, name_='operationresultType'):
        if self.mailname is not None:
            self.mailname.export(outfile, level, name_='mailname')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mailname':
            obj_ = mailnameType.factory()
            obj_.build(child_)
            self.setMailname(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class operationresultType


class MailResponseType:
    subclass = None
    def __init__(self, create=None, update=None, get_info=None, enable=None, disable=None, remove=None, set_prefs=None, get_prefs=None, rename=None, get_supported_webmail=None, get_available_webmail=None):
        if create is None:
            self.create = []
        else:
            self.create = create
        if update is None:
            self.update = []
        else:
            self.update = update
        if get_info is None:
            self.get_info = []
        else:
            self.get_info = get_info
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
        if set_prefs is None:
            self.set_prefs = []
        else:
            self.set_prefs = set_prefs
        if get_prefs is None:
            self.get_prefs = []
        else:
            self.get_prefs = get_prefs
        if rename is None:
            self.rename = []
        else:
            self.rename = rename
        if get_supported_webmail is None:
            self.get_supported_webmail = []
        else:
            self.get_supported_webmail = get_supported_webmail
        if get_available_webmail is None:
            self.get_available_webmail = []
        else:
            self.get_available_webmail = get_available_webmail
    def factory(*args_, **kwargs_):
        if MailResponseType.subclass:
            return MailResponseType.subclass(*args_, **kwargs_)
        else:
            return MailResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCreate(self): return self.create
    def setCreate(self, value): self.create = value
    def addCreate(self, value): self.create.append(value)
    def insertCreate(self, index, value): self.create[index] = value
    def getUpdate(self): return self.update
    def setUpdate(self, value): self.update = value
    def addUpdate(self, value): self.update.append(value)
    def insertUpdate(self, index, value): self.update[index] = value
    def getGet_info(self): return self.get_info
    def setGet_info(self, value): self.get_info = value
    def addGet_info(self, value): self.get_info.append(value)
    def insertGet_info(self, index, value): self.get_info[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def getSet_prefs(self): return self.set_prefs
    def setSet_prefs(self, value): self.set_prefs = value
    def addSet_prefs(self, value): self.set_prefs.append(value)
    def insertSet_prefs(self, index, value): self.set_prefs[index] = value
    def getGet_prefs(self): return self.get_prefs
    def setGet_prefs(self, value): self.get_prefs = value
    def addGet_prefs(self, value): self.get_prefs.append(value)
    def insertGet_prefs(self, index, value): self.get_prefs[index] = value
    def getRename(self): return self.rename
    def setRename(self, value): self.rename = value
    def addRename(self, value): self.rename.append(value)
    def insertRename(self, index, value): self.rename[index] = value
    def getGet_supported_webmail(self): return self.get_supported_webmail
    def setGet_supported_webmail(self, value): self.get_supported_webmail = value
    def addGet_supported_webmail(self, value): self.get_supported_webmail.append(value)
    def insertGet_supported_webmail(self, index, value): self.get_supported_webmail[index] = value
    def getGet_available_webmail(self): return self.get_available_webmail
    def setGet_available_webmail(self, value): self.get_available_webmail = value
    def addGet_available_webmail(self, value): self.get_available_webmail.append(value)
    def insertGet_available_webmail(self, index, value): self.get_available_webmail[index] = value
    def export(self, outfile, level, name_='MailResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='MailResponseType'):
        for create_ in self.getCreate():
            create_.export(outfile, level)
        for update_ in self.getUpdate():
            update_.export(outfile, level)
        for get_info_ in self.getGet_info():
            get_info_.export(outfile, level)
        for enable_ in self.getEnable():
            enable_.export(outfile, level)
        for disable_ in self.getDisable():
            disable_.export(outfile, level)
        for remove_ in self.getRemove():
            remove_.export(outfile, level)
        for set_prefs_ in self.getSet_prefs():
            set_prefs_.export(outfile, level)
        for get_prefs_ in self.getGet_prefs():
            get_prefs_.export(outfile, level)
        for rename_ in self.getRename():
            rename_.export(outfile, level)
        for get_supported_webmail_ in self.getGet_supported_webmail():
            get_supported_webmail_.export(outfile, level)
        for get_available_webmail_ in self.getGet_available_webmail():
            get_available_webmail_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create':
            obj_ = create.factory()
            obj_.build(child_)
            self.create.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'update':
            obj_ = update.factory()
            obj_.build(child_)
            self.update.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_info':
            obj_ = get_info.factory()
            obj_.build(child_)
            self.get_info.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = enable.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = disable.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = remove.factory()
            obj_.build(child_)
            self.remove.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set_prefs':
            obj_ = set_prefs.factory()
            obj_.build(child_)
            self.set_prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_prefs':
            obj_ = get_prefs.factory()
            obj_.build(child_)
            self.get_prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rename':
            obj_ = rename.factory()
            obj_.build(child_)
            self.rename.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-webmail':
            obj_ = get_supported_webmail.factory()
            obj_.build(child_)
            self.get_supported_webmail.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-available-webmail':
            obj_ = get_available_webmail.factory()
            obj_.build(child_)
            self.get_available_webmail.append(obj_)
# end class MailResponseType


class WebmailResultType(resultType):
    subclass = None
    def __init__(self, webmail=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        if webmail is None:
            self.webmail = []
        else:
            self.webmail = webmail
    def factory(*args_, **kwargs_):
        if WebmailResultType.subclass:
            return WebmailResultType.subclass(*args_, **kwargs_)
        else:
            return WebmailResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getWebmail(self): return self.webmail
    def setWebmail(self, value): self.webmail = value
    def addWebmail(self, value): self.webmail.append(value)
    def insertWebmail(self, index, value): self.webmail[index] = value
    def export(self, outfile, level, name_='WebmailResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebmailResultType'):
        resultType.exportAttributes(self, outfile, level, name_='WebmailResultType')
    def exportChildren(self, outfile, level, name_='WebmailResultType'):
        for webmail_ in self.getWebmail():
            showIndent(outfile, level)
            outfile.write('<webmail>%s</webmail>\n' % quote_xml(webmail_))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webmail':
            webmail_ = ''
            for text__content_ in child_.childNodes:
                webmail_ += text__content_.nodeValue
            self.addWebmail(webmail_)
        resultType.buildChildren(self, child_, nodeName_)
# end class WebmailResultType


class MigrationArguments:
    subclass = None
    def __init__(self, host='', login='', password='', source_host_directory='', destination_host_directory='', system_type=None, selected_objects=None):
        self.host = host
        self.login = login
        self.password = password
        self.source_host_directory = source_host_directory
        self.destination_host_directory = destination_host_directory
        self.system_type = system_type
        self.selected_objects = selected_objects
    def factory(*args_, **kwargs_):
        if MigrationArguments.subclass:
            return MigrationArguments.subclass(*args_, **kwargs_)
        else:
            return MigrationArguments(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getSource_host_directory(self): return self.source_host_directory
    def setSource_host_directory(self, value): self.source_host_directory = value
    def getDestination_host_directory(self): return self.destination_host_directory
    def setDestination_host_directory(self, value): self.destination_host_directory = value
    def getSystem_type(self): return self.system_type
    def setSystem_type(self, value): self.system_type = value
    def getSelected_objects(self): return self.selected_objects
    def setSelected_objects(self, value): self.selected_objects = value
    def export(self, outfile, level, name_='MigrationArguments'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationArguments'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationArguments'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        showIndent(outfile, level)
        outfile.write('<source-host-directory>%s</source-host-directory>\n' % quote_xml(self.getSource_host_directory()))
        showIndent(outfile, level)
        outfile.write('<destination-host-directory>%s</destination-host-directory>\n' % quote_xml(self.getDestination_host_directory()))
        if self.system_type is not None:
            showIndent(outfile, level)
            outfile.write('<system-type>%s</system-type>\n' % quote_xml(self.getSystem_type()))
        if self.selected_objects is not None:
            self.selected_objects.export(outfile, level, name_='selected-objects')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'source-host-directory':
            source_host_directory_ = ''
            for text__content_ in child_.childNodes:
                source_host_directory_ += text__content_.nodeValue
            self.source_host_directory = source_host_directory_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'destination-host-directory':
            destination_host_directory_ = ''
            for text__content_ in child_.childNodes:
                destination_host_directory_ += text__content_.nodeValue
            self.destination_host_directory = destination_host_directory_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'system-type':
            system_type_ = ''
            for text__content_ in child_.childNodes:
                system_type_ += text__content_.nodeValue
            self.system_type = system_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'selected-objects':
            obj_ = SelectedObjects.factory()
            obj_.build(child_)
            self.setSelected_objects(obj_)
# end class MigrationArguments


class ActionGetStatusResponse:
    subclass = None
    def __init__(self, working=None, finished=None):
        self.working = working
        self.finished = finished
    def factory(*args_, **kwargs_):
        if ActionGetStatusResponse.subclass:
            return ActionGetStatusResponse.subclass(*args_, **kwargs_)
        else:
            return ActionGetStatusResponse(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getWorking(self): return self.working
    def setWorking(self, value): self.working = value
    def getFinished(self): return self.finished
    def setFinished(self, value): self.finished = value
    def export(self, outfile, level, name_='ActionGetStatusResponse'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ActionGetStatusResponse'):
        pass
    def exportChildren(self, outfile, level, name_='ActionGetStatusResponse'):
        if self.working is not None:
            self.working.export(outfile, level, name_='working')
        if self.finished is not None:
            self.finished.export(outfile, level, name_='finished')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'working':
            obj_ = StatusWorking.factory()
            obj_.build(child_)
            self.setWorking(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'finished':
            obj_ = StatusFinished.factory()
            obj_.build(child_)
            self.setFinished(obj_)
# end class ActionGetStatusResponse


class SelectedObjects:
    subclass = None
    def __init__(self, migrate_clients=None, migrate_domains=None):
        self.migrate_clients = migrate_clients
        if migrate_domains is None:
            self.migrate_domains = []
        else:
            self.migrate_domains = migrate_domains
    def factory(*args_, **kwargs_):
        if SelectedObjects.subclass:
            return SelectedObjects.subclass(*args_, **kwargs_)
        else:
            return SelectedObjects(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMigrate_clients(self): return self.migrate_clients
    def setMigrate_clients(self, value): self.migrate_clients = value
    def getMigrate_domains(self): return self.migrate_domains
    def setMigrate_domains(self, value): self.migrate_domains = value
    def addMigrate_domains(self, value): self.migrate_domains.append(value)
    def insertMigrate_domains(self, index, value): self.migrate_domains[index] = value
    def export(self, outfile, level, name_='SelectedObjects'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SelectedObjects'):
        pass
    def exportChildren(self, outfile, level, name_='SelectedObjects'):
        if self.migrate_clients is not None:
            self.migrate_clients.export(outfile, level, name_='migrate-clients')
        for migrate_domains_ in self.getMigrate_domains():
            migrate_domains_.export(outfile, level, name_='migrate-domains')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migrate-clients':
            obj_ = SelectedClients.factory()
            obj_.build(child_)
            self.setMigrate_clients(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migrate-domains':
            obj_ = SelectedDomains.factory()
            obj_.build(child_)
            self.migrate_domains.append(obj_)
# end class SelectedObjects


class SelectedDomains:
    subclass = None
    def __init__(self, target_client='', domain=None):
        self.target_client = target_client
        if domain is None:
            self.domain = []
        else:
            self.domain = domain
    def factory(*args_, **kwargs_):
        if SelectedDomains.subclass:
            return SelectedDomains.subclass(*args_, **kwargs_)
        else:
            return SelectedDomains(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTarget_client(self): return self.target_client
    def setTarget_client(self, value): self.target_client = value
    def getDomain(self): return self.domain
    def setDomain(self, value): self.domain = value
    def addDomain(self, value): self.domain.append(value)
    def insertDomain(self, index, value): self.domain[index] = value
    def export(self, outfile, level, name_='SelectedDomains'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SelectedDomains'):
        pass
    def exportChildren(self, outfile, level, name_='SelectedDomains'):
        showIndent(outfile, level)
        outfile.write('<target-client>%s</target-client>\n' % quote_xml(self.getTarget_client()))
        for domain_ in self.getDomain():
            domain_.export(outfile, level, name_='domain')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'target-client':
            target_client_ = ''
            for text__content_ in child_.childNodes:
                target_client_ += text__content_.nodeValue
            self.target_client = target_client_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain':
            obj_ = MappedDomain.factory()
            obj_.build(child_)
            self.domain.append(obj_)
# end class SelectedDomains


class SelectedClients:
    subclass = None
    def __init__(self, client=None):
        if client is None:
            self.client = []
        else:
            self.client = client
    def factory(*args_, **kwargs_):
        if SelectedClients.subclass:
            return SelectedClients.subclass(*args_, **kwargs_)
        else:
            return SelectedClients(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getClient(self): return self.client
    def setClient(self, value): self.client = value
    def addClient(self, value): self.client.append(value)
    def insertClient(self, index, value): self.client[index] = value
    def export(self, outfile, level, name_='SelectedClients'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SelectedClients'):
        pass
    def exportChildren(self, outfile, level, name_='SelectedClients'):
        for client_ in self.getClient():
            client_.export(outfile, level, name_='client')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client':
            obj_ = MappedClient.factory()
            obj_.build(child_)
            self.client.append(obj_)
# end class SelectedClients


class StatusWorking:
    subclass = None
    def __init__(self, idle=None, starting=None, translate=None, deploy=None, agent=None, dumping=None, transfer=None):
        self.idle = idle
        self.starting = starting
        self.translate = translate
        self.deploy = deploy
        self.agent = agent
        self.dumping = dumping
        self.transfer = transfer
    def factory(*args_, **kwargs_):
        if StatusWorking.subclass:
            return StatusWorking.subclass(*args_, **kwargs_)
        else:
            return StatusWorking(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdle(self): return self.idle
    def setIdle(self, value): self.idle = value
    def getStarting(self): return self.starting
    def setStarting(self, value): self.starting = value
    def getTranslate(self): return self.translate
    def setTranslate(self, value): self.translate = value
    def getDeploy(self): return self.deploy
    def setDeploy(self, value): self.deploy = value
    def getAgent(self): return self.agent
    def setAgent(self, value): self.agent = value
    def getDumping(self): return self.dumping
    def setDumping(self, value): self.dumping = value
    def getTransfer(self): return self.transfer
    def setTransfer(self, value): self.transfer = value
    def export(self, outfile, level, name_='StatusWorking'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorking'):
        pass
    def exportChildren(self, outfile, level, name_='StatusWorking'):
        if self.idle is not None:
            self.idle.export(outfile, level, name_='idle')
        if self.starting is not None:
            self.starting.export(outfile, level, name_='starting')
        if self.translate is not None:
            self.translate.export(outfile, level, name_='translate')
        if self.deploy is not None:
            self.deploy.export(outfile, level, name_='deploy')
        if self.agent is not None:
            self.agent.export(outfile, level, name_='agent')
        if self.dumping is not None:
            self.dumping.export(outfile, level, name_='dumping')
        if self.transfer is not None:
            self.transfer.export(outfile, level, name_='transfer')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idle':
            obj_ = StatusWorkingIdle.factory()
            obj_.build(child_)
            self.setIdle(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'starting':
            obj_ = StatusWorkingStarting.factory()
            obj_.build(child_)
            self.setStarting(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'translate':
            obj_ = StatusWorkingTranslate.factory()
            obj_.build(child_)
            self.setTranslate(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'deploy':
            obj_ = StatusWorkingDeploy.factory()
            obj_.build(child_)
            self.setDeploy(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'agent':
            obj_ = StatusWorkingAgent.factory()
            obj_.build(child_)
            self.setAgent(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dumping':
            obj_ = MigrationAgentStatusWorkingDumping.factory()
            obj_.build(child_)
            self.setDumping(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'transfer':
            obj_ = StatusWorkingTransfer.factory()
            obj_.build(child_)
            self.setTransfer(obj_)
# end class StatusWorking


class StatusWorkingIdle:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StatusWorkingIdle.subclass:
            return StatusWorkingIdle.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingIdle(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='StatusWorkingIdle'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingIdle'):
        pass
    def exportChildren(self, outfile, level, name_='StatusWorkingIdle'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class StatusWorkingIdle


class StatusWorkingStarting:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StatusWorkingStarting.subclass:
            return StatusWorkingStarting.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingStarting(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='StatusWorkingStarting'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingStarting'):
        pass
    def exportChildren(self, outfile, level, name_='StatusWorkingStarting'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class StatusWorkingStarting


class StatusWorkingTranslate:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StatusWorkingTranslate.subclass:
            return StatusWorkingTranslate.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingTranslate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='StatusWorkingTranslate'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingTranslate'):
        pass
    def exportChildren(self, outfile, level, name_='StatusWorkingTranslate'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class StatusWorkingTranslate


class StatusWorkingAgent:
    subclass = None
    def __init__(self, action=None, host=''):
        self.action = action
        self.host = host
    def factory(*args_, **kwargs_):
        if StatusWorkingAgent.subclass:
            return StatusWorkingAgent.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingAgent(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getAction(self): return self.action
    def setAction(self, value): self.action = value
    def export(self, outfile, level, name_='StatusWorkingAgent'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='StatusWorkingAgent')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingAgent'):
        if self.getAction() is not None:
            outfile.write(' action="%s"' % (quote_attrib(self.getAction()), ))
    def exportChildren(self, outfile, level, name_='StatusWorkingAgent'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('action'):
            self.action = attrs.get('action').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
# end class StatusWorkingAgent


class StatusWorkingTransfer:
    subclass = None
    def __init__(self, speed=None, host='', dumpfile=None, files=None):
        self.speed = speed
        self.host = host
        self.dumpfile = dumpfile
        self.files = files
    def factory(*args_, **kwargs_):
        if StatusWorkingTransfer.subclass:
            return StatusWorkingTransfer.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingTransfer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getDumpfile(self): return self.dumpfile
    def setDumpfile(self, value): self.dumpfile = value
    def getFiles(self): return self.files
    def setFiles(self, value): self.files = value
    def getSpeed(self): return self.speed
    def setSpeed(self, value): self.speed = value
    def export(self, outfile, level, name_='StatusWorkingTransfer'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='StatusWorkingTransfer')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingTransfer'):
        if self.getSpeed() is not None:
            outfile.write(' speed="%s"' % (quote_attrib(self.getSpeed()), ))
    def exportChildren(self, outfile, level, name_='StatusWorkingTransfer'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        if self.dumpfile is not None:
            self.dumpfile.export(outfile, level, name_='dumpfile')
        if self.files is not None:
            self.files.export(outfile, level, name_='files')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('speed'):
            self.speed = attrs.get('speed').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dumpfile':
            obj_ = StatusWorkingTransferDumpFile.factory()
            obj_.build(child_)
            self.setDumpfile(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'files':
            obj_ = TransferFiles.factory()
            obj_.build(child_)
            self.setFiles(obj_)
# end class StatusWorkingTransfer


class StatusWorkingTransferDumpFile:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StatusWorkingTransferDumpFile.subclass:
            return StatusWorkingTransferDumpFile.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingTransferDumpFile(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='StatusWorkingTransferDumpFile'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingTransferDumpFile'):
        pass
    def exportChildren(self, outfile, level, name_='StatusWorkingTransferDumpFile'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class StatusWorkingTransferDumpFile


class TransferFiles:
    subclass = None
    def __init__(self, size_total=None, total='', size_left=None, left='', current_file=None):
        self.size_total = size_total
        self.total = total
        self.size_left = size_left
        self.left = left
        self.current_file = current_file
    def factory(*args_, **kwargs_):
        if TransferFiles.subclass:
            return TransferFiles.subclass(*args_, **kwargs_)
        else:
            return TransferFiles(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCurrent_file(self): return self.current_file
    def setCurrent_file(self, value): self.current_file = value
    def getSize_total(self): return self.size_total
    def setSize_total(self, value): self.size_total = value
    def getTotal(self): return self.total
    def setTotal(self, value): self.total = value
    def getSize_left(self): return self.size_left
    def setSize_left(self, value): self.size_left = value
    def getLeft(self): return self.left
    def setLeft(self, value): self.left = value
    def export(self, outfile, level, name_='TransferFiles'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='TransferFiles')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='TransferFiles'):
        if self.getSize_total() is not None:
            outfile.write(' size-total="%s"' % (quote_attrib(self.getSize_total()), ))
        outfile.write(' total="%s"' % (quote_attrib(self.getTotal()), ))
        if self.getSize_left() is not None:
            outfile.write(' size-left="%s"' % (quote_attrib(self.getSize_left()), ))
        outfile.write(' left="%s"' % (quote_attrib(self.getLeft()), ))
    def exportChildren(self, outfile, level, name_='TransferFiles'):
        if self.current_file is not None:
            self.current_file.export(outfile, level, name_='current-file')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('size-total'):
            self.size_total = attrs.get('size-total').value
        if attrs.get('total'):
            self.total = attrs.get('total').value
        if attrs.get('size-left'):
            self.size_left = attrs.get('size-left').value
        if attrs.get('left'):
            self.left = attrs.get('left').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'current-file':
            obj_ = TransferFilesCurrentFileType.factory()
            obj_.build(child_)
            self.setCurrent_file(obj_)
# end class TransferFiles


class TransferFilesCurrentFileType:
    subclass = None
    def __init__(self, size_left=None, size=None, valueOf_=''):
        self.size_left = size_left
        self.size = size
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if TransferFilesCurrentFileType.subclass:
            return TransferFilesCurrentFileType.subclass(*args_, **kwargs_)
        else:
            return TransferFilesCurrentFileType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSize_left(self): return self.size_left
    def setSize_left(self, value): self.size_left = value
    def getSize(self): return self.size
    def setSize(self, value): self.size = value
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='TransferFilesCurrentFileType'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='TransferFilesCurrentFileType')
        outfile.write('>')
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='TransferFilesCurrentFileType'):
        if self.getSize_left() is not None:
            outfile.write(' size-left="%s"' % (quote_attrib(self.getSize_left()), ))
        if self.getSize() is not None:
            outfile.write(' size="%s"' % (quote_attrib(self.getSize()), ))
    def exportChildren(self, outfile, level, name_='TransferFilesCurrentFileType'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('size-left'):
            self.size_left = attrs.get('size-left').value
        if attrs.get('size'):
            self.size = attrs.get('size').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class TransferFilesCurrentFileType


class StatusWorkingDeploy:
    subclass = None
    def __init__(self, domains=-1, accounts_left=-1, accounts=-1, domains_left=-1, current_object=None):
        self.domains = domains
        self.accounts_left = accounts_left
        self.accounts = accounts
        self.domains_left = domains_left
        self.current_object = current_object
    def factory(*args_, **kwargs_):
        if StatusWorkingDeploy.subclass:
            return StatusWorkingDeploy.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingDeploy(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCurrent_object(self): return self.current_object
    def setCurrent_object(self, value): self.current_object = value
    def getDomains(self): return self.domains
    def setDomains(self, value): self.domains = value
    def getAccounts_left(self): return self.accounts_left
    def setAccounts_left(self, value): self.accounts_left = value
    def getAccounts(self): return self.accounts
    def setAccounts(self, value): self.accounts = value
    def getDomains_left(self): return self.domains_left
    def setDomains_left(self, value): self.domains_left = value
    def export(self, outfile, level, name_='StatusWorkingDeploy'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='StatusWorkingDeploy')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingDeploy'):
        outfile.write(' domains="%s"' % (quote_attrib(self.getDomains()), ))
        outfile.write(' accounts-left="%s"' % (quote_attrib(self.getAccounts_left()), ))
        outfile.write(' accounts="%s"' % (quote_attrib(self.getAccounts()), ))
        outfile.write(' domains-left="%s"' % (quote_attrib(self.getDomains_left()), ))
    def exportChildren(self, outfile, level, name_='StatusWorkingDeploy'):
        if self.current_object is not None:
            self.current_object.export(outfile, level, name_='current-object')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('domains'):
            try:
                self.domains = long(attrs.get('domains').value)
            except ValueError:
                raise ValueError('Bad integer attribute (domains)')
        if attrs.get('accounts-left'):
            try:
                self.accounts_left = long(attrs.get('accounts-left').value)
            except ValueError:
                raise ValueError('Bad integer attribute (accounts-left)')
        if attrs.get('accounts'):
            try:
                self.accounts = long(attrs.get('accounts').value)
            except ValueError:
                raise ValueError('Bad integer attribute (accounts)')
        if attrs.get('domains-left'):
            try:
                self.domains_left = long(attrs.get('domains-left').value)
            except ValueError:
                raise ValueError('Bad integer attribute (domains-left)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'current-object':
            obj_ = StatusWorkingDeployCurrentObject.factory()
            obj_.build(child_)
            self.setCurrent_object(obj_)
# end class StatusWorkingDeploy


class StatusWorkingDeployCurrentObject:
    subclass = None
    def __init__(self, ttype='', valueOf_=''):
        self.ttype = ttype
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StatusWorkingDeployCurrentObject.subclass:
            return StatusWorkingDeployCurrentObject.subclass(*args_, **kwargs_)
        else:
            return StatusWorkingDeployCurrentObject(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='StatusWorkingDeployCurrentObject'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='StatusWorkingDeployCurrentObject')
        outfile.write('>')
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusWorkingDeployCurrentObject'):
        outfile.write(' type="%s"' % (quote_attrib(self.getType()), ))
    def exportChildren(self, outfile, level, name_='StatusWorkingDeployCurrentObject'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('type'):
            self.ttype = attrs.get('type').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class StatusWorkingDeployCurrentObject


class MigrationAgentStatusWorking:
    subclass = None
    def __init__(self, preparing=None, dumping=None):
        self.preparing = preparing
        self.dumping = dumping
    def factory(*args_, **kwargs_):
        if MigrationAgentStatusWorking.subclass:
            return MigrationAgentStatusWorking.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentStatusWorking(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPreparing(self): return self.preparing
    def setPreparing(self, value): self.preparing = value
    def getDumping(self): return self.dumping
    def setDumping(self, value): self.dumping = value
    def export(self, outfile, level, name_='MigrationAgentStatusWorking'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentStatusWorking'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentStatusWorking'):
        if self.preparing is not None:
            self.preparing.export(outfile, level, name_='preparing')
        if self.dumping is not None:
            self.dumping.export(outfile, level, name_='dumping')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preparing':
            obj_ = MigrationAgentStatusWorkingPreparing.factory()
            obj_.build(child_)
            self.setPreparing(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dumping':
            obj_ = MigrationAgentStatusWorkingDumping.factory()
            obj_.build(child_)
            self.setDumping(obj_)
# end class MigrationAgentStatusWorking


class MigrationAgentStatusWorkingPreparing:
    subclass = None
    def __init__(self, valueOf_=''):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if MigrationAgentStatusWorkingPreparing.subclass:
            return MigrationAgentStatusWorkingPreparing.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentStatusWorkingPreparing(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='MigrationAgentStatusWorkingPreparing'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentStatusWorkingPreparing'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentStatusWorkingPreparing'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class MigrationAgentStatusWorkingPreparing


class MigrationAgentStatusWorkingDumping:
    subclass = None
    def __init__(self, total_clients=-1, completed_clients=-1, completed_domains=-1, current_object=None, total_domains=-1, valueOf_=''):
        self.total_clients = total_clients
        self.completed_clients = completed_clients
        self.completed_domains = completed_domains
        self.current_object = current_object
        self.total_domains = total_domains
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if MigrationAgentStatusWorkingDumping.subclass:
            return MigrationAgentStatusWorkingDumping.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentStatusWorkingDumping(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTotal_clients(self): return self.total_clients
    def setTotal_clients(self, value): self.total_clients = value
    def getCompleted_clients(self): return self.completed_clients
    def setCompleted_clients(self, value): self.completed_clients = value
    def getCompleted_domains(self): return self.completed_domains
    def setCompleted_domains(self, value): self.completed_domains = value
    def getCurrent_object(self): return self.current_object
    def setCurrent_object(self, value): self.current_object = value
    def getTotal_domains(self): return self.total_domains
    def setTotal_domains(self, value): self.total_domains = value
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='MigrationAgentStatusWorkingDumping'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='MigrationAgentStatusWorkingDumping')
        outfile.write('>')
        self.exportChildren(outfile, level + 1, name_)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentStatusWorkingDumping'):
        outfile.write(' total-clients="%s"' % (quote_attrib(self.getTotal_clients()), ))
        outfile.write(' completed-clients="%s"' % (quote_attrib(self.getCompleted_clients()), ))
        outfile.write(' completed-domains="%s"' % (quote_attrib(self.getCompleted_domains()), ))
        if self.getCurrent_object() is not None:
            outfile.write(' current-object="%s"' % (quote_attrib(self.getCurrent_object()), ))
        outfile.write(' total-domains="%s"' % (quote_attrib(self.getTotal_domains()), ))
    def exportChildren(self, outfile, level, name_='MigrationAgentStatusWorkingDumping'):
        outfile.write(self.valueOf_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('total-clients'):
            try:
                self.total_clients = long(attrs.get('total-clients').value)
            except ValueError:
                raise ValueError('Bad integer attribute (total-clients)')
        if attrs.get('completed-clients'):
            try:
                self.completed_clients = long(attrs.get('completed-clients').value)
            except ValueError:
                raise ValueError('Bad integer attribute (completed-clients)')
        if attrs.get('completed-domains'):
            try:
                self.completed_domains = long(attrs.get('completed-domains').value)
            except ValueError:
                raise ValueError('Bad integer attribute (completed-domains)')
        if attrs.get('current-object'):
            self.current_object = attrs.get('current-object').value
        if attrs.get('total-domains'):
            try:
                self.total_domains = long(attrs.get('total-domains').value)
            except ValueError:
                raise ValueError('Bad integer attribute (total-domains)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class MigrationAgentStatusWorkingDumping


class StatusFinished:
    subclass = None
    def __init__(self, status=None, log_location=None, message=None, object=None):
        self.status = status
        self.log_location = log_location
        if message is None:
            self.message = []
        else:
            self.message = message
        if object is None:
            self.object = []
        else:
            self.object = object
    def factory(*args_, **kwargs_):
        if StatusFinished.subclass:
            return StatusFinished.subclass(*args_, **kwargs_)
        else:
            return StatusFinished(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMessage(self): return self.message
    def setMessage(self, value): self.message = value
    def addMessage(self, value): self.message.append(value)
    def insertMessage(self, index, value): self.message[index] = value
    def getObject(self): return self.object
    def setObject(self, value): self.object = value
    def addObject(self, value): self.object.append(value)
    def insertObject(self, index, value): self.object[index] = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getLog_location(self): return self.log_location
    def setLog_location(self, value): self.log_location = value
    def export(self, outfile, level, name_='StatusFinished'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='StatusFinished')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='StatusFinished'):
        outfile.write(' status="%s"' % (quote_attrib(self.getStatus()), ))
        if self.getLog_location() is not None:
            outfile.write(' log-location="%s"' % (quote_attrib(self.getLog_location()), ))
    def exportChildren(self, outfile, level, name_='StatusFinished'):
        for message_ in self.getMessage():
            message_.export(outfile, level, name_='message')
        for object_ in self.getObject():
            object_.export(outfile, level, name_='object')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('status'):
            self.status = attrs.get('status').value
        if attrs.get('log-location'):
            self.log_location = attrs.get('log-location').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.message.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'object':
            obj_ = ObjectType.factory()
            obj_.build(child_)
            self.object.append(obj_)
# end class StatusFinished


class ObjectType:
    subclass = None
    def __init__(self, ttype='', name='', object=None, message=None):
        self.ttype = ttype
        self.name = name
        if object is None:
            self.object = []
        else:
            self.object = object
        if message is None:
            self.message = []
        else:
            self.message = message
    def factory(*args_, **kwargs_):
        if ObjectType.subclass:
            return ObjectType.subclass(*args_, **kwargs_)
        else:
            return ObjectType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getObject(self): return self.object
    def setObject(self, value): self.object = value
    def addObject(self, value): self.object.append(value)
    def insertObject(self, index, value): self.object[index] = value
    def getMessage(self): return self.message
    def setMessage(self, value): self.message = value
    def addMessage(self, value): self.message.append(value)
    def insertMessage(self, index, value): self.message[index] = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='ObjectType'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='ObjectType')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ObjectType'):
        outfile.write(' type="%s"' % (quote_attrib(self.getType()), ))
        outfile.write(' name="%s"' % (quote_attrib(self.getName()), ))
    def exportChildren(self, outfile, level, name_='ObjectType'):
        for object_ in self.getObject():
            object_.export(outfile, level, name_='object')
        for message_ in self.getMessage():
            message_.export(outfile, level, name_='message')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('type'):
            self.ttype = attrs.get('type').value
        if attrs.get('name'):
            self.name = attrs.get('name').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'object':
            obj_ = ObjectType.factory()
            obj_.build(child_)
            self.object.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.message.append(obj_)
# end class ObjectType


class MessageType:
    subclass = None
    def __init__(self, code='', context=None, file=None, line=None, text='', message=None):
        self.code = code
        self.context = context
        self.file = file
        self.line = line
        self.text = text
        self.message = message
    def factory(*args_, **kwargs_):
        if MessageType.subclass:
            return MessageType.subclass(*args_, **kwargs_)
        else:
            return MessageType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getContext(self): return self.context
    def setContext(self, value): self.context = value
    def getFile(self): return self.file
    def setFile(self, value): self.file = value
    def getLine(self): return self.line
    def setLine(self, value): self.line = value
    def getText(self): return self.text
    def setText(self, value): self.text = value
    def getMessage(self): return self.message
    def setMessage(self, value): self.message = value
    def getCode(self): return self.code
    def setCode(self, value): self.code = value
    def export(self, outfile, level, name_='MessageType'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='MessageType')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MessageType'):
        outfile.write(' code="%s"' % (quote_attrib(self.getCode()), ))
    def exportChildren(self, outfile, level, name_='MessageType'):
        if self.context is not None:
            showIndent(outfile, level)
            outfile.write('<context>%s</context>\n' % quote_xml(self.getContext()))
        if self.file is not None:
            showIndent(outfile, level)
            outfile.write('<file>%s</file>\n' % quote_xml(self.getFile()))
        if self.line is not None:
            showIndent(outfile, level)
            outfile.write('<line>%s</line>\n' % quote_xml(self.getLine()))
        showIndent(outfile, level)
        outfile.write('<text>%s</text>\n' % quote_xml(self.getText()))
        if self.message is not None:
            self.message.export(outfile, level, name_='message')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('code'):
            self.code = attrs.get('code').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'context':
            context_ = ''
            for text__content_ in child_.childNodes:
                context_ += text__content_.nodeValue
            self.context = context_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            file_ = ''
            for text__content_ in child_.childNodes:
                file_ += text__content_.nodeValue
            self.file = file_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'line':
            line_ = ''
            for text__content_ in child_.childNodes:
                line_ += text__content_.nodeValue
            self.line = line_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'text':
            text_ = ''
            for text__content_ in child_.childNodes:
                text_ += text__content_.nodeValue
            self.text = text_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            obj_ = MessageType.factory()
            obj_.build(child_)
            self.setMessage(obj_)
# end class MessageType


class MigrationApiStatusWorking:
    subclass = None
    def __init__(self, preparing=None, total=None, completed=None, description=None):
        self.preparing = preparing
        self.total = total
        self.completed = completed
        self.description = description
    def factory(*args_, **kwargs_):
        if MigrationApiStatusWorking.subclass:
            return MigrationApiStatusWorking.subclass(*args_, **kwargs_)
        else:
            return MigrationApiStatusWorking(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPreparing(self): return self.preparing
    def setPreparing(self, value): self.preparing = value
    def getTotal(self): return self.total
    def setTotal(self, value): self.total = value
    def getCompleted(self): return self.completed
    def setCompleted(self, value): self.completed = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def export(self, outfile, level, name_='MigrationApiStatusWorking'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationApiStatusWorking'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationApiStatusWorking'):
        if self.preparing is not None:
            self.preparing.export(outfile, level, name_='preparing')
        if self.total is not None:
            showIndent(outfile, level)
            outfile.write('<total>%d</total>\n' % self.getTotal())
        if self.completed is not None:
            showIndent(outfile, level)
            outfile.write('<completed>%d</completed>\n' % self.getCompleted())
        if self.description is not None:
            showIndent(outfile, level)
            outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preparing':
            obj_ = MigrationAgentStatusWorkingPreparing.factory()
            obj_.build(child_)
            self.setPreparing(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'total':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.total = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'completed':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.completed = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
# end class MigrationApiStatusWorking


class Ip:
    subclass = None
    def __init__(self, ip_type='', ip_address=''):
        self.ip_type = ip_type
        self.ip_address = ip_address
    def factory(*args_, **kwargs_):
        if Ip.subclass:
            return Ip.subclass(*args_, **kwargs_)
        else:
            return Ip(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_type(self): return self.ip_type
    def setIp_type(self, value): self.ip_type = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def export(self, outfile, level, name_='Ip'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='Ip'):
        pass
    def exportChildren(self, outfile, level, name_='Ip'):
        showIndent(outfile, level)
        outfile.write('<ip-type>%s</ip-type>\n' % quote_xml(self.getIp_type()))
        showIndent(outfile, level)
        outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(self.getIp_address()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-type':
            ip_type_ = ''
            for text__content_ in child_.childNodes:
                ip_type_ += text__content_.nodeValue
            self.ip_type = ip_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
# end class Ip


class MappedClient:
    subclass = None
    def __init__(self, name='', ip=None, domain=None):
        self.name = name
        if ip is None:
            self.ip = []
        else:
            self.ip = ip
        if domain is None:
            self.domain = []
        else:
            self.domain = domain
    def factory(*args_, **kwargs_):
        if MappedClient.subclass:
            return MappedClient.subclass(*args_, **kwargs_)
        else:
            return MappedClient(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def addIp(self, value): self.ip.append(value)
    def insertIp(self, index, value): self.ip[index] = value
    def getDomain(self): return self.domain
    def setDomain(self, value): self.domain = value
    def addDomain(self, value): self.domain.append(value)
    def insertDomain(self, index, value): self.domain[index] = value
    def export(self, outfile, level, name_='MappedClient'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MappedClient'):
        pass
    def exportChildren(self, outfile, level, name_='MappedClient'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        for ip_ in self.getIp():
            ip_.export(outfile, level, name_='ip')
        for domain_ in self.getDomain():
            domain_.export(outfile, level, name_='domain')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = MappedIp.factory()
            obj_.build(child_)
            self.ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain':
            obj_ = MappedDomain.factory()
            obj_.build(child_)
            self.domain.append(obj_)
# end class MappedClient


class MappedDomain:
    subclass = None
    def __init__(self, name='', ip=None, db_server=None):
        self.name = name
        self.ip = ip
        if db_server is None:
            self.db_server = []
        else:
            self.db_server = db_server
    def factory(*args_, **kwargs_):
        if MappedDomain.subclass:
            return MappedDomain.subclass(*args_, **kwargs_)
        else:
            return MappedDomain(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def getDb_server(self): return self.db_server
    def setDb_server(self, value): self.db_server = value
    def addDb_server(self, value): self.db_server.append(value)
    def insertDb_server(self, index, value): self.db_server[index] = value
    def export(self, outfile, level, name_='MappedDomain'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MappedDomain'):
        pass
    def exportChildren(self, outfile, level, name_='MappedDomain'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.ip is not None:
            self.ip.export(outfile, level, name_='ip')
        for db_server_ in self.getDb_server():
            db_server_.export(outfile, level, name_='db-server')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = MappedIp.factory()
            obj_.build(child_)
            self.setIp(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'db-server':
            obj_ = MappedDbServer.factory()
            obj_.build(child_)
            self.db_server.append(obj_)
# end class MappedDomain


class MappedIp:
    subclass = None
    def __init__(self, old=None, new=None):
        self.old = old
        self.new = new
    def factory(*args_, **kwargs_):
        if MappedIp.subclass:
            return MappedIp.subclass(*args_, **kwargs_)
        else:
            return MappedIp(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getOld(self): return self.old
    def setOld(self, value): self.old = value
    def getNew(self): return self.new
    def setNew(self, value): self.new = value
    def export(self, outfile, level, name_='MappedIp'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MappedIp'):
        pass
    def exportChildren(self, outfile, level, name_='MappedIp'):
        if self.old is not None:
            self.old.export(outfile, level, name_='old')
        if self.new is not None:
            self.new.export(outfile, level, name_='new')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'old':
            obj_ = Ip.factory()
            obj_.build(child_)
            self.setOld(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'new':
            obj_ = Ip.factory()
            obj_.build(child_)
            self.setNew(obj_)
# end class MappedIp


class MappedDbServer:
    subclass = None
    def __init__(self, old=None, new=None):
        self.old = old
        self.new = new
    def factory(*args_, **kwargs_):
        if MappedDbServer.subclass:
            return MappedDbServer.subclass(*args_, **kwargs_)
        else:
            return MappedDbServer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getOld(self): return self.old
    def setOld(self, value): self.old = value
    def getNew(self): return self.new
    def setNew(self, value): self.new = value
    def export(self, outfile, level, name_='MappedDbServer'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MappedDbServer'):
        pass
    def exportChildren(self, outfile, level, name_='MappedDbServer'):
        if self.old is not None:
            self.old.export(outfile, level, name_='old')
        if self.new is not None:
            self.new.export(outfile, level, name_='new')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'old':
            obj_ = DbServer.factory()
            obj_.build(child_)
            self.setOld(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'new':
            obj_ = DbServer.factory()
            obj_.build(child_)
            self.setNew(obj_)
# end class MappedDbServer


class DbServer:
    subclass = None
    def __init__(self, host='', port='', ttype=''):
        self.host = host
        self.port = port
        self.ttype = ttype
    def factory(*args_, **kwargs_):
        if DbServer.subclass:
            return DbServer.subclass(*args_, **kwargs_)
        else:
            return DbServer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getPort(self): return self.port
    def setPort(self, value): self.port = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def export(self, outfile, level, name_='DbServer'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DbServer'):
        pass
    def exportChildren(self, outfile, level, name_='DbServer'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        showIndent(outfile, level)
        outfile.write('<port>%s</port>\n' % quote_xml(self.getPort()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'port':
            port_ = ''
            for text__content_ in child_.childNodes:
                port_ += text__content_.nodeValue
            self.port = port_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
# end class DbServer


class SystemIp(Ip):
    subclass = None
    def __init__(self, ip_netmask='', ip_interface='', ip_type='', ip_address=''):
        Ip.__init__(self, ip_type, ip_address)
        self.ip_netmask = ip_netmask
        self.ip_interface = ip_interface
    def factory(*args_, **kwargs_):
        if SystemIp.subclass:
            return SystemIp.subclass(*args_, **kwargs_)
        else:
            return SystemIp(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_netmask(self): return self.ip_netmask
    def setIp_netmask(self, value): self.ip_netmask = value
    def getIp_interface(self): return self.ip_interface
    def setIp_interface(self, value): self.ip_interface = value
    def export(self, outfile, level, name_='SystemIp'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SystemIp'):
        Ip.exportAttributes(self, outfile, level, name_='SystemIp')
    def exportChildren(self, outfile, level, name_='SystemIp'):
        showIndent(outfile, level)
        outfile.write('<ip-netmask>%s</ip-netmask>\n' % quote_xml(self.getIp_netmask()))
        showIndent(outfile, level)
        outfile.write('<ip-interface>%s</ip-interface>\n' % quote_xml(self.getIp_interface()))
        Ip.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        Ip.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-netmask':
            ip_netmask_ = ''
            for text__content_ in child_.childNodes:
                ip_netmask_ += text__content_.nodeValue
            self.ip_netmask = ip_netmask_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-interface':
            ip_interface_ = ''
            for text__content_ in child_.childNodes:
                ip_interface_ += text__content_.nodeValue
            self.ip_interface = ip_interface_
        Ip.buildChildren(self, child_, nodeName_)
# end class SystemIp


class MappedSystemIp:
    subclass = None
    def __init__(self, old=None, new=None):
        self.old = old
        self.new = new
    def factory(*args_, **kwargs_):
        if MappedSystemIp.subclass:
            return MappedSystemIp.subclass(*args_, **kwargs_)
        else:
            return MappedSystemIp(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getOld(self): return self.old
    def setOld(self, value): self.old = value
    def getNew(self): return self.new
    def setNew(self, value): self.new = value
    def export(self, outfile, level, name_='MappedSystemIp'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MappedSystemIp'):
        pass
    def exportChildren(self, outfile, level, name_='MappedSystemIp'):
        if self.old is not None:
            self.old.export(outfile, level, name_='old')
        if self.new is not None:
            self.new.export(outfile, level, name_='new')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'old':
            obj_ = SystemIp.factory()
            obj_.build(child_)
            self.setOld(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'new':
            obj_ = SystemIp.factory()
            obj_.build(child_)
            self.setNew(obj_)
# end class MappedSystemIp


class SelectedServer:
    subclass = None
    def __init__(self, client=None, db_server=None, license=None, ip=None, default_ip=None, hostname=None, restore_admin_pinfo=None, password=None, sso_enabled=None, sso_admin_uid=None, sso_server=None, sso_relay=None, sso_application_id=None, restore_certificates=None, restore_mail=None, restore_dns=None, restore_custom_buttons=None, restore_domain_templates=None, restore_client_templates=None):
        if client is None:
            self.client = []
        else:
            self.client = client
        if db_server is None:
            self.db_server = []
        else:
            self.db_server = db_server
        self.license = license
        if ip is None:
            self.ip = []
        else:
            self.ip = ip
        self.default_ip = default_ip
        self.hostname = hostname
        self.restore_admin_pinfo = restore_admin_pinfo
        self.password = password
        self.sso_enabled = sso_enabled
        self.sso_admin_uid = sso_admin_uid
        self.sso_server = sso_server
        self.sso_relay = sso_relay
        self.sso_application_id = sso_application_id
        self.restore_certificates = restore_certificates
        self.restore_mail = restore_mail
        self.restore_dns = restore_dns
        self.restore_custom_buttons = restore_custom_buttons
        self.restore_domain_templates = restore_domain_templates
        self.restore_client_templates = restore_client_templates
    def factory(*args_, **kwargs_):
        if SelectedServer.subclass:
            return SelectedServer.subclass(*args_, **kwargs_)
        else:
            return SelectedServer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getClient(self): return self.client
    def setClient(self, value): self.client = value
    def addClient(self, value): self.client.append(value)
    def insertClient(self, index, value): self.client[index] = value
    def getDb_server(self): return self.db_server
    def setDb_server(self, value): self.db_server = value
    def addDb_server(self, value): self.db_server.append(value)
    def insertDb_server(self, index, value): self.db_server[index] = value
    def getLicense(self): return self.license
    def setLicense(self, value): self.license = value
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def addIp(self, value): self.ip.append(value)
    def insertIp(self, index, value): self.ip[index] = value
    def getDefault_ip(self): return self.default_ip
    def setDefault_ip(self, value): self.default_ip = value
    def getHostname(self): return self.hostname
    def setHostname(self, value): self.hostname = value
    def getRestore_admin_pinfo(self): return self.restore_admin_pinfo
    def setRestore_admin_pinfo(self, value): self.restore_admin_pinfo = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getSso_enabled(self): return self.sso_enabled
    def setSso_enabled(self, value): self.sso_enabled = value
    def getSso_admin_uid(self): return self.sso_admin_uid
    def setSso_admin_uid(self, value): self.sso_admin_uid = value
    def getSso_server(self): return self.sso_server
    def setSso_server(self, value): self.sso_server = value
    def getSso_relay(self): return self.sso_relay
    def setSso_relay(self, value): self.sso_relay = value
    def getSso_application_id(self): return self.sso_application_id
    def setSso_application_id(self, value): self.sso_application_id = value
    def getRestore_certificates(self): return self.restore_certificates
    def setRestore_certificates(self, value): self.restore_certificates = value
    def getRestore_mail(self): return self.restore_mail
    def setRestore_mail(self, value): self.restore_mail = value
    def getRestore_dns(self): return self.restore_dns
    def setRestore_dns(self, value): self.restore_dns = value
    def getRestore_custom_buttons(self): return self.restore_custom_buttons
    def setRestore_custom_buttons(self, value): self.restore_custom_buttons = value
    def getRestore_domain_templates(self): return self.restore_domain_templates
    def setRestore_domain_templates(self, value): self.restore_domain_templates = value
    def getRestore_client_templates(self): return self.restore_client_templates
    def setRestore_client_templates(self, value): self.restore_client_templates = value
    def export(self, outfile, level, name_='SelectedServer'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SelectedServer'):
        pass
    def exportChildren(self, outfile, level, name_='SelectedServer'):
        for client_ in self.getClient():
            client_.export(outfile, level, name_='client')
        for db_server_ in self.getDb_server():
            db_server_.export(outfile, level, name_='db-server')
        if self.license is not None:
            self.license.export(outfile, level, name_='license')
        for ip_ in self.getIp():
            ip_.export(outfile, level, name_='ip')
        if self.default_ip is not None:
            showIndent(outfile, level)
            outfile.write('<default-ip>%s</default-ip>\n' % quote_xml(self.getDefault_ip()))
        if self.hostname is not None:
            showIndent(outfile, level)
            outfile.write('<hostname>%s</hostname>\n' % quote_xml(self.getHostname()))
        if self.restore_admin_pinfo is not None:
            self.restore_admin_pinfo.export(outfile, level, name_='restore-admin-pinfo')
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.sso_enabled is not None:
            showIndent(outfile, level)
            outfile.write('<sso-enabled>%s</sso-enabled>\n' % quote_xml(self.getSso_enabled()))
        if self.sso_admin_uid is not None:
            showIndent(outfile, level)
            outfile.write('<sso-admin-uid>%s</sso-admin-uid>\n' % quote_xml(self.getSso_admin_uid()))
        if self.sso_server is not None:
            showIndent(outfile, level)
            outfile.write('<sso-server>%s</sso-server>\n' % quote_xml(self.getSso_server()))
        if self.sso_relay is not None:
            showIndent(outfile, level)
            outfile.write('<sso-relay>%s</sso-relay>\n' % quote_xml(self.getSso_relay()))
        if self.sso_application_id is not None:
            showIndent(outfile, level)
            outfile.write('<sso-application-id>%s</sso-application-id>\n' % quote_xml(self.getSso_application_id()))
        if self.restore_certificates is not None:
            self.restore_certificates.export(outfile, level, name_='restore-certificates')
        if self.restore_mail is not None:
            self.restore_mail.export(outfile, level, name_='restore-mail')
        if self.restore_dns is not None:
            self.restore_dns.export(outfile, level, name_='restore-dns')
        if self.restore_custom_buttons is not None:
            self.restore_custom_buttons.export(outfile, level, name_='restore-custom-buttons')
        if self.restore_domain_templates is not None:
            self.restore_domain_templates.export(outfile, level, name_='restore-domain-templates')
        if self.restore_client_templates is not None:
            self.restore_client_templates.export(outfile, level, name_='restore-client-templates')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client':
            obj_ = MappedClient.factory()
            obj_.build(child_)
            self.client.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'db-server':
            obj_ = MappedDbServer.factory()
            obj_.build(child_)
            self.db_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'license':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLicense(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = MappedSystemIp.factory()
            obj_.build(child_)
            self.ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'default-ip':
            default_ip_ = ''
            for text__content_ in child_.childNodes:
                default_ip_ += text__content_.nodeValue
            self.default_ip = default_ip_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hostname':
            hostname_ = ''
            for text__content_ in child_.childNodes:
                hostname_ += text__content_.nodeValue
            self.hostname = hostname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-admin-pinfo':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_admin_pinfo(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso-enabled':
            sso_enabled_ = ''
            for text__content_ in child_.childNodes:
                sso_enabled_ += text__content_.nodeValue
            self.sso_enabled = sso_enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso-admin-uid':
            sso_admin_uid_ = ''
            for text__content_ in child_.childNodes:
                sso_admin_uid_ += text__content_.nodeValue
            self.sso_admin_uid = sso_admin_uid_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso-server':
            sso_server_ = ''
            for text__content_ in child_.childNodes:
                sso_server_ += text__content_.nodeValue
            self.sso_server = sso_server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso-relay':
            sso_relay_ = ''
            for text__content_ in child_.childNodes:
                sso_relay_ += text__content_.nodeValue
            self.sso_relay = sso_relay_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso-application-id':
            sso_application_id_ = ''
            for text__content_ in child_.childNodes:
                sso_application_id_ += text__content_.nodeValue
            self.sso_application_id = sso_application_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-certificates':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_certificates(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-mail':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_mail(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-dns':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_dns(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-custom-buttons':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_custom_buttons(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-domain-templates':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_domain_templates(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-client-templates':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setRestore_client_templates(obj_)
# end class SelectedServer


class AgentDumpingStatus:
    subclass = None
    def __init__(self, pid='', account='', domain='', accounts_left=-1, domains_left=-1):
        self.pid = pid
        self.account = account
        self.domain = domain
        self.accounts_left = accounts_left
        self.domains_left = domains_left
    def factory(*args_, **kwargs_):
        if AgentDumpingStatus.subclass:
            return AgentDumpingStatus.subclass(*args_, **kwargs_)
        else:
            return AgentDumpingStatus(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPid(self): return self.pid
    def setPid(self, value): self.pid = value
    def getAccount(self): return self.account
    def setAccount(self, value): self.account = value
    def getDomain(self): return self.domain
    def setDomain(self, value): self.domain = value
    def getAccounts_left(self): return self.accounts_left
    def setAccounts_left(self, value): self.accounts_left = value
    def getDomains_left(self): return self.domains_left
    def setDomains_left(self, value): self.domains_left = value
    def export(self, outfile, level, name_='AgentDumpingStatus'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AgentDumpingStatus'):
        pass
    def exportChildren(self, outfile, level, name_='AgentDumpingStatus'):
        showIndent(outfile, level)
        outfile.write('<pid>%s</pid>\n' % quote_xml(self.getPid()))
        showIndent(outfile, level)
        outfile.write('<account>%s</account>\n' % quote_xml(self.getAccount()))
        showIndent(outfile, level)
        outfile.write('<domain>%s</domain>\n' % quote_xml(self.getDomain()))
        showIndent(outfile, level)
        outfile.write('<accounts-left>%d</accounts-left>\n' % self.getAccounts_left())
        showIndent(outfile, level)
        outfile.write('<domains-left>%d</domains-left>\n' % self.getDomains_left())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pid':
            pid_ = ''
            for text__content_ in child_.childNodes:
                pid_ += text__content_.nodeValue
            self.pid = pid_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'account':
            account_ = ''
            for text__content_ in child_.childNodes:
                account_ += text__content_.nodeValue
            self.account = account_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain':
            domain_ = ''
            for text__content_ in child_.childNodes:
                domain_ += text__content_.nodeValue
            self.domain = domain_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'accounts-left':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.accounts_left = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domains-left':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.domains_left = ival_
# end class AgentDumpingStatus


class MigrationAgentOutputType:
    subclass = None
    def __init__(self, start=None, get_status=None, finish=None, check=None):
        if start is None:
            self.start = []
        else:
            self.start = start
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
        if finish is None:
            self.finish = []
        else:
            self.finish = finish
        if check is None:
            self.check = []
        else:
            self.check = check
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputType.subclass:
            return MigrationAgentOutputType.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStart(self): return self.start
    def setStart(self, value): self.start = value
    def addStart(self, value): self.start.append(value)
    def insertStart(self, index, value): self.start[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def getFinish(self): return self.finish
    def setFinish(self, value): self.finish = value
    def addFinish(self, value): self.finish.append(value)
    def insertFinish(self, index, value): self.finish[index] = value
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def export(self, outfile, level, name_='MigrationAgentOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputType'):
        for start_ in self.getStart():
            start_.export(outfile, level, name_='start')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get-status')
        for finish_ in self.getFinish():
            finish_.export(outfile, level, name_='finish')
        for check_ in self.getCheck():
            check_.export(outfile, level, name_='check')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'start':
            obj_ = MigrationAgentOutputStart.factory()
            obj_.build(child_)
            self.start.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status':
            obj_ = MigrationAgentOutputGetStatus.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'finish':
            obj_ = MigrationAgentOutputFinish.factory()
            obj_.build(child_)
            self.finish.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            obj_ = MigrationAgentOutputFinish.factory()
            obj_.build(child_)
            self.check.append(obj_)
# end class MigrationAgentOutputType


class MigrationAgentOutputStart:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputStart.subclass:
            return MigrationAgentOutputStart.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputStart(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationAgentOutputStart'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputStart'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputStart'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MigrationAgentOutputStartType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationAgentOutputStart


class MigrationAgentOutputStartType(resultType):
    subclass = None
    def __init__(self, migration_id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.migration_id = migration_id
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputStartType.subclass:
            return MigrationAgentOutputStartType.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputStartType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMigration_id(self): return self.migration_id
    def setMigration_id(self, value): self.migration_id = value
    def export(self, outfile, level, name_='MigrationAgentOutputStartType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputStartType'):
        resultType.exportAttributes(self, outfile, level, name_='MigrationAgentOutputStartType')
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputStartType'):
        if self.migration_id is not None:
            showIndent(outfile, level)
            outfile.write('<migration-id>%s</migration-id>\n' % quote_xml(self.getMigration_id()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migration-id':
            migration_id_ = ''
            for text__content_ in child_.childNodes:
                migration_id_ += text__content_.nodeValue
            self.migration_id = migration_id_
        resultType.buildChildren(self, child_, nodeName_)
# end class MigrationAgentOutputStartType


class MigrationAgentOutputGetStatus:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputGetStatus.subclass:
            return MigrationAgentOutputGetStatus.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputGetStatus(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationAgentOutputGetStatus'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputGetStatus'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputGetStatus'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MigrationAgentOutputGetStatusType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationAgentOutputGetStatus


class MigrationAgentOutputGetStatusType(resultType):
    subclass = None
    def __init__(self, working=None, finished=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.working = working
        self.finished = finished
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputGetStatusType.subclass:
            return MigrationAgentOutputGetStatusType.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputGetStatusType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getWorking(self): return self.working
    def setWorking(self, value): self.working = value
    def getFinished(self): return self.finished
    def setFinished(self, value): self.finished = value
    def export(self, outfile, level, name_='MigrationAgentOutputGetStatusType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputGetStatusType'):
        resultType.exportAttributes(self, outfile, level, name_='MigrationAgentOutputGetStatusType')
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputGetStatusType'):
        if self.working is not None:
            self.working.export(outfile, level, name_='working')
        if self.finished is not None:
            self.finished.export(outfile, level, name_='finished')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'working':
            obj_ = MigrationAgentStatusWorking.factory()
            obj_.build(child_)
            self.setWorking(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'finished':
            obj_ = MigrationAgentStatusFinished.factory()
            obj_.build(child_)
            self.setFinished(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class MigrationAgentOutputGetStatusType


class MigrationAgentStatusFinished:
    subclass = None
    def __init__(self, error=None, password=None, dump_url=None, content_url=None):
        self.error = error
        self.password = password
        self.dump_url = dump_url
        if content_url is None:
            self.content_url = []
        else:
            self.content_url = content_url
    def factory(*args_, **kwargs_):
        if MigrationAgentStatusFinished.subclass:
            return MigrationAgentStatusFinished.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentStatusFinished(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getError(self): return self.error
    def setError(self, value): self.error = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getDump_url(self): return self.dump_url
    def setDump_url(self, value): self.dump_url = value
    def getContent_url(self): return self.content_url
    def setContent_url(self, value): self.content_url = value
    def addContent_url(self, value): self.content_url.append(value)
    def insertContent_url(self, index, value): self.content_url[index] = value
    def export(self, outfile, level, name_='MigrationAgentStatusFinished'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentStatusFinished'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentStatusFinished'):
        if self.error is not None:
            showIndent(outfile, level)
            outfile.write('<error>%s</error>\n' % quote_xml(self.getError()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.dump_url is not None:
            showIndent(outfile, level)
            outfile.write('<dump-url>%s</dump-url>\n' % quote_xml(self.getDump_url()))
        for content_url_ in self.getContent_url():
            showIndent(outfile, level)
            outfile.write('<content-url>%s</content-url>\n' % quote_xml(content_url_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'error':
            error_ = ''
            for text__content_ in child_.childNodes:
                error_ += text__content_.nodeValue
            self.error = error_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dump-url':
            dump_url_ = ''
            for text__content_ in child_.childNodes:
                dump_url_ += text__content_.nodeValue
            self.dump_url = dump_url_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'content-url':
            content_url_ = ''
            for text__content_ in child_.childNodes:
                content_url_ += text__content_.nodeValue
            self.addContent_url(content_url_)
# end class MigrationAgentStatusFinished


class MigrationAgentOutputFinish:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationAgentOutputFinish.subclass:
            return MigrationAgentOutputFinish.subclass(*args_, **kwargs_)
        else:
            return MigrationAgentOutputFinish(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationAgentOutputFinish'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationAgentOutputFinish'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationAgentOutputFinish'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationAgentOutputFinish


class MigrationOutputType:
    subclass = None
    def __init__(self, start=None, finish=None, get_fs=None, get_status=None, check=None):
        if start is None:
            self.start = []
        else:
            self.start = start
        if finish is None:
            self.finish = []
        else:
            self.finish = finish
        if get_fs is None:
            self.get_fs = []
        else:
            self.get_fs = get_fs
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
        if check is None:
            self.check = []
        else:
            self.check = check
    def factory(*args_, **kwargs_):
        if MigrationOutputType.subclass:
            return MigrationOutputType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStart(self): return self.start
    def setStart(self, value): self.start = value
    def addStart(self, value): self.start.append(value)
    def insertStart(self, index, value): self.start[index] = value
    def getFinish(self): return self.finish
    def setFinish(self, value): self.finish = value
    def addFinish(self, value): self.finish.append(value)
    def insertFinish(self, index, value): self.finish[index] = value
    def getGet_fs(self): return self.get_fs
    def setGet_fs(self, value): self.get_fs = value
    def addGet_fs(self, value): self.get_fs.append(value)
    def insertGet_fs(self, index, value): self.get_fs[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def export(self, outfile, level, name_='MigrationOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationOutputType'):
        for start_ in self.getStart():
            start_.export(outfile, level, name_='start')
        for finish_ in self.getFinish():
            finish_.export(outfile, level, name_='finish')
        for get_fs_ in self.getGet_fs():
            get_fs_.export(outfile, level, name_='get_fs')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get_status')
        for check_ in self.getCheck():
            check_.export(outfile, level, name_='check')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'start':
            obj_ = MigrationOutputStartType.factory()
            obj_.build(child_)
            self.start.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'finish':
            obj_ = MigrationOutputFinishType.factory()
            obj_.build(child_)
            self.finish.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_fs':
            obj_ = MigrationOutputGetFsType.factory()
            obj_.build(child_)
            self.get_fs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_status':
            obj_ = MigrationOutputGetStatusType.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            obj_ = MigrationOutputFinishType.factory()
            obj_.build(child_)
            self.check.append(obj_)
# end class MigrationOutputType


class MigrationOutputStartType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationOutputStartType.subclass:
            return MigrationOutputStartType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputStartType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationOutputStartType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputStartType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationOutputStartType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MigrationOutputStartResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationOutputStartType


class MigrationOutputStartResultType(resultType):
    subclass = None
    def __init__(self, migration_id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.migration_id = migration_id
    def factory(*args_, **kwargs_):
        if MigrationOutputStartResultType.subclass:
            return MigrationOutputStartResultType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputStartResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMigration_id(self): return self.migration_id
    def setMigration_id(self, value): self.migration_id = value
    def export(self, outfile, level, name_='MigrationOutputStartResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputStartResultType'):
        resultType.exportAttributes(self, outfile, level, name_='MigrationOutputStartResultType')
    def exportChildren(self, outfile, level, name_='MigrationOutputStartResultType'):
        showIndent(outfile, level)
        outfile.write('<migration_id>%s</migration_id>\n' % quote_xml(self.getMigration_id()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migration_id':
            migration_id_ = ''
            for text__content_ in child_.childNodes:
                migration_id_ += text__content_.nodeValue
            self.migration_id = migration_id_
        resultType.buildChildren(self, child_, nodeName_)
# end class MigrationOutputStartResultType


class MigrationOutputGetStatusType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationOutputGetStatusType.subclass:
            return MigrationOutputGetStatusType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputGetStatusType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationOutputGetStatusType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputGetStatusType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationOutputGetStatusType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MigrationOutputGetStatusResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationOutputGetStatusType


class MigrationOutputGetStatusResultType(resultType):
    subclass = None
    def __init__(self, migration_status=None, finished=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.migration_status = migration_status
        self.finished = finished
    def factory(*args_, **kwargs_):
        if MigrationOutputGetStatusResultType.subclass:
            return MigrationOutputGetStatusResultType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputGetStatusResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMigration_status(self): return self.migration_status
    def setMigration_status(self, value): self.migration_status = value
    def getFinished(self): return self.finished
    def setFinished(self, value): self.finished = value
    def export(self, outfile, level, name_='MigrationOutputGetStatusResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputGetStatusResultType'):
        resultType.exportAttributes(self, outfile, level, name_='MigrationOutputGetStatusResultType')
    def exportChildren(self, outfile, level, name_='MigrationOutputGetStatusResultType'):
        if self.migration_status is not None:
            self.migration_status.export(outfile, level, name_='migration_status')
        if self.finished is not None:
            self.finished.export(outfile, level, name_='finished')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migration_status':
            obj_ = MigrationStatus.factory()
            obj_.build(child_)
            self.setMigration_status(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'finished':
            obj_ = MigrationFinishedType.factory()
            obj_.build(child_)
            self.setFinished(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class MigrationOutputGetStatusResultType


class MigrationFinishedType:
    subclass = None
    def __init__(self, success=None, error=None):
        self.success = success
        if error is None:
            self.error = []
        else:
            self.error = error
    def factory(*args_, **kwargs_):
        if MigrationFinishedType.subclass:
            return MigrationFinishedType.subclass(*args_, **kwargs_)
        else:
            return MigrationFinishedType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSuccess(self): return self.success
    def setSuccess(self, value): self.success = value
    def getError(self): return self.error
    def setError(self, value): self.error = value
    def addError(self, value): self.error.append(value)
    def insertError(self, index, value): self.error[index] = value
    def export(self, outfile, level, name_='MigrationFinishedType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationFinishedType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationFinishedType'):
        if self.success is not None:
            showIndent(outfile, level)
            outfile.write('<success>%s</success>\n' % quote_xml(self.getSuccess()))
        for error_ in self.getError():
            error_.export(outfile, level, name_='error')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'success':
            success_ = ''
            for text__content_ in child_.childNodes:
                success_ += text__content_.nodeValue
            self.success = success_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'error':
            obj_ = ErrorType.factory()
            obj_.build(child_)
            self.error.append(obj_)
# end class MigrationFinishedType


class ErrorType:
    subclass = None
    def __init__(self, object=None, message=None):
        self.object = object
        if message is None:
            self.message = []
        else:
            self.message = message
    def factory(*args_, **kwargs_):
        if ErrorType.subclass:
            return ErrorType.subclass(*args_, **kwargs_)
        else:
            return ErrorType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getObject(self): return self.object
    def setObject(self, value): self.object = value
    def getMessage(self): return self.message
    def setMessage(self, value): self.message = value
    def addMessage(self, value): self.message.append(value)
    def insertMessage(self, index, value): self.message[index] = value
    def export(self, outfile, level, name_='ErrorType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ErrorType'):
        pass
    def exportChildren(self, outfile, level, name_='ErrorType'):
        if self.object is not None:
            self.object.export(outfile, level, name_='object')
        for message_ in self.getMessage():
            showIndent(outfile, level)
            outfile.write('<message>%s</message>\n' % quote_xml(message_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'object':
            obj_ = ObjectErrorType.factory()
            obj_.build(child_)
            self.setObject(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            message_ = ''
            for text__content_ in child_.childNodes:
                message_ += text__content_.nodeValue
            self.addMessage(message_)
# end class ErrorType


class ObjectErrorType:
    subclass = None
    def __init__(self, ttype='', name=''):
        self.ttype = ttype
        self.name = name
    def factory(*args_, **kwargs_):
        if ObjectErrorType.subclass:
            return ObjectErrorType.subclass(*args_, **kwargs_)
        else:
            return ObjectErrorType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='ObjectErrorType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ObjectErrorType'):
        pass
    def exportChildren(self, outfile, level, name_='ObjectErrorType'):
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
# end class ObjectErrorType


class MigrationOutputFinishType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationOutputFinishType.subclass:
            return MigrationOutputFinishType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputFinishType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationOutputFinishType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputFinishType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationOutputFinishType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationOutputFinishType


class MigrationOutputGetFsType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MigrationOutputGetFsType.subclass:
            return MigrationOutputGetFsType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputGetFsType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MigrationOutputGetFsType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputGetFsType'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationOutputGetFsType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MigrationOutputGetFsResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MigrationOutputGetFsType


class MigrationOutputGetFsResultType(resultType):
    subclass = None
    def __init__(self, fs=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        if fs is None:
            self.fs = []
        else:
            self.fs = fs
    def factory(*args_, **kwargs_):
        if MigrationOutputGetFsResultType.subclass:
            return MigrationOutputGetFsResultType.subclass(*args_, **kwargs_)
        else:
            return MigrationOutputGetFsResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFs(self): return self.fs
    def setFs(self, value): self.fs = value
    def addFs(self, value): self.fs.append(value)
    def insertFs(self, index, value): self.fs[index] = value
    def export(self, outfile, level, name_='MigrationOutputGetFsResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationOutputGetFsResultType'):
        resultType.exportAttributes(self, outfile, level, name_='MigrationOutputGetFsResultType')
    def exportChildren(self, outfile, level, name_='MigrationOutputGetFsResultType'):
        for fs_ in self.getFs():
            fs_.export(outfile, level, name_='fs')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fs':
            obj_ = FS.factory()
            obj_.build(child_)
            self.fs.append(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class MigrationOutputGetFsResultType


class FS:
    subclass = None
    def __init__(self, mountpoint='', device='', mode='', size='', free='', ttype=''):
        self.mountpoint = mountpoint
        self.device = device
        self.mode = mode
        self.size = size
        self.free = free
        self.ttype = ttype
    def factory(*args_, **kwargs_):
        if FS.subclass:
            return FS.subclass(*args_, **kwargs_)
        else:
            return FS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getMountpoint(self): return self.mountpoint
    def setMountpoint(self, value): self.mountpoint = value
    def getDevice(self): return self.device
    def setDevice(self, value): self.device = value
    def getMode(self): return self.mode
    def setMode(self, value): self.mode = value
    def getSize(self): return self.size
    def setSize(self, value): self.size = value
    def getFree(self): return self.free
    def setFree(self, value): self.free = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def export(self, outfile, level, name_='FS'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FS'):
        pass
    def exportChildren(self, outfile, level, name_='FS'):
        showIndent(outfile, level)
        outfile.write('<mountpoint>%s</mountpoint>\n' % quote_xml(self.getMountpoint()))
        showIndent(outfile, level)
        outfile.write('<device>%s</device>\n' % quote_xml(self.getDevice()))
        showIndent(outfile, level)
        outfile.write('<mode>%s</mode>\n' % quote_xml(self.getMode()))
        showIndent(outfile, level)
        outfile.write('<size>%s</size>\n' % quote_xml(self.getSize()))
        showIndent(outfile, level)
        outfile.write('<free>%s</free>\n' % quote_xml(self.getFree()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mountpoint':
            mountpoint_ = ''
            for text__content_ in child_.childNodes:
                mountpoint_ += text__content_.nodeValue
            self.mountpoint = mountpoint_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'device':
            device_ = ''
            for text__content_ in child_.childNodes:
                device_ += text__content_.nodeValue
            self.device = device_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mode':
            mode_ = ''
            for text__content_ in child_.childNodes:
                mode_ += text__content_.nodeValue
            self.mode = mode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'size':
            size_ = ''
            for text__content_ in child_.childNodes:
                size_ += text__content_.nodeValue
            self.size = size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'free':
            free_ = ''
            for text__content_ in child_.childNodes:
                free_ += text__content_.nodeValue
            self.free = free_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
# end class FS


class MigrationStatus:
    subclass = None
    def __init__(self, total=-1, completed=-1, description=None):
        self.total = total
        self.completed = completed
        self.description = description
    def factory(*args_, **kwargs_):
        if MigrationStatus.subclass:
            return MigrationStatus.subclass(*args_, **kwargs_)
        else:
            return MigrationStatus(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTotal(self): return self.total
    def setTotal(self, value): self.total = value
    def getCompleted(self): return self.completed
    def setCompleted(self, value): self.completed = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def export(self, outfile, level, name_='MigrationStatus'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MigrationStatus'):
        pass
    def exportChildren(self, outfile, level, name_='MigrationStatus'):
        showIndent(outfile, level)
        outfile.write('<total>%d</total>\n' % self.getTotal())
        showIndent(outfile, level)
        outfile.write('<completed>%d</completed>\n' % self.getCompleted())
        if self.description is not None:
            showIndent(outfile, level)
            outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'total':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.total = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'completed':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.completed = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
# end class MigrationStatus


class SecretKeyInfo:
    subclass = None
    def __init__(self, key='', ip_address='', description=''):
        self.key = key
        self.ip_address = ip_address
        self.description = description
    def factory(*args_, **kwargs_):
        if SecretKeyInfo.subclass:
            return SecretKeyInfo.subclass(*args_, **kwargs_)
        else:
            return SecretKeyInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getKey(self): return self.key
    def setKey(self, value): self.key = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def export(self, outfile, level, name_='SecretKeyInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SecretKeyInfo'):
        pass
    def exportChildren(self, outfile, level, name_='SecretKeyInfo'):
        showIndent(outfile, level)
        outfile.write('<key>%s</key>\n' % quote_xml(self.getKey()))
        showIndent(outfile, level)
        outfile.write('<ip_address>%s</ip_address>\n' % quote_xml(self.getIp_address()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'key':
            key_ = ''
            for text__content_ in child_.childNodes:
                key_ += text__content_.nodeValue
            self.key = key_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip_address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
# end class SecretKeyInfo


class SecretKeyResponseType:
    subclass = None
    def __init__(self, create=None, delete=None, get_info=None):
        if create is None:
            self.create = []
        else:
            self.create = create
        if delete is None:
            self.delete = []
        else:
            self.delete = delete
        if get_info is None:
            self.get_info = []
        else:
            self.get_info = get_info
    def factory(*args_, **kwargs_):
        if SecretKeyResponseType.subclass:
            return SecretKeyResponseType.subclass(*args_, **kwargs_)
        else:
            return SecretKeyResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCreate(self): return self.create
    def setCreate(self, value): self.create = value
    def addCreate(self, value): self.create.append(value)
    def insertCreate(self, index, value): self.create[index] = value
    def getDelete(self): return self.delete
    def setDelete(self, value): self.delete = value
    def addDelete(self, value): self.delete.append(value)
    def insertDelete(self, index, value): self.delete[index] = value
    def getGet_info(self): return self.get_info
    def setGet_info(self, value): self.get_info = value
    def addGet_info(self, value): self.get_info.append(value)
    def insertGet_info(self, index, value): self.get_info[index] = value
    def export(self, outfile, level, name_='SecretKeyResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SecretKeyResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='SecretKeyResponseType'):
        for create_ in self.getCreate():
            create_.export(outfile, level)
        for delete_ in self.getDelete():
            delete_.export(outfile, level)
        for get_info_ in self.getGet_info():
            get_info_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create':
            obj_ = create.factory()
            obj_.build(child_)
            self.create.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete':
            obj_ = delete.factory()
            obj_.build(child_)
            self.delete.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_info':
            obj_ = get_info.factory()
            obj_.build(child_)
            self.get_info.append(obj_)
# end class SecretKeyResponseType


class keyType:
    subclass = None
    def __init__(self, property=None, content=''):
        if property is None:
            self.property = []
        else:
            self.property = property
        self.content = content
    def factory(*args_, **kwargs_):
        if keyType.subclass:
            return keyType.subclass(*args_, **kwargs_)
        else:
            return keyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def getContent(self): return self.content
    def setContent(self, value): self.content = value
    def export(self, outfile, level, name_='keyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='keyType'):
        pass
    def exportChildren(self, outfile, level, name_='keyType'):
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
        showIndent(outfile, level)
        outfile.write('<content>%s</content>\n' % quote_xml(self.getContent()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = KeyPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'content':
            content_ = ''
            for text__content_ in child_.childNodes:
                content_ += text__content_.nodeValue
            self.content = content_
# end class keyType


class serverGenInfoType:
    subclass = None
    def __init__(self, server_name=''):
        self.server_name = server_name
    def factory(*args_, **kwargs_):
        if serverGenInfoType.subclass:
            return serverGenInfoType.subclass(*args_, **kwargs_)
        else:
            return serverGenInfoType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getServer_name(self): return self.server_name
    def setServer_name(self, value): self.server_name = value
    def export(self, outfile, level, name_='serverGenInfoType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='serverGenInfoType'):
        pass
    def exportChildren(self, outfile, level, name_='serverGenInfoType'):
        showIndent(outfile, level)
        outfile.write('<server_name>%s</server_name>\n' % quote_xml(self.getServer_name()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server_name':
            server_name_ = ''
            for text__content_ in child_.childNodes:
                server_name_ += text__content_.nodeValue
            self.server_name = server_name_
# end class serverGenInfoType


class componentsType:
    subclass = None
    def __init__(self, component=None):
        if component is None:
            self.component = []
        else:
            self.component = component
    def factory(*args_, **kwargs_):
        if componentsType.subclass:
            return componentsType.subclass(*args_, **kwargs_)
        else:
            return componentsType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getComponent(self): return self.component
    def setComponent(self, value): self.component = value
    def addComponent(self, value): self.component.append(value)
    def insertComponent(self, index, value): self.component[index] = value
    def export(self, outfile, level, name_='componentsType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='componentsType'):
        pass
    def exportChildren(self, outfile, level, name_='componentsType'):
        for component_ in self.getComponent():
            component_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'component':
            obj_ = component.factory()
            obj_.build(child_)
            self.component.append(obj_)
# end class componentsType


class servicesState:
    subclass = None
    def __init__(self, srv=None):
        if srv is None:
            self.srv = []
        else:
            self.srv = srv
    def factory(*args_, **kwargs_):
        if servicesState.subclass:
            return servicesState.subclass(*args_, **kwargs_)
        else:
            return servicesState(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSrv(self): return self.srv
    def setSrv(self, value): self.srv = value
    def addSrv(self, value): self.srv.append(value)
    def insertSrv(self, index, value): self.srv[index] = value
    def export(self, outfile, level, name_='servicesState'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='servicesState'):
        pass
    def exportChildren(self, outfile, level, name_='servicesState'):
        for srv_ in self.getSrv():
            srv_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'srv':
            obj_ = srv.factory()
            obj_.build(child_)
            self.srv.append(obj_)
# end class servicesState


class serverPrefs:
    subclass = None
    def __init__(self, stat_ttl=None, traffic_accounting=None, restart_apache_interval=None, aps_catalog_url=None):
        self.stat_ttl = stat_ttl
        self.traffic_accounting = traffic_accounting
        self.restart_apache_interval = restart_apache_interval
        self.aps_catalog_url = aps_catalog_url
    def factory(*args_, **kwargs_):
        if serverPrefs.subclass:
            return serverPrefs.subclass(*args_, **kwargs_)
        else:
            return serverPrefs(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStat_ttl(self): return self.stat_ttl
    def setStat_ttl(self, value): self.stat_ttl = value
    def getTraffic_accounting(self): return self.traffic_accounting
    def setTraffic_accounting(self, value): self.traffic_accounting = value
    def getRestart_apache_interval(self): return self.restart_apache_interval
    def setRestart_apache_interval(self, value): self.restart_apache_interval = value
    def getAps_catalog_url(self): return self.aps_catalog_url
    def setAps_catalog_url(self, value): self.aps_catalog_url = value
    def export(self, outfile, level, name_='serverPrefs'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='serverPrefs'):
        pass
    def exportChildren(self, outfile, level, name_='serverPrefs'):
        if self.stat_ttl is not None:
            showIndent(outfile, level)
            outfile.write('<stat_ttl>%s</stat_ttl>\n' % quote_xml(self.getStat_ttl()))
        if self.traffic_accounting is not None:
            showIndent(outfile, level)
            outfile.write('<traffic_accounting>%s</traffic_accounting>\n' % quote_xml(self.getTraffic_accounting()))
        if self.restart_apache_interval is not None:
            showIndent(outfile, level)
            outfile.write('<restart_apache_interval>%s</restart_apache_interval>\n' % quote_xml(self.getRestart_apache_interval()))
        if self.aps_catalog_url is not None:
            showIndent(outfile, level)
            outfile.write('<aps-catalog-url>%s</aps-catalog-url>\n' % quote_xml(self.getAps_catalog_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat_ttl':
            stat_ttl_ = ''
            for text__content_ in child_.childNodes:
                stat_ttl_ += text__content_.nodeValue
            self.stat_ttl = stat_ttl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic_accounting':
            traffic_accounting_ = ''
            for text__content_ in child_.childNodes:
                traffic_accounting_ += text__content_.nodeValue
            self.traffic_accounting = traffic_accounting_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restart_apache_interval':
            restart_apache_interval_ = ''
            for text__content_ in child_.childNodes:
                restart_apache_interval_ += text__content_.nodeValue
            self.restart_apache_interval = restart_apache_interval_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aps-catalog-url':
            aps_catalog_url_ = ''
            for text__content_ in child_.childNodes:
                aps_catalog_url_ += text__content_.nodeValue
            self.aps_catalog_url = aps_catalog_url_
# end class serverPrefs


class serverSessionSetup:
    subclass = None
    def __init__(self, login_timeout=None):
        self.login_timeout = login_timeout
    def factory(*args_, **kwargs_):
        if serverSessionSetup.subclass:
            return serverSessionSetup.subclass(*args_, **kwargs_)
        else:
            return serverSessionSetup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getLogin_timeout(self): return self.login_timeout
    def setLogin_timeout(self, value): self.login_timeout = value
    def export(self, outfile, level, name_='serverSessionSetup'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='serverSessionSetup'):
        pass
    def exportChildren(self, outfile, level, name_='serverSessionSetup'):
        if self.login_timeout is not None:
            showIndent(outfile, level)
            outfile.write('<login_timeout>%s</login_timeout>\n' % quote_xml(self.getLogin_timeout()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login_timeout':
            login_timeout_ = ''
            for text__content_ in child_.childNodes:
                login_timeout_ += text__content_.nodeValue
            self.login_timeout = login_timeout_
# end class serverSessionSetup


class statType:
    subclass = None
    def __init__(self, objects=None, version=None, other=None, load_avg=None, mem=None, swap=None, diskspace=None):
        self.objects = objects
        self.version = version
        self.other = other
        self.load_avg = load_avg
        self.mem = mem
        self.swap = swap
        self.diskspace = diskspace
    def factory(*args_, **kwargs_):
        if statType.subclass:
            return statType.subclass(*args_, **kwargs_)
        else:
            return statType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getObjects(self): return self.objects
    def setObjects(self, value): self.objects = value
    def getVersion(self): return self.version
    def setVersion(self, value): self.version = value
    def getOther(self): return self.other
    def setOther(self, value): self.other = value
    def getLoad_avg(self): return self.load_avg
    def setLoad_avg(self, value): self.load_avg = value
    def getMem(self): return self.mem
    def setMem(self, value): self.mem = value
    def getSwap(self): return self.swap
    def setSwap(self, value): self.swap = value
    def getDiskspace(self): return self.diskspace
    def setDiskspace(self, value): self.diskspace = value
    def export(self, outfile, level, name_='statType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='statType'):
        pass
    def exportChildren(self, outfile, level, name_='statType'):
        if self.objects is not None:
            self.objects.export(outfile, level, name_='objects')
        if self.version is not None:
            self.version.export(outfile, level, name_='version')
        if self.other is not None:
            self.other.export(outfile, level, name_='other')
        if self.load_avg is not None:
            self.load_avg.export(outfile, level, name_='load_avg')
        if self.mem is not None:
            self.mem.export(outfile, level, name_='mem')
        if self.swap is not None:
            self.swap.export(outfile, level, name_='swap')
        if self.diskspace is not None:
            self.diskspace.export(outfile, level, name_='diskspace')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'objects':
            obj_ = objectsStatType.factory()
            obj_.build(child_)
            self.setObjects(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'version':
            obj_ = versionStatType.factory()
            obj_.build(child_)
            self.setVersion(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'other':
            obj_ = otherStatType.factory()
            obj_.build(child_)
            self.setOther(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'load_avg':
            obj_ = load_avgStatType.factory()
            obj_.build(child_)
            self.setLoad_avg(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mem':
            obj_ = memStatType.factory()
            obj_.build(child_)
            self.setMem(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'swap':
            obj_ = swapStatType.factory()
            obj_.build(child_)
            self.setSwap(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'diskspace':
            obj_ = diskspaceStatType.factory()
            obj_.build(child_)
            self.setDiskspace(obj_)
# end class statType


class objectsStatType:
    subclass = None
    def __init__(self, clients='', domains='', active_domains='', mail_boxes='', mail_redirects='', mail_groups='', mail_responders='', web_users='', databases='', database_users='', problem_clients='', problem_domains=''):
        self.clients = clients
        self.domains = domains
        self.active_domains = active_domains
        self.mail_boxes = mail_boxes
        self.mail_redirects = mail_redirects
        self.mail_groups = mail_groups
        self.mail_responders = mail_responders
        self.web_users = web_users
        self.databases = databases
        self.database_users = database_users
        self.problem_clients = problem_clients
        self.problem_domains = problem_domains
    def factory(*args_, **kwargs_):
        if objectsStatType.subclass:
            return objectsStatType.subclass(*args_, **kwargs_)
        else:
            return objectsStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getClients(self): return self.clients
    def setClients(self, value): self.clients = value
    def getDomains(self): return self.domains
    def setDomains(self, value): self.domains = value
    def getActive_domains(self): return self.active_domains
    def setActive_domains(self, value): self.active_domains = value
    def getMail_boxes(self): return self.mail_boxes
    def setMail_boxes(self, value): self.mail_boxes = value
    def getMail_redirects(self): return self.mail_redirects
    def setMail_redirects(self, value): self.mail_redirects = value
    def getMail_groups(self): return self.mail_groups
    def setMail_groups(self, value): self.mail_groups = value
    def getMail_responders(self): return self.mail_responders
    def setMail_responders(self, value): self.mail_responders = value
    def getWeb_users(self): return self.web_users
    def setWeb_users(self, value): self.web_users = value
    def getDatabases(self): return self.databases
    def setDatabases(self, value): self.databases = value
    def getDatabase_users(self): return self.database_users
    def setDatabase_users(self, value): self.database_users = value
    def getProblem_clients(self): return self.problem_clients
    def setProblem_clients(self, value): self.problem_clients = value
    def getProblem_domains(self): return self.problem_domains
    def setProblem_domains(self, value): self.problem_domains = value
    def export(self, outfile, level, name_='objectsStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='objectsStatType'):
        pass
    def exportChildren(self, outfile, level, name_='objectsStatType'):
        showIndent(outfile, level)
        outfile.write('<clients>%s</clients>\n' % quote_xml(self.getClients()))
        showIndent(outfile, level)
        outfile.write('<domains>%s</domains>\n' % quote_xml(self.getDomains()))
        showIndent(outfile, level)
        outfile.write('<active_domains>%s</active_domains>\n' % quote_xml(self.getActive_domains()))
        showIndent(outfile, level)
        outfile.write('<mail_boxes>%s</mail_boxes>\n' % quote_xml(self.getMail_boxes()))
        showIndent(outfile, level)
        outfile.write('<mail_redirects>%s</mail_redirects>\n' % quote_xml(self.getMail_redirects()))
        showIndent(outfile, level)
        outfile.write('<mail_groups>%s</mail_groups>\n' % quote_xml(self.getMail_groups()))
        showIndent(outfile, level)
        outfile.write('<mail_responders>%s</mail_responders>\n' % quote_xml(self.getMail_responders()))
        showIndent(outfile, level)
        outfile.write('<web_users>%s</web_users>\n' % quote_xml(self.getWeb_users()))
        showIndent(outfile, level)
        outfile.write('<databases>%s</databases>\n' % quote_xml(self.getDatabases()))
        showIndent(outfile, level)
        outfile.write('<database_users>%s</database_users>\n' % quote_xml(self.getDatabase_users()))
        showIndent(outfile, level)
        outfile.write('<problem_clients>%s</problem_clients>\n' % quote_xml(self.getProblem_clients()))
        showIndent(outfile, level)
        outfile.write('<problem_domains>%s</problem_domains>\n' % quote_xml(self.getProblem_domains()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'clients':
            clients_ = ''
            for text__content_ in child_.childNodes:
                clients_ += text__content_.nodeValue
            self.clients = clients_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domains':
            domains_ = ''
            for text__content_ in child_.childNodes:
                domains_ += text__content_.nodeValue
            self.domains = domains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'active_domains':
            active_domains_ = ''
            for text__content_ in child_.childNodes:
                active_domains_ += text__content_.nodeValue
            self.active_domains = active_domains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_boxes':
            mail_boxes_ = ''
            for text__content_ in child_.childNodes:
                mail_boxes_ += text__content_.nodeValue
            self.mail_boxes = mail_boxes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_redirects':
            mail_redirects_ = ''
            for text__content_ in child_.childNodes:
                mail_redirects_ += text__content_.nodeValue
            self.mail_redirects = mail_redirects_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_groups':
            mail_groups_ = ''
            for text__content_ in child_.childNodes:
                mail_groups_ += text__content_.nodeValue
            self.mail_groups = mail_groups_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail_responders':
            mail_responders_ = ''
            for text__content_ in child_.childNodes:
                mail_responders_ += text__content_.nodeValue
            self.mail_responders = mail_responders_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'web_users':
            web_users_ = ''
            for text__content_ in child_.childNodes:
                web_users_ += text__content_.nodeValue
            self.web_users = web_users_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'databases':
            databases_ = ''
            for text__content_ in child_.childNodes:
                databases_ += text__content_.nodeValue
            self.databases = databases_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'database_users':
            database_users_ = ''
            for text__content_ in child_.childNodes:
                database_users_ += text__content_.nodeValue
            self.database_users = database_users_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'problem_clients':
            problem_clients_ = ''
            for text__content_ in child_.childNodes:
                problem_clients_ += text__content_.nodeValue
            self.problem_clients = problem_clients_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'problem_domains':
            problem_domains_ = ''
            for text__content_ in child_.childNodes:
                problem_domains_ += text__content_.nodeValue
            self.problem_domains = problem_domains_
# end class objectsStatType


class versionStatType:
    subclass = None
    def __init__(self, plesk_name='', plesk_version='', plesk_os='', plesk_os_version='', plesk_build='', os_release='', veid=None):
        self.plesk_name = plesk_name
        self.plesk_version = plesk_version
        self.plesk_os = plesk_os
        self.plesk_os_version = plesk_os_version
        self.plesk_build = plesk_build
        self.os_release = os_release
        self.veid = veid
    def factory(*args_, **kwargs_):
        if versionStatType.subclass:
            return versionStatType.subclass(*args_, **kwargs_)
        else:
            return versionStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPlesk_name(self): return self.plesk_name
    def setPlesk_name(self, value): self.plesk_name = value
    def getPlesk_version(self): return self.plesk_version
    def setPlesk_version(self, value): self.plesk_version = value
    def getPlesk_os(self): return self.plesk_os
    def setPlesk_os(self, value): self.plesk_os = value
    def getPlesk_os_version(self): return self.plesk_os_version
    def setPlesk_os_version(self, value): self.plesk_os_version = value
    def getPlesk_build(self): return self.plesk_build
    def setPlesk_build(self, value): self.plesk_build = value
    def getOs_release(self): return self.os_release
    def setOs_release(self, value): self.os_release = value
    def getVeid(self): return self.veid
    def setVeid(self, value): self.veid = value
    def export(self, outfile, level, name_='versionStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='versionStatType'):
        pass
    def exportChildren(self, outfile, level, name_='versionStatType'):
        showIndent(outfile, level)
        outfile.write('<plesk_name>%s</plesk_name>\n' % quote_xml(self.getPlesk_name()))
        showIndent(outfile, level)
        outfile.write('<plesk_version>%s</plesk_version>\n' % quote_xml(self.getPlesk_version()))
        showIndent(outfile, level)
        outfile.write('<plesk_os>%s</plesk_os>\n' % quote_xml(self.getPlesk_os()))
        showIndent(outfile, level)
        outfile.write('<plesk_os_version>%s</plesk_os_version>\n' % quote_xml(self.getPlesk_os_version()))
        showIndent(outfile, level)
        outfile.write('<plesk_build>%s</plesk_build>\n' % quote_xml(self.getPlesk_build()))
        showIndent(outfile, level)
        outfile.write('<os_release>%s</os_release>\n' % quote_xml(self.getOs_release()))
        if self.veid is not None:
            showIndent(outfile, level)
            outfile.write('<veid>%d</veid>\n' % self.getVeid())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk_name':
            plesk_name_ = ''
            for text__content_ in child_.childNodes:
                plesk_name_ += text__content_.nodeValue
            self.plesk_name = plesk_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk_version':
            plesk_version_ = ''
            for text__content_ in child_.childNodes:
                plesk_version_ += text__content_.nodeValue
            self.plesk_version = plesk_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk_os':
            plesk_os_ = ''
            for text__content_ in child_.childNodes:
                plesk_os_ += text__content_.nodeValue
            self.plesk_os = plesk_os_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk_os_version':
            plesk_os_version_ = ''
            for text__content_ in child_.childNodes:
                plesk_os_version_ += text__content_.nodeValue
            self.plesk_os_version = plesk_os_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk_build':
            plesk_build_ = ''
            for text__content_ in child_.childNodes:
                plesk_build_ += text__content_.nodeValue
            self.plesk_build = plesk_build_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'os_release':
            os_release_ = ''
            for text__content_ in child_.childNodes:
                os_release_ += text__content_.nodeValue
            self.os_release = os_release_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'veid':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                try:
                    ival_ = int(sval_)
                except ValueError:
                    raise ValueError('requires integer -- %s' % child_.toxml())
                self.veid = ival_
# end class versionStatType


class otherStatType:
    subclass = None
    def __init__(self, cpu='', uptime='', inside_vz=''):
        self.cpu = cpu
        self.uptime = uptime
        self.inside_vz = inside_vz
    def factory(*args_, **kwargs_):
        if otherStatType.subclass:
            return otherStatType.subclass(*args_, **kwargs_)
        else:
            return otherStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCpu(self): return self.cpu
    def setCpu(self, value): self.cpu = value
    def getUptime(self): return self.uptime
    def setUptime(self, value): self.uptime = value
    def getInside_vz(self): return self.inside_vz
    def setInside_vz(self, value): self.inside_vz = value
    def export(self, outfile, level, name_='otherStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='otherStatType'):
        pass
    def exportChildren(self, outfile, level, name_='otherStatType'):
        showIndent(outfile, level)
        outfile.write('<cpu>%s</cpu>\n' % quote_xml(self.getCpu()))
        showIndent(outfile, level)
        outfile.write('<uptime>%s</uptime>\n' % quote_xml(self.getUptime()))
        showIndent(outfile, level)
        outfile.write('<inside_vz>%s</inside_vz>\n' % quote_xml(self.getInside_vz()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cpu':
            cpu_ = ''
            for text__content_ in child_.childNodes:
                cpu_ += text__content_.nodeValue
            self.cpu = cpu_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'uptime':
            uptime_ = ''
            for text__content_ in child_.childNodes:
                uptime_ += text__content_.nodeValue
            self.uptime = uptime_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'inside_vz':
            inside_vz_ = ''
            for text__content_ in child_.childNodes:
                inside_vz_ += text__content_.nodeValue
            self.inside_vz = inside_vz_
# end class otherStatType


class load_avgStatType:
    subclass = None
    def __init__(self, l1='', l5='', l15=''):
        self.l1 = l1
        self.l5 = l5
        self.l15 = l15
    def factory(*args_, **kwargs_):
        if load_avgStatType.subclass:
            return load_avgStatType.subclass(*args_, **kwargs_)
        else:
            return load_avgStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getL1(self): return self.l1
    def setL1(self, value): self.l1 = value
    def getL5(self): return self.l5
    def setL5(self, value): self.l5 = value
    def getL15(self): return self.l15
    def setL15(self, value): self.l15 = value
    def export(self, outfile, level, name_='load_avgStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='load_avgStatType'):
        pass
    def exportChildren(self, outfile, level, name_='load_avgStatType'):
        showIndent(outfile, level)
        outfile.write('<l1>%s</l1>\n' % quote_xml(self.getL1()))
        showIndent(outfile, level)
        outfile.write('<l5>%s</l5>\n' % quote_xml(self.getL5()))
        showIndent(outfile, level)
        outfile.write('<l15>%s</l15>\n' % quote_xml(self.getL15()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'l1':
            l1_ = ''
            for text__content_ in child_.childNodes:
                l1_ += text__content_.nodeValue
            self.l1 = l1_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'l5':
            l5_ = ''
            for text__content_ in child_.childNodes:
                l5_ += text__content_.nodeValue
            self.l5 = l5_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'l15':
            l15_ = ''
            for text__content_ in child_.childNodes:
                l15_ += text__content_.nodeValue
            self.l15 = l15_
# end class load_avgStatType


class memStatType:
    subclass = None
    def __init__(self, total='', used='', free='', shared='', buffer='', cached=''):
        self.total = total
        self.used = used
        self.free = free
        self.shared = shared
        self.buffer = buffer
        self.cached = cached
    def factory(*args_, **kwargs_):
        if memStatType.subclass:
            return memStatType.subclass(*args_, **kwargs_)
        else:
            return memStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTotal(self): return self.total
    def setTotal(self, value): self.total = value
    def getUsed(self): return self.used
    def setUsed(self, value): self.used = value
    def getFree(self): return self.free
    def setFree(self, value): self.free = value
    def getShared(self): return self.shared
    def setShared(self, value): self.shared = value
    def getBuffer(self): return self.buffer
    def setBuffer(self, value): self.buffer = value
    def getCached(self): return self.cached
    def setCached(self, value): self.cached = value
    def export(self, outfile, level, name_='memStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='memStatType'):
        pass
    def exportChildren(self, outfile, level, name_='memStatType'):
        showIndent(outfile, level)
        outfile.write('<total>%s</total>\n' % quote_xml(self.getTotal()))
        showIndent(outfile, level)
        outfile.write('<used>%s</used>\n' % quote_xml(self.getUsed()))
        showIndent(outfile, level)
        outfile.write('<free>%s</free>\n' % quote_xml(self.getFree()))
        showIndent(outfile, level)
        outfile.write('<shared>%s</shared>\n' % quote_xml(self.getShared()))
        showIndent(outfile, level)
        outfile.write('<buffer>%s</buffer>\n' % quote_xml(self.getBuffer()))
        showIndent(outfile, level)
        outfile.write('<cached>%s</cached>\n' % quote_xml(self.getCached()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'total':
            total_ = ''
            for text__content_ in child_.childNodes:
                total_ += text__content_.nodeValue
            self.total = total_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'used':
            used_ = ''
            for text__content_ in child_.childNodes:
                used_ += text__content_.nodeValue
            self.used = used_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'free':
            free_ = ''
            for text__content_ in child_.childNodes:
                free_ += text__content_.nodeValue
            self.free = free_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shared':
            shared_ = ''
            for text__content_ in child_.childNodes:
                shared_ += text__content_.nodeValue
            self.shared = shared_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'buffer':
            buffer_ = ''
            for text__content_ in child_.childNodes:
                buffer_ += text__content_.nodeValue
            self.buffer = buffer_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cached':
            cached_ = ''
            for text__content_ in child_.childNodes:
                cached_ += text__content_.nodeValue
            self.cached = cached_
# end class memStatType


class swapStatType:
    subclass = None
    def __init__(self, total='', used='', free=''):
        self.total = total
        self.used = used
        self.free = free
    def factory(*args_, **kwargs_):
        if swapStatType.subclass:
            return swapStatType.subclass(*args_, **kwargs_)
        else:
            return swapStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTotal(self): return self.total
    def setTotal(self, value): self.total = value
    def getUsed(self): return self.used
    def setUsed(self, value): self.used = value
    def getFree(self): return self.free
    def setFree(self, value): self.free = value
    def export(self, outfile, level, name_='swapStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='swapStatType'):
        pass
    def exportChildren(self, outfile, level, name_='swapStatType'):
        showIndent(outfile, level)
        outfile.write('<total>%s</total>\n' % quote_xml(self.getTotal()))
        showIndent(outfile, level)
        outfile.write('<used>%s</used>\n' % quote_xml(self.getUsed()))
        showIndent(outfile, level)
        outfile.write('<free>%s</free>\n' % quote_xml(self.getFree()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'total':
            total_ = ''
            for text__content_ in child_.childNodes:
                total_ += text__content_.nodeValue
            self.total = total_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'used':
            used_ = ''
            for text__content_ in child_.childNodes:
                used_ += text__content_.nodeValue
            self.used = used_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'free':
            free_ = ''
            for text__content_ in child_.childNodes:
                free_ += text__content_.nodeValue
            self.free = free_
# end class swapStatType


class diskspaceStatType:
    subclass = None
    def __init__(self, device=None):
        if device is None:
            self.device = []
        else:
            self.device = device
    def factory(*args_, **kwargs_):
        if diskspaceStatType.subclass:
            return diskspaceStatType.subclass(*args_, **kwargs_)
        else:
            return diskspaceStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDevice(self): return self.device
    def setDevice(self, value): self.device = value
    def addDevice(self, value): self.device.append(value)
    def insertDevice(self, index, value): self.device[index] = value
    def export(self, outfile, level, name_='diskspaceStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='diskspaceStatType'):
        pass
    def exportChildren(self, outfile, level, name_='diskspaceStatType'):
        for device_ in self.getDevice():
            device_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'device':
            obj_ = device.factory()
            obj_.build(child_)
            self.device.append(obj_)
# end class diskspaceStatType


class adminType:
    subclass = None
    def __init__(self, admin_cname='', admin_pname='', admin_phone='', admin_fax='', admin_email='', admin_address='', admin_city='', admin_state='', admin_pcode='', admin_country='', send_announce=''):
        self.admin_cname = admin_cname
        self.admin_pname = admin_pname
        self.admin_phone = admin_phone
        self.admin_fax = admin_fax
        self.admin_email = admin_email
        self.admin_address = admin_address
        self.admin_city = admin_city
        self.admin_state = admin_state
        self.admin_pcode = admin_pcode
        self.admin_country = admin_country
        self.send_announce = send_announce
    def factory(*args_, **kwargs_):
        if adminType.subclass:
            return adminType.subclass(*args_, **kwargs_)
        else:
            return adminType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdmin_cname(self): return self.admin_cname
    def setAdmin_cname(self, value): self.admin_cname = value
    def getAdmin_pname(self): return self.admin_pname
    def setAdmin_pname(self, value): self.admin_pname = value
    def getAdmin_phone(self): return self.admin_phone
    def setAdmin_phone(self, value): self.admin_phone = value
    def getAdmin_fax(self): return self.admin_fax
    def setAdmin_fax(self, value): self.admin_fax = value
    def getAdmin_email(self): return self.admin_email
    def setAdmin_email(self, value): self.admin_email = value
    def getAdmin_address(self): return self.admin_address
    def setAdmin_address(self, value): self.admin_address = value
    def getAdmin_city(self): return self.admin_city
    def setAdmin_city(self, value): self.admin_city = value
    def getAdmin_state(self): return self.admin_state
    def setAdmin_state(self, value): self.admin_state = value
    def getAdmin_pcode(self): return self.admin_pcode
    def setAdmin_pcode(self, value): self.admin_pcode = value
    def getAdmin_country(self): return self.admin_country
    def setAdmin_country(self, value): self.admin_country = value
    def getSend_announce(self): return self.send_announce
    def setSend_announce(self, value): self.send_announce = value
    def export(self, outfile, level, name_='adminType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='adminType'):
        pass
    def exportChildren(self, outfile, level, name_='adminType'):
        showIndent(outfile, level)
        outfile.write('<admin_cname>%s</admin_cname>\n' % quote_xml(self.getAdmin_cname()))
        showIndent(outfile, level)
        outfile.write('<admin_pname>%s</admin_pname>\n' % quote_xml(self.getAdmin_pname()))
        showIndent(outfile, level)
        outfile.write('<admin_phone>%s</admin_phone>\n' % quote_xml(self.getAdmin_phone()))
        showIndent(outfile, level)
        outfile.write('<admin_fax>%s</admin_fax>\n' % quote_xml(self.getAdmin_fax()))
        showIndent(outfile, level)
        outfile.write('<admin_email>%s</admin_email>\n' % quote_xml(self.getAdmin_email()))
        showIndent(outfile, level)
        outfile.write('<admin_address>%s</admin_address>\n' % quote_xml(self.getAdmin_address()))
        showIndent(outfile, level)
        outfile.write('<admin_city>%s</admin_city>\n' % quote_xml(self.getAdmin_city()))
        showIndent(outfile, level)
        outfile.write('<admin_state>%s</admin_state>\n' % quote_xml(self.getAdmin_state()))
        showIndent(outfile, level)
        outfile.write('<admin_pcode>%s</admin_pcode>\n' % quote_xml(self.getAdmin_pcode()))
        showIndent(outfile, level)
        outfile.write('<admin_country>%s</admin_country>\n' % quote_xml(self.getAdmin_country()))
        showIndent(outfile, level)
        outfile.write('<send_announce>%s</send_announce>\n' % quote_xml(self.getSend_announce()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_cname':
            admin_cname_ = ''
            for text__content_ in child_.childNodes:
                admin_cname_ += text__content_.nodeValue
            self.admin_cname = admin_cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_pname':
            admin_pname_ = ''
            for text__content_ in child_.childNodes:
                admin_pname_ += text__content_.nodeValue
            self.admin_pname = admin_pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_phone':
            admin_phone_ = ''
            for text__content_ in child_.childNodes:
                admin_phone_ += text__content_.nodeValue
            self.admin_phone = admin_phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_fax':
            admin_fax_ = ''
            for text__content_ in child_.childNodes:
                admin_fax_ += text__content_.nodeValue
            self.admin_fax = admin_fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_email':
            admin_email_ = ''
            for text__content_ in child_.childNodes:
                admin_email_ += text__content_.nodeValue
            self.admin_email = admin_email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_address':
            admin_address_ = ''
            for text__content_ in child_.childNodes:
                admin_address_ += text__content_.nodeValue
            self.admin_address = admin_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_city':
            admin_city_ = ''
            for text__content_ in child_.childNodes:
                admin_city_ += text__content_.nodeValue
            self.admin_city = admin_city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_state':
            admin_state_ = ''
            for text__content_ in child_.childNodes:
                admin_state_ += text__content_.nodeValue
            self.admin_state = admin_state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_pcode':
            admin_pcode_ = ''
            for text__content_ in child_.childNodes:
                admin_pcode_ += text__content_.nodeValue
            self.admin_pcode = admin_pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin_country':
            admin_country_ = ''
            for text__content_ in child_.childNodes:
                admin_country_ += text__content_.nodeValue
            self.admin_country = admin_country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'send_announce':
            send_announce_ = ''
            for text__content_ in child_.childNodes:
                send_announce_ += text__content_.nodeValue
            self.send_announce = send_announce_
# end class adminType


class interfacesType:
    subclass = None
    def __init__(self, interface=''):
        self.interface = interface
    def factory(*args_, **kwargs_):
        if interfacesType.subclass:
            return interfacesType.subclass(*args_, **kwargs_)
        else:
            return interfacesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getInterface(self): return self.interface
    def setInterface(self, value): self.interface = value
    def export(self, outfile, level, name_='interfacesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='interfacesType'):
        pass
    def exportChildren(self, outfile, level, name_='interfacesType'):
        showIndent(outfile, level)
        outfile.write('<interface>%s</interface>\n' % quote_xml(self.getInterface()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'interface':
            interface_ = ''
            for text__content_ in child_.childNodes:
                interface_ += text__content_.nodeValue
            self.interface = interface_
# end class interfacesType


class shellType:
    subclass = None
    def __init__(self, name='', path=''):
        self.name = name
        self.path = path
    def factory(*args_, **kwargs_):
        if shellType.subclass:
            return shellType.subclass(*args_, **kwargs_)
        else:
            return shellType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getPath(self): return self.path
    def setPath(self, value): self.path = value
    def export(self, outfile, level, name_='shellType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='shellType'):
        pass
    def exportChildren(self, outfile, level, name_='shellType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<path>%s</path>\n' % quote_xml(self.getPath()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'path':
            path_ = ''
            for text__content_ in child_.childNodes:
                path_ += text__content_.nodeValue
            self.path = path_
# end class shellType


class initialSetupType:
    subclass = None
    def __init__(self, admin=None, password='', server_name=None):
        self.admin = admin
        self.password = password
        self.server_name = server_name
    def factory(*args_, **kwargs_):
        if initialSetupType.subclass:
            return initialSetupType.subclass(*args_, **kwargs_)
        else:
            return initialSetupType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getServer_name(self): return self.server_name
    def setServer_name(self, value): self.server_name = value
    def export(self, outfile, level, name_='initialSetupType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='initialSetupType'):
        pass
    def exportChildren(self, outfile, level, name_='initialSetupType'):
        if self.admin is not None:
            self.admin.export(outfile, level, name_='admin')
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.server_name is not None:
            showIndent(outfile, level)
            outfile.write('<server_name>%s</server_name>\n' % quote_xml(self.getServer_name()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            obj_ = adminType.factory()
            obj_.build(child_)
            self.setAdmin(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server_name':
            server_name_ = ''
            for text__content_ in child_.childNodes:
                server_name_ += text__content_.nodeValue
            self.server_name = server_name_
# end class initialSetupType


class aeParamsType:
    subclass = None
    def __init__(self, host='', user='', password=''):
        self.host = host
        self.user = user
        self.password = password
    def factory(*args_, **kwargs_):
        if aeParamsType.subclass:
            return aeParamsType.subclass(*args_, **kwargs_)
        else:
            return aeParamsType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getUser(self): return self.user
    def setUser(self, value): self.user = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def export(self, outfile, level, name_='aeParamsType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='aeParamsType'):
        pass
    def exportChildren(self, outfile, level, name_='aeParamsType'):
        showIndent(outfile, level)
        outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        showIndent(outfile, level)
        outfile.write('<user>%s</user>\n' % quote_xml(self.getUser()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'user':
            user_ = ''
            for text__content_ in child_.childNodes:
                user_ += text__content_.nodeValue
            self.user = user_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
# end class aeParamsType


class KeyPropertyType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if KeyPropertyType.subclass:
            return KeyPropertyType.subclass(*args_, **kwargs_)
        else:
            return KeyPropertyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='KeyPropertyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='KeyPropertyType'):
        pass
    def exportChildren(self, outfile, level, name_='KeyPropertyType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class KeyPropertyType


class GetValidationModeResultType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if GetValidationModeResultType.subclass:
            return GetValidationModeResultType.subclass(*args_, **kwargs_)
        else:
            return GetValidationModeResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='GetValidationModeResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetValidationModeResultType'):
        pass
    def exportChildren(self, outfile, level, name_='GetValidationModeResultType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class GetValidationModeResultType


class SetValidationModeResultType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SetValidationModeResultType.subclass:
            return SetValidationModeResultType.subclass(*args_, **kwargs_)
        else:
            return SetValidationModeResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SetValidationModeResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetValidationModeResultType'):
        pass
    def exportChildren(self, outfile, level, name_='SetValidationModeResultType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SetValidationModeResultType


class ServerOperatorType:
    subclass = None
    def __init__(self, get_protos=None, get=None, set=None, srv_man=None, lic_install=None, initial_setup=None, get_additional_key=None, set_misc=None, get_misc=None, del_misc=None, create_session=None, set_ppb_connection=None):
        if get_protos is None:
            self.get_protos = []
        else:
            self.get_protos = get_protos
        if get is None:
            self.get = []
        else:
            self.get = get
        if set is None:
            self.set = []
        else:
            self.set = set
        if srv_man is None:
            self.srv_man = []
        else:
            self.srv_man = srv_man
        if lic_install is None:
            self.lic_install = []
        else:
            self.lic_install = lic_install
        if initial_setup is None:
            self.initial_setup = []
        else:
            self.initial_setup = initial_setup
        if get_additional_key is None:
            self.get_additional_key = []
        else:
            self.get_additional_key = get_additional_key
        if set_misc is None:
            self.set_misc = []
        else:
            self.set_misc = set_misc
        if get_misc is None:
            self.get_misc = []
        else:
            self.get_misc = get_misc
        if del_misc is None:
            self.del_misc = []
        else:
            self.del_misc = del_misc
        if create_session is None:
            self.create_session = []
        else:
            self.create_session = create_session
        if set_ppb_connection is None:
            self.set_ppb_connection = []
        else:
            self.set_ppb_connection = set_ppb_connection
    def factory(*args_, **kwargs_):
        if ServerOperatorType.subclass:
            return ServerOperatorType.subclass(*args_, **kwargs_)
        else:
            return ServerOperatorType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet_protos(self): return self.get_protos
    def setGet_protos(self, value): self.get_protos = value
    def addGet_protos(self, value): self.get_protos.append(value)
    def insertGet_protos(self, index, value): self.get_protos[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getSrv_man(self): return self.srv_man
    def setSrv_man(self, value): self.srv_man = value
    def addSrv_man(self, value): self.srv_man.append(value)
    def insertSrv_man(self, index, value): self.srv_man[index] = value
    def getLic_install(self): return self.lic_install
    def setLic_install(self, value): self.lic_install = value
    def addLic_install(self, value): self.lic_install.append(value)
    def insertLic_install(self, index, value): self.lic_install[index] = value
    def getInitial_setup(self): return self.initial_setup
    def setInitial_setup(self, value): self.initial_setup = value
    def addInitial_setup(self, value): self.initial_setup.append(value)
    def insertInitial_setup(self, index, value): self.initial_setup[index] = value
    def getGet_additional_key(self): return self.get_additional_key
    def setGet_additional_key(self, value): self.get_additional_key = value
    def addGet_additional_key(self, value): self.get_additional_key.append(value)
    def insertGet_additional_key(self, index, value): self.get_additional_key[index] = value
    def getSet_misc(self): return self.set_misc
    def setSet_misc(self, value): self.set_misc = value
    def addSet_misc(self, value): self.set_misc.append(value)
    def insertSet_misc(self, index, value): self.set_misc[index] = value
    def getGet_misc(self): return self.get_misc
    def setGet_misc(self, value): self.get_misc = value
    def addGet_misc(self, value): self.get_misc.append(value)
    def insertGet_misc(self, index, value): self.get_misc[index] = value
    def getDel_misc(self): return self.del_misc
    def setDel_misc(self, value): self.del_misc = value
    def addDel_misc(self, value): self.del_misc.append(value)
    def insertDel_misc(self, index, value): self.del_misc[index] = value
    def getCreate_session(self): return self.create_session
    def setCreate_session(self, value): self.create_session = value
    def addCreate_session(self, value): self.create_session.append(value)
    def insertCreate_session(self, index, value): self.create_session[index] = value
    def getSet_ppb_connection(self): return self.set_ppb_connection
    def setSet_ppb_connection(self, value): self.set_ppb_connection = value
    def addSet_ppb_connection(self, value): self.set_ppb_connection.append(value)
    def insertSet_ppb_connection(self, index, value): self.set_ppb_connection[index] = value
    def export(self, outfile, level, name_='ServerOperatorType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ServerOperatorType'):
        pass
    def exportChildren(self, outfile, level, name_='ServerOperatorType'):
        for get_protos_ in self.getGet_protos():
            get_protos_.export(outfile, level, name_='get_protos')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for srv_man_ in self.getSrv_man():
            srv_man_.export(outfile, level, name_='srv_man')
        for lic_install_ in self.getLic_install():
            lic_install_.export(outfile, level, name_='lic_install')
        for initial_setup_ in self.getInitial_setup():
            initial_setup_.export(outfile, level, name_='initial_setup')
        for get_additional_key_ in self.getGet_additional_key():
            get_additional_key_.export(outfile, level, name_='get_additional_key')
        for set_misc_ in self.getSet_misc():
            set_misc_.export(outfile, level, name_='set_misc')
        for get_misc_ in self.getGet_misc():
            get_misc_.export(outfile, level, name_='get_misc')
        for del_misc_ in self.getDel_misc():
            del_misc_.export(outfile, level, name_='del_misc')
        for create_session_ in self.getCreate_session():
            create_session_.export(outfile, level, name_='create_session')
        for set_ppb_connection_ in self.getSet_ppb_connection():
            set_ppb_connection_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_protos':
            obj_ = GetProtosType.factory()
            obj_.build(child_)
            self.get_protos.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = GetType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = SetType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'srv_man':
            obj_ = ServicesManagementType.factory()
            obj_.build(child_)
            self.srv_man.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'lic_install':
            obj_ = LicenseInstallType.factory()
            obj_.build(child_)
            self.lic_install.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'initial_setup':
            obj_ = InitialSetupType.factory()
            obj_.build(child_)
            self.initial_setup.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_additional_key':
            obj_ = GetAdditionalKeyType.factory()
            obj_.build(child_)
            self.get_additional_key.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set_misc':
            obj_ = SetMiscType.factory()
            obj_.build(child_)
            self.set_misc.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_misc':
            obj_ = GetMiscType.factory()
            obj_.build(child_)
            self.get_misc.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del_misc':
            obj_ = DelMiscType.factory()
            obj_.build(child_)
            self.del_misc.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create_session':
            obj_ = CreateSessionType.factory()
            obj_.build(child_)
            self.create_session.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-ppb-connection':
            obj_ = set_ppb_connection.factory()
            obj_.build(child_)
            self.set_ppb_connection.append(obj_)
# end class ServerOperatorType


class additionalKeyType:
    subclass = None
    def __init__(self, number='', name='', active=0, license_update_date=None, lim_date=None, content='', property=None):
        self.number = number
        self.name = name
        self.active = active
        self.license_update_date = license_update_date
        self.lim_date = lim_date
        self.content = content
        if property is None:
            self.property = []
        else:
            self.property = property
    def factory(*args_, **kwargs_):
        if additionalKeyType.subclass:
            return additionalKeyType.subclass(*args_, **kwargs_)
        else:
            return additionalKeyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getNumber(self): return self.number
    def setNumber(self, value): self.number = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getActive(self): return self.active
    def setActive(self, value): self.active = value
    def getLicense_update_date(self): return self.license_update_date
    def setLicense_update_date(self, value): self.license_update_date = value
    def getLim_date(self): return self.lim_date
    def setLim_date(self, value): self.lim_date = value
    def getContent(self): return self.content
    def setContent(self, value): self.content = value
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def export(self, outfile, level, name_='additionalKeyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='additionalKeyType'):
        pass
    def exportChildren(self, outfile, level, name_='additionalKeyType'):
        showIndent(outfile, level)
        outfile.write('<number>%s</number>\n' % quote_xml(self.getNumber()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<active>%d</active>\n' % self.getActive())
        if self.license_update_date is not None:
            showIndent(outfile, level)
            outfile.write('<license_update_date>%s</license_update_date>\n' % quote_xml(self.getLicense_update_date()))
        if self.lim_date is not None:
            showIndent(outfile, level)
            outfile.write('<lim_date>%s</lim_date>\n' % quote_xml(self.getLim_date()))
        showIndent(outfile, level)
        outfile.write('<content>%s</content>\n' % quote_xml(self.getContent()))
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'number':
            number_ = ''
            for text__content_ in child_.childNodes:
                number_ += text__content_.nodeValue
            self.number = number_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'active':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.active = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'license_update_date':
            license_update_date_ = ''
            for text__content_ in child_.childNodes:
                license_update_date_ += text__content_.nodeValue
            self.license_update_date = license_update_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'lim_date':
            lim_date_ = ''
            for text__content_ in child_.childNodes:
                lim_date_ += text__content_.nodeValue
            self.lim_date = lim_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'content':
            content_ = ''
            for text__content_ in child_.childNodes:
                content_ += text__content_.nodeValue
            self.content = content_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = AdditionalKeyPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
# end class additionalKeyType


class miscResultType(resultType):
    subclass = None
    def __init__(self, property=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.property = property
    def factory(*args_, **kwargs_):
        if miscResultType.subclass:
            return miscResultType.subclass(*args_, **kwargs_)
        else:
            return miscResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def export(self, outfile, level, name_='miscResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='miscResultType'):
        resultType.exportAttributes(self, outfile, level, name_='miscResultType')
    def exportChildren(self, outfile, level, name_='miscResultType'):
        if self.property is not None:
            self.property.export(outfile, level, name_='property')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = miscPropertyType.factory()
            obj_.build(child_)
            self.setProperty(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class miscResultType


class miscPropertyType:
    subclass = None
    def __init__(self, name='', value=None):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if miscPropertyType.subclass:
            return miscPropertyType.subclass(*args_, **kwargs_)
        else:
            return miscPropertyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='miscPropertyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='miscPropertyType'):
        pass
    def exportChildren(self, outfile, level, name_='miscPropertyType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.value is not None:
            showIndent(outfile, level)
            outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class miscPropertyType


class GetProtosType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if GetProtosType.subclass:
            return GetProtosType.subclass(*args_, **kwargs_)
        else:
            return GetProtosType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='GetProtosType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetProtosType'):
        pass
    def exportChildren(self, outfile, level, name_='GetProtosType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = GetProtosResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class GetProtosType


class GetType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if GetType.subclass:
            return GetType.subclass(*args_, **kwargs_)
        else:
            return GetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='GetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetType'):
        pass
    def exportChildren(self, outfile, level, name_='GetType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = GetResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class GetType


class SetType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SetType.subclass:
            return SetType.subclass(*args_, **kwargs_)
        else:
            return SetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetType'):
        pass
    def exportChildren(self, outfile, level, name_='SetType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = SetResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SetType


class ServicesManagementType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ServicesManagementType.subclass:
            return ServicesManagementType.subclass(*args_, **kwargs_)
        else:
            return ServicesManagementType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ServicesManagementType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ServicesManagementType'):
        pass
    def exportChildren(self, outfile, level, name_='ServicesManagementType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ServicesManagementResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ServicesManagementType


class LicenseInstallType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if LicenseInstallType.subclass:
            return LicenseInstallType.subclass(*args_, **kwargs_)
        else:
            return LicenseInstallType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='LicenseInstallType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LicenseInstallType'):
        pass
    def exportChildren(self, outfile, level, name_='LicenseInstallType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class LicenseInstallType


class InitialSetupType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if InitialSetupType.subclass:
            return InitialSetupType.subclass(*args_, **kwargs_)
        else:
            return InitialSetupType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='InitialSetupType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='InitialSetupType'):
        pass
    def exportChildren(self, outfile, level, name_='InitialSetupType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = InitialSetupResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class InitialSetupType


class GetAdditionalKeyType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if GetAdditionalKeyType.subclass:
            return GetAdditionalKeyType.subclass(*args_, **kwargs_)
        else:
            return GetAdditionalKeyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='GetAdditionalKeyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetAdditionalKeyType'):
        pass
    def exportChildren(self, outfile, level, name_='GetAdditionalKeyType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = GetAdditionalKeyResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class GetAdditionalKeyType


class SetMiscType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SetMiscType.subclass:
            return SetMiscType.subclass(*args_, **kwargs_)
        else:
            return SetMiscType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SetMiscType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetMiscType'):
        pass
    def exportChildren(self, outfile, level, name_='SetMiscType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = miscResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SetMiscType


class GetMiscType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if GetMiscType.subclass:
            return GetMiscType.subclass(*args_, **kwargs_)
        else:
            return GetMiscType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='GetMiscType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetMiscType'):
        pass
    def exportChildren(self, outfile, level, name_='GetMiscType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = miscResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class GetMiscType


class DelMiscType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DelMiscType.subclass:
            return DelMiscType.subclass(*args_, **kwargs_)
        else:
            return DelMiscType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DelMiscType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DelMiscType'):
        pass
    def exportChildren(self, outfile, level, name_='DelMiscType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = miscResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DelMiscType


class EnableAeType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if EnableAeType.subclass:
            return EnableAeType.subclass(*args_, **kwargs_)
        else:
            return EnableAeType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='EnableAeType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='EnableAeType'):
        pass
    def exportChildren(self, outfile, level, name_='EnableAeType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class EnableAeType


class DisableAeType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DisableAeType.subclass:
            return DisableAeType.subclass(*args_, **kwargs_)
        else:
            return DisableAeType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DisableAeType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DisableAeType'):
        pass
    def exportChildren(self, outfile, level, name_='DisableAeType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DisableAeType


class GetAeParametersType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if GetAeParametersType.subclass:
            return GetAeParametersType.subclass(*args_, **kwargs_)
        else:
            return GetAeParametersType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='GetAeParametersType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetAeParametersType'):
        pass
    def exportChildren(self, outfile, level, name_='GetAeParametersType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = GetAeParametersResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class GetAeParametersType


class CreateSessionType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if CreateSessionType.subclass:
            return CreateSessionType.subclass(*args_, **kwargs_)
        else:
            return CreateSessionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='CreateSessionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CreateSessionType'):
        pass
    def exportChildren(self, outfile, level, name_='CreateSessionType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = CreateSessionResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class CreateSessionType


class AdditionalKeyPropertyType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if AdditionalKeyPropertyType.subclass:
            return AdditionalKeyPropertyType.subclass(*args_, **kwargs_)
        else:
            return AdditionalKeyPropertyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='AdditionalKeyPropertyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AdditionalKeyPropertyType'):
        pass
    def exportChildren(self, outfile, level, name_='AdditionalKeyPropertyType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class AdditionalKeyPropertyType


class GetProtosResultType(resultType):
    subclass = None
    def __init__(self, protos=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.protos = protos
    def factory(*args_, **kwargs_):
        if GetProtosResultType.subclass:
            return GetProtosResultType.subclass(*args_, **kwargs_)
        else:
            return GetProtosResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProtos(self): return self.protos
    def setProtos(self, value): self.protos = value
    def export(self, outfile, level, name_='GetProtosResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetProtosResultType'):
        resultType.exportAttributes(self, outfile, level, name_='GetProtosResultType')
    def exportChildren(self, outfile, level, name_='GetProtosResultType'):
        if self.protos is not None:
            self.protos.export(outfile, level, name_='protos')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'protos':
            obj_ = ProtosList.factory()
            obj_.build(child_)
            self.setProtos(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class GetProtosResultType


class GetResultType(resultType):
    subclass = None
    def __init__(self, key=None, gen_info=None, components=None, stat=None, admin=None, interfaces=None, services_state=None, prefs=None, shells=None, session_setup=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        if key is None:
            self.key = []
        else:
            self.key = key
        if gen_info is None:
            self.gen_info = []
        else:
            self.gen_info = gen_info
        if components is None:
            self.components = []
        else:
            self.components = components
        if stat is None:
            self.stat = []
        else:
            self.stat = stat
        if admin is None:
            self.admin = []
        else:
            self.admin = admin
        if interfaces is None:
            self.interfaces = []
        else:
            self.interfaces = interfaces
        if services_state is None:
            self.services_state = []
        else:
            self.services_state = services_state
        if prefs is None:
            self.prefs = []
        else:
            self.prefs = prefs
        if shells is None:
            self.shells = []
        else:
            self.shells = shells
        if session_setup is None:
            self.session_setup = []
        else:
            self.session_setup = session_setup
    def factory(*args_, **kwargs_):
        if GetResultType.subclass:
            return GetResultType.subclass(*args_, **kwargs_)
        else:
            return GetResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getKey(self): return self.key
    def setKey(self, value): self.key = value
    def addKey(self, value): self.key.append(value)
    def insertKey(self, index, value): self.key[index] = value
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def addGen_info(self, value): self.gen_info.append(value)
    def insertGen_info(self, index, value): self.gen_info[index] = value
    def getComponents(self): return self.components
    def setComponents(self, value): self.components = value
    def addComponents(self, value): self.components.append(value)
    def insertComponents(self, index, value): self.components[index] = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def addStat(self, value): self.stat.append(value)
    def insertStat(self, index, value): self.stat[index] = value
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def addAdmin(self, value): self.admin.append(value)
    def insertAdmin(self, index, value): self.admin[index] = value
    def getInterfaces(self): return self.interfaces
    def setInterfaces(self, value): self.interfaces = value
    def addInterfaces(self, value): self.interfaces.append(value)
    def insertInterfaces(self, index, value): self.interfaces[index] = value
    def getServices_state(self): return self.services_state
    def setServices_state(self, value): self.services_state = value
    def addServices_state(self, value): self.services_state.append(value)
    def insertServices_state(self, index, value): self.services_state[index] = value
    def getPrefs(self): return self.prefs
    def setPrefs(self, value): self.prefs = value
    def addPrefs(self, value): self.prefs.append(value)
    def insertPrefs(self, index, value): self.prefs[index] = value
    def getShells(self): return self.shells
    def setShells(self, value): self.shells = value
    def addShells(self, value): self.shells.append(value)
    def insertShells(self, index, value): self.shells[index] = value
    def getSession_setup(self): return self.session_setup
    def setSession_setup(self, value): self.session_setup = value
    def addSession_setup(self, value): self.session_setup.append(value)
    def insertSession_setup(self, index, value): self.session_setup[index] = value
    def export(self, outfile, level, name_='GetResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetResultType'):
        resultType.exportAttributes(self, outfile, level, name_='GetResultType')
    def exportChildren(self, outfile, level, name_='GetResultType'):
        for key_ in self.getKey():
            key_.export(outfile, level, name_='key')
        for gen_info_ in self.getGen_info():
            gen_info_.export(outfile, level, name_='gen_info')
        for components_ in self.getComponents():
            components_.export(outfile, level, name_='components')
        for stat_ in self.getStat():
            stat_.export(outfile, level, name_='stat')
        for admin_ in self.getAdmin():
            admin_.export(outfile, level, name_='admin')
        for interfaces_ in self.getInterfaces():
            interfaces_.export(outfile, level, name_='interfaces')
        for services_state_ in self.getServices_state():
            services_state_.export(outfile, level, name_='services_state')
        for prefs_ in self.getPrefs():
            prefs_.export(outfile, level, name_='prefs')
        for shells_ in self.getShells():
            shells_.export(outfile, level, name_='shells')
        for session_setup_ in self.getSession_setup():
            session_setup_.export(outfile, level, name_='session_setup')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'key':
            obj_ = keyType.factory()
            obj_.build(child_)
            self.key.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen_info':
            obj_ = serverGenInfoType.factory()
            obj_.build(child_)
            self.gen_info.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'components':
            obj_ = componentsType.factory()
            obj_.build(child_)
            self.components.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            obj_ = statType.factory()
            obj_.build(child_)
            self.stat.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            obj_ = adminType.factory()
            obj_.build(child_)
            self.admin.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'interfaces':
            obj_ = interfacesType.factory()
            obj_.build(child_)
            self.interfaces.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'services_state':
            obj_ = servicesState.factory()
            obj_.build(child_)
            self.services_state.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefs':
            obj_ = serverPrefs.factory()
            obj_.build(child_)
            self.prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shells':
            obj_ = ShellsList.factory()
            obj_.build(child_)
            self.shells.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'session_setup':
            obj_ = serverSessionSetup.factory()
            obj_.build(child_)
            self.session_setup.append(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class GetResultType


class SetResultType(resultType):
    subclass = None
    def __init__(self, status='', errcode=None, errtext=None, valueOf_=''):
        resultType.__init__(self, status, errcode, errtext)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if SetResultType.subclass:
            return SetResultType.subclass(*args_, **kwargs_)
        else:
            return SetResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='SetResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetResultType'):
        resultType.exportAttributes(self, outfile, level, name_='SetResultType')
    def exportChildren(self, outfile, level, name_='SetResultType'):
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        resultType.buildChildren(self, child_, nodeName_)
# end class SetResultType


class ServicesManagementResultType(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if ServicesManagementResultType.subclass:
            return ServicesManagementResultType.subclass(*args_, **kwargs_)
        else:
            return ServicesManagementResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='ServicesManagementResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ServicesManagementResultType'):
        resultType.exportAttributes(self, outfile, level, name_='ServicesManagementResultType')
    def exportChildren(self, outfile, level, name_='ServicesManagementResultType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class ServicesManagementResultType


class InitialSetupResultType(resultType):
    subclass = None
    def __init__(self, server_name='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.server_name = server_name
    def factory(*args_, **kwargs_):
        if InitialSetupResultType.subclass:
            return InitialSetupResultType.subclass(*args_, **kwargs_)
        else:
            return InitialSetupResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getServer_name(self): return self.server_name
    def setServer_name(self, value): self.server_name = value
    def export(self, outfile, level, name_='InitialSetupResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='InitialSetupResultType'):
        resultType.exportAttributes(self, outfile, level, name_='InitialSetupResultType')
    def exportChildren(self, outfile, level, name_='InitialSetupResultType'):
        showIndent(outfile, level)
        outfile.write('<server_name>%s</server_name>\n' % quote_xml(self.getServer_name()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server_name':
            server_name_ = ''
            for text__content_ in child_.childNodes:
                server_name_ += text__content_.nodeValue
            self.server_name = server_name_
        resultType.buildChildren(self, child_, nodeName_)
# end class InitialSetupResultType


class GetAdditionalKeyResultType(resultType):
    subclass = None
    def __init__(self, name=None, key_info=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.name = name
        self.key_info = key_info
    def factory(*args_, **kwargs_):
        if GetAdditionalKeyResultType.subclass:
            return GetAdditionalKeyResultType.subclass(*args_, **kwargs_)
        else:
            return GetAdditionalKeyResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getKey_info(self): return self.key_info
    def setKey_info(self, value): self.key_info = value
    def export(self, outfile, level, name_='GetAdditionalKeyResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetAdditionalKeyResultType'):
        resultType.exportAttributes(self, outfile, level, name_='GetAdditionalKeyResultType')
    def exportChildren(self, outfile, level, name_='GetAdditionalKeyResultType'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.key_info is not None:
            self.key_info.export(outfile, level, name_='key_info')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'key_info':
            obj_ = additionalKeyType.factory()
            obj_.build(child_)
            self.setKey_info(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class GetAdditionalKeyResultType


class GetAeParametersResultType(resultType):
    subclass = None
    def __init__(self, params=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.params = params
    def factory(*args_, **kwargs_):
        if GetAeParametersResultType.subclass:
            return GetAeParametersResultType.subclass(*args_, **kwargs_)
        else:
            return GetAeParametersResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getParams(self): return self.params
    def setParams(self, value): self.params = value
    def export(self, outfile, level, name_='GetAeParametersResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetAeParametersResultType'):
        resultType.exportAttributes(self, outfile, level, name_='GetAeParametersResultType')
    def exportChildren(self, outfile, level, name_='GetAeParametersResultType'):
        if self.params is not None:
            self.params.export(outfile, level, name_='params')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'params':
            obj_ = aeParamsType.factory()
            obj_.build(child_)
            self.setParams(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class GetAeParametersResultType


class CreateSessionResultType(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if CreateSessionResultType.subclass:
            return CreateSessionResultType.subclass(*args_, **kwargs_)
        else:
            return CreateSessionResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='CreateSessionResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CreateSessionResultType'):
        resultType.exportAttributes(self, outfile, level, name_='CreateSessionResultType')
    def exportChildren(self, outfile, level, name_='CreateSessionResultType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class CreateSessionResultType


class ProtosList:
    subclass = None
    def __init__(self, proto=None):
        if proto is None:
            self.proto = []
        else:
            self.proto = proto
    def factory(*args_, **kwargs_):
        if ProtosList.subclass:
            return ProtosList.subclass(*args_, **kwargs_)
        else:
            return ProtosList(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProto(self): return self.proto
    def setProto(self, value): self.proto = value
    def addProto(self, value): self.proto.append(value)
    def insertProto(self, index, value): self.proto[index] = value
    def export(self, outfile, level, name_='ProtosList'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtosList'):
        pass
    def exportChildren(self, outfile, level, name_='ProtosList'):
        for proto_ in self.getProto():
            showIndent(outfile, level)
            outfile.write('<proto>%s</proto>\n' % quote_xml(proto_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'proto':
            proto_ = ''
            for text__content_ in child_.childNodes:
                proto_ += text__content_.nodeValue
            self.addProto(proto_)
# end class ProtosList


class ShellsList:
    subclass = None
    def __init__(self, shell=None):
        if shell is None:
            self.shell = []
        else:
            self.shell = shell
    def factory(*args_, **kwargs_):
        if ShellsList.subclass:
            return ShellsList.subclass(*args_, **kwargs_)
        else:
            return ShellsList(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getShell(self): return self.shell
    def setShell(self, value): self.shell = value
    def addShell(self, value): self.shell.append(value)
    def insertShell(self, index, value): self.shell[index] = value
    def export(self, outfile, level, name_='ShellsList'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ShellsList'):
        pass
    def exportChildren(self, outfile, level, name_='ShellsList'):
        for shell_ in self.getShell():
            shell_.export(outfile, level, name_='shell')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shell':
            obj_ = shellType.factory()
            obj_.build(child_)
            self.shell.append(obj_)
# end class ShellsList


class siteappDescriptionType:
    subclass = None
    def __init__(self, id='', name='', version='', release='', description='', license='', access_level='', instance=None):
        self.id = id
        self.name = name
        self.version = version
        self.release = release
        self.description = description
        self.license = license
        self.access_level = access_level
        self.instance = instance
    def factory(*args_, **kwargs_):
        if siteappDescriptionType.subclass:
            return siteappDescriptionType.subclass(*args_, **kwargs_)
        else:
            return siteappDescriptionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getVersion(self): return self.version
    def setVersion(self, value): self.version = value
    def getRelease(self): return self.release
    def setRelease(self, value): self.release = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getLicense(self): return self.license
    def setLicense(self, value): self.license = value
    def getAccess_level(self): return self.access_level
    def setAccess_level(self, value): self.access_level = value
    def getInstance(self): return self.instance
    def setInstance(self, value): self.instance = value
    def export(self, outfile, level, name_='siteappDescriptionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='siteappDescriptionType'):
        pass
    def exportChildren(self, outfile, level, name_='siteappDescriptionType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<version>%s</version>\n' % quote_xml(self.getVersion()))
        showIndent(outfile, level)
        outfile.write('<release>%s</release>\n' % quote_xml(self.getRelease()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        showIndent(outfile, level)
        outfile.write('<license>%s</license>\n' % quote_xml(self.getLicense()))
        showIndent(outfile, level)
        outfile.write('<access_level>%s</access_level>\n' % quote_xml(self.getAccess_level()))
        if self.instance is not None:
            showIndent(outfile, level)
            outfile.write('<instance>%s</instance>\n' % quote_xml(self.getInstance()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'version':
            version_ = ''
            for text__content_ in child_.childNodes:
                version_ += text__content_.nodeValue
            self.version = version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'release':
            release_ = ''
            for text__content_ in child_.childNodes:
                release_ += text__content_.nodeValue
            self.release = release_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'license':
            license_ = ''
            for text__content_ in child_.childNodes:
                license_ += text__content_.nodeValue
            self.license = license_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'access_level':
            access_level_ = ''
            for text__content_ in child_.childNodes:
                access_level_ += text__content_.nodeValue
            self.access_level = access_level_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'instance':
            instance_ = ''
            for text__content_ in child_.childNodes:
                instance_ += text__content_.nodeValue
            self.instance = instance_
# end class siteappDescriptionType


class operationResultType(resultType):
    subclass = None
    def __init__(self, package_id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.package_id = package_id
    def factory(*args_, **kwargs_):
        if operationResultType.subclass:
            return operationResultType.subclass(*args_, **kwargs_)
        else:
            return operationResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPackage_id(self): return self.package_id
    def setPackage_id(self, value): self.package_id = value
    def export(self, outfile, level, name_='operationResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='operationResultType'):
        resultType.exportAttributes(self, outfile, level, name_='operationResultType')
    def exportChildren(self, outfile, level, name_='operationResultType'):
        showIndent(outfile, level)
        outfile.write('<package_id>%s</package_id>\n' % quote_xml(self.getPackage_id()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'package_id':
            package_id_ = ''
            for text__content_ in child_.childNodes:
                package_id_ += text__content_.nodeValue
            self.package_id = package_id_
        resultType.buildChildren(self, child_, nodeName_)
# end class operationResultType


class SiteAppResponseType:
    subclass = None
    def __init__(self, get_all_packages_list=None, get_packages_list_by_client=None, add_packages_to_client_pool=None, remove_packages_from_client_pool=None, get_packages_list_by_domain=None, get_package_requirements=None, install_packages=None, set_package_properties=None):
        if get_all_packages_list is None:
            self.get_all_packages_list = []
        else:
            self.get_all_packages_list = get_all_packages_list
        if get_packages_list_by_client is None:
            self.get_packages_list_by_client = []
        else:
            self.get_packages_list_by_client = get_packages_list_by_client
        if add_packages_to_client_pool is None:
            self.add_packages_to_client_pool = []
        else:
            self.add_packages_to_client_pool = add_packages_to_client_pool
        if remove_packages_from_client_pool is None:
            self.remove_packages_from_client_pool = []
        else:
            self.remove_packages_from_client_pool = remove_packages_from_client_pool
        if get_packages_list_by_domain is None:
            self.get_packages_list_by_domain = []
        else:
            self.get_packages_list_by_domain = get_packages_list_by_domain
        if get_package_requirements is None:
            self.get_package_requirements = []
        else:
            self.get_package_requirements = get_package_requirements
        if install_packages is None:
            self.install_packages = []
        else:
            self.install_packages = install_packages
        if set_package_properties is None:
            self.set_package_properties = []
        else:
            self.set_package_properties = set_package_properties
    def factory(*args_, **kwargs_):
        if SiteAppResponseType.subclass:
            return SiteAppResponseType.subclass(*args_, **kwargs_)
        else:
            return SiteAppResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet_all_packages_list(self): return self.get_all_packages_list
    def setGet_all_packages_list(self, value): self.get_all_packages_list = value
    def addGet_all_packages_list(self, value): self.get_all_packages_list.append(value)
    def insertGet_all_packages_list(self, index, value): self.get_all_packages_list[index] = value
    def getGet_packages_list_by_client(self): return self.get_packages_list_by_client
    def setGet_packages_list_by_client(self, value): self.get_packages_list_by_client = value
    def addGet_packages_list_by_client(self, value): self.get_packages_list_by_client.append(value)
    def insertGet_packages_list_by_client(self, index, value): self.get_packages_list_by_client[index] = value
    def getAdd_packages_to_client_pool(self): return self.add_packages_to_client_pool
    def setAdd_packages_to_client_pool(self, value): self.add_packages_to_client_pool = value
    def addAdd_packages_to_client_pool(self, value): self.add_packages_to_client_pool.append(value)
    def insertAdd_packages_to_client_pool(self, index, value): self.add_packages_to_client_pool[index] = value
    def getRemove_packages_from_client_pool(self): return self.remove_packages_from_client_pool
    def setRemove_packages_from_client_pool(self, value): self.remove_packages_from_client_pool = value
    def addRemove_packages_from_client_pool(self, value): self.remove_packages_from_client_pool.append(value)
    def insertRemove_packages_from_client_pool(self, index, value): self.remove_packages_from_client_pool[index] = value
    def getGet_packages_list_by_domain(self): return self.get_packages_list_by_domain
    def setGet_packages_list_by_domain(self, value): self.get_packages_list_by_domain = value
    def addGet_packages_list_by_domain(self, value): self.get_packages_list_by_domain.append(value)
    def insertGet_packages_list_by_domain(self, index, value): self.get_packages_list_by_domain[index] = value
    def getGet_package_requirements(self): return self.get_package_requirements
    def setGet_package_requirements(self, value): self.get_package_requirements = value
    def addGet_package_requirements(self, value): self.get_package_requirements.append(value)
    def insertGet_package_requirements(self, index, value): self.get_package_requirements[index] = value
    def getInstall_packages(self): return self.install_packages
    def setInstall_packages(self, value): self.install_packages = value
    def addInstall_packages(self, value): self.install_packages.append(value)
    def insertInstall_packages(self, index, value): self.install_packages[index] = value
    def getSet_package_properties(self): return self.set_package_properties
    def setSet_package_properties(self, value): self.set_package_properties = value
    def addSet_package_properties(self, value): self.set_package_properties.append(value)
    def insertSet_package_properties(self, index, value): self.set_package_properties[index] = value
    def export(self, outfile, level, name_='SiteAppResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SiteAppResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='SiteAppResponseType'):
        for get_all_packages_list_ in self.getGet_all_packages_list():
            get_all_packages_list_.export(outfile, level)
        for get_packages_list_by_client_ in self.getGet_packages_list_by_client():
            get_packages_list_by_client_.export(outfile, level)
        for add_packages_to_client_pool_ in self.getAdd_packages_to_client_pool():
            add_packages_to_client_pool_.export(outfile, level)
        for remove_packages_from_client_pool_ in self.getRemove_packages_from_client_pool():
            remove_packages_from_client_pool_.export(outfile, level)
        for get_packages_list_by_domain_ in self.getGet_packages_list_by_domain():
            get_packages_list_by_domain_.export(outfile, level)
        for get_package_requirements_ in self.getGet_package_requirements():
            get_package_requirements_.export(outfile, level)
        for install_packages_ in self.getInstall_packages():
            install_packages_.export(outfile, level)
        for set_package_properties_ in self.getSet_package_properties():
            set_package_properties_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_all_packages_list':
            obj_ = get_all_packages_list.factory()
            obj_.build(child_)
            self.get_all_packages_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_packages_list_by_client':
            obj_ = get_packages_list_by_client.factory()
            obj_.build(child_)
            self.get_packages_list_by_client.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add_packages_to_client_pool':
            obj_ = add_packages_to_client_pool.factory()
            obj_.build(child_)
            self.add_packages_to_client_pool.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove_packages_from_client_pool':
            obj_ = remove_packages_from_client_pool.factory()
            obj_.build(child_)
            self.remove_packages_from_client_pool.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_packages_list_by_domain':
            obj_ = get_packages_list_by_domain.factory()
            obj_.build(child_)
            self.get_packages_list_by_domain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get_package_requirements':
            obj_ = get_package_requirements.factory()
            obj_.build(child_)
            self.get_package_requirements.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install_packages':
            obj_ = install_packages.factory()
            obj_.build(child_)
            self.install_packages.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set_package_properties':
            obj_ = set_package_properties.factory()
            obj_.build(child_)
            self.set_package_properties.append(obj_)
# end class SiteAppResponseType


class CBOptionalProps:
    subclass = None
    def __init__(self, sort_key=None, conhelp=None, file=None, public=None, internal=None):
        self.sort_key = sort_key
        self.conhelp = conhelp
        self.file = file
        self.public = public
        self.internal = internal
    def factory(*args_, **kwargs_):
        if CBOptionalProps.subclass:
            return CBOptionalProps.subclass(*args_, **kwargs_)
        else:
            return CBOptionalProps(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSort_key(self): return self.sort_key
    def setSort_key(self, value): self.sort_key = value
    def getConhelp(self): return self.conhelp
    def setConhelp(self, value): self.conhelp = value
    def getFile(self): return self.file
    def setFile(self, value): self.file = value
    def getPublic(self): return self.public
    def setPublic(self, value): self.public = value
    def getInternal(self): return self.internal
    def setInternal(self, value): self.internal = value
    def export(self, outfile, level, name_='CBOptionalProps'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CBOptionalProps'):
        pass
    def exportChildren(self, outfile, level, name_='CBOptionalProps'):
        if self.sort_key is not None:
            showIndent(outfile, level)
            outfile.write('<sort_key>%s</sort_key>\n' % quote_xml(self.getSort_key()))
        if self.conhelp is not None:
            showIndent(outfile, level)
            outfile.write('<conhelp>%s</conhelp>\n' % quote_xml(self.getConhelp()))
        if self.file is not None:
            showIndent(outfile, level)
            outfile.write('<file>%s</file>\n' % quote_xml(self.getFile()))
        if self.public is not None:
            showIndent(outfile, level)
            outfile.write('<public>%s</public>\n' % quote_xml(self.getPublic()))
        if self.internal is not None:
            showIndent(outfile, level)
            outfile.write('<internal>%s</internal>\n' % quote_xml(self.getInternal()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sort_key':
            sort_key_ = ''
            for text__content_ in child_.childNodes:
                sort_key_ += text__content_.nodeValue
            self.sort_key = sort_key_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'conhelp':
            conhelp_ = ''
            for text__content_ in child_.childNodes:
                conhelp_ += text__content_.nodeValue
            self.conhelp = conhelp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            file_ = ''
            for text__content_ in child_.childNodes:
                file_ += text__content_.nodeValue
            self.file = file_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'public':
            public_ = ''
            for text__content_ in child_.childNodes:
                public_ += text__content_.nodeValue
            self.public = public_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'internal':
            internal_ = ''
            for text__content_ in child_.childNodes:
                internal_ += text__content_.nodeValue
            self.internal = internal_
# end class CBOptionalProps


class CBProps(CBOptionalProps):
    subclass = None
    def __init__(self, place='', url='', text='', sort_key=None, conhelp=None, file=None, public=None, internal=None):
        CBOptionalProps.__init__(self, sort_key, conhelp, file, public, internal)
        self.place = place
        self.url = url
        self.text = text
    def factory(*args_, **kwargs_):
        if CBProps.subclass:
            return CBProps.subclass(*args_, **kwargs_)
        else:
            return CBProps(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPlace(self): return self.place
    def setPlace(self, value): self.place = value
    def getUrl(self): return self.url
    def setUrl(self, value): self.url = value
    def getText(self): return self.text
    def setText(self, value): self.text = value
    def export(self, outfile, level, name_='CBProps'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CBProps'):
        CBOptionalProps.exportAttributes(self, outfile, level, name_='CBProps')
    def exportChildren(self, outfile, level, name_='CBProps'):
        showIndent(outfile, level)
        outfile.write('<place>%s</place>\n' % quote_xml(self.getPlace()))
        showIndent(outfile, level)
        outfile.write('<url>%s</url>\n' % quote_xml(self.getUrl()))
        showIndent(outfile, level)
        outfile.write('<text>%s</text>\n' % quote_xml(self.getText()))
        CBOptionalProps.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        CBOptionalProps.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'place':
            place_ = ''
            for text__content_ in child_.childNodes:
                place_ += text__content_.nodeValue
            self.place = place_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'url':
            url_ = ''
            for text__content_ in child_.childNodes:
                url_ += text__content_.nodeValue
            self.url = url_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'text':
            text_ = ''
            for text__content_ in child_.childNodes:
                text_ += text__content_.nodeValue
            self.text = text_
        CBOptionalProps.buildChildren(self, child_, nodeName_)
# end class CBProps


class CBUrlComponents:
    subclass = None
    def __init__(self, dom_id=None, dom_name=None, ftp_user=None, ftp_pass=None, cl_id=None, cname=None, pname=None, email=None):
        self.dom_id = dom_id
        self.dom_name = dom_name
        self.ftp_user = ftp_user
        self.ftp_pass = ftp_pass
        self.cl_id = cl_id
        self.cname = cname
        self.pname = pname
        self.email = email
    def factory(*args_, **kwargs_):
        if CBUrlComponents.subclass:
            return CBUrlComponents.subclass(*args_, **kwargs_)
        else:
            return CBUrlComponents(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDom_id(self): return self.dom_id
    def setDom_id(self, value): self.dom_id = value
    def getDom_name(self): return self.dom_name
    def setDom_name(self, value): self.dom_name = value
    def getFtp_user(self): return self.ftp_user
    def setFtp_user(self, value): self.ftp_user = value
    def getFtp_pass(self): return self.ftp_pass
    def setFtp_pass(self, value): self.ftp_pass = value
    def getCl_id(self): return self.cl_id
    def setCl_id(self, value): self.cl_id = value
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def export(self, outfile, level, name_='CBUrlComponents'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CBUrlComponents'):
        pass
    def exportChildren(self, outfile, level, name_='CBUrlComponents'):
        if self.dom_id is not None:
            showIndent(outfile, level)
            outfile.write('<dom_id>%s</dom_id>\n' % quote_xml(self.getDom_id()))
        if self.dom_name is not None:
            showIndent(outfile, level)
            outfile.write('<dom_name>%s</dom_name>\n' % quote_xml(self.getDom_name()))
        if self.ftp_user is not None:
            showIndent(outfile, level)
            outfile.write('<ftp_user>%s</ftp_user>\n' % quote_xml(self.getFtp_user()))
        if self.ftp_pass is not None:
            showIndent(outfile, level)
            outfile.write('<ftp_pass>%s</ftp_pass>\n' % quote_xml(self.getFtp_pass()))
        if self.cl_id is not None:
            showIndent(outfile, level)
            outfile.write('<cl_id>%s</cl_id>\n' % quote_xml(self.getCl_id()))
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        if self.pname is not None:
            showIndent(outfile, level)
            outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dom_id':
            dom_id_ = ''
            for text__content_ in child_.childNodes:
                dom_id_ += text__content_.nodeValue
            self.dom_id = dom_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dom_name':
            dom_name_ = ''
            for text__content_ in child_.childNodes:
                dom_name_ += text__content_.nodeValue
            self.dom_name = dom_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_user':
            ftp_user_ = ''
            for text__content_ in child_.childNodes:
                ftp_user_ += text__content_.nodeValue
            self.ftp_user = ftp_user_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_pass':
            ftp_pass_ = ''
            for text__content_ in child_.childNodes:
                ftp_pass_ += text__content_.nodeValue
            self.ftp_pass = ftp_pass_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cl_id':
            cl_id_ = ''
            for text__content_ in child_.childNodes:
                cl_id_ += text__content_.nodeValue
            self.cl_id = cl_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
# end class CBUrlComponents


class CBOwner:
    subclass = None
    def __init__(self, admin=None, client_id=None, domain_id=None, reseller_id=None):
        self.admin = admin
        self.client_id = client_id
        self.domain_id = domain_id
        self.reseller_id = reseller_id
    def factory(*args_, **kwargs_):
        if CBOwner.subclass:
            return CBOwner.subclass(*args_, **kwargs_)
        else:
            return CBOwner(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdmin(self): return self.admin
    def setAdmin(self, value): self.admin = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def export(self, outfile, level, name_='CBOwner'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CBOwner'):
        pass
    def exportChildren(self, outfile, level, name_='CBOwner'):
        if self.admin is not None:
            showIndent(outfile, level)
            outfile.write('<admin>%s</admin>\n' % quote_xml(self.getAdmin()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin':
            admin_ = ''
            for text__content_ in child_.childNodes:
                admin_ += text__content_.nodeValue
            self.admin = admin_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
# end class CBOwner


class UIResponseType:
    subclass = None
    def __init__(self, set_visibility_customizations=None, create_custombutton=None, get_custombutton=None, delete_custombutton=None, get_navigation=None):
        if set_visibility_customizations is None:
            self.set_visibility_customizations = []
        else:
            self.set_visibility_customizations = set_visibility_customizations
        if create_custombutton is None:
            self.create_custombutton = []
        else:
            self.create_custombutton = create_custombutton
        if get_custombutton is None:
            self.get_custombutton = []
        else:
            self.get_custombutton = get_custombutton
        if delete_custombutton is None:
            self.delete_custombutton = []
        else:
            self.delete_custombutton = delete_custombutton
        if get_navigation is None:
            self.get_navigation = []
        else:
            self.get_navigation = get_navigation
    def factory(*args_, **kwargs_):
        if UIResponseType.subclass:
            return UIResponseType.subclass(*args_, **kwargs_)
        else:
            return UIResponseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSet_visibility_customizations(self): return self.set_visibility_customizations
    def setSet_visibility_customizations(self, value): self.set_visibility_customizations = value
    def addSet_visibility_customizations(self, value): self.set_visibility_customizations.append(value)
    def insertSet_visibility_customizations(self, index, value): self.set_visibility_customizations[index] = value
    def getCreate_custombutton(self): return self.create_custombutton
    def setCreate_custombutton(self, value): self.create_custombutton = value
    def addCreate_custombutton(self, value): self.create_custombutton.append(value)
    def insertCreate_custombutton(self, index, value): self.create_custombutton[index] = value
    def getGet_custombutton(self): return self.get_custombutton
    def setGet_custombutton(self, value): self.get_custombutton = value
    def addGet_custombutton(self, value): self.get_custombutton.append(value)
    def insertGet_custombutton(self, index, value): self.get_custombutton[index] = value
    def getDelete_custombutton(self): return self.delete_custombutton
    def setDelete_custombutton(self, value): self.delete_custombutton = value
    def addDelete_custombutton(self, value): self.delete_custombutton.append(value)
    def insertDelete_custombutton(self, index, value): self.delete_custombutton[index] = value
    def getGet_navigation(self): return self.get_navigation
    def setGet_navigation(self, value): self.get_navigation = value
    def addGet_navigation(self, value): self.get_navigation.append(value)
    def insertGet_navigation(self, index, value): self.get_navigation[index] = value
    def export(self, outfile, level, name_='UIResponseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UIResponseType'):
        pass
    def exportChildren(self, outfile, level, name_='UIResponseType'):
        for set_visibility_customizations_ in self.getSet_visibility_customizations():
            set_visibility_customizations_.export(outfile, level)
        for create_custombutton_ in self.getCreate_custombutton():
            create_custombutton_.export(outfile, level)
        for get_custombutton_ in self.getGet_custombutton():
            get_custombutton_.export(outfile, level)
        for delete_custombutton_ in self.getDelete_custombutton():
            delete_custombutton_.export(outfile, level)
        for get_navigation_ in self.getGet_navigation():
            get_navigation_.export(outfile, level, name_='get-navigation')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set_visibility_customizations':
            obj_ = set_visibility_customizations.factory()
            obj_.build(child_)
            self.set_visibility_customizations.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create-custombutton':
            obj_ = create_custombutton.factory()
            obj_.build(child_)
            self.create_custombutton.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-custombutton':
            obj_ = get_custombutton.factory()
            obj_.build(child_)
            self.get_custombutton.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete-custombutton':
            obj_ = delete_custombutton.factory()
            obj_.build(child_)
            self.delete_custombutton.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-navigation':
            obj_ = GetNavigationOutputType.factory()
            obj_.build(child_)
            self.get_navigation.append(obj_)
# end class UIResponseType


class GetNavigationOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if GetNavigationOutputType.subclass:
            return GetNavigationOutputType.subclass(*args_, **kwargs_)
        else:
            return GetNavigationOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='GetNavigationOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='GetNavigationOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='GetNavigationOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class GetNavigationOutputType


class UploadOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if UploadOutputType.subclass:
            return UploadOutputType.subclass(*args_, **kwargs_)
        else:
            return UploadOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='UploadOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UploadOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UploadOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = UploadOutputResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class UploadOutputType


class UploadOutputResultType(resultType):
    subclass = None
    def __init__(self, name='', file='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.name = name
        self.file = file
    def factory(*args_, **kwargs_):
        if UploadOutputResultType.subclass:
            return UploadOutputResultType.subclass(*args_, **kwargs_)
        else:
            return UploadOutputResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getFile(self): return self.file
    def setFile(self, value): self.file = value
    def export(self, outfile, level, name_='UploadOutputResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UploadOutputResultType'):
        resultType.exportAttributes(self, outfile, level, name_='UploadOutputResultType')
    def exportChildren(self, outfile, level, name_='UploadOutputResultType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<file>%s</file>\n' % quote_xml(self.getFile()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            file_ = ''
            for text__content_ in child_.childNodes:
                file_ += text__content_.nodeValue
            self.file = file_
        resultType.buildChildren(self, child_, nodeName_)
# end class UploadOutputResultType


class DesktopInputPacketType:
    subclass = None
    def __init__(self, set_admin=None, set_default_preset=None, preset_list=None, add_preset=None, remove_preset=None):
        if set_admin is None:
            self.set_admin = []
        else:
            self.set_admin = set_admin
        if set_default_preset is None:
            self.set_default_preset = []
        else:
            self.set_default_preset = set_default_preset
        if preset_list is None:
            self.preset_list = []
        else:
            self.preset_list = preset_list
        if add_preset is None:
            self.add_preset = []
        else:
            self.add_preset = add_preset
        if remove_preset is None:
            self.remove_preset = []
        else:
            self.remove_preset = remove_preset
    def factory(*args_, **kwargs_):
        if DesktopInputPacketType.subclass:
            return DesktopInputPacketType.subclass(*args_, **kwargs_)
        else:
            return DesktopInputPacketType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSet_admin(self): return self.set_admin
    def setSet_admin(self, value): self.set_admin = value
    def addSet_admin(self, value): self.set_admin.append(value)
    def insertSet_admin(self, index, value): self.set_admin[index] = value
    def getSet_default_preset(self): return self.set_default_preset
    def setSet_default_preset(self, value): self.set_default_preset = value
    def addSet_default_preset(self, value): self.set_default_preset.append(value)
    def insertSet_default_preset(self, index, value): self.set_default_preset[index] = value
    def getPreset_list(self): return self.preset_list
    def setPreset_list(self, value): self.preset_list = value
    def addPreset_list(self, value): self.preset_list.append(value)
    def insertPreset_list(self, index, value): self.preset_list[index] = value
    def getAdd_preset(self): return self.add_preset
    def setAdd_preset(self, value): self.add_preset = value
    def addAdd_preset(self, value): self.add_preset.append(value)
    def insertAdd_preset(self, index, value): self.add_preset[index] = value
    def getRemove_preset(self): return self.remove_preset
    def setRemove_preset(self, value): self.remove_preset = value
    def addRemove_preset(self, value): self.remove_preset.append(value)
    def insertRemove_preset(self, index, value): self.remove_preset[index] = value
    def export(self, outfile, level, name_='DesktopInputPacketType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesktopInputPacketType'):
        pass
    def exportChildren(self, outfile, level, name_='DesktopInputPacketType'):
        for set_admin_ in self.getSet_admin():
            set_admin_.export(outfile, level, name_='set-admin')
        for set_default_preset_ in self.getSet_default_preset():
            set_default_preset_.export(outfile, level, name_='set-default-preset')
        for preset_list_ in self.getPreset_list():
            preset_list_.export(outfile, level, name_='preset-list')
        for add_preset_ in self.getAdd_preset():
            add_preset_.export(outfile, level, name_='add-preset')
        for remove_preset_ in self.getRemove_preset():
            remove_preset_.export(outfile, level, name_='remove-preset')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-admin':
            obj_ = SetAdminInputCommandType.factory()
            obj_.build(child_)
            self.set_admin.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default-preset':
            obj_ = SetDefaultPresetInputCommandType.factory()
            obj_.build(child_)
            self.set_default_preset.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preset-list':
            obj_ = PresetListsInputCommandType.factory()
            obj_.build(child_)
            self.preset_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-preset':
            obj_ = AddPresetInputCommandType.factory()
            obj_.build(child_)
            self.add_preset.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove-preset':
            obj_ = RemovePresetInputCommandType.factory()
            obj_.build(child_)
            self.remove_preset.append(obj_)
# end class DesktopInputPacketType


class SetAdminInputCommandType:
    subclass = None
    def __init__(self, desktop_preset=''):
        self.desktop_preset = desktop_preset
    def factory(*args_, **kwargs_):
        if SetAdminInputCommandType.subclass:
            return SetAdminInputCommandType.subclass(*args_, **kwargs_)
        else:
            return SetAdminInputCommandType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDesktop_preset(self): return self.desktop_preset
    def setDesktop_preset(self, value): self.desktop_preset = value
    def export(self, outfile, level, name_='SetAdminInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetAdminInputCommandType'):
        pass
    def exportChildren(self, outfile, level, name_='SetAdminInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<desktop-preset>%s</desktop-preset>\n' % quote_xml(self.getDesktop_preset()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'desktop-preset':
            desktop_preset_ = ''
            for text__content_ in child_.childNodes:
                desktop_preset_ += text__content_.nodeValue
            self.desktop_preset = desktop_preset_
# end class SetAdminInputCommandType


class SetDefaultPresetInputCommandType:
    subclass = None
    def __init__(self, name=None, id=None, ttype=''):
        self.name = name
        self.id = id
        self.ttype = ttype
    def factory(*args_, **kwargs_):
        if SetDefaultPresetInputCommandType.subclass:
            return SetDefaultPresetInputCommandType.subclass(*args_, **kwargs_)
        else:
            return SetDefaultPresetInputCommandType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def export(self, outfile, level, name_='SetDefaultPresetInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetDefaultPresetInputCommandType'):
        pass
    def exportChildren(self, outfile, level, name_='SetDefaultPresetInputCommandType'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
# end class SetDefaultPresetInputCommandType


class AddPresetInputCommandType:
    subclass = None
    def __init__(self, file='', overwrite=None):
        self.file = file
        self.overwrite = overwrite
    def factory(*args_, **kwargs_):
        if AddPresetInputCommandType.subclass:
            return AddPresetInputCommandType.subclass(*args_, **kwargs_)
        else:
            return AddPresetInputCommandType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFile(self): return self.file
    def setFile(self, value): self.file = value
    def getOverwrite(self): return self.overwrite
    def setOverwrite(self, value): self.overwrite = value
    def export(self, outfile, level, name_='AddPresetInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AddPresetInputCommandType'):
        pass
    def exportChildren(self, outfile, level, name_='AddPresetInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<file>%s</file>\n' % quote_xml(self.getFile()))
        if self.overwrite is not None:
            self.overwrite.export(outfile, level, name_='overwrite')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            file_ = ''
            for text__content_ in child_.childNodes:
                file_ += text__content_.nodeValue
            self.file = file_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'overwrite':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setOverwrite(obj_)
# end class AddPresetInputCommandType


class RemovePresetInputCommandType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if RemovePresetInputCommandType.subclass:
            return RemovePresetInputCommandType.subclass(*args_, **kwargs_)
        else:
            return RemovePresetInputCommandType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='RemovePresetInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='RemovePresetInputCommandType'):
        pass
    def exportChildren(self, outfile, level, name_='RemovePresetInputCommandType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = PresetFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class RemovePresetInputCommandType


class DesktopOutputPacketType:
    subclass = None
    def __init__(self, set_admin=None, set_default_preset=None, preset_list=None, add_preset=None, remove_preset=None):
        if set_admin is None:
            self.set_admin = []
        else:
            self.set_admin = set_admin
        if set_default_preset is None:
            self.set_default_preset = []
        else:
            self.set_default_preset = set_default_preset
        if preset_list is None:
            self.preset_list = []
        else:
            self.preset_list = preset_list
        if add_preset is None:
            self.add_preset = []
        else:
            self.add_preset = add_preset
        if remove_preset is None:
            self.remove_preset = []
        else:
            self.remove_preset = remove_preset
    def factory(*args_, **kwargs_):
        if DesktopOutputPacketType.subclass:
            return DesktopOutputPacketType.subclass(*args_, **kwargs_)
        else:
            return DesktopOutputPacketType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSet_admin(self): return self.set_admin
    def setSet_admin(self, value): self.set_admin = value
    def addSet_admin(self, value): self.set_admin.append(value)
    def insertSet_admin(self, index, value): self.set_admin[index] = value
    def getSet_default_preset(self): return self.set_default_preset
    def setSet_default_preset(self, value): self.set_default_preset = value
    def addSet_default_preset(self, value): self.set_default_preset.append(value)
    def insertSet_default_preset(self, index, value): self.set_default_preset[index] = value
    def getPreset_list(self): return self.preset_list
    def setPreset_list(self, value): self.preset_list = value
    def addPreset_list(self, value): self.preset_list.append(value)
    def insertPreset_list(self, index, value): self.preset_list[index] = value
    def getAdd_preset(self): return self.add_preset
    def setAdd_preset(self, value): self.add_preset = value
    def addAdd_preset(self, value): self.add_preset.append(value)
    def insertAdd_preset(self, index, value): self.add_preset[index] = value
    def getRemove_preset(self): return self.remove_preset
    def setRemove_preset(self, value): self.remove_preset = value
    def addRemove_preset(self, value): self.remove_preset.append(value)
    def insertRemove_preset(self, index, value): self.remove_preset[index] = value
    def export(self, outfile, level, name_='DesktopOutputPacketType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesktopOutputPacketType'):
        pass
    def exportChildren(self, outfile, level, name_='DesktopOutputPacketType'):
        for set_admin_ in self.getSet_admin():
            set_admin_.export(outfile, level, name_='set-admin')
        for set_default_preset_ in self.getSet_default_preset():
            set_default_preset_.export(outfile, level, name_='set-default-preset')
        for preset_list_ in self.getPreset_list():
            preset_list_.export(outfile, level, name_='preset-list')
        for add_preset_ in self.getAdd_preset():
            add_preset_.export(outfile, level, name_='add-preset')
        for remove_preset_ in self.getRemove_preset():
            remove_preset_.export(outfile, level, name_='remove-preset')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-admin':
            obj_ = SetAdminResult.factory()
            obj_.build(child_)
            self.set_admin.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default-preset':
            obj_ = SetDefaultResult.factory()
            obj_.build(child_)
            self.set_default_preset.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preset-list':
            obj_ = PresetListsResult.factory()
            obj_.build(child_)
            self.preset_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-preset':
            obj_ = AddPresetResult.factory()
            obj_.build(child_)
            self.add_preset.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove-preset':
            obj_ = RemovePresetResult.factory()
            obj_.build(child_)
            self.remove_preset.append(obj_)
# end class DesktopOutputPacketType


class PresetFilterType:
    subclass = None
    def __init__(self, name=None, ttype=None, id=None):
        self.name = name
        self.ttype = ttype
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if PresetFilterType.subclass:
            return PresetFilterType.subclass(*args_, **kwargs_)
        else:
            return PresetFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='PresetFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PresetFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='PresetFilterType'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.ttype is not None:
            showIndent(outfile, level)
            outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class PresetFilterType


class DesktopOpResultType(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if DesktopOpResultType.subclass:
            return DesktopOpResultType.subclass(*args_, **kwargs_)
        else:
            return DesktopOpResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='DesktopOpResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesktopOpResultType'):
        resultType.exportAttributes(self, outfile, level, name_='DesktopOpResultType')
    def exportChildren(self, outfile, level, name_='DesktopOpResultType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class DesktopOpResultType


class PresetListsInputCommandType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if PresetListsInputCommandType.subclass:
            return PresetListsInputCommandType.subclass(*args_, **kwargs_)
        else:
            return PresetListsInputCommandType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='PresetListsInputCommandType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PresetListsInputCommandType'):
        pass
    def exportChildren(self, outfile, level, name_='PresetListsInputCommandType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = PresetSimpleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class PresetListsInputCommandType


class PresetSimpleFilterType:
    subclass = None
    def __init__(self, id=None):
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if PresetSimpleFilterType.subclass:
            return PresetSimpleFilterType.subclass(*args_, **kwargs_)
        else:
            return PresetSimpleFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='PresetSimpleFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PresetSimpleFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='PresetSimpleFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class PresetSimpleFilterType


class PresetType:
    subclass = None
    def __init__(self, name='', ttype='', default=None):
        self.name = name
        self.ttype = ttype
        self.default = default
    def factory(*args_, **kwargs_):
        if PresetType.subclass:
            return PresetType.subclass(*args_, **kwargs_)
        else:
            return PresetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getDefault(self): return self.default
    def setDefault(self, value): self.default = value
    def export(self, outfile, level, name_='PresetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PresetType'):
        pass
    def exportChildren(self, outfile, level, name_='PresetType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        if self.default is not None:
            self.default.export(outfile, level, name_='default')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'default':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDefault(obj_)
# end class PresetType


class DesktopOpAdvancedpresetType(DesktopOpResultType):
    subclass = None
    def __init__(self, preset=None, id='', status='', errcode=None, errtext=None):
        DesktopOpResultType.__init__(self, id, status, errcode, errtext)
        self.preset = preset
    def factory(*args_, **kwargs_):
        if DesktopOpAdvancedpresetType.subclass:
            return DesktopOpAdvancedpresetType.subclass(*args_, **kwargs_)
        else:
            return DesktopOpAdvancedpresetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPreset(self): return self.preset
    def setPreset(self, value): self.preset = value
    def export(self, outfile, level, name_='DesktopOpAdvancedpresetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DesktopOpAdvancedpresetType'):
        DesktopOpResultType.exportAttributes(self, outfile, level, name_='DesktopOpAdvancedpresetType')
    def exportChildren(self, outfile, level, name_='DesktopOpAdvancedpresetType'):
        if self.preset is not None:
            self.preset.export(outfile, level, name_='preset')
        DesktopOpResultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        DesktopOpResultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preset':
            obj_ = PresetType.factory()
            obj_.build(child_)
            self.setPreset(obj_)
        DesktopOpResultType.buildChildren(self, child_, nodeName_)
# end class DesktopOpAdvancedpresetType


class SetAdminResult:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SetAdminResult.subclass:
            return SetAdminResult.subclass(*args_, **kwargs_)
        else:
            return SetAdminResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SetAdminResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetAdminResult'):
        pass
    def exportChildren(self, outfile, level, name_='SetAdminResult'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = DesktopOpResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SetAdminResult


class SetDefaultResult:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SetDefaultResult.subclass:
            return SetDefaultResult.subclass(*args_, **kwargs_)
        else:
            return SetDefaultResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SetDefaultResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SetDefaultResult'):
        pass
    def exportChildren(self, outfile, level, name_='SetDefaultResult'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = DesktopOpResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SetDefaultResult


class AddPresetResult:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if AddPresetResult.subclass:
            return AddPresetResult.subclass(*args_, **kwargs_)
        else:
            return AddPresetResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='AddPresetResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AddPresetResult'):
        pass
    def exportChildren(self, outfile, level, name_='AddPresetResult'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = DesktopOpResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class AddPresetResult


class RemovePresetResult:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if RemovePresetResult.subclass:
            return RemovePresetResult.subclass(*args_, **kwargs_)
        else:
            return RemovePresetResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='RemovePresetResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='RemovePresetResult'):
        pass
    def exportChildren(self, outfile, level, name_='RemovePresetResult'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = DesktopOpResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class RemovePresetResult


class PresetListsResult:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if PresetListsResult.subclass:
            return PresetListsResult.subclass(*args_, **kwargs_)
        else:
            return PresetListsResult(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='PresetListsResult'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='PresetListsResult'):
        pass
    def exportChildren(self, outfile, level, name_='PresetListsResult'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = DesktopOpAdvancedpresetType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class PresetListsResult


class DomainTemplateInputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if DomainTemplateInputType.subclass:
            return DomainTemplateInputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='DomainTemplateInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = DomainTemplateAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = DomainTemplateGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = DomanTemplateDeleteInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = DomainTemplateSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class DomainTemplateInputType


class DomainTemplatePHostingPreferences:
    subclass = None
    def __init__(self, ftp_quota=None, fp=None, fp_ssl=None, fp_auth=None, ssl=None, shell=None, php=None, ssi=None, ssi_html=None, cgi=None, mod_perl=None, mod_python=None, asp=None, asp_dot_net=None, coldfusion=None, webstat=None, webstat_protected=None, errdocs=None, at_domains=None, php_safe_mode=None, sb_publishing=None, php_isapi=None, managed_runtime_version=None, iis_app_pool=None, fastcgi=None, cpu_usage=None, wuscripts=None, php_version=None, create_sb_subdomains=None):
        self.ftp_quota = ftp_quota
        self.fp = fp
        self.fp_ssl = fp_ssl
        self.fp_auth = fp_auth
        self.ssl = ssl
        self.shell = shell
        self.php = php
        self.ssi = ssi
        self.ssi_html = ssi_html
        self.cgi = cgi
        self.mod_perl = mod_perl
        self.mod_python = mod_python
        self.asp = asp
        self.asp_dot_net = asp_dot_net
        self.coldfusion = coldfusion
        self.webstat = webstat
        self.webstat_protected = webstat_protected
        self.errdocs = errdocs
        self.at_domains = at_domains
        self.php_safe_mode = php_safe_mode
        self.sb_publishing = sb_publishing
        self.php_isapi = php_isapi
        self.managed_runtime_version = managed_runtime_version
        self.iis_app_pool = iis_app_pool
        self.fastcgi = fastcgi
        self.cpu_usage = cpu_usage
        self.wuscripts = wuscripts
        self.php_version = php_version
        self.create_sb_subdomains = create_sb_subdomains
    def factory(*args_, **kwargs_):
        if DomainTemplatePHostingPreferences.subclass:
            return DomainTemplatePHostingPreferences.subclass(*args_, **kwargs_)
        else:
            return DomainTemplatePHostingPreferences(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFtp_quota(self): return self.ftp_quota
    def setFtp_quota(self, value): self.ftp_quota = value
    def getFp(self): return self.fp
    def setFp(self, value): self.fp = value
    def getFp_ssl(self): return self.fp_ssl
    def setFp_ssl(self, value): self.fp_ssl = value
    def getFp_auth(self): return self.fp_auth
    def setFp_auth(self, value): self.fp_auth = value
    def getSsl(self): return self.ssl
    def setSsl(self, value): self.ssl = value
    def getShell(self): return self.shell
    def setShell(self, value): self.shell = value
    def getPhp(self): return self.php
    def setPhp(self, value): self.php = value
    def getSsi(self): return self.ssi
    def setSsi(self, value): self.ssi = value
    def getSsi_html(self): return self.ssi_html
    def setSsi_html(self, value): self.ssi_html = value
    def getCgi(self): return self.cgi
    def setCgi(self, value): self.cgi = value
    def getMod_perl(self): return self.mod_perl
    def setMod_perl(self, value): self.mod_perl = value
    def getMod_python(self): return self.mod_python
    def setMod_python(self, value): self.mod_python = value
    def getAsp(self): return self.asp
    def setAsp(self, value): self.asp = value
    def getAsp_dot_net(self): return self.asp_dot_net
    def setAsp_dot_net(self, value): self.asp_dot_net = value
    def getColdfusion(self): return self.coldfusion
    def setColdfusion(self, value): self.coldfusion = value
    def getWebstat(self): return self.webstat
    def setWebstat(self, value): self.webstat = value
    def getWebstat_protected(self): return self.webstat_protected
    def setWebstat_protected(self, value): self.webstat_protected = value
    def getErrdocs(self): return self.errdocs
    def setErrdocs(self, value): self.errdocs = value
    def getAt_domains(self): return self.at_domains
    def setAt_domains(self, value): self.at_domains = value
    def getPhp_safe_mode(self): return self.php_safe_mode
    def setPhp_safe_mode(self, value): self.php_safe_mode = value
    def getSb_publishing(self): return self.sb_publishing
    def setSb_publishing(self, value): self.sb_publishing = value
    def getPhp_isapi(self): return self.php_isapi
    def setPhp_isapi(self, value): self.php_isapi = value
    def getManaged_runtime_version(self): return self.managed_runtime_version
    def setManaged_runtime_version(self, value): self.managed_runtime_version = value
    def getIis_app_pool(self): return self.iis_app_pool
    def setIis_app_pool(self, value): self.iis_app_pool = value
    def getFastcgi(self): return self.fastcgi
    def setFastcgi(self, value): self.fastcgi = value
    def getCpu_usage(self): return self.cpu_usage
    def setCpu_usage(self, value): self.cpu_usage = value
    def getWuscripts(self): return self.wuscripts
    def setWuscripts(self, value): self.wuscripts = value
    def getPhp_version(self): return self.php_version
    def setPhp_version(self, value): self.php_version = value
    def getCreate_sb_subdomains(self): return self.create_sb_subdomains
    def setCreate_sb_subdomains(self, value): self.create_sb_subdomains = value
    def export(self, outfile, level, name_='DomainTemplatePHostingPreferences'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplatePHostingPreferences'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplatePHostingPreferences'):
        if self.ftp_quota is not None:
            showIndent(outfile, level)
            outfile.write('<ftp_quota>%s</ftp_quota>\n' % quote_xml(self.getFtp_quota()))
        if self.fp is not None:
            showIndent(outfile, level)
            outfile.write('<fp>%s</fp>\n' % quote_xml(self.getFp()))
        if self.fp_ssl is not None:
            showIndent(outfile, level)
            outfile.write('<fp_ssl>%s</fp_ssl>\n' % quote_xml(self.getFp_ssl()))
        if self.fp_auth is not None:
            showIndent(outfile, level)
            outfile.write('<fp_auth>%s</fp_auth>\n' % quote_xml(self.getFp_auth()))
        if self.ssl is not None:
            showIndent(outfile, level)
            outfile.write('<ssl>%s</ssl>\n' % quote_xml(self.getSsl()))
        if self.shell is not None:
            showIndent(outfile, level)
            outfile.write('<shell>%s</shell>\n' % quote_xml(self.getShell()))
        if self.php is not None:
            showIndent(outfile, level)
            outfile.write('<php>%s</php>\n' % quote_xml(self.getPhp()))
        if self.ssi is not None:
            showIndent(outfile, level)
            outfile.write('<ssi>%s</ssi>\n' % quote_xml(self.getSsi()))
        if self.ssi_html is not None:
            showIndent(outfile, level)
            outfile.write('<ssi_html>%s</ssi_html>\n' % quote_xml(self.getSsi_html()))
        if self.cgi is not None:
            showIndent(outfile, level)
            outfile.write('<cgi>%s</cgi>\n' % quote_xml(self.getCgi()))
        if self.mod_perl is not None:
            showIndent(outfile, level)
            outfile.write('<mod_perl>%s</mod_perl>\n' % quote_xml(self.getMod_perl()))
        if self.mod_python is not None:
            showIndent(outfile, level)
            outfile.write('<mod_python>%s</mod_python>\n' % quote_xml(self.getMod_python()))
        if self.asp is not None:
            showIndent(outfile, level)
            outfile.write('<asp>%s</asp>\n' % quote_xml(self.getAsp()))
        if self.asp_dot_net is not None:
            showIndent(outfile, level)
            outfile.write('<asp_dot_net>%s</asp_dot_net>\n' % quote_xml(self.getAsp_dot_net()))
        if self.coldfusion is not None:
            showIndent(outfile, level)
            outfile.write('<coldfusion>%s</coldfusion>\n' % quote_xml(self.getColdfusion()))
        if self.webstat is not None:
            showIndent(outfile, level)
            outfile.write('<webstat>%s</webstat>\n' % quote_xml(self.getWebstat()))
        if self.webstat_protected is not None:
            showIndent(outfile, level)
            outfile.write('<webstat_protected>%d</webstat_protected>\n' % self.getWebstat_protected())
        if self.errdocs is not None:
            showIndent(outfile, level)
            outfile.write('<errdocs>%s</errdocs>\n' % quote_xml(self.getErrdocs()))
        if self.at_domains is not None:
            showIndent(outfile, level)
            outfile.write('<at_domains>%s</at_domains>\n' % quote_xml(self.getAt_domains()))
        if self.php_safe_mode is not None:
            showIndent(outfile, level)
            outfile.write('<php_safe_mode>%s</php_safe_mode>\n' % quote_xml(self.getPhp_safe_mode()))
        if self.sb_publishing is not None:
            showIndent(outfile, level)
            outfile.write('<sb_publishing>%s</sb_publishing>\n' % quote_xml(self.getSb_publishing()))
        if self.php_isapi is not None:
            showIndent(outfile, level)
            outfile.write('<php_isapi>%s</php_isapi>\n' % quote_xml(self.getPhp_isapi()))
        if self.managed_runtime_version is not None:
            showIndent(outfile, level)
            outfile.write('<managed_runtime_version>%s</managed_runtime_version>\n' % quote_xml(self.getManaged_runtime_version()))
        if self.iis_app_pool is not None:
            showIndent(outfile, level)
            outfile.write('<iis-app-pool>%s</iis-app-pool>\n' % quote_xml(self.getIis_app_pool()))
        if self.fastcgi is not None:
            showIndent(outfile, level)
            outfile.write('<fastcgi>%s</fastcgi>\n' % quote_xml(self.getFastcgi()))
        if self.cpu_usage is not None:
            showIndent(outfile, level)
            outfile.write('<cpu-usage>%s</cpu-usage>\n' % quote_xml(self.getCpu_usage()))
        if self.wuscripts is not None:
            showIndent(outfile, level)
            outfile.write('<wuscripts>%s</wuscripts>\n' % quote_xml(self.getWuscripts()))
        if self.php_version is not None:
            showIndent(outfile, level)
            outfile.write('<php-version>%s</php-version>\n' % quote_xml(self.getPhp_version()))
        if self.create_sb_subdomains is not None:
            showIndent(outfile, level)
            outfile.write('<create-sb-subdomains>%s</create-sb-subdomains>\n' % quote_xml(self.getCreate_sb_subdomains()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp_quota':
            ftp_quota_ = ''
            for text__content_ in child_.childNodes:
                ftp_quota_ += text__content_.nodeValue
            self.ftp_quota = ftp_quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fp':
            fp_ = ''
            for text__content_ in child_.childNodes:
                fp_ += text__content_.nodeValue
            self.fp = fp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fp_ssl':
            fp_ssl_ = ''
            for text__content_ in child_.childNodes:
                fp_ssl_ += text__content_.nodeValue
            self.fp_ssl = fp_ssl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fp_auth':
            fp_auth_ = ''
            for text__content_ in child_.childNodes:
                fp_auth_ += text__content_.nodeValue
            self.fp_auth = fp_auth_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ssl':
            ssl_ = ''
            for text__content_ in child_.childNodes:
                ssl_ += text__content_.nodeValue
            self.ssl = ssl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shell':
            shell_ = ''
            for text__content_ in child_.childNodes:
                shell_ += text__content_.nodeValue
            self.shell = shell_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'php':
            php_ = ''
            for text__content_ in child_.childNodes:
                php_ += text__content_.nodeValue
            self.php = php_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ssi':
            ssi_ = ''
            for text__content_ in child_.childNodes:
                ssi_ += text__content_.nodeValue
            self.ssi = ssi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ssi_html':
            ssi_html_ = ''
            for text__content_ in child_.childNodes:
                ssi_html_ += text__content_.nodeValue
            self.ssi_html = ssi_html_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cgi':
            cgi_ = ''
            for text__content_ in child_.childNodes:
                cgi_ += text__content_.nodeValue
            self.cgi = cgi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mod_perl':
            mod_perl_ = ''
            for text__content_ in child_.childNodes:
                mod_perl_ += text__content_.nodeValue
            self.mod_perl = mod_perl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mod_python':
            mod_python_ = ''
            for text__content_ in child_.childNodes:
                mod_python_ += text__content_.nodeValue
            self.mod_python = mod_python_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp':
            asp_ = ''
            for text__content_ in child_.childNodes:
                asp_ += text__content_.nodeValue
            self.asp = asp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp_dot_net':
            asp_dot_net_ = ''
            for text__content_ in child_.childNodes:
                asp_dot_net_ += text__content_.nodeValue
            self.asp_dot_net = asp_dot_net_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'coldfusion':
            coldfusion_ = ''
            for text__content_ in child_.childNodes:
                coldfusion_ += text__content_.nodeValue
            self.coldfusion = coldfusion_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webstat':
            webstat_ = ''
            for text__content_ in child_.childNodes:
                webstat_ += text__content_.nodeValue
            self.webstat = webstat_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webstat_protected':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.webstat_protected = ival_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errdocs':
            errdocs_ = ''
            for text__content_ in child_.childNodes:
                errdocs_ += text__content_.nodeValue
            self.errdocs = errdocs_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'at_domains':
            at_domains_ = ''
            for text__content_ in child_.childNodes:
                at_domains_ += text__content_.nodeValue
            self.at_domains = at_domains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'php_safe_mode':
            php_safe_mode_ = ''
            for text__content_ in child_.childNodes:
                php_safe_mode_ += text__content_.nodeValue
            self.php_safe_mode = php_safe_mode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sb_publishing':
            sb_publishing_ = ''
            for text__content_ in child_.childNodes:
                sb_publishing_ += text__content_.nodeValue
            self.sb_publishing = sb_publishing_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'php_isapi':
            php_isapi_ = ''
            for text__content_ in child_.childNodes:
                php_isapi_ += text__content_.nodeValue
            self.php_isapi = php_isapi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'managed_runtime_version':
            managed_runtime_version_ = ''
            for text__content_ in child_.childNodes:
                managed_runtime_version_ += text__content_.nodeValue
            self.managed_runtime_version = managed_runtime_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'iis-app-pool':
            iis_app_pool_ = ''
            for text__content_ in child_.childNodes:
                iis_app_pool_ += text__content_.nodeValue
            self.iis_app_pool = iis_app_pool_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fastcgi':
            fastcgi_ = ''
            for text__content_ in child_.childNodes:
                fastcgi_ += text__content_.nodeValue
            self.fastcgi = fastcgi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cpu-usage':
            cpu_usage_ = ''
            for text__content_ in child_.childNodes:
                cpu_usage_ += text__content_.nodeValue
            self.cpu_usage = cpu_usage_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'wuscripts':
            wuscripts_ = ''
            for text__content_ in child_.childNodes:
                wuscripts_ += text__content_.nodeValue
            self.wuscripts = wuscripts_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'php-version':
            php_version_ = ''
            for text__content_ in child_.childNodes:
                php_version_ += text__content_.nodeValue
            self.php_version = php_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create-sb-subdomains':
            create_sb_subdomains_ = ''
            for text__content_ in child_.childNodes:
                create_sb_subdomains_ += text__content_.nodeValue
            self.create_sb_subdomains = create_sb_subdomains_
# end class DomainTemplatePHostingPreferences


class DomainTemplateAddInputType:
    subclass = None
    def __init__(self, name='', owner_id=None, owner_login=None, mail=None, limits=None, log_rotation=None, preferences=None, hosting=None, performance=None):
        self.name = name
        self.owner_id = owner_id
        self.owner_login = owner_login
        self.mail = mail
        self.limits = limits
        self.log_rotation = log_rotation
        self.preferences = preferences
        self.hosting = hosting
        self.performance = performance
    def factory(*args_, **kwargs_):
        if DomainTemplateAddInputType.subclass:
            return DomainTemplateAddInputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def getMail(self): return self.mail
    def setMail(self, value): self.mail = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getLog_rotation(self): return self.log_rotation
    def setLog_rotation(self, value): self.log_rotation = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getHosting(self): return self.hosting
    def setHosting(self, value): self.hosting = value
    def getPerformance(self): return self.performance
    def setPerformance(self, value): self.performance = value
    def export(self, outfile, level, name_='DomainTemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateAddInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
        if self.mail is not None:
            self.mail.export(outfile, level, name_='mail')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.log_rotation is not None:
            self.log_rotation.export(outfile, level, name_='log-rotation')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.hosting is not None:
            self.hosting.export(outfile, level, name_='hosting')
        if self.performance is not None:
            self.performance.export(outfile, level, name_='performance')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail':
            obj_ = MailPreferences.factory()
            obj_.build(child_)
            self.setMail(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = domainLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-rotation':
            obj_ = LogRotationType.factory()
            obj_.build(child_)
            self.setLog_rotation(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = DomainTemplatePreferecesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hosting':
            obj_ = DomainTemplateVrtHst.factory()
            obj_.build(child_)
            self.setHosting(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'performance':
            obj_ = DomainPerformanceType.factory()
            obj_.build(child_)
            self.setPerformance(obj_)
# end class DomainTemplateAddInputType


class DomainTemplatePreferecesType:
    subclass = None
    def __init__(self, stat=None, maillists=None, dns_zone_type=None, shared=None):
        self.stat = stat
        self.maillists = maillists
        self.dns_zone_type = dns_zone_type
        self.shared = shared
    def factory(*args_, **kwargs_):
        if DomainTemplatePreferecesType.subclass:
            return DomainTemplatePreferecesType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplatePreferecesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getMaillists(self): return self.maillists
    def setMaillists(self, value): self.maillists = value
    def getDns_zone_type(self): return self.dns_zone_type
    def setDns_zone_type(self, value): self.dns_zone_type = value
    def getShared(self): return self.shared
    def setShared(self, value): self.shared = value
    def export(self, outfile, level, name_='DomainTemplatePreferecesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplatePreferecesType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplatePreferecesType'):
        if self.stat is not None:
            showIndent(outfile, level)
            outfile.write('<stat>%s</stat>\n' % quote_xml(self.getStat()))
        if self.maillists is not None:
            showIndent(outfile, level)
            outfile.write('<maillists>%s</maillists>\n' % quote_xml(self.getMaillists()))
        if self.dns_zone_type is not None:
            showIndent(outfile, level)
            outfile.write('<dns_zone_type>%s</dns_zone_type>\n' % quote_xml(self.getDns_zone_type()))
        if self.shared is not None:
            showIndent(outfile, level)
            outfile.write('<shared>%s</shared>\n' % quote_xml(self.getShared()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            stat_ = ''
            for text__content_ in child_.childNodes:
                stat_ += text__content_.nodeValue
            self.stat = stat_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maillists':
            maillists_ = ''
            for text__content_ in child_.childNodes:
                maillists_ += text__content_.nodeValue
            self.maillists = maillists_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dns_zone_type':
            dns_zone_type_ = ''
            for text__content_ in child_.childNodes:
                dns_zone_type_ += text__content_.nodeValue
            self.dns_zone_type = dns_zone_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shared':
            shared_ = ''
            for text__content_ in child_.childNodes:
                shared_ += text__content_.nodeValue
            self.shared = shared_
# end class DomainTemplatePreferecesType


class LogRotationType:
    subclass = None
    def __init__(self, on=None, off=None):
        self.on = on
        self.off = off
    def factory(*args_, **kwargs_):
        if LogRotationType.subclass:
            return LogRotationType.subclass(*args_, **kwargs_)
        else:
            return LogRotationType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getOn(self): return self.on
    def setOn(self, value): self.on = value
    def getOff(self): return self.off
    def setOff(self, value): self.off = value
    def export(self, outfile, level, name_='LogRotationType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationType'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationType'):
        if self.on is not None:
            self.on.export(outfile, level)
        if self.off is not None:
            self.off.export(outfile, level, name_='off')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'on':
            obj_ = on.factory()
            obj_.build(child_)
            self.setOn(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'off':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setOff(obj_)
# end class LogRotationType


class DomainTemplateFilterType:
    subclass = None
    def __init__(self, name=None, id=None):
        if name is None:
            self.name = []
        else:
            self.name = name
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if DomainTemplateFilterType.subclass:
            return DomainTemplateFilterType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='DomainTemplateFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateFilterType'):
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class DomainTemplateFilterType


class DomainTemplateGetInputType:
    subclass = None
    def __init__(self, filter=None, owner_id=None, owner_login=None):
        self.filter = filter
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if DomainTemplateGetInputType.subclass:
            return DomainTemplateGetInputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='DomainTemplateGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = DomainTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class DomainTemplateGetInputType


class DomanTemplateDeleteInputType:
    subclass = None
    def __init__(self, filter=None, owner_id=None, owner_login=None):
        self.filter = filter
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if DomanTemplateDeleteInputType.subclass:
            return DomanTemplateDeleteInputType.subclass(*args_, **kwargs_)
        else:
            return DomanTemplateDeleteInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='DomanTemplateDeleteInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomanTemplateDeleteInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomanTemplateDeleteInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = DomainTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class DomanTemplateDeleteInputType


class DomainTemplateSetInputType:
    subclass = None
    def __init__(self, filter=None, owner_id=None, owner_login=None, mail=None, limits=None, log_rotation=None, preferences=None, hosting=None, performance=None):
        self.filter = filter
        self.owner_id = owner_id
        self.owner_login = owner_login
        self.mail = mail
        self.limits = limits
        self.log_rotation = log_rotation
        self.preferences = preferences
        self.hosting = hosting
        self.performance = performance
    def factory(*args_, **kwargs_):
        if DomainTemplateSetInputType.subclass:
            return DomainTemplateSetInputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def getMail(self): return self.mail
    def setMail(self, value): self.mail = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getLog_rotation(self): return self.log_rotation
    def setLog_rotation(self, value): self.log_rotation = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getHosting(self): return self.hosting
    def setHosting(self, value): self.hosting = value
    def getPerformance(self): return self.performance
    def setPerformance(self, value): self.performance = value
    def export(self, outfile, level, name_='DomainTemplateSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
        if self.mail is not None:
            self.mail.export(outfile, level, name_='mail')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.log_rotation is not None:
            self.log_rotation.export(outfile, level, name_='log-rotation')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.hosting is not None:
            self.hosting.export(outfile, level, name_='hosting')
        if self.performance is not None:
            self.performance.export(outfile, level, name_='performance')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = DomainTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail':
            obj_ = MailPreferences.factory()
            obj_.build(child_)
            self.setMail(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = domainLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-rotation':
            obj_ = LogRotationType.factory()
            obj_.build(child_)
            self.setLog_rotation(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = DomainTemplatePreferecesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'hosting':
            obj_ = DomanTemplatePHosting.factory()
            obj_.build(child_)
            self.setHosting(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'performance':
            obj_ = DomainPerformanceType.factory()
            obj_.build(child_)
            self.setPerformance(obj_)
# end class DomainTemplateSetInputType


class DomainTemplateOutputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if DomainTemplateOutputType.subclass:
            return DomainTemplateOutputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='DomainTemplateOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = DomainTemplateAddOutputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = DomainTemplateGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = DomainTemplateDeleteOutputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = DomainTemplateSetOutputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class DomainTemplateOutputType


class DomainTemplateAddOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if DomainTemplateAddOutputType.subclass:
            return DomainTemplateAddOutputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateAddOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='DomainTemplateAddOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateAddOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateAddOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class DomainTemplateAddOutputType


class DomainTemplateGetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DomainTemplateGetOutputType.subclass:
            return DomainTemplateGetOutputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DomainTemplateGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateGetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DomainTemplateGetOutputType


class DomanTemplatePHosting:
    subclass = None
    def __init__(self, vrt_hst=None, none=None):
        self.vrt_hst = vrt_hst
        self.none = none
    def factory(*args_, **kwargs_):
        if DomanTemplatePHosting.subclass:
            return DomanTemplatePHosting.subclass(*args_, **kwargs_)
        else:
            return DomanTemplatePHosting(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getVrt_hst(self): return self.vrt_hst
    def setVrt_hst(self, value): self.vrt_hst = value
    def getNone(self): return self.none
    def setNone(self, value): self.none = value
    def export(self, outfile, level, name_='DomanTemplatePHosting'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomanTemplatePHosting'):
        pass
    def exportChildren(self, outfile, level, name_='DomanTemplatePHosting'):
        if self.vrt_hst is not None:
            self.vrt_hst.export(outfile, level, name_='vrt_hst')
        if self.none is not None:
            self.none.export(outfile, level, name_='none')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'vrt_hst':
            obj_ = DomainTemplateVrtHst.factory()
            obj_.build(child_)
            self.setVrt_hst(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'none':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setNone(obj_)
# end class DomanTemplatePHosting


class DomainTemplateResultType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if DomainTemplateResultType.subclass:
            return DomainTemplateResultType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='DomainTemplateResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateResultType'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateResultType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class DomainTemplateResultType


class DomainTemplateSetOutputType(DomainTemplateResultType):
    subclass = None
    def __init__(self, result=None, valueOf_=''):
        DomainTemplateResultType.__init__(self, result)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DomainTemplateSetOutputType.subclass:
            return DomainTemplateSetOutputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateSetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='DomainTemplateSetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateSetOutputType'):
        DomainTemplateResultType.exportAttributes(self, outfile, level, name_='DomainTemplateSetOutputType')
    def exportChildren(self, outfile, level, name_='DomainTemplateSetOutputType'):
        DomainTemplateResultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        DomainTemplateResultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        DomainTemplateResultType.buildChildren(self, child_, nodeName_)
# end class DomainTemplateSetOutputType


class ConditionType:
    subclass = None
    def __init__(self, log_bysize=None, log_bytime=None):
        self.log_bysize = log_bysize
        self.log_bytime = log_bytime
    def factory(*args_, **kwargs_):
        if ConditionType.subclass:
            return ConditionType.subclass(*args_, **kwargs_)
        else:
            return ConditionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getLog_bysize(self): return self.log_bysize
    def setLog_bysize(self, value): self.log_bysize = value
    def getLog_bytime(self): return self.log_bytime
    def setLog_bytime(self, value): self.log_bytime = value
    def export(self, outfile, level, name_='ConditionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ConditionType'):
        pass
    def exportChildren(self, outfile, level, name_='ConditionType'):
        if self.log_bysize is not None:
            showIndent(outfile, level)
            outfile.write('<log-bysize>%s</log-bysize>\n' % quote_xml(self.getLog_bysize()))
        if self.log_bytime is not None:
            showIndent(outfile, level)
            outfile.write('<log-bytime>%s</log-bytime>\n' % quote_xml(self.getLog_bytime()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-bysize':
            log_bysize_ = ''
            for text__content_ in child_.childNodes:
                log_bysize_ += text__content_.nodeValue
            self.log_bysize = log_bysize_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-bytime':
            log_bytime_ = ''
            for text__content_ in child_.childNodes:
                log_bytime_ += text__content_.nodeValue
            self.log_bytime = log_bytime_
# end class ConditionType


class DomainTemplateVrtHst:
    subclass = None
    def __init__(self, property=None):
        if property is None:
            self.property = []
        else:
            self.property = property
    def factory(*args_, **kwargs_):
        if DomainTemplateVrtHst.subclass:
            return DomainTemplateVrtHst.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateVrtHst(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def export(self, outfile, level, name_='DomainTemplateVrtHst'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateVrtHst'):
        pass
    def exportChildren(self, outfile, level, name_='DomainTemplateVrtHst'):
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = PleskPhysHOstingPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
# end class DomainTemplateVrtHst


class ClientTemplateInputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if ClientTemplateInputType.subclass:
            return ClientTemplateInputType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='ClientTemplateInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ClienttemplateAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ClientTemplateGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ClientTemplateDelInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ClientTemplateSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class ClientTemplateInputType


class ClienttemplateAddInputType:
    subclass = None
    def __init__(self, name='', limits=None, permissions=None, ip_pool=None, preferences=None, owner_id=None, owner_login=None):
        self.name = name
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if ClienttemplateAddInputType.subclass:
            return ClienttemplateAddInputType.subclass(*args_, **kwargs_)
        else:
            return ClienttemplateAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='ClienttemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClienttemplateAddInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClienttemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = clientTemplateLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = ClienttemplateIpPoolType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = ClientTemplatePreferencesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class ClienttemplateAddInputType


class ClientTemplateGetInputType:
    subclass = None
    def __init__(self, filter=None, limits=None, permissions=None, ip_pool=None, preferences=None, owner_id=None, owner_login=None):
        self.filter = filter
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if ClientTemplateGetInputType.subclass:
            return ClientTemplateGetInputType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='ClientTemplateGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ClientTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class ClientTemplateGetInputType


class ClientTemplateDelInputType:
    subclass = None
    def __init__(self, filter=None, owner_id=None, owner_login=None):
        self.filter = filter
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if ClientTemplateDelInputType.subclass:
            return ClientTemplateDelInputType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateDelInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='ClientTemplateDelInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateDelInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateDelInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ClientTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class ClientTemplateDelInputType


class ClientTemplateSetInputType:
    subclass = None
    def __init__(self, filter=None, limits=None, permissions=None, ip_pool=None, preferences=None, owner_id=None, owner_login=None):
        self.filter = filter
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
        self.owner_id = owner_id
        self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if ClientTemplateSetInputType.subclass:
            return ClientTemplateSetInputType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def export(self, outfile, level, name_='ClientTemplateSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.owner_id is not None:
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(self.getOwner_id()))
        if self.owner_login is not None:
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(self.getOwner_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ClientTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = clientTemplateLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = ClienttemplateIpPoolType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = ClientTemplatePreferencesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.owner_id = owner_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.owner_login = owner_login_
# end class ClientTemplateSetInputType


class ClientTemplateFilterType:
    subclass = None
    def __init__(self, id=None, name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
    def factory(*args_, **kwargs_):
        if ClientTemplateFilterType.subclass:
            return ClientTemplateFilterType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def export(self, outfile, level, name_='ClientTemplateFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
# end class ClientTemplateFilterType


class ClienttemplateIpPoolType:
    subclass = None
    def __init__(self, ip_address=None, allocate_ip=None):
        if ip_address is None:
            self.ip_address = []
        else:
            self.ip_address = ip_address
        self.allocate_ip = allocate_ip
    def factory(*args_, **kwargs_):
        if ClienttemplateIpPoolType.subclass:
            return ClienttemplateIpPoolType.subclass(*args_, **kwargs_)
        else:
            return ClienttemplateIpPoolType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def addIp_address(self, value): self.ip_address.append(value)
    def insertIp_address(self, index, value): self.ip_address[index] = value
    def getAllocate_ip(self): return self.allocate_ip
    def setAllocate_ip(self, value): self.allocate_ip = value
    def export(self, outfile, level, name_='ClienttemplateIpPoolType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClienttemplateIpPoolType'):
        pass
    def exportChildren(self, outfile, level, name_='ClienttemplateIpPoolType'):
        for ip_address_ in self.getIp_address():
            showIndent(outfile, level)
            outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(ip_address_))
        if self.allocate_ip is not None:
            showIndent(outfile, level)
            outfile.write('<allocate-ip>%s</allocate-ip>\n' % quote_xml(self.getAllocate_ip()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.addIp_address(ip_address_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'allocate-ip':
            allocate_ip_ = ''
            for text__content_ in child_.childNodes:
                allocate_ip_ += text__content_.nodeValue
            self.allocate_ip = allocate_ip_
# end class ClienttemplateIpPoolType


class ClientTemplateOutputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if ClientTemplateOutputType.subclass:
            return ClientTemplateOutputType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='ClientTemplateOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ClientTemplateOutputAddType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ClienttemplateOutputGetType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ClientTemplateOutputDelType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ClientTemplateOutputSetType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class ClientTemplateOutputType


class ClientTemplateOutputAddType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ClientTemplateOutputAddType.subclass:
            return ClientTemplateOutputAddType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateOutputAddType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ClientTemplateOutputAddType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateOutputAddType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateOutputAddType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ClientTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ClientTemplateOutputAddType


class ClientTemplateOutputResulttype(resultType):
    subclass = None
    def __init__(self, id=None, name=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
        self.name = name
    def factory(*args_, **kwargs_):
        if ClientTemplateOutputResulttype.subclass:
            return ClientTemplateOutputResulttype.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateOutputResulttype(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='ClientTemplateOutputResulttype'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateOutputResulttype'):
        resultType.exportAttributes(self, outfile, level, name_='ClientTemplateOutputResulttype')
    def exportChildren(self, outfile, level, name_='ClientTemplateOutputResulttype'):
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        resultType.buildChildren(self, child_, nodeName_)
# end class ClientTemplateOutputResulttype


class ClienttemplateOutputGetType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ClienttemplateOutputGetType.subclass:
            return ClienttemplateOutputGetType.subclass(*args_, **kwargs_)
        else:
            return ClienttemplateOutputGetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ClienttemplateOutputGetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClienttemplateOutputGetType'):
        pass
    def exportChildren(self, outfile, level, name_='ClienttemplateOutputGetType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ClienttemplateOutputGetType


class ClientTemplateOutputSetType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ClientTemplateOutputSetType.subclass:
            return ClientTemplateOutputSetType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateOutputSetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ClientTemplateOutputSetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateOutputSetType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateOutputSetType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ClientTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ClientTemplateOutputSetType


class ClientTemplateOutputDelType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ClientTemplateOutputDelType.subclass:
            return ClientTemplateOutputDelType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplateOutputDelType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ClientTemplateOutputDelType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplateOutputDelType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplateOutputDelType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ClientTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ClientTemplateOutputDelType


class ClientTemplatePreferencesType:
    subclass = None
    def __init__(self, sbnet_user=None, shared=None):
        self.sbnet_user = sbnet_user
        self.shared = shared
    def factory(*args_, **kwargs_):
        if ClientTemplatePreferencesType.subclass:
            return ClientTemplatePreferencesType.subclass(*args_, **kwargs_)
        else:
            return ClientTemplatePreferencesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSbnet_user(self): return self.sbnet_user
    def setSbnet_user(self, value): self.sbnet_user = value
    def getShared(self): return self.shared
    def setShared(self, value): self.shared = value
    def export(self, outfile, level, name_='ClientTemplatePreferencesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ClientTemplatePreferencesType'):
        pass
    def exportChildren(self, outfile, level, name_='ClientTemplatePreferencesType'):
        if self.sbnet_user is not None:
            showIndent(outfile, level)
            outfile.write('<sbnet-user>%s</sbnet-user>\n' % quote_xml(self.getSbnet_user()))
        if self.shared is not None:
            showIndent(outfile, level)
            outfile.write('<shared>%s</shared>\n' % quote_xml(self.getShared()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sbnet-user':
            sbnet_user_ = ''
            for text__content_ in child_.childNodes:
                sbnet_user_ += text__content_.nodeValue
            self.sbnet_user = sbnet_user_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'shared':
            shared_ = ''
            for text__content_ in child_.childNodes:
                shared_ += text__content_.nodeValue
            self.shared = shared_
# end class ClientTemplatePreferencesType


class clientTemplateLimits:
    subclass = None
    def __init__(self, resource_policy=None, limit=None):
        self.resource_policy = resource_policy
        if limit is None:
            self.limit = []
        else:
            self.limit = limit
    def factory(*args_, **kwargs_):
        if clientTemplateLimits.subclass:
            return clientTemplateLimits.subclass(*args_, **kwargs_)
        else:
            return clientTemplateLimits(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResource_policy(self): return self.resource_policy
    def setResource_policy(self, value): self.resource_policy = value
    def getLimit(self): return self.limit
    def setLimit(self, value): self.limit = value
    def addLimit(self, value): self.limit.append(value)
    def insertLimit(self, index, value): self.limit[index] = value
    def export(self, outfile, level, name_='clientTemplateLimits'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='clientTemplateLimits'):
        pass
    def exportChildren(self, outfile, level, name_='clientTemplateLimits'):
        if self.resource_policy is not None:
            self.resource_policy.export(outfile, level)
        for limit_ in self.getLimit():
            limit_.export(outfile, level, name_='limit')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'resource-policy':
            obj_ = resource_policy.factory()
            obj_.build(child_)
            self.setResource_policy(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limit':
            obj_ = PleskLimitType.factory()
            obj_.build(child_)
            self.limit.append(obj_)
# end class clientTemplateLimits


class WebUserInputType:
    subclass = None
    def __init__(self, add=None, ddel=None, set=None, get=None, set_prefs=None, get_prefs=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if set_prefs is None:
            self.set_prefs = []
        else:
            self.set_prefs = set_prefs
        if get_prefs is None:
            self.get_prefs = []
        else:
            self.get_prefs = get_prefs
    def factory(*args_, **kwargs_):
        if WebUserInputType.subclass:
            return WebUserInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet_prefs(self): return self.set_prefs
    def setSet_prefs(self, value): self.set_prefs = value
    def addSet_prefs(self, value): self.set_prefs.append(value)
    def insertSet_prefs(self, index, value): self.set_prefs[index] = value
    def getGet_prefs(self): return self.get_prefs
    def setGet_prefs(self, value): self.get_prefs = value
    def addGet_prefs(self, value): self.get_prefs.append(value)
    def insertGet_prefs(self, index, value): self.get_prefs[index] = value
    def export(self, outfile, level, name_='WebUserInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for set_prefs_ in self.getSet_prefs():
            set_prefs_.export(outfile, level, name_='set-prefs')
        for get_prefs_ in self.getGet_prefs():
            get_prefs_.export(outfile, level, name_='get-prefs')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = WebUserAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = WebUserDelInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = WebUserSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = WebUserGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-prefs':
            obj_ = WebUserSetPrefInputType.factory()
            obj_.build(child_)
            self.set_prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-prefs':
            obj_ = WebUserGetPrefInputType.factory()
            obj_.build(child_)
            self.get_prefs.append(obj_)
# end class WebUserInputType


class WebUserAddInputType:
    subclass = None
    def __init__(self, domain_id='', login='', password='', password_type=None, ftp_quota=None, services=None):
        self.domain_id = domain_id
        self.login = login
        self.password = password
        self.password_type = password_type
        self.ftp_quota = ftp_quota
        self.services = services
    def factory(*args_, **kwargs_):
        if WebUserAddInputType.subclass:
            return WebUserAddInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def getFtp_quota(self): return self.ftp_quota
    def setFtp_quota(self, value): self.ftp_quota = value
    def getServices(self): return self.services
    def setServices(self, value): self.services = value
    def export(self, outfile, level, name_='WebUserAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserAddInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserAddInputType'):
        showIndent(outfile, level)
        outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password-type>%s</password-type>\n' % quote_xml(self.getPassword_type()))
        if self.ftp_quota is not None:
            showIndent(outfile, level)
            outfile.write('<ftp-quota>%s</ftp-quota>\n' % quote_xml(self.getFtp_quota()))
        if self.services is not None:
            self.services.export(outfile, level, name_='services')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password-type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp-quota':
            ftp_quota_ = ''
            for text__content_ in child_.childNodes:
                ftp_quota_ += text__content_.nodeValue
            self.ftp_quota = ftp_quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'services':
            obj_ = ServicesType.factory()
            obj_.build(child_)
            self.setServices(obj_)
# end class WebUserAddInputType


class WebUserFilter:
    subclass = None
    def __init__(self, id=None, login=None, domain_id=None, domain_name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if login is None:
            self.login = []
        else:
            self.login = login
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if WebUserFilter.subclass:
            return WebUserFilter.subclass(*args_, **kwargs_)
        else:
            return WebUserFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def addLogin(self, value): self.login.append(value)
    def insertLogin(self, index, value): self.login[index] = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='WebUserFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserFilter'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserFilter'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for login_ in self.getLogin():
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(login_))
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.addLogin(login_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class WebUserFilter


class WebUserDelInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if WebUserDelInputType.subclass:
            return WebUserDelInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserDelInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='WebUserDelInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserDelInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserDelInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = WebUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class WebUserDelInputType


class WebUserOutputType:
    subclass = None
    def __init__(self, add=None, ddel=None, set=None, get=None, set_prefs=None, get_prefs=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if set_prefs is None:
            self.set_prefs = []
        else:
            self.set_prefs = set_prefs
        if get_prefs is None:
            self.get_prefs = []
        else:
            self.get_prefs = get_prefs
    def factory(*args_, **kwargs_):
        if WebUserOutputType.subclass:
            return WebUserOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet_prefs(self): return self.set_prefs
    def setSet_prefs(self, value): self.set_prefs = value
    def addSet_prefs(self, value): self.set_prefs.append(value)
    def insertSet_prefs(self, index, value): self.set_prefs[index] = value
    def getGet_prefs(self): return self.get_prefs
    def setGet_prefs(self, value): self.get_prefs = value
    def addGet_prefs(self, value): self.get_prefs.append(value)
    def insertGet_prefs(self, index, value): self.get_prefs[index] = value
    def export(self, outfile, level, name_='WebUserOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for set_prefs_ in self.getSet_prefs():
            set_prefs_.export(outfile, level, name_='set-prefs')
        for get_prefs_ in self.getGet_prefs():
            get_prefs_.export(outfile, level, name_='get-prefs')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = WebUserAddOutputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = WebUserDelOutputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = WebUserSetOutputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = WebUserGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-prefs':
            obj_ = WebUserSetPrefOutputType.factory()
            obj_.build(child_)
            self.set_prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-prefs':
            obj_ = WebUserGetPrefOutputType.factory()
            obj_.build(child_)
            self.get_prefs.append(obj_)
# end class WebUserOutputType


class WebUserAddOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if WebUserAddOutputType.subclass:
            return WebUserAddOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserAddOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='WebUserAddOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserAddOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserAddOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class WebUserAddOutputType


class WebUserDelOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if WebUserDelOutputType.subclass:
            return WebUserDelOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserDelOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='WebUserDelOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserDelOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserDelOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class WebUserDelOutputType


class ExtendedResultType(resultType):
    subclass = None
    def __init__(self, status='', errcode=None, errtext=None, valueOf_=''):
        resultType.__init__(self, status, errcode, errtext)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ExtendedResultType.subclass:
            return ExtendedResultType.subclass(*args_, **kwargs_)
        else:
            return ExtendedResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='ExtendedResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ExtendedResultType'):
        resultType.exportAttributes(self, outfile, level, name_='ExtendedResultType')
    def exportChildren(self, outfile, level, name_='ExtendedResultType'):
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        resultType.buildChildren(self, child_, nodeName_)
# end class ExtendedResultType


class WebUserBindingInputType:
    subclass = None
    def __init__(self, id=None, login=None, domain_id=None, domain_name=None):
        self.id = id
        self.login = login
        self.domain_id = domain_id
        self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if WebUserBindingInputType.subclass:
            return WebUserBindingInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserBindingInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def export(self, outfile, level, name_='WebUserBindingInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserBindingInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserBindingInputType'):
        if self.id is not None:
            self.id.export(outfile, level, name_='id')
        if self.login is not None:
            self.login.export(outfile, level, name_='login')
        if self.domain_id is not None:
            self.domain_id.export(outfile, level, name_='domain-id')
        if self.domain_name is not None:
            self.domain_name.export(outfile, level, name_='domain-name')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setId(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLogin(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDomain_id(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDomain_name(obj_)
# end class WebUserBindingInputType


class WebUserResultType(resultType):
    subclass = None
    def __init__(self, list=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.list = list
    def factory(*args_, **kwargs_):
        if WebUserResultType.subclass:
            return WebUserResultType.subclass(*args_, **kwargs_)
        else:
            return WebUserResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getList(self): return self.list
    def setList(self, value): self.list = value
    def export(self, outfile, level, name_='WebUserResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserResultType'):
        resultType.exportAttributes(self, outfile, level, name_='WebUserResultType')
    def exportChildren(self, outfile, level, name_='WebUserResultType'):
        if self.list is not None:
            self.list.export(outfile, level, name_='list')
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list':
            obj_ = WebUserList.factory()
            obj_.build(child_)
            self.setList(obj_)
        resultType.buildChildren(self, child_, nodeName_)
# end class WebUserResultType


class WebUserType:
    subclass = None
    def __init__(self, id='', login='', password='', ftp_quota=None, asp=None, ssi=None, php=None, cgi=None, mod_perl=None, mod_python=None):
        self.id = id
        self.login = login
        self.password = password
        self.ftp_quota = ftp_quota
        self.asp = asp
        self.ssi = ssi
        self.php = php
        self.cgi = cgi
        self.mod_perl = mod_perl
        self.mod_python = mod_python
    def factory(*args_, **kwargs_):
        if WebUserType.subclass:
            return WebUserType.subclass(*args_, **kwargs_)
        else:
            return WebUserType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getFtp_quota(self): return self.ftp_quota
    def setFtp_quota(self, value): self.ftp_quota = value
    def getAsp(self): return self.asp
    def setAsp(self, value): self.asp = value
    def getSsi(self): return self.ssi
    def setSsi(self, value): self.ssi = value
    def getPhp(self): return self.php
    def setPhp(self, value): self.php = value
    def getCgi(self): return self.cgi
    def setCgi(self, value): self.cgi = value
    def getMod_perl(self): return self.mod_perl
    def setMod_perl(self, value): self.mod_perl = value
    def getMod_python(self): return self.mod_python
    def setMod_python(self, value): self.mod_python = value
    def export(self, outfile, level, name_='WebUserType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.ftp_quota is not None:
            showIndent(outfile, level)
            outfile.write('<ftp-quota>%s</ftp-quota>\n' % quote_xml(self.getFtp_quota()))
        if self.asp is not None:
            showIndent(outfile, level)
            outfile.write('<asp>%s</asp>\n' % quote_xml(self.getAsp()))
        if self.ssi is not None:
            showIndent(outfile, level)
            outfile.write('<ssi>%s</ssi>\n' % quote_xml(self.getSsi()))
        if self.php is not None:
            showIndent(outfile, level)
            outfile.write('<php>%s</php>\n' % quote_xml(self.getPhp()))
        if self.cgi is not None:
            showIndent(outfile, level)
            outfile.write('<cgi>%s</cgi>\n' % quote_xml(self.getCgi()))
        if self.mod_perl is not None:
            showIndent(outfile, level)
            outfile.write('<mod_perl>%s</mod_perl>\n' % quote_xml(self.getMod_perl()))
        if self.mod_python is not None:
            showIndent(outfile, level)
            outfile.write('<mod_python>%s</mod_python>\n' % quote_xml(self.getMod_python()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp-quota':
            ftp_quota_ = ''
            for text__content_ in child_.childNodes:
                ftp_quota_ += text__content_.nodeValue
            self.ftp_quota = ftp_quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp':
            asp_ = ''
            for text__content_ in child_.childNodes:
                asp_ += text__content_.nodeValue
            self.asp = asp_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ssi':
            ssi_ = ''
            for text__content_ in child_.childNodes:
                ssi_ += text__content_.nodeValue
            self.ssi = ssi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'php':
            php_ = ''
            for text__content_ in child_.childNodes:
                php_ += text__content_.nodeValue
            self.php = php_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cgi':
            cgi_ = ''
            for text__content_ in child_.childNodes:
                cgi_ += text__content_.nodeValue
            self.cgi = cgi_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mod_perl':
            mod_perl_ = ''
            for text__content_ in child_.childNodes:
                mod_perl_ += text__content_.nodeValue
            self.mod_perl = mod_perl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mod_python':
            mod_python_ = ''
            for text__content_ in child_.childNodes:
                mod_python_ += text__content_.nodeValue
            self.mod_python = mod_python_
# end class WebUserType


class WebUserList:
    subclass = None
    def __init__(self, item=None):
        if item is None:
            self.item = []
        else:
            self.item = item
    def factory(*args_, **kwargs_):
        if WebUserList.subclass:
            return WebUserList.subclass(*args_, **kwargs_)
        else:
            return WebUserList(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getItem(self): return self.item
    def setItem(self, value): self.item = value
    def addItem(self, value): self.item.append(value)
    def insertItem(self, index, value): self.item[index] = value
    def export(self, outfile, level, name_='WebUserList'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserList'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserList'):
        for item_ in self.getItem():
            item_.export(outfile, level, name_='item')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'item':
            obj_ = WebUserType.factory()
            obj_.build(child_)
            self.item.append(obj_)
# end class WebUserList


class WebUserGetInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if WebUserGetInputType.subclass:
            return WebUserGetInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='WebUserGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = WebUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class WebUserGetInputType


class WebUserGetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if WebUserGetOutputType.subclass:
            return WebUserGetOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='WebUserGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserGetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class WebUserGetOutputType


class WebUserSetParam:
    subclass = None
    def __init__(self, password='', password_type=None, ftp_quota=None, services=None):
        self.password = password
        self.password_type = password_type
        self.ftp_quota = ftp_quota
        self.services = services
    def factory(*args_, **kwargs_):
        if WebUserSetParam.subclass:
            return WebUserSetParam.subclass(*args_, **kwargs_)
        else:
            return WebUserSetParam(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def getFtp_quota(self): return self.ftp_quota
    def setFtp_quota(self, value): self.ftp_quota = value
    def getServices(self): return self.services
    def setServices(self, value): self.services = value
    def export(self, outfile, level, name_='WebUserSetParam'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserSetParam'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserSetParam'):
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password-type>%s</password-type>\n' % quote_xml(self.getPassword_type()))
        if self.ftp_quota is not None:
            showIndent(outfile, level)
            outfile.write('<ftp-quota>%s</ftp-quota>\n' % quote_xml(self.getFtp_quota()))
        if self.services is not None:
            self.services.export(outfile, level, name_='services')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password-type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp-quota':
            ftp_quota_ = ''
            for text__content_ in child_.childNodes:
                ftp_quota_ += text__content_.nodeValue
            self.ftp_quota = ftp_quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'services':
            obj_ = ServicesType.factory()
            obj_.build(child_)
            self.setServices(obj_)
# end class WebUserSetParam


class WebUserSetInputType:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if WebUserSetInputType.subclass:
            return WebUserSetInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='WebUserSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level, name_='values')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = WebUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = WebUserSetParam.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class WebUserSetInputType


class WebUserSetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if WebUserSetOutputType.subclass:
            return WebUserSetOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserSetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='WebUserSetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserSetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserSetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class WebUserSetOutputType


class WebUserSetPrefInputType:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if WebUserSetPrefInputType.subclass:
            return WebUserSetPrefInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserSetPrefInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='WebUserSetPrefInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserSetPrefInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserSetPrefInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level, name_='values')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = WebUserOwnFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = WebUserPrefs.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class WebUserSetPrefInputType


class WebUserPrefs:
    subclass = None
    def __init__(self, wuscripts=''):
        self.wuscripts = wuscripts
    def factory(*args_, **kwargs_):
        if WebUserPrefs.subclass:
            return WebUserPrefs.subclass(*args_, **kwargs_)
        else:
            return WebUserPrefs(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getWuscripts(self): return self.wuscripts
    def setWuscripts(self, value): self.wuscripts = value
    def export(self, outfile, level, name_='WebUserPrefs'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserPrefs'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserPrefs'):
        showIndent(outfile, level)
        outfile.write('<wuscripts>%s</wuscripts>\n' % quote_xml(self.getWuscripts()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'wuscripts':
            wuscripts_ = ''
            for text__content_ in child_.childNodes:
                wuscripts_ += text__content_.nodeValue
            self.wuscripts = wuscripts_
# end class WebUserPrefs


class WebUserSetPrefOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if WebUserSetPrefOutputType.subclass:
            return WebUserSetPrefOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserSetPrefOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='WebUserSetPrefOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserSetPrefOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserSetPrefOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class WebUserSetPrefOutputType


class WebUserGetPrefInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if WebUserGetPrefInputType.subclass:
            return WebUserGetPrefInputType.subclass(*args_, **kwargs_)
        else:
            return WebUserGetPrefInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='WebUserGetPrefInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserGetPrefInputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserGetPrefInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = WebUserOwnFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class WebUserGetPrefInputType


class WebUserOwnFilter:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None):
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if WebUserOwnFilter.subclass:
            return WebUserOwnFilter.subclass(*args_, **kwargs_)
        else:
            return WebUserOwnFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='WebUserOwnFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserOwnFilter'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserOwnFilter'):
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class WebUserOwnFilter


class WebUserGetPrefOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if WebUserGetPrefOutputType.subclass:
            return WebUserGetPrefOutputType.subclass(*args_, **kwargs_)
        else:
            return WebUserGetPrefOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='WebUserGetPrefOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebUserGetPrefOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='WebUserGetPrefOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class WebUserGetPrefOutputType


class ServicesType:
    subclass = None
    def __init__(self, service=None):
        if service is None:
            self.service = []
        else:
            self.service = service
    def factory(*args_, **kwargs_):
        if ServicesType.subclass:
            return ServicesType.subclass(*args_, **kwargs_)
        else:
            return ServicesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getService(self): return self.service
    def setService(self, value): self.service = value
    def addService(self, value): self.service.append(value)
    def insertService(self, index, value): self.service[index] = value
    def export(self, outfile, level, name_='ServicesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ServicesType'):
        pass
    def exportChildren(self, outfile, level, name_='ServicesType'):
        for service_ in self.getService():
            service_.export(outfile, level, name_='service')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'service':
            obj_ = WebuserScriptType.factory()
            obj_.build(child_)
            self.service.append(obj_)
# end class ServicesType


class WebuserScriptType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if WebuserScriptType.subclass:
            return WebuserScriptType.subclass(*args_, **kwargs_)
        else:
            return WebuserScriptType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='WebuserScriptType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='WebuserScriptType'):
        pass
    def exportChildren(self, outfile, level, name_='WebuserScriptType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class WebuserScriptType


class MaillistSimpleFilterType:
    subclass = None
    def __init__(self, list_id=None, list_name=None):
        if list_id is None:
            self.list_id = []
        else:
            self.list_id = list_id
        if list_name is None:
            self.list_name = []
        else:
            self.list_name = list_name
    def factory(*args_, **kwargs_):
        if MaillistSimpleFilterType.subclass:
            return MaillistSimpleFilterType.subclass(*args_, **kwargs_)
        else:
            return MaillistSimpleFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getList_id(self): return self.list_id
    def setList_id(self, value): self.list_id = value
    def addList_id(self, value): self.list_id.append(value)
    def insertList_id(self, index, value): self.list_id[index] = value
    def getList_name(self): return self.list_name
    def setList_name(self, value): self.list_name = value
    def addList_name(self, value): self.list_name.append(value)
    def insertList_name(self, index, value): self.list_name[index] = value
    def export(self, outfile, level, name_='MaillistSimpleFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistSimpleFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistSimpleFilterType'):
        for list_id_ in self.getList_id():
            showIndent(outfile, level)
            outfile.write('<list-id>%s</list-id>\n' % quote_xml(list_id_))
        for list_name_ in self.getList_name():
            showIndent(outfile, level)
            outfile.write('<list-name>%s</list-name>\n' % quote_xml(list_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list-id':
            list_id_ = ''
            for text__content_ in child_.childNodes:
                list_id_ += text__content_.nodeValue
            self.addList_id(list_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list-name':
            list_name_ = ''
            for text__content_ in child_.childNodes:
                list_name_ += text__content_.nodeValue
            self.addList_name(list_name_)
# end class MaillistSimpleFilterType


class MaillistFilterType:
    subclass = None
    def __init__(self, id=None, name=None, domain_id=None, domain_name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if MaillistFilterType.subclass:
            return MaillistFilterType.subclass(*args_, **kwargs_)
        else:
            return MaillistFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='MaillistFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class MaillistFilterType


class MaillistInputType:
    subclass = None
    def __init__(self, add_list=None, del_list=None, get_list=None, add_member=None, get_members=None, del_member=None, enable=None, disable=None, enable_list=None, disable_list=None, get_status=None):
        if add_list is None:
            self.add_list = []
        else:
            self.add_list = add_list
        if del_list is None:
            self.del_list = []
        else:
            self.del_list = del_list
        if get_list is None:
            self.get_list = []
        else:
            self.get_list = get_list
        if add_member is None:
            self.add_member = []
        else:
            self.add_member = add_member
        if get_members is None:
            self.get_members = []
        else:
            self.get_members = get_members
        if del_member is None:
            self.del_member = []
        else:
            self.del_member = del_member
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if enable_list is None:
            self.enable_list = []
        else:
            self.enable_list = enable_list
        if disable_list is None:
            self.disable_list = []
        else:
            self.disable_list = disable_list
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
    def factory(*args_, **kwargs_):
        if MaillistInputType.subclass:
            return MaillistInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_list(self): return self.add_list
    def setAdd_list(self, value): self.add_list = value
    def addAdd_list(self, value): self.add_list.append(value)
    def insertAdd_list(self, index, value): self.add_list[index] = value
    def getDel_list(self): return self.del_list
    def setDel_list(self, value): self.del_list = value
    def addDel_list(self, value): self.del_list.append(value)
    def insertDel_list(self, index, value): self.del_list[index] = value
    def getGet_list(self): return self.get_list
    def setGet_list(self, value): self.get_list = value
    def addGet_list(self, value): self.get_list.append(value)
    def insertGet_list(self, index, value): self.get_list[index] = value
    def getAdd_member(self): return self.add_member
    def setAdd_member(self, value): self.add_member = value
    def addAdd_member(self, value): self.add_member.append(value)
    def insertAdd_member(self, index, value): self.add_member[index] = value
    def getGet_members(self): return self.get_members
    def setGet_members(self, value): self.get_members = value
    def addGet_members(self, value): self.get_members.append(value)
    def insertGet_members(self, index, value): self.get_members[index] = value
    def getDel_member(self): return self.del_member
    def setDel_member(self, value): self.del_member = value
    def addDel_member(self, value): self.del_member.append(value)
    def insertDel_member(self, index, value): self.del_member[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getEnable_list(self): return self.enable_list
    def setEnable_list(self, value): self.enable_list = value
    def addEnable_list(self, value): self.enable_list.append(value)
    def insertEnable_list(self, index, value): self.enable_list[index] = value
    def getDisable_list(self): return self.disable_list
    def setDisable_list(self, value): self.disable_list = value
    def addDisable_list(self, value): self.disable_list.append(value)
    def insertDisable_list(self, index, value): self.disable_list[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def export(self, outfile, level, name_='MaillistInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistInputType'):
        for add_list_ in self.getAdd_list():
            add_list_.export(outfile, level, name_='add-list')
        for del_list_ in self.getDel_list():
            del_list_.export(outfile, level, name_='del-list')
        for get_list_ in self.getGet_list():
            get_list_.export(outfile, level, name_='get-list')
        for add_member_ in self.getAdd_member():
            add_member_.export(outfile, level, name_='add-member')
        for get_members_ in self.getGet_members():
            get_members_.export(outfile, level, name_='get-members')
        for del_member_ in self.getDel_member():
            del_member_.export(outfile, level, name_='del-member')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for enable_list_ in self.getEnable_list():
            enable_list_.export(outfile, level, name_='enable-list')
        for disable_list_ in self.getDisable_list():
            disable_list_.export(outfile, level, name_='disable-list')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get-status')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-list':
            obj_ = MaillistAddListInputType.factory()
            obj_.build(child_)
            self.add_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-list':
            obj_ = MaillistDelListInputType.factory()
            obj_.build(child_)
            self.del_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-list':
            obj_ = MaillistGetListInputType.factory()
            obj_.build(child_)
            self.get_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-member':
            obj_ = MaillistAddMemberInputType.factory()
            obj_.build(child_)
            self.add_member.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-members':
            obj_ = MaillistGetMemberInputType.factory()
            obj_.build(child_)
            self.get_members.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-member':
            obj_ = MaillistDelMemberInputType.factory()
            obj_.build(child_)
            self.del_member.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = MaillistEnableInputType.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = MaillistDisableInputType.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable-list':
            obj_ = MaillistEnableListInputType.factory()
            obj_.build(child_)
            self.enable_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable-list':
            obj_ = MailistDisableListInputType.factory()
            obj_.build(child_)
            self.disable_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status':
            obj_ = MaillistGetStatusInputType.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
# end class MaillistInputType


class MailistOutputType:
    subclass = None
    def __init__(self, add_list=None, del_list=None, get_list=None, add_member=None, del_member=None, get_members=None, enable=None, disable=None, enable_list=None, disable_list=None, get_status=None):
        if add_list is None:
            self.add_list = []
        else:
            self.add_list = add_list
        if del_list is None:
            self.del_list = []
        else:
            self.del_list = del_list
        if get_list is None:
            self.get_list = []
        else:
            self.get_list = get_list
        if add_member is None:
            self.add_member = []
        else:
            self.add_member = add_member
        if del_member is None:
            self.del_member = []
        else:
            self.del_member = del_member
        if get_members is None:
            self.get_members = []
        else:
            self.get_members = get_members
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if enable_list is None:
            self.enable_list = []
        else:
            self.enable_list = enable_list
        if disable_list is None:
            self.disable_list = []
        else:
            self.disable_list = disable_list
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
    def factory(*args_, **kwargs_):
        if MailistOutputType.subclass:
            return MailistOutputType.subclass(*args_, **kwargs_)
        else:
            return MailistOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_list(self): return self.add_list
    def setAdd_list(self, value): self.add_list = value
    def addAdd_list(self, value): self.add_list.append(value)
    def insertAdd_list(self, index, value): self.add_list[index] = value
    def getDel_list(self): return self.del_list
    def setDel_list(self, value): self.del_list = value
    def addDel_list(self, value): self.del_list.append(value)
    def insertDel_list(self, index, value): self.del_list[index] = value
    def getGet_list(self): return self.get_list
    def setGet_list(self, value): self.get_list = value
    def addGet_list(self, value): self.get_list.append(value)
    def insertGet_list(self, index, value): self.get_list[index] = value
    def getAdd_member(self): return self.add_member
    def setAdd_member(self, value): self.add_member = value
    def addAdd_member(self, value): self.add_member.append(value)
    def insertAdd_member(self, index, value): self.add_member[index] = value
    def getDel_member(self): return self.del_member
    def setDel_member(self, value): self.del_member = value
    def addDel_member(self, value): self.del_member.append(value)
    def insertDel_member(self, index, value): self.del_member[index] = value
    def getGet_members(self): return self.get_members
    def setGet_members(self, value): self.get_members = value
    def addGet_members(self, value): self.get_members.append(value)
    def insertGet_members(self, index, value): self.get_members[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getEnable_list(self): return self.enable_list
    def setEnable_list(self, value): self.enable_list = value
    def addEnable_list(self, value): self.enable_list.append(value)
    def insertEnable_list(self, index, value): self.enable_list[index] = value
    def getDisable_list(self): return self.disable_list
    def setDisable_list(self, value): self.disable_list = value
    def addDisable_list(self, value): self.disable_list.append(value)
    def insertDisable_list(self, index, value): self.disable_list[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def export(self, outfile, level, name_='MailistOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailistOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MailistOutputType'):
        for add_list_ in self.getAdd_list():
            add_list_.export(outfile, level, name_='add-list')
        for del_list_ in self.getDel_list():
            del_list_.export(outfile, level, name_='del-list')
        for get_list_ in self.getGet_list():
            get_list_.export(outfile, level, name_='get-list')
        for add_member_ in self.getAdd_member():
            add_member_.export(outfile, level, name_='add-member')
        for del_member_ in self.getDel_member():
            del_member_.export(outfile, level, name_='del-member')
        for get_members_ in self.getGet_members():
            get_members_.export(outfile, level, name_='get-members')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for enable_list_ in self.getEnable_list():
            enable_list_.export(outfile, level, name_='enable-list')
        for disable_list_ in self.getDisable_list():
            disable_list_.export(outfile, level, name_='disable-list')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get-status')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-list':
            obj_ = MaillistAddOutputType.factory()
            obj_.build(child_)
            self.add_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-list':
            obj_ = MaillistDelListOutputType.factory()
            obj_.build(child_)
            self.del_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-list':
            obj_ = MaillistGetListOutputType.factory()
            obj_.build(child_)
            self.get_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-member':
            obj_ = MailistAddMemberOutputType.factory()
            obj_.build(child_)
            self.add_member.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-member':
            obj_ = MaillistDelMemberOutputType.factory()
            obj_.build(child_)
            self.del_member.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-members':
            obj_ = MaillistGetMemberOutputType.factory()
            obj_.build(child_)
            self.get_members.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = MaillistEnableOutputType.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = MaillistDisableOutputType.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable-list':
            obj_ = MailistEnableListOutoutType.factory()
            obj_.build(child_)
            self.enable_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable-list':
            obj_ = MaillistDisableListOutputType.factory()
            obj_.build(child_)
            self.disable_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status':
            obj_ = MaillistGetStatusOutputType.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
# end class MailistOutputType


class MaillistAddListInputType:
    subclass = None
    def __init__(self, domain_id='', name='', password='', admin_email='', notify=None):
        self.domain_id = domain_id
        self.name = name
        self.password = password
        self.admin_email = admin_email
        self.notify = notify
    def factory(*args_, **kwargs_):
        if MaillistAddListInputType.subclass:
            return MaillistAddListInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistAddListInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getAdmin_email(self): return self.admin_email
    def setAdmin_email(self, value): self.admin_email = value
    def getNotify(self): return self.notify
    def setNotify(self, value): self.notify = value
    def export(self, outfile, level, name_='MaillistAddListInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistAddListInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistAddListInputType'):
        showIndent(outfile, level)
        outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        showIndent(outfile, level)
        outfile.write('<admin-email>%s</admin-email>\n' % quote_xml(self.getAdmin_email()))
        if self.notify is not None:
            showIndent(outfile, level)
            outfile.write('<notify>%s</notify>\n' % quote_xml(self.getNotify()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'admin-email':
            admin_email_ = ''
            for text__content_ in child_.childNodes:
                admin_email_ += text__content_.nodeValue
            self.admin_email = admin_email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'notify':
            notify_ = ''
            for text__content_ in child_.childNodes:
                notify_ += text__content_.nodeValue
            self.notify = notify_
# end class MaillistAddListInputType


class MaillistAddOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if MaillistAddOutputType.subclass:
            return MaillistAddOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistAddOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='MaillistAddOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistAddOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistAddOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class MaillistAddOutputType


class MaillistDelListInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistDelListInputType.subclass:
            return MaillistDelListInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDelListInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistDelListInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDelListInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDelListInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistDelListInputType


class MaillistDelListOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistDelListOutputType.subclass:
            return MaillistDelListOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDelListOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistDelListOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDelListOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDelListOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistDelListOutputType


class MaillistGetListInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistGetListInputType.subclass:
            return MaillistGetListInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetListInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistGetListInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetListInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetListInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistGetListInputType


class MaillistGetListOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistGetListOutputType.subclass:
            return MaillistGetListOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetListOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistGetListOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetListOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetListOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistGetListOutputType


class MaillistAddMemberInputType:
    subclass = None
    def __init__(self, filter=None, id=''):
        self.filter = filter
        self.id = id
    def factory(*args_, **kwargs_):
        if MaillistAddMemberInputType.subclass:
            return MaillistAddMemberInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistAddMemberInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='MaillistAddMemberInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistAddMemberInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistAddMemberInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistSimpleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
# end class MaillistAddMemberInputType


class MailistAddMemberOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MailistAddMemberOutputType.subclass:
            return MailistAddMemberOutputType.subclass(*args_, **kwargs_)
        else:
            return MailistAddMemberOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MailistAddMemberOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailistAddMemberOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MailistAddMemberOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MaillistMemberResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MailistAddMemberOutputType


class MaillistDelMemberInputType:
    subclass = None
    def __init__(self, filter=None, id=''):
        self.filter = filter
        self.id = id
    def factory(*args_, **kwargs_):
        if MaillistDelMemberInputType.subclass:
            return MaillistDelMemberInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDelMemberInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='MaillistDelMemberInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDelMemberInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDelMemberInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistSimpleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
# end class MaillistDelMemberInputType


class MaillistDelMemberOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistDelMemberOutputType.subclass:
            return MaillistDelMemberOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDelMemberOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistDelMemberOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDelMemberOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDelMemberOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MaillistMemberResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistDelMemberOutputType


class MaillistGetMemberInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistGetMemberInputType.subclass:
            return MaillistGetMemberInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetMemberInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistGetMemberInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetMemberInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetMemberInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistSimpleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistGetMemberInputType


class MaillistGetMemberOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistGetMemberOutputType.subclass:
            return MaillistGetMemberOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetMemberOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistGetMemberOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetMemberOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetMemberOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = MaillistGetMemberResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistGetMemberOutputType


class MaillistGetMemberResultType:
    subclass = None
    def __init__(self, status='', errcode=None, errtext=None, filter_id=None, id=None):
        self.status = status
        self.errcode = errcode
        self.errtext = errtext
        self.filter_id = filter_id
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if MaillistGetMemberResultType.subclass:
            return MaillistGetMemberResultType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetMemberResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getErrcode(self): return self.errcode
    def setErrcode(self, value): self.errcode = value
    def getErrtext(self): return self.errtext
    def setErrtext(self, value): self.errtext = value
    def getFilter_id(self): return self.filter_id
    def setFilter_id(self, value): self.filter_id = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='MaillistGetMemberResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetMemberResultType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetMemberResultType'):
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.errcode is not None:
            showIndent(outfile, level)
            outfile.write('<errcode>%s</errcode>\n' % quote_xml(self.getErrcode()))
        if self.errtext is not None:
            showIndent(outfile, level)
            outfile.write('<errtext>%s</errtext>\n' % quote_xml(self.getErrtext()))
        if self.filter_id is not None:
            showIndent(outfile, level)
            outfile.write('<filter-id>%s</filter-id>\n' % quote_xml(self.getFilter_id()))
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errcode':
            errcode_ = ''
            for text__content_ in child_.childNodes:
                errcode_ += text__content_.nodeValue
            self.errcode = errcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errtext':
            errtext_ = ''
            for text__content_ in child_.childNodes:
                errtext_ += text__content_.nodeValue
            self.errtext = errtext_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter-id':
            filter_id_ = ''
            for text__content_ in child_.childNodes:
                filter_id_ += text__content_.nodeValue
            self.filter_id = filter_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class MaillistGetMemberResultType


class MaillistEnableInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistEnableInputType.subclass:
            return MaillistEnableInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistEnableInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistEnableInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistEnableInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistEnableInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistToggleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistEnableInputType


class MaillistToggleFilterType:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None):
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if MaillistToggleFilterType.subclass:
            return MaillistToggleFilterType.subclass(*args_, **kwargs_)
        else:
            return MaillistToggleFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='MaillistToggleFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistToggleFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistToggleFilterType'):
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class MaillistToggleFilterType


class MaillistEnableOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistEnableOutputType.subclass:
            return MaillistEnableOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistEnableOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistEnableOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistEnableOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistEnableOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistEnableOutputType


class MaillistDisableInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistDisableInputType.subclass:
            return MaillistDisableInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDisableInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistDisableInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDisableInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDisableInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistToggleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistDisableInputType


class MaillistDisableOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistDisableOutputType.subclass:
            return MaillistDisableOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDisableOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistDisableOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDisableOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDisableOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistDisableOutputType


class MaillistEnableListInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistEnableListInputType.subclass:
            return MaillistEnableListInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistEnableListInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistEnableListInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistEnableListInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistEnableListInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistEnableListInputType


class MailistEnableListOutoutType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MailistEnableListOutoutType.subclass:
            return MailistEnableListOutoutType.subclass(*args_, **kwargs_)
        else:
            return MailistEnableListOutoutType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MailistEnableListOutoutType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailistEnableListOutoutType'):
        pass
    def exportChildren(self, outfile, level, name_='MailistEnableListOutoutType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MailistEnableListOutoutType


class MailistDisableListInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MailistDisableListInputType.subclass:
            return MailistDisableListInputType.subclass(*args_, **kwargs_)
        else:
            return MailistDisableListInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MailistDisableListInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MailistDisableListInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MailistDisableListInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MailistDisableListInputType


class MaillistDisableListOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistDisableListOutputType.subclass:
            return MaillistDisableListOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistDisableListOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistDisableListOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistDisableListOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistDisableListOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistDisableListOutputType


class MaillistMemberResultType:
    subclass = None
    def __init__(self, status='', errcode=None, errtext=None, filter_id=None, id=None):
        self.status = status
        self.errcode = errcode
        self.errtext = errtext
        self.filter_id = filter_id
        self.id = id
    def factory(*args_, **kwargs_):
        if MaillistMemberResultType.subclass:
            return MaillistMemberResultType.subclass(*args_, **kwargs_)
        else:
            return MaillistMemberResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getErrcode(self): return self.errcode
    def setErrcode(self, value): self.errcode = value
    def getErrtext(self): return self.errtext
    def setErrtext(self, value): self.errtext = value
    def getFilter_id(self): return self.filter_id
    def setFilter_id(self, value): self.filter_id = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='MaillistMemberResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistMemberResultType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistMemberResultType'):
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.errcode is not None:
            showIndent(outfile, level)
            outfile.write('<errcode>%s</errcode>\n' % quote_xml(self.getErrcode()))
        if self.errtext is not None:
            showIndent(outfile, level)
            outfile.write('<errtext>%s</errtext>\n' % quote_xml(self.getErrtext()))
        if self.filter_id is not None:
            showIndent(outfile, level)
            outfile.write('<filter-id>%s</filter-id>\n' % quote_xml(self.getFilter_id()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errcode':
            errcode_ = ''
            for text__content_ in child_.childNodes:
                errcode_ += text__content_.nodeValue
            self.errcode = errcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'errtext':
            errtext_ = ''
            for text__content_ in child_.childNodes:
                errtext_ += text__content_.nodeValue
            self.errtext = errtext_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter-id':
            filter_id_ = ''
            for text__content_ in child_.childNodes:
                filter_id_ += text__content_.nodeValue
            self.filter_id = filter_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
# end class MaillistMemberResultType


class MaillistGetStatusInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if MaillistGetStatusInputType.subclass:
            return MaillistGetStatusInputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetStatusInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='MaillistGetStatusInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetStatusInputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetStatusInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = MaillistToggleFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class MaillistGetStatusInputType


class MaillistGetStatusOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if MaillistGetStatusOutputType.subclass:
            return MaillistGetStatusOutputType.subclass(*args_, **kwargs_)
        else:
            return MaillistGetStatusOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='MaillistGetStatusOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='MaillistGetStatusOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='MaillistGetStatusOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class MaillistGetStatusOutputType


class VDirInputType:
    subclass = None
    def __init__(self, create=None, remove=None):
        if create is None:
            self.create = []
        else:
            self.create = create
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
    def factory(*args_, **kwargs_):
        if VDirInputType.subclass:
            return VDirInputType.subclass(*args_, **kwargs_)
        else:
            return VDirInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCreate(self): return self.create
    def setCreate(self, value): self.create = value
    def addCreate(self, value): self.create.append(value)
    def insertCreate(self, index, value): self.create[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def export(self, outfile, level, name_='VDirInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirInputType'):
        pass
    def exportChildren(self, outfile, level, name_='VDirInputType'):
        for create_ in self.getCreate():
            create_.export(outfile, level, name_='create')
        for remove_ in self.getRemove():
            remove_.export(outfile, level, name_='remove')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create':
            obj_ = CreateVDirInputType.factory()
            obj_.build(child_)
            self.create.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = RemoveVDirInputType.factory()
            obj_.build(child_)
            self.remove.append(obj_)
# end class VDirInputType


class VDirOutputType:
    subclass = None
    def __init__(self, create=None, remove=None):
        if create is None:
            self.create = []
        else:
            self.create = create
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
    def factory(*args_, **kwargs_):
        if VDirOutputType.subclass:
            return VDirOutputType.subclass(*args_, **kwargs_)
        else:
            return VDirOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCreate(self): return self.create
    def setCreate(self, value): self.create = value
    def addCreate(self, value): self.create.append(value)
    def insertCreate(self, index, value): self.create[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def export(self, outfile, level, name_='VDirOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='VDirOutputType'):
        for create_ in self.getCreate():
            create_.export(outfile, level, name_='create')
        for remove_ in self.getRemove():
            remove_.export(outfile, level, name_='remove')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create':
            obj_ = VDirResultType.factory()
            obj_.build(child_)
            self.create.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = VDirResultType.factory()
            obj_.build(child_)
            self.remove.append(obj_)
# end class VDirOutputType


class VDirResultType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if VDirResultType.subclass:
            return VDirResultType.subclass(*args_, **kwargs_)
        else:
            return VDirResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='VDirResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirResultType'):
        pass
    def exportChildren(self, outfile, level, name_='VDirResultType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class VDirResultType


class CreateVDirInputType:
    subclass = None
    def __init__(self, domain_id=None, subdomain_id=None, name='', properties=None):
        self.domain_id = domain_id
        self.subdomain_id = subdomain_id
        self.name = name
        self.properties = properties
    def factory(*args_, **kwargs_):
        if CreateVDirInputType.subclass:
            return CreateVDirInputType.subclass(*args_, **kwargs_)
        else:
            return CreateVDirInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getSubdomain_id(self): return self.subdomain_id
    def setSubdomain_id(self, value): self.subdomain_id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getProperties(self): return self.properties
    def setProperties(self, value): self.properties = value
    def export(self, outfile, level, name_='CreateVDirInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='CreateVDirInputType'):
        pass
    def exportChildren(self, outfile, level, name_='CreateVDirInputType'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.subdomain_id is not None:
            showIndent(outfile, level)
            outfile.write('<subdomain-id>%s</subdomain-id>\n' % quote_xml(self.getSubdomain_id()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.properties is not None:
            self.properties.export(outfile, level, name_='properties')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdomain-id':
            subdomain_id_ = ''
            for text__content_ in child_.childNodes:
                subdomain_id_ += text__content_.nodeValue
            self.subdomain_id = subdomain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'properties':
            obj_ = VDirProperties.factory()
            obj_.build(child_)
            self.setProperties(obj_)
# end class CreateVDirInputType


class RemoveVDirInputType:
    subclass = None
    def __init__(self, domain_id=None, subdomain_id=None, name=''):
        self.domain_id = domain_id
        self.subdomain_id = subdomain_id
        self.name = name
    def factory(*args_, **kwargs_):
        if RemoveVDirInputType.subclass:
            return RemoveVDirInputType.subclass(*args_, **kwargs_)
        else:
            return RemoveVDirInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getSubdomain_id(self): return self.subdomain_id
    def setSubdomain_id(self, value): self.subdomain_id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='RemoveVDirInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='RemoveVDirInputType'):
        pass
    def exportChildren(self, outfile, level, name_='RemoveVDirInputType'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.subdomain_id is not None:
            showIndent(outfile, level)
            outfile.write('<subdomain-id>%s</subdomain-id>\n' % quote_xml(self.getSubdomain_id()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdomain-id':
            subdomain_id_ = ''
            for text__content_ in child_.childNodes:
                subdomain_id_ += text__content_.nodeValue
            self.subdomain_id = subdomain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
# end class RemoveVDirInputType


class VDirProperties:
    subclass = None
    def __init__(self, real_path=None, access_source=None, access_read=None, access_write=None, dir_browsing=None, log_visits=None, application=None, execute_perm=None, default_doc=None, access_anonymous=None, require_ssl=None, asp_buffering_limit=None, asp_max_request_entity_allowed=None, asp_enabled_server_debug=None, asp_enabled_client_debug=None):
        self.real_path = real_path
        self.access_source = access_source
        self.access_read = access_read
        self.access_write = access_write
        self.dir_browsing = dir_browsing
        self.log_visits = log_visits
        self.application = application
        self.execute_perm = execute_perm
        self.default_doc = default_doc
        self.access_anonymous = access_anonymous
        self.require_ssl = require_ssl
        self.asp_buffering_limit = asp_buffering_limit
        self.asp_max_request_entity_allowed = asp_max_request_entity_allowed
        self.asp_enabled_server_debug = asp_enabled_server_debug
        self.asp_enabled_client_debug = asp_enabled_client_debug
    def factory(*args_, **kwargs_):
        if VDirProperties.subclass:
            return VDirProperties.subclass(*args_, **kwargs_)
        else:
            return VDirProperties(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReal_path(self): return self.real_path
    def setReal_path(self, value): self.real_path = value
    def getAccess_source(self): return self.access_source
    def setAccess_source(self, value): self.access_source = value
    def getAccess_read(self): return self.access_read
    def setAccess_read(self, value): self.access_read = value
    def getAccess_write(self): return self.access_write
    def setAccess_write(self, value): self.access_write = value
    def getDir_browsing(self): return self.dir_browsing
    def setDir_browsing(self, value): self.dir_browsing = value
    def getLog_visits(self): return self.log_visits
    def setLog_visits(self, value): self.log_visits = value
    def getApplication(self): return self.application
    def setApplication(self, value): self.application = value
    def getExecute_perm(self): return self.execute_perm
    def setExecute_perm(self, value): self.execute_perm = value
    def getDefault_doc(self): return self.default_doc
    def setDefault_doc(self, value): self.default_doc = value
    def getAccess_anonymous(self): return self.access_anonymous
    def setAccess_anonymous(self, value): self.access_anonymous = value
    def getRequire_ssl(self): return self.require_ssl
    def setRequire_ssl(self, value): self.require_ssl = value
    def getAsp_buffering_limit(self): return self.asp_buffering_limit
    def setAsp_buffering_limit(self, value): self.asp_buffering_limit = value
    def getAsp_max_request_entity_allowed(self): return self.asp_max_request_entity_allowed
    def setAsp_max_request_entity_allowed(self, value): self.asp_max_request_entity_allowed = value
    def getAsp_enabled_server_debug(self): return self.asp_enabled_server_debug
    def setAsp_enabled_server_debug(self, value): self.asp_enabled_server_debug = value
    def getAsp_enabled_client_debug(self): return self.asp_enabled_client_debug
    def setAsp_enabled_client_debug(self, value): self.asp_enabled_client_debug = value
    def export(self, outfile, level, name_='VDirProperties'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirProperties'):
        pass
    def exportChildren(self, outfile, level, name_='VDirProperties'):
        if self.real_path is not None:
            showIndent(outfile, level)
            outfile.write('<real-path>%s</real-path>\n' % quote_xml(self.getReal_path()))
        if self.access_source is not None:
            showIndent(outfile, level)
            outfile.write('<access-source>%s</access-source>\n' % quote_xml(self.getAccess_source()))
        if self.access_read is not None:
            showIndent(outfile, level)
            outfile.write('<access-read>%s</access-read>\n' % quote_xml(self.getAccess_read()))
        if self.access_write is not None:
            showIndent(outfile, level)
            outfile.write('<access-write>%s</access-write>\n' % quote_xml(self.getAccess_write()))
        if self.dir_browsing is not None:
            showIndent(outfile, level)
            outfile.write('<dir-browsing>%s</dir-browsing>\n' % quote_xml(self.getDir_browsing()))
        if self.log_visits is not None:
            showIndent(outfile, level)
            outfile.write('<log-visits>%s</log-visits>\n' % quote_xml(self.getLog_visits()))
        if self.application is not None:
            self.application.export(outfile, level, name_='application')
        if self.execute_perm is not None:
            showIndent(outfile, level)
            outfile.write('<execute-perm>%s</execute-perm>\n' % quote_xml(self.getExecute_perm()))
        if self.default_doc is not None:
            self.default_doc.export(outfile, level, name_='default-doc')
        if self.access_anonymous is not None:
            showIndent(outfile, level)
            outfile.write('<access-anonymous>%s</access-anonymous>\n' % quote_xml(self.getAccess_anonymous()))
        if self.require_ssl is not None:
            showIndent(outfile, level)
            outfile.write('<require-ssl>%s</require-ssl>\n' % quote_xml(self.getRequire_ssl()))
        if self.asp_buffering_limit is not None:
            showIndent(outfile, level)
            outfile.write('<asp-buffering-limit>%s</asp-buffering-limit>\n' % quote_xml(self.getAsp_buffering_limit()))
        if self.asp_max_request_entity_allowed is not None:
            showIndent(outfile, level)
            outfile.write('<asp-max-request-entity-allowed>%s</asp-max-request-entity-allowed>\n' % quote_xml(self.getAsp_max_request_entity_allowed()))
        if self.asp_enabled_server_debug is not None:
            showIndent(outfile, level)
            outfile.write('<asp-enabled-server-debug>%s</asp-enabled-server-debug>\n' % quote_xml(self.getAsp_enabled_server_debug()))
        if self.asp_enabled_client_debug is not None:
            showIndent(outfile, level)
            outfile.write('<asp-enabled-client-debug>%s</asp-enabled-client-debug>\n' % quote_xml(self.getAsp_enabled_client_debug()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'real-path':
            real_path_ = ''
            for text__content_ in child_.childNodes:
                real_path_ += text__content_.nodeValue
            self.real_path = real_path_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'access-source':
            access_source_ = ''
            for text__content_ in child_.childNodes:
                access_source_ += text__content_.nodeValue
            self.access_source = access_source_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'access-read':
            access_read_ = ''
            for text__content_ in child_.childNodes:
                access_read_ += text__content_.nodeValue
            self.access_read = access_read_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'access-write':
            access_write_ = ''
            for text__content_ in child_.childNodes:
                access_write_ += text__content_.nodeValue
            self.access_write = access_write_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dir-browsing':
            dir_browsing_ = ''
            for text__content_ in child_.childNodes:
                dir_browsing_ += text__content_.nodeValue
            self.dir_browsing = dir_browsing_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-visits':
            log_visits_ = ''
            for text__content_ in child_.childNodes:
                log_visits_ += text__content_.nodeValue
            self.log_visits = log_visits_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'application':
            obj_ = VDirAppType.factory()
            obj_.build(child_)
            self.setApplication(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'execute-perm':
            execute_perm_ = ''
            for text__content_ in child_.childNodes:
                execute_perm_ += text__content_.nodeValue
            self.execute_perm = execute_perm_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'default-doc':
            obj_ = VDirDefaultDocType.factory()
            obj_.build(child_)
            self.setDefault_doc(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'access-anonymous':
            access_anonymous_ = ''
            for text__content_ in child_.childNodes:
                access_anonymous_ += text__content_.nodeValue
            self.access_anonymous = access_anonymous_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'require-ssl':
            require_ssl_ = ''
            for text__content_ in child_.childNodes:
                require_ssl_ += text__content_.nodeValue
            self.require_ssl = require_ssl_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp-buffering-limit':
            asp_buffering_limit_ = ''
            for text__content_ in child_.childNodes:
                asp_buffering_limit_ += text__content_.nodeValue
            self.asp_buffering_limit = asp_buffering_limit_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp-max-request-entity-allowed':
            asp_max_request_entity_allowed_ = ''
            for text__content_ in child_.childNodes:
                asp_max_request_entity_allowed_ += text__content_.nodeValue
            self.asp_max_request_entity_allowed = asp_max_request_entity_allowed_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp-enabled-server-debug':
            asp_enabled_server_debug_ = ''
            for text__content_ in child_.childNodes:
                asp_enabled_server_debug_ += text__content_.nodeValue
            self.asp_enabled_server_debug = asp_enabled_server_debug_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'asp-enabled-client-debug':
            asp_enabled_client_debug_ = ''
            for text__content_ in child_.childNodes:
                asp_enabled_client_debug_ += text__content_.nodeValue
            self.asp_enabled_client_debug = asp_enabled_client_debug_
# end class VDirProperties


class VDirAppType:
    subclass = None
    def __init__(self, enabled=None, parent_paths=None, run_in_mta=None, aspnet_version=None, disabled=None):
        self.enabled = enabled
        self.parent_paths = parent_paths
        self.run_in_mta = run_in_mta
        self.aspnet_version = aspnet_version
        self.disabled = disabled
    def factory(*args_, **kwargs_):
        if VDirAppType.subclass:
            return VDirAppType.subclass(*args_, **kwargs_)
        else:
            return VDirAppType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getParent_paths(self): return self.parent_paths
    def setParent_paths(self, value): self.parent_paths = value
    def getRun_in_mta(self): return self.run_in_mta
    def setRun_in_mta(self, value): self.run_in_mta = value
    def getAspnet_version(self): return self.aspnet_version
    def setAspnet_version(self, value): self.aspnet_version = value
    def getDisabled(self): return self.disabled
    def setDisabled(self, value): self.disabled = value
    def export(self, outfile, level, name_='VDirAppType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirAppType'):
        pass
    def exportChildren(self, outfile, level, name_='VDirAppType'):
        if self.enabled is not None:
            showIndent(outfile, level)
            outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        if self.parent_paths is not None:
            showIndent(outfile, level)
            outfile.write('<parent-paths>%s</parent-paths>\n' % quote_xml(self.getParent_paths()))
        if self.run_in_mta is not None:
            showIndent(outfile, level)
            outfile.write('<run-in-mta>%s</run-in-mta>\n' % quote_xml(self.getRun_in_mta()))
        if self.aspnet_version is not None:
            showIndent(outfile, level)
            outfile.write('<aspnet-version>%s</aspnet-version>\n' % quote_xml(self.getAspnet_version()))
        if self.disabled is not None:
            showIndent(outfile, level)
            outfile.write('<disabled>%s</disabled>\n' % quote_xml(self.getDisabled()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'parent-paths':
            parent_paths_ = ''
            for text__content_ in child_.childNodes:
                parent_paths_ += text__content_.nodeValue
            self.parent_paths = parent_paths_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'run-in-mta':
            run_in_mta_ = ''
            for text__content_ in child_.childNodes:
                run_in_mta_ += text__content_.nodeValue
            self.run_in_mta = run_in_mta_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'aspnet-version':
            aspnet_version_ = ''
            for text__content_ in child_.childNodes:
                aspnet_version_ += text__content_.nodeValue
            self.aspnet_version = aspnet_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disabled':
            disabled_ = ''
            for text__content_ in child_.childNodes:
                disabled_ += text__content_.nodeValue
            self.disabled = disabled_
# end class VDirAppType


class VDirDefaultDocType:
    subclass = None
    def __init__(self, enabled=None, search=None, disabled=None):
        self.enabled = enabled
        if search is None:
            self.search = []
        else:
            self.search = search
        self.disabled = disabled
    def factory(*args_, **kwargs_):
        if VDirDefaultDocType.subclass:
            return VDirDefaultDocType.subclass(*args_, **kwargs_)
        else:
            return VDirDefaultDocType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getSearch(self): return self.search
    def setSearch(self, value): self.search = value
    def addSearch(self, value): self.search.append(value)
    def insertSearch(self, index, value): self.search[index] = value
    def getDisabled(self): return self.disabled
    def setDisabled(self, value): self.disabled = value
    def export(self, outfile, level, name_='VDirDefaultDocType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='VDirDefaultDocType'):
        pass
    def exportChildren(self, outfile, level, name_='VDirDefaultDocType'):
        if self.enabled is not None:
            showIndent(outfile, level)
            outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        for search_ in self.getSearch():
            showIndent(outfile, level)
            outfile.write('<search>%s</search>\n' % quote_xml(search_))
        if self.disabled is not None:
            showIndent(outfile, level)
            outfile.write('<disabled>%s</disabled>\n' % quote_xml(self.getDisabled()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'search':
            search_ = ''
            for text__content_ in child_.childNodes:
                search_ += text__content_.nodeValue
            self.addSearch(search_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disabled':
            disabled_ = ''
            for text__content_ in child_.childNodes:
                disabled_ += text__content_.nodeValue
            self.disabled = disabled_
# end class VDirDefaultDocType


class SpamassassinFilterType:
    subclass = None
    def __init__(self, username=None, spamfilter_id=None):
        if username is None:
            self.username = []
        else:
            self.username = username
        if spamfilter_id is None:
            self.spamfilter_id = []
        else:
            self.spamfilter_id = spamfilter_id
    def factory(*args_, **kwargs_):
        if SpamassassinFilterType.subclass:
            return SpamassassinFilterType.subclass(*args_, **kwargs_)
        else:
            return SpamassassinFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getUsername(self): return self.username
    def setUsername(self, value): self.username = value
    def addUsername(self, value): self.username.append(value)
    def insertUsername(self, index, value): self.username[index] = value
    def getSpamfilter_id(self): return self.spamfilter_id
    def setSpamfilter_id(self, value): self.spamfilter_id = value
    def addSpamfilter_id(self, value): self.spamfilter_id.append(value)
    def insertSpamfilter_id(self, index, value): self.spamfilter_id[index] = value
    def export(self, outfile, level, name_='SpamassassinFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamassassinFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamassassinFilterType'):
        for username_ in self.getUsername():
            showIndent(outfile, level)
            outfile.write('<username>%s</username>\n' % quote_xml(username_))
        for spamfilter_id_ in self.getSpamfilter_id():
            showIndent(outfile, level)
            outfile.write('<spamfilter-id>%s</spamfilter-id>\n' % quote_xml(spamfilter_id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'username':
            username_ = ''
            for text__content_ in child_.childNodes:
                username_ += text__content_.nodeValue
            self.addUsername(username_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spamfilter-id':
            spamfilter_id_ = ''
            for text__content_ in child_.childNodes:
                spamfilter_id_ += text__content_.nodeValue
            self.addSpamfilter_id(spamfilter_id_)
# end class SpamassassinFilterType


class SpamassassinPreferencesType:
    subclass = None
    def __init__(self, personal=None, max_children_process=None, use_server_wide_settings=None, required_score=None, rewrite_header=None, reject_spam=None):
        self.personal = personal
        self.max_children_process = max_children_process
        self.use_server_wide_settings = use_server_wide_settings
        self.required_score = required_score
        self.rewrite_header = rewrite_header
        self.reject_spam = reject_spam
    def factory(*args_, **kwargs_):
        if SpamassassinPreferencesType.subclass:
            return SpamassassinPreferencesType.subclass(*args_, **kwargs_)
        else:
            return SpamassassinPreferencesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPersonal(self): return self.personal
    def setPersonal(self, value): self.personal = value
    def getMax_children_process(self): return self.max_children_process
    def setMax_children_process(self, value): self.max_children_process = value
    def getUse_server_wide_settings(self): return self.use_server_wide_settings
    def setUse_server_wide_settings(self, value): self.use_server_wide_settings = value
    def getRequired_score(self): return self.required_score
    def setRequired_score(self, value): self.required_score = value
    def getRewrite_header(self): return self.rewrite_header
    def setRewrite_header(self, value): self.rewrite_header = value
    def getReject_spam(self): return self.reject_spam
    def setReject_spam(self, value): self.reject_spam = value
    def export(self, outfile, level, name_='SpamassassinPreferencesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamassassinPreferencesType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamassassinPreferencesType'):
        if self.personal is not None:
            showIndent(outfile, level)
            outfile.write('<personal>%s</personal>\n' % quote_xml(self.getPersonal()))
        if self.max_children_process is not None:
            showIndent(outfile, level)
            outfile.write('<max-children-process>%s</max-children-process>\n' % quote_xml(self.getMax_children_process()))
        if self.use_server_wide_settings is not None:
            showIndent(outfile, level)
            outfile.write('<use-server-wide-settings>%s</use-server-wide-settings>\n' % quote_xml(self.getUse_server_wide_settings()))
        if self.required_score is not None:
            showIndent(outfile, level)
            outfile.write('<required-score>%s</required-score>\n' % quote_xml(self.getRequired_score()))
        if self.rewrite_header is not None:
            showIndent(outfile, level)
            outfile.write('<rewrite-header>%s</rewrite-header>\n' % quote_xml(self.getRewrite_header()))
        if self.reject_spam is not None:
            showIndent(outfile, level)
            outfile.write('<reject-spam>%s</reject-spam>\n' % quote_xml(self.getReject_spam()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'personal':
            personal_ = ''
            for text__content_ in child_.childNodes:
                personal_ += text__content_.nodeValue
            self.personal = personal_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'max-children-process':
            max_children_process_ = ''
            for text__content_ in child_.childNodes:
                max_children_process_ += text__content_.nodeValue
            self.max_children_process = max_children_process_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'use-server-wide-settings':
            use_server_wide_settings_ = ''
            for text__content_ in child_.childNodes:
                use_server_wide_settings_ += text__content_.nodeValue
            self.use_server_wide_settings = use_server_wide_settings_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'required-score':
            required_score_ = ''
            for text__content_ in child_.childNodes:
                required_score_ += text__content_.nodeValue
            self.required_score = required_score_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rewrite-header':
            rewrite_header_ = ''
            for text__content_ in child_.childNodes:
                rewrite_header_ += text__content_.nodeValue
            self.rewrite_header = rewrite_header_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reject-spam':
            reject_spam_ = ''
            for text__content_ in child_.childNodes:
                reject_spam_ += text__content_.nodeValue
            self.reject_spam = reject_spam_
# end class SpamassassinPreferencesType


class SpamPatternFilterType:
    subclass = None
    def __init__(self, pattern=None):
        if pattern is None:
            self.pattern = []
        else:
            self.pattern = pattern
    def factory(*args_, **kwargs_):
        if SpamPatternFilterType.subclass:
            return SpamPatternFilterType.subclass(*args_, **kwargs_)
        else:
            return SpamPatternFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPattern(self): return self.pattern
    def setPattern(self, value): self.pattern = value
    def addPattern(self, value): self.pattern.append(value)
    def insertPattern(self, index, value): self.pattern[index] = value
    def export(self, outfile, level, name_='SpamPatternFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamPatternFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamPatternFilterType'):
        for pattern_ in self.getPattern():
            showIndent(outfile, level)
            outfile.write('<pattern>%s</pattern>\n' % quote_xml(pattern_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pattern':
            pattern_ = ''
            for text__content_ in child_.childNodes:
                pattern_ += text__content_.nodeValue
            self.addPattern(pattern_)
# end class SpamPatternFilterType


class SpamFilterInputType:
    subclass = None
    def __init__(self, add_pattern=None, del_pattern=None, get_patterns=None, get=None, set=None, get_allowed_preferences=None, get_allowed_lists=None, check=None):
        if add_pattern is None:
            self.add_pattern = []
        else:
            self.add_pattern = add_pattern
        if del_pattern is None:
            self.del_pattern = []
        else:
            self.del_pattern = del_pattern
        if get_patterns is None:
            self.get_patterns = []
        else:
            self.get_patterns = get_patterns
        if get is None:
            self.get = []
        else:
            self.get = get
        if set is None:
            self.set = []
        else:
            self.set = set
        if get_allowed_preferences is None:
            self.get_allowed_preferences = []
        else:
            self.get_allowed_preferences = get_allowed_preferences
        if get_allowed_lists is None:
            self.get_allowed_lists = []
        else:
            self.get_allowed_lists = get_allowed_lists
        if check is None:
            self.check = []
        else:
            self.check = check
    def factory(*args_, **kwargs_):
        if SpamFilterInputType.subclass:
            return SpamFilterInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_pattern(self): return self.add_pattern
    def setAdd_pattern(self, value): self.add_pattern = value
    def addAdd_pattern(self, value): self.add_pattern.append(value)
    def insertAdd_pattern(self, index, value): self.add_pattern[index] = value
    def getDel_pattern(self): return self.del_pattern
    def setDel_pattern(self, value): self.del_pattern = value
    def addDel_pattern(self, value): self.del_pattern.append(value)
    def insertDel_pattern(self, index, value): self.del_pattern[index] = value
    def getGet_patterns(self): return self.get_patterns
    def setGet_patterns(self, value): self.get_patterns = value
    def addGet_patterns(self, value): self.get_patterns.append(value)
    def insertGet_patterns(self, index, value): self.get_patterns[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet_allowed_preferences(self): return self.get_allowed_preferences
    def setGet_allowed_preferences(self, value): self.get_allowed_preferences = value
    def addGet_allowed_preferences(self, value): self.get_allowed_preferences.append(value)
    def insertGet_allowed_preferences(self, index, value): self.get_allowed_preferences[index] = value
    def getGet_allowed_lists(self): return self.get_allowed_lists
    def setGet_allowed_lists(self, value): self.get_allowed_lists = value
    def addGet_allowed_lists(self, value): self.get_allowed_lists.append(value)
    def insertGet_allowed_lists(self, index, value): self.get_allowed_lists[index] = value
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def export(self, outfile, level, name_='SpamFilterInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterInputType'):
        for add_pattern_ in self.getAdd_pattern():
            add_pattern_.export(outfile, level, name_='add-pattern')
        for del_pattern_ in self.getDel_pattern():
            del_pattern_.export(outfile, level, name_='del-pattern')
        for get_patterns_ in self.getGet_patterns():
            get_patterns_.export(outfile, level, name_='get-patterns')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_allowed_preferences_ in self.getGet_allowed_preferences():
            get_allowed_preferences_.export(outfile, level, name_='get-allowed-preferences')
        for get_allowed_lists_ in self.getGet_allowed_lists():
            get_allowed_lists_.export(outfile, level, name_='get-allowed-lists')
        for check_ in self.getCheck():
            check_.export(outfile, level, name_='check')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-pattern':
            obj_ = SpamFilterAddPatternInputType.factory()
            obj_.build(child_)
            self.add_pattern.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-pattern':
            obj_ = SpamFilterDelPatternInputType.factory()
            obj_.build(child_)
            self.del_pattern.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-patterns':
            obj_ = SpamFilterGetPatternsInputType.factory()
            obj_.build(child_)
            self.get_patterns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = SpamFilterGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = SpamFilterSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-allowed-preferences':
            obj_ = SpamFilterGetAllowedPreferencesInputType.factory()
            obj_.build(child_)
            self.get_allowed_preferences.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-allowed-lists':
            obj_ = SpamFilterGetAllowedListsInputType.factory()
            obj_.build(child_)
            self.get_allowed_lists.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.check.append(obj_)
# end class SpamFilterInputType


class SpamFilterAddPatternInputType:
    subclass = None
    def __init__(self, filter=None, list='', username=None, spamfilter_id=None):
        self.filter = filter
        self.list = list
        self.username = username
        self.spamfilter_id = spamfilter_id
    def factory(*args_, **kwargs_):
        if SpamFilterAddPatternInputType.subclass:
            return SpamFilterAddPatternInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterAddPatternInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getList(self): return self.list
    def setList(self, value): self.list = value
    def getUsername(self): return self.username
    def setUsername(self, value): self.username = value
    def getSpamfilter_id(self): return self.spamfilter_id
    def setSpamfilter_id(self, value): self.spamfilter_id = value
    def export(self, outfile, level, name_='SpamFilterAddPatternInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterAddPatternInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterAddPatternInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<list>%s</list>\n' % quote_xml(self.getList()))
        if self.username is not None:
            showIndent(outfile, level)
            outfile.write('<username>%s</username>\n' % quote_xml(self.getUsername()))
        if self.spamfilter_id is not None:
            showIndent(outfile, level)
            outfile.write('<spamfilter-id>%s</spamfilter-id>\n' % quote_xml(self.getSpamfilter_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamPatternFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list':
            list_ = ''
            for text__content_ in child_.childNodes:
                list_ += text__content_.nodeValue
            self.list = list_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'username':
            username_ = ''
            for text__content_ in child_.childNodes:
                username_ += text__content_.nodeValue
            self.username = username_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spamfilter-id':
            spamfilter_id_ = ''
            for text__content_ in child_.childNodes:
                spamfilter_id_ += text__content_.nodeValue
            self.spamfilter_id = spamfilter_id_
# end class SpamFilterAddPatternInputType


class SpamFilterDelPatternInputType:
    subclass = None
    def __init__(self, filter=None, list='', username=None, spamfilter_id=None):
        self.filter = filter
        self.list = list
        self.username = username
        self.spamfilter_id = spamfilter_id
    def factory(*args_, **kwargs_):
        if SpamFilterDelPatternInputType.subclass:
            return SpamFilterDelPatternInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterDelPatternInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getList(self): return self.list
    def setList(self, value): self.list = value
    def getUsername(self): return self.username
    def setUsername(self, value): self.username = value
    def getSpamfilter_id(self): return self.spamfilter_id
    def setSpamfilter_id(self, value): self.spamfilter_id = value
    def export(self, outfile, level, name_='SpamFilterDelPatternInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterDelPatternInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterDelPatternInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<list>%s</list>\n' % quote_xml(self.getList()))
        if self.username is not None:
            showIndent(outfile, level)
            outfile.write('<username>%s</username>\n' % quote_xml(self.getUsername()))
        if self.spamfilter_id is not None:
            showIndent(outfile, level)
            outfile.write('<spamfilter-id>%s</spamfilter-id>\n' % quote_xml(self.getSpamfilter_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamPatternFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list':
            list_ = ''
            for text__content_ in child_.childNodes:
                list_ += text__content_.nodeValue
            self.list = list_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'username':
            username_ = ''
            for text__content_ in child_.childNodes:
                username_ += text__content_.nodeValue
            self.username = username_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spamfilter-id':
            spamfilter_id_ = ''
            for text__content_ in child_.childNodes:
                spamfilter_id_ += text__content_.nodeValue
            self.spamfilter_id = spamfilter_id_
# end class SpamFilterDelPatternInputType


class SpamFilterSetInputType:
    subclass = None
    def __init__(self, filter=None, preferences=None, enabled=None, disabled=None):
        self.filter = filter
        self.preferences = preferences
        self.enabled = enabled
        self.disabled = disabled
    def factory(*args_, **kwargs_):
        if SpamFilterSetInputType.subclass:
            return SpamFilterSetInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getDisabled(self): return self.disabled
    def setDisabled(self, value): self.disabled = value
    def export(self, outfile, level, name_='SpamFilterSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
        if self.enabled is not None:
            self.enabled.export(outfile, level, name_='enabled')
        if self.disabled is not None:
            self.disabled.export(outfile, level, name_='disabled')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamassassinFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = SpamassassinPreferencesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setEnabled(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disabled':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDisabled(obj_)
# end class SpamFilterSetInputType


class SpamFilterGetInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SpamFilterGetInputType.subclass:
            return SpamFilterGetInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SpamFilterGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamassassinFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SpamFilterGetInputType


class SpamFilterGetPatternsInputType:
    subclass = None
    def __init__(self, filter=None, list=''):
        self.filter = filter
        self.list = list
    def factory(*args_, **kwargs_):
        if SpamFilterGetPatternsInputType.subclass:
            return SpamFilterGetPatternsInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetPatternsInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getList(self): return self.list
    def setList(self, value): self.list = value
    def export(self, outfile, level, name_='SpamFilterGetPatternsInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetPatternsInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetPatternsInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<list>%s</list>\n' % quote_xml(self.getList()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamassassinFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'list':
            list_ = ''
            for text__content_ in child_.childNodes:
                list_ += text__content_.nodeValue
            self.list = list_
# end class SpamFilterGetPatternsInputType


class SpamFilterGetAllowedPreferencesInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SpamFilterGetAllowedPreferencesInputType.subclass:
            return SpamFilterGetAllowedPreferencesInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetAllowedPreferencesInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SpamFilterGetAllowedPreferencesInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetAllowedPreferencesInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetAllowedPreferencesInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamassassinFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SpamFilterGetAllowedPreferencesInputType


class SpamFilterGetAllowedListsInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SpamFilterGetAllowedListsInputType.subclass:
            return SpamFilterGetAllowedListsInputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetAllowedListsInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SpamFilterGetAllowedListsInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetAllowedListsInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetAllowedListsInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SpamassassinFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SpamFilterGetAllowedListsInputType


class SpamFilterOutputType:
    subclass = None
    def __init__(self, add_pattern=None, del_pattern=None, get_patterns=None, get=None, set=None, get_allowed_preferences=None, get_allowed_lists=None, check=None):
        if add_pattern is None:
            self.add_pattern = []
        else:
            self.add_pattern = add_pattern
        if del_pattern is None:
            self.del_pattern = []
        else:
            self.del_pattern = del_pattern
        if get_patterns is None:
            self.get_patterns = []
        else:
            self.get_patterns = get_patterns
        if get is None:
            self.get = []
        else:
            self.get = get
        if set is None:
            self.set = []
        else:
            self.set = set
        if get_allowed_preferences is None:
            self.get_allowed_preferences = []
        else:
            self.get_allowed_preferences = get_allowed_preferences
        if get_allowed_lists is None:
            self.get_allowed_lists = []
        else:
            self.get_allowed_lists = get_allowed_lists
        if check is None:
            self.check = []
        else:
            self.check = check
    def factory(*args_, **kwargs_):
        if SpamFilterOutputType.subclass:
            return SpamFilterOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd_pattern(self): return self.add_pattern
    def setAdd_pattern(self, value): self.add_pattern = value
    def addAdd_pattern(self, value): self.add_pattern.append(value)
    def insertAdd_pattern(self, index, value): self.add_pattern[index] = value
    def getDel_pattern(self): return self.del_pattern
    def setDel_pattern(self, value): self.del_pattern = value
    def addDel_pattern(self, value): self.del_pattern.append(value)
    def insertDel_pattern(self, index, value): self.del_pattern[index] = value
    def getGet_patterns(self): return self.get_patterns
    def setGet_patterns(self, value): self.get_patterns = value
    def addGet_patterns(self, value): self.get_patterns.append(value)
    def insertGet_patterns(self, index, value): self.get_patterns[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet_allowed_preferences(self): return self.get_allowed_preferences
    def setGet_allowed_preferences(self, value): self.get_allowed_preferences = value
    def addGet_allowed_preferences(self, value): self.get_allowed_preferences.append(value)
    def insertGet_allowed_preferences(self, index, value): self.get_allowed_preferences[index] = value
    def getGet_allowed_lists(self): return self.get_allowed_lists
    def setGet_allowed_lists(self, value): self.get_allowed_lists = value
    def addGet_allowed_lists(self, value): self.get_allowed_lists.append(value)
    def insertGet_allowed_lists(self, index, value): self.get_allowed_lists[index] = value
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def export(self, outfile, level, name_='SpamFilterOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterOutputType'):
        for add_pattern_ in self.getAdd_pattern():
            add_pattern_.export(outfile, level, name_='add-pattern')
        for del_pattern_ in self.getDel_pattern():
            del_pattern_.export(outfile, level, name_='del-pattern')
        for get_patterns_ in self.getGet_patterns():
            get_patterns_.export(outfile, level, name_='get-patterns')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_allowed_preferences_ in self.getGet_allowed_preferences():
            get_allowed_preferences_.export(outfile, level, name_='get-allowed-preferences')
        for get_allowed_lists_ in self.getGet_allowed_lists():
            get_allowed_lists_.export(outfile, level, name_='get-allowed-lists')
        for check_ in self.getCheck():
            check_.export(outfile, level, name_='check')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-pattern':
            obj_ = SpamFilterAddPatternOutputType.factory()
            obj_.build(child_)
            self.add_pattern.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-pattern':
            obj_ = SpamFilterDelPatternOutputType.factory()
            obj_.build(child_)
            self.del_pattern.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-patterns':
            obj_ = SpamFilterGetPatternsOutputType.factory()
            obj_.build(child_)
            self.get_patterns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = SpamFilterGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = SpamFilterSetOutputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-allowed-preferences':
            obj_ = SpamFilterGetAllowedPreferencesOutputType.factory()
            obj_.build(child_)
            self.get_allowed_preferences.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-allowed-lists':
            obj_ = SpamFilterGetAllowedListsOutputType.factory()
            obj_.build(child_)
            self.get_allowed_lists.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            obj_ = SpamFilterCheckOutputType.factory()
            obj_.build(child_)
            self.check.append(obj_)
# end class SpamFilterOutputType


class SpamFilterAddPatternOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterAddPatternOutputType.subclass:
            return SpamFilterAddPatternOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterAddPatternOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterAddPatternOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterAddPatternOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterAddPatternOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterAddPatternOutputType


class SpamFilterDelPatternOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterDelPatternOutputType.subclass:
            return SpamFilterDelPatternOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterDelPatternOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterDelPatternOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterDelPatternOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterDelPatternOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterDelPatternOutputType


class SpamFilterGetPatternsOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterGetPatternsOutputType.subclass:
            return SpamFilterGetPatternsOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetPatternsOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterGetPatternsOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetPatternsOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetPatternsOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterGetPatternsOutputType


class SpamFilterGetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterGetOutputType.subclass:
            return SpamFilterGetOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterGetOutputType


class SpamFilterSetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterSetOutputType.subclass:
            return SpamFilterSetOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterSetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterSetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterSetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterSetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterSetOutputType


class SpamFilterGetAllowedPreferencesOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterGetAllowedPreferencesOutputType.subclass:
            return SpamFilterGetAllowedPreferencesOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetAllowedPreferencesOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterGetAllowedPreferencesOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetAllowedPreferencesOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetAllowedPreferencesOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterGetAllowedPreferencesOutputType


class SpamFilterGetAllowedListsOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterGetAllowedListsOutputType.subclass:
            return SpamFilterGetAllowedListsOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterGetAllowedListsOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SpamFilterGetAllowedListsOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterGetAllowedListsOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterGetAllowedListsOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SpamFilterGetAllowedListsOutputType


class SpamFilterCheckOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SpamFilterCheckOutputType.subclass:
            return SpamFilterCheckOutputType.subclass(*args_, **kwargs_)
        else:
            return SpamFilterCheckOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SpamFilterCheckOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SpamFilterCheckOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SpamFilterCheckOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SpamFilterCheckOutputType


class FtpUserInputType:
    subclass = None
    def __init__(self, add=None, set=None, ddel=None, get=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if get is None:
            self.get = []
        else:
            self.get = get
    def factory(*args_, **kwargs_):
        if FtpUserInputType.subclass:
            return FtpUserInputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def export(self, outfile, level, name_='FtpUserInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserInputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = FtpUserAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = FtpUserSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = FtpUserDelInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = FtpUserGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
# end class FtpUserInputType


class FtpUserNewType:
    subclass = None
    def __init__(self, name='', password='', home='', create_non_existent=None, quota=None, permissions=None):
        self.name = name
        self.password = password
        self.home = home
        self.create_non_existent = create_non_existent
        self.quota = quota
        self.permissions = permissions
    def factory(*args_, **kwargs_):
        if FtpUserNewType.subclass:
            return FtpUserNewType.subclass(*args_, **kwargs_)
        else:
            return FtpUserNewType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getHome(self): return self.home
    def setHome(self, value): self.home = value
    def getCreate_non_existent(self): return self.create_non_existent
    def setCreate_non_existent(self, value): self.create_non_existent = value
    def getQuota(self): return self.quota
    def setQuota(self, value): self.quota = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def export(self, outfile, level, name_='FtpUserNewType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserNewType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserNewType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        showIndent(outfile, level)
        outfile.write('<home>%s</home>\n' % quote_xml(self.getHome()))
        if self.create_non_existent is not None:
            showIndent(outfile, level)
            outfile.write('<create-non-existent>%s</create-non-existent>\n' % quote_xml(self.getCreate_non_existent()))
        if self.quota is not None:
            showIndent(outfile, level)
            outfile.write('<quota>%s</quota>\n' % quote_xml(self.getQuota()))
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'home':
            home_ = ''
            for text__content_ in child_.childNodes:
                home_ += text__content_.nodeValue
            self.home = home_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create-non-existent':
            create_non_existent_ = ''
            for text__content_ in child_.childNodes:
                create_non_existent_ += text__content_.nodeValue
            self.create_non_existent = create_non_existent_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'quota':
            quota_ = ''
            for text__content_ in child_.childNodes:
                quota_ += text__content_.nodeValue
            self.quota = quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = FtpUserPermissions.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
# end class FtpUserNewType


class FtpUserPermissions:
    subclass = None
    def __init__(self, read=None, write=None):
        self.read = read
        self.write = write
    def factory(*args_, **kwargs_):
        if FtpUserPermissions.subclass:
            return FtpUserPermissions.subclass(*args_, **kwargs_)
        else:
            return FtpUserPermissions(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getRead(self): return self.read
    def setRead(self, value): self.read = value
    def getWrite(self): return self.write
    def setWrite(self, value): self.write = value
    def export(self, outfile, level, name_='FtpUserPermissions'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserPermissions'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserPermissions'):
        if self.read is not None:
            showIndent(outfile, level)
            outfile.write('<read>%s</read>\n' % quote_xml(self.getRead()))
        if self.write is not None:
            showIndent(outfile, level)
            outfile.write('<write>%s</write>\n' % quote_xml(self.getWrite()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'read':
            read_ = ''
            for text__content_ in child_.childNodes:
                read_ += text__content_.nodeValue
            self.read = read_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'write':
            write_ = ''
            for text__content_ in child_.childNodes:
                write_ += text__content_.nodeValue
            self.write = write_
# end class FtpUserPermissions


class FtpUserExistType:
    subclass = None
    def __init__(self, name=None, password=None, home='', quota=None, permissions=None):
        self.name = name
        self.password = password
        self.home = home
        self.quota = quota
        self.permissions = permissions
    def factory(*args_, **kwargs_):
        if FtpUserExistType.subclass:
            return FtpUserExistType.subclass(*args_, **kwargs_)
        else:
            return FtpUserExistType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getHome(self): return self.home
    def setHome(self, value): self.home = value
    def getQuota(self): return self.quota
    def setQuota(self, value): self.quota = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def export(self, outfile, level, name_='FtpUserExistType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserExistType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserExistType'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        showIndent(outfile, level)
        outfile.write('<home>%s</home>\n' % quote_xml(self.getHome()))
        if self.quota is not None:
            showIndent(outfile, level)
            outfile.write('<quota>%s</quota>\n' % quote_xml(self.getQuota()))
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'home':
            home_ = ''
            for text__content_ in child_.childNodes:
                home_ += text__content_.nodeValue
            self.home = home_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'quota':
            quota_ = ''
            for text__content_ in child_.childNodes:
                quota_ += text__content_.nodeValue
            self.quota = quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = FtpUserPermissions.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
# end class FtpUserExistType


class FtpUserAddInputType(FtpUserNewType):
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, name='', password='', home='', create_non_existent=None, quota=None, permissions=None):
        FtpUserNewType.__init__(self, name, password, home, create_non_existent, quota, permissions)
        self.domain_id = domain_id
        self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if FtpUserAddInputType.subclass:
            return FtpUserAddInputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def export(self, outfile, level, name_='FtpUserAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserAddInputType'):
        FtpUserNewType.exportAttributes(self, outfile, level, name_='FtpUserAddInputType')
    def exportChildren(self, outfile, level, name_='FtpUserAddInputType'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        FtpUserNewType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        FtpUserNewType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        FtpUserNewType.buildChildren(self, child_, nodeName_)
# end class FtpUserAddInputType


class FtpUserSetInputType:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if FtpUserSetInputType.subclass:
            return FtpUserSetInputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='FtpUserSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level, name_='values')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = FtpUserFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = FtpUserSetType.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class FtpUserSetInputType


class FtpUserFilterType:
    subclass = None
    def __init__(self, id=None, name=None, domain_id=None, domain_name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if FtpUserFilterType.subclass:
            return FtpUserFilterType.subclass(*args_, **kwargs_)
        else:
            return FtpUserFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='FtpUserFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class FtpUserFilterType


class FtpUserDelInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if FtpUserDelInputType.subclass:
            return FtpUserDelInputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserDelInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='FtpUserDelInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserDelInputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserDelInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = FtpUserFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class FtpUserDelInputType


class FtpUserOutputType:
    subclass = None
    def __init__(self, add=None, set=None, ddel=None, get=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if get is None:
            self.get = []
        else:
            self.get = get
    def factory(*args_, **kwargs_):
        if FtpUserOutputType.subclass:
            return FtpUserOutputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def export(self, outfile, level, name_='FtpUserOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = FtpUserAddOutputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = FtpUserSetOutputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = FtpUserDelOutputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = FtpUserGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
# end class FtpUserOutputType


class FtpUserAddOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if FtpUserAddOutputType.subclass:
            return FtpUserAddOutputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserAddOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='FtpUserAddOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserAddOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserAddOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = FtpUserSimpleResultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class FtpUserAddOutputType


class FtpUserSimpleResultType(resultType):
    subclass = None
    def __init__(self, id='', status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
    def factory(*args_, **kwargs_):
        if FtpUserSimpleResultType.subclass:
            return FtpUserSimpleResultType.subclass(*args_, **kwargs_)
        else:
            return FtpUserSimpleResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='FtpUserSimpleResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserSimpleResultType'):
        resultType.exportAttributes(self, outfile, level, name_='FtpUserSimpleResultType')
    def exportChildren(self, outfile, level, name_='FtpUserSimpleResultType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class FtpUserSimpleResultType


class FtpUserGetInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if FtpUserGetInputType.subclass:
            return FtpUserGetInputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='FtpUserGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = FtpUserFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class FtpUserGetInputType


class FtpUserSetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if FtpUserSetOutputType.subclass:
            return FtpUserSetOutputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserSetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='FtpUserSetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserSetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserSetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class FtpUserSetOutputType


class FtpUserDelOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if FtpUserDelOutputType.subclass:
            return FtpUserDelOutputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserDelOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='FtpUserDelOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserDelOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserDelOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class FtpUserDelOutputType


class FtpUserGetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if FtpUserGetOutputType.subclass:
            return FtpUserGetOutputType.subclass(*args_, **kwargs_)
        else:
            return FtpUserGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='FtpUserGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserGetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = FtpUserGetResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class FtpUserGetOutputType


class FtpUserGetResultType(resultFilterType):
    subclass = None
    def __init__(self, name='', home='', quota='', permissions=None, domain_id='', filter_id=None, id=None, status='', errcode=None, errtext=None):
        resultFilterType.__init__(self, filter_id, id, status, errcode, errtext)
        self.name = name
        self.home = home
        self.quota = quota
        self.permissions = permissions
        self.domain_id = domain_id
    def factory(*args_, **kwargs_):
        if FtpUserGetResultType.subclass:
            return FtpUserGetResultType.subclass(*args_, **kwargs_)
        else:
            return FtpUserGetResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getHome(self): return self.home
    def setHome(self, value): self.home = value
    def getQuota(self): return self.quota
    def setQuota(self, value): self.quota = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def export(self, outfile, level, name_='FtpUserGetResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserGetResultType'):
        resultFilterType.exportAttributes(self, outfile, level, name_='FtpUserGetResultType')
    def exportChildren(self, outfile, level, name_='FtpUserGetResultType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<home>%s</home>\n' % quote_xml(self.getHome()))
        showIndent(outfile, level)
        outfile.write('<quota>%s</quota>\n' % quote_xml(self.getQuota()))
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        showIndent(outfile, level)
        outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        resultFilterType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultFilterType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'home':
            home_ = ''
            for text__content_ in child_.childNodes:
                home_ += text__content_.nodeValue
            self.home = home_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'quota':
            quota_ = ''
            for text__content_ in child_.childNodes:
                quota_ += text__content_.nodeValue
            self.quota = quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = FtpUserPermissions.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        resultFilterType.buildChildren(self, child_, nodeName_)
# end class FtpUserGetResultType


class FtpUserSetType:
    subclass = None
    def __init__(self, name=None, password=None, home='', create_non_existent=None, quota=None, permissions=None):
        self.name = name
        self.password = password
        self.home = home
        self.create_non_existent = create_non_existent
        self.quota = quota
        self.permissions = permissions
    def factory(*args_, **kwargs_):
        if FtpUserSetType.subclass:
            return FtpUserSetType.subclass(*args_, **kwargs_)
        else:
            return FtpUserSetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getHome(self): return self.home
    def setHome(self, value): self.home = value
    def getCreate_non_existent(self): return self.create_non_existent
    def setCreate_non_existent(self, value): self.create_non_existent = value
    def getQuota(self): return self.quota
    def setQuota(self, value): self.quota = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def export(self, outfile, level, name_='FtpUserSetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='FtpUserSetType'):
        pass
    def exportChildren(self, outfile, level, name_='FtpUserSetType'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        showIndent(outfile, level)
        outfile.write('<home>%s</home>\n' % quote_xml(self.getHome()))
        if self.create_non_existent is not None:
            showIndent(outfile, level)
            outfile.write('<create-non-existent>%s</create-non-existent>\n' % quote_xml(self.getCreate_non_existent()))
        if self.quota is not None:
            showIndent(outfile, level)
            outfile.write('<quota>%s</quota>\n' % quote_xml(self.getQuota()))
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'home':
            home_ = ''
            for text__content_ in child_.childNodes:
                home_ += text__content_.nodeValue
            self.home = home_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'create-non-existent':
            create_non_existent_ = ''
            for text__content_ in child_.childNodes:
                create_non_existent_ += text__content_.nodeValue
            self.create_non_existent = create_non_existent_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'quota':
            quota_ = ''
            for text__content_ in child_.childNodes:
                quota_ += text__content_.nodeValue
            self.quota = quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = FtpUserPermissions.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
# end class FtpUserSetType


class SessionInputType:
    subclass = None
    def __init__(self, get=None, terminate=None):
        if get is None:
            self.get = []
        else:
            self.get = get
        if terminate is None:
            self.terminate = []
        else:
            self.terminate = terminate
    def factory(*args_, **kwargs_):
        if SessionInputType.subclass:
            return SessionInputType.subclass(*args_, **kwargs_)
        else:
            return SessionInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getTerminate(self): return self.terminate
    def setTerminate(self, value): self.terminate = value
    def addTerminate(self, value): self.terminate.append(value)
    def insertTerminate(self, index, value): self.terminate[index] = value
    def export(self, outfile, level, name_='SessionInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SessionInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SessionInputType'):
        for get_ in self.getGet():
            get_.export(outfile, level)
        for terminate_ in self.getTerminate():
            terminate_.export(outfile, level, name_='terminate')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = get.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'terminate':
            obj_ = SessionTerminateInput.factory()
            obj_.build(child_)
            self.terminate.append(obj_)
# end class SessionInputType


class SessionOutputType:
    subclass = None
    def __init__(self, get=None, terminate=None):
        if get is None:
            self.get = []
        else:
            self.get = get
        if terminate is None:
            self.terminate = []
        else:
            self.terminate = terminate
    def factory(*args_, **kwargs_):
        if SessionOutputType.subclass:
            return SessionOutputType.subclass(*args_, **kwargs_)
        else:
            return SessionOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getTerminate(self): return self.terminate
    def setTerminate(self, value): self.terminate = value
    def addTerminate(self, value): self.terminate.append(value)
    def insertTerminate(self, index, value): self.terminate[index] = value
    def export(self, outfile, level, name_='SessionOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SessionOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SessionOutputType'):
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for terminate_ in self.getTerminate():
            terminate_.export(outfile, level, name_='terminate')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = SessionGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'terminate':
            obj_ = SessionTerminateOutput.factory()
            obj_.build(child_)
            self.terminate.append(obj_)
# end class SessionOutputType


class SessionGetOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SessionGetOutputType.subclass:
            return SessionGetOutputType.subclass(*args_, **kwargs_)
        else:
            return SessionGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SessionGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SessionGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SessionGetOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SessionGetOutputType


class Session:
    subclass = None
    def __init__(self, id='', ttype='', ip_address='', login='', login_time='', idle=''):
        self.id = id
        self.ttype = ttype
        self.ip_address = ip_address
        self.login = login
        self.login_time = login_time
        self.idle = idle
    def factory(*args_, **kwargs_):
        if Session.subclass:
            return Session.subclass(*args_, **kwargs_)
        else:
            return Session(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getType(self): return self.ttype
    def setType(self, value): self.ttype = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getLogin_time(self): return self.login_time
    def setLogin_time(self, value): self.login_time = value
    def getIdle(self): return self.idle
    def setIdle(self, value): self.idle = value
    def export(self, outfile, level, name_='Session'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='Session'):
        pass
    def exportChildren(self, outfile, level, name_='Session'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<type>%s</type>\n' % quote_xml(self.getType()))
        showIndent(outfile, level)
        outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(self.getIp_address()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<login-time>%s</login-time>\n' % quote_xml(self.getLogin_time()))
        showIndent(outfile, level)
        outfile.write('<idle>%s</idle>\n' % quote_xml(self.getIdle()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'type':
            type_ = ''
            for text__content_ in child_.childNodes:
                type_ += text__content_.nodeValue
            self.ttype = type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login-time':
            login_time_ = ''
            for text__content_ in child_.childNodes:
                login_time_ += text__content_.nodeValue
            self.login_time = login_time_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idle':
            idle_ = ''
            for text__content_ in child_.childNodes:
                idle_ += text__content_.nodeValue
            self.idle = idle_
# end class Session


class SessionTerminateInput:
    subclass = None
    def __init__(self, session_id=''):
        self.session_id = session_id
    def factory(*args_, **kwargs_):
        if SessionTerminateInput.subclass:
            return SessionTerminateInput.subclass(*args_, **kwargs_)
        else:
            return SessionTerminateInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSession_id(self): return self.session_id
    def setSession_id(self, value): self.session_id = value
    def export(self, outfile, level, name_='SessionTerminateInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SessionTerminateInput'):
        pass
    def exportChildren(self, outfile, level, name_='SessionTerminateInput'):
        showIndent(outfile, level)
        outfile.write('<session-id>%s</session-id>\n' % quote_xml(self.getSession_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'session-id':
            session_id_ = ''
            for text__content_ in child_.childNodes:
                session_id_ += text__content_.nodeValue
            self.session_id = session_id_
# end class SessionTerminateInput


class SessionTerminateOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SessionTerminateOutput.subclass:
            return SessionTerminateOutput.subclass(*args_, **kwargs_)
        else:
            return SessionTerminateOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SessionTerminateOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SessionTerminateOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SessionTerminateOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SessionTerminateOutput


class AutoinstallerInputType:
    subclass = None
    def __init__(self, check=None, get_updates=None, get_components=None, install_component=None, update=None):
        if check is None:
            self.check = []
        else:
            self.check = check
        if get_updates is None:
            self.get_updates = []
        else:
            self.get_updates = get_updates
        if get_components is None:
            self.get_components = []
        else:
            self.get_components = get_components
        if install_component is None:
            self.install_component = []
        else:
            self.install_component = install_component
        if update is None:
            self.update = []
        else:
            self.update = update
    def factory(*args_, **kwargs_):
        if AutoinstallerInputType.subclass:
            return AutoinstallerInputType.subclass(*args_, **kwargs_)
        else:
            return AutoinstallerInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def getGet_updates(self): return self.get_updates
    def setGet_updates(self, value): self.get_updates = value
    def addGet_updates(self, value): self.get_updates.append(value)
    def insertGet_updates(self, index, value): self.get_updates[index] = value
    def getGet_components(self): return self.get_components
    def setGet_components(self, value): self.get_components = value
    def addGet_components(self, value): self.get_components.append(value)
    def insertGet_components(self, index, value): self.get_components[index] = value
    def getInstall_component(self): return self.install_component
    def setInstall_component(self, value): self.install_component = value
    def addInstall_component(self, value): self.install_component.append(value)
    def insertInstall_component(self, index, value): self.install_component[index] = value
    def getUpdate(self): return self.update
    def setUpdate(self, value): self.update = value
    def addUpdate(self, value): self.update.append(value)
    def insertUpdate(self, index, value): self.update[index] = value
    def export(self, outfile, level, name_='AutoinstallerInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AutoinstallerInputType'):
        pass
    def exportChildren(self, outfile, level, name_='AutoinstallerInputType'):
        for check_ in self.getCheck():
            showIndent(outfile, level)
            outfile.write('<check>%s</check>\n' % quote_xml(check_))
        for get_updates_ in self.getGet_updates():
            showIndent(outfile, level)
            outfile.write('<get-updates>%s</get-updates>\n' % quote_xml(get_updates_))
        for get_components_ in self.getGet_components():
            get_components_.export(outfile, level)
        for install_component_ in self.getInstall_component():
            install_component_.export(outfile, level)
        for update_ in self.getUpdate():
            update_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            check_ = ''
            for text__content_ in child_.childNodes:
                check_ += text__content_.nodeValue
            self.addCheck(check_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-updates':
            get_updates_ = ''
            for text__content_ in child_.childNodes:
                get_updates_ += text__content_.nodeValue
            self.addGet_updates(get_updates_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-components':
            obj_ = get_components.factory()
            obj_.build(child_)
            self.get_components.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install-component':
            obj_ = install_component.factory()
            obj_.build(child_)
            self.install_component.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'update':
            obj_ = update.factory()
            obj_.build(child_)
            self.update.append(obj_)
# end class AutoinstallerInputType


class AutoinstallerOutputType:
    subclass = None
    def __init__(self, check=None, get_updates=None, get_components=None, install_component=None, update=None):
        if check is None:
            self.check = []
        else:
            self.check = check
        if get_updates is None:
            self.get_updates = []
        else:
            self.get_updates = get_updates
        if get_components is None:
            self.get_components = []
        else:
            self.get_components = get_components
        if install_component is None:
            self.install_component = []
        else:
            self.install_component = install_component
        if update is None:
            self.update = []
        else:
            self.update = update
    def factory(*args_, **kwargs_):
        if AutoinstallerOutputType.subclass:
            return AutoinstallerOutputType.subclass(*args_, **kwargs_)
        else:
            return AutoinstallerOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCheck(self): return self.check
    def setCheck(self, value): self.check = value
    def addCheck(self, value): self.check.append(value)
    def insertCheck(self, index, value): self.check[index] = value
    def getGet_updates(self): return self.get_updates
    def setGet_updates(self, value): self.get_updates = value
    def addGet_updates(self, value): self.get_updates.append(value)
    def insertGet_updates(self, index, value): self.get_updates[index] = value
    def getGet_components(self): return self.get_components
    def setGet_components(self, value): self.get_components = value
    def addGet_components(self, value): self.get_components.append(value)
    def insertGet_components(self, index, value): self.get_components[index] = value
    def getInstall_component(self): return self.install_component
    def setInstall_component(self, value): self.install_component = value
    def addInstall_component(self, value): self.install_component.append(value)
    def insertInstall_component(self, index, value): self.install_component[index] = value
    def getUpdate(self): return self.update
    def setUpdate(self, value): self.update = value
    def addUpdate(self, value): self.update.append(value)
    def insertUpdate(self, index, value): self.update[index] = value
    def export(self, outfile, level, name_='AutoinstallerOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AutoinstallerOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='AutoinstallerOutputType'):
        for check_ in self.getCheck():
            check_.export(outfile, level, name_='check')
        for get_updates_ in self.getGet_updates():
            get_updates_.export(outfile, level, name_='get-updates')
        for get_components_ in self.getGet_components():
            get_components_.export(outfile, level, name_='get-components')
        for install_component_ in self.getInstall_component():
            install_component_.export(outfile, level, name_='install-component')
        for update_ in self.getUpdate():
            update_.export(outfile, level, name_='update')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'check':
            obj_ = UpdaterCheckOutputType.factory()
            obj_.build(child_)
            self.check.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-updates':
            obj_ = UpdaterGetUpdatesOutputType.factory()
            obj_.build(child_)
            self.get_updates.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-components':
            obj_ = UpdaterGetComponentsOutputType.factory()
            obj_.build(child_)
            self.get_components.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install-component':
            obj_ = UpdaterInstallComponentOutputType.factory()
            obj_.build(child_)
            self.install_component.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'update':
            obj_ = UpdaterUpdateOutputType.factory()
            obj_.build(child_)
            self.update.append(obj_)
# end class AutoinstallerOutputType


class ReleaseType:
    subclass = None
    def __init__(self, id='', action='', description=''):
        self.id = id
        self.action = action
        self.description = description
    def factory(*args_, **kwargs_):
        if ReleaseType.subclass:
            return ReleaseType.subclass(*args_, **kwargs_)
        else:
            return ReleaseType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getAction(self): return self.action
    def setAction(self, value): self.action = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def export(self, outfile, level, name_='ReleaseType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ReleaseType'):
        pass
    def exportChildren(self, outfile, level, name_='ReleaseType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<action>%s</action>\n' % quote_xml(self.getAction()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'action':
            action_ = ''
            for text__content_ in child_.childNodes:
                action_ += text__content_.nodeValue
            self.action = action_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
# end class ReleaseType


class UpdateType:
    subclass = None
    def __init__(self, id='', action='', description=''):
        self.id = id
        self.action = action
        self.description = description
    def factory(*args_, **kwargs_):
        if UpdateType.subclass:
            return UpdateType.subclass(*args_, **kwargs_)
        else:
            return UpdateType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getAction(self): return self.action
    def setAction(self, value): self.action = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def export(self, outfile, level, name_='UpdateType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdateType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdateType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<action>%s</action>\n' % quote_xml(self.getAction()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'action':
            action_ = ''
            for text__content_ in child_.childNodes:
                action_ += text__content_.nodeValue
            self.action = action_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
# end class UpdateType


class UpdaterCheckOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if UpdaterCheckOutputType.subclass:
            return UpdaterCheckOutputType.subclass(*args_, **kwargs_)
        else:
            return UpdaterCheckOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='UpdaterCheckOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdaterCheckOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdaterCheckOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class UpdaterCheckOutputType


class UpdaterGetUpdatesOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if UpdaterGetUpdatesOutputType.subclass:
            return UpdaterGetUpdatesOutputType.subclass(*args_, **kwargs_)
        else:
            return UpdaterGetUpdatesOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='UpdaterGetUpdatesOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdaterGetUpdatesOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdaterGetUpdatesOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class UpdaterGetUpdatesOutputType


class UpdaterGetComponentsOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if UpdaterGetComponentsOutputType.subclass:
            return UpdaterGetComponentsOutputType.subclass(*args_, **kwargs_)
        else:
            return UpdaterGetComponentsOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='UpdaterGetComponentsOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdaterGetComponentsOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdaterGetComponentsOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class UpdaterGetComponentsOutputType


class ComponentType:
    subclass = None
    def __init__(self, id='', action='', description='', server_build_time='', local_build_time='', server_version='', local_version=''):
        self.id = id
        self.action = action
        self.description = description
        self.server_build_time = server_build_time
        self.local_build_time = local_build_time
        self.server_version = server_version
        self.local_version = local_version
    def factory(*args_, **kwargs_):
        if ComponentType.subclass:
            return ComponentType.subclass(*args_, **kwargs_)
        else:
            return ComponentType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getAction(self): return self.action
    def setAction(self, value): self.action = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getServer_build_time(self): return self.server_build_time
    def setServer_build_time(self, value): self.server_build_time = value
    def getLocal_build_time(self): return self.local_build_time
    def setLocal_build_time(self, value): self.local_build_time = value
    def getServer_version(self): return self.server_version
    def setServer_version(self, value): self.server_version = value
    def getLocal_version(self): return self.local_version
    def setLocal_version(self, value): self.local_version = value
    def export(self, outfile, level, name_='ComponentType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ComponentType'):
        pass
    def exportChildren(self, outfile, level, name_='ComponentType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<action>%s</action>\n' % quote_xml(self.getAction()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        showIndent(outfile, level)
        outfile.write('<server-build-time>%s</server-build-time>\n' % quote_xml(self.getServer_build_time()))
        showIndent(outfile, level)
        outfile.write('<local-build-time>%s</local-build-time>\n' % quote_xml(self.getLocal_build_time()))
        showIndent(outfile, level)
        outfile.write('<server-version>%s</server-version>\n' % quote_xml(self.getServer_version()))
        showIndent(outfile, level)
        outfile.write('<local-version>%s</local-version>\n' % quote_xml(self.getLocal_version()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'action':
            action_ = ''
            for text__content_ in child_.childNodes:
                action_ += text__content_.nodeValue
            self.action = action_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server-build-time':
            server_build_time_ = ''
            for text__content_ in child_.childNodes:
                server_build_time_ += text__content_.nodeValue
            self.server_build_time = server_build_time_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local-build-time':
            local_build_time_ = ''
            for text__content_ in child_.childNodes:
                local_build_time_ += text__content_.nodeValue
            self.local_build_time = local_build_time_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server-version':
            server_version_ = ''
            for text__content_ in child_.childNodes:
                server_version_ += text__content_.nodeValue
            self.server_version = server_version_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local-version':
            local_version_ = ''
            for text__content_ in child_.childNodes:
                local_version_ += text__content_.nodeValue
            self.local_version = local_version_
# end class ComponentType


class UpdaterInstallComponentOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if UpdaterInstallComponentOutputType.subclass:
            return UpdaterInstallComponentOutputType.subclass(*args_, **kwargs_)
        else:
            return UpdaterInstallComponentOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='UpdaterInstallComponentOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdaterInstallComponentOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdaterInstallComponentOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class UpdaterInstallComponentOutputType


class UpdaterUpdateOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if UpdaterUpdateOutputType.subclass:
            return UpdaterUpdateOutputType.subclass(*args_, **kwargs_)
        else:
            return UpdaterUpdateOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='UpdaterUpdateOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='UpdaterUpdateOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='UpdaterUpdateOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class UpdaterUpdateOutputType


class LocaleInput:
    subclass = None
    def __init__(self, get=None, install=None, get_message=None, remove=None, enable=None, disable=None):
        if get is None:
            self.get = []
        else:
            self.get = get
        if install is None:
            self.install = []
        else:
            self.install = install
        if get_message is None:
            self.get_message = []
        else:
            self.get_message = get_message
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
    def factory(*args_, **kwargs_):
        if LocaleInput.subclass:
            return LocaleInput.subclass(*args_, **kwargs_)
        else:
            return LocaleInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getInstall(self): return self.install
    def setInstall(self, value): self.install = value
    def addInstall(self, value): self.install.append(value)
    def insertInstall(self, index, value): self.install[index] = value
    def getGet_message(self): return self.get_message
    def setGet_message(self, value): self.get_message = value
    def addGet_message(self, value): self.get_message.append(value)
    def insertGet_message(self, index, value): self.get_message[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def export(self, outfile, level, name_='LocaleInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleInput'):
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for install_ in self.getInstall():
            install_.export(outfile, level, name_='install')
        for get_message_ in self.getGet_message():
            get_message_.export(outfile, level, name_='get-message')
        for remove_ in self.getRemove():
            remove_.export(outfile, level, name_='remove')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = LocaleGetInput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install':
            obj_ = LocaleInstallInput.factory()
            obj_.build(child_)
            self.install.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-message':
            obj_ = LocaleGetMessageInput.factory()
            obj_.build(child_)
            self.get_message.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = LocaleRemoveInput.factory()
            obj_.build(child_)
            self.remove.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = LocaleEnableInput.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = LocaleDisableInput.factory()
            obj_.build(child_)
            self.disable.append(obj_)
# end class LocaleInput


class LocaleOutput:
    subclass = None
    def __init__(self, get=None, install=None, get_message=None, remove=None, enable=None, disable=None):
        if get is None:
            self.get = []
        else:
            self.get = get
        if install is None:
            self.install = []
        else:
            self.install = install
        if get_message is None:
            self.get_message = []
        else:
            self.get_message = get_message
        if remove is None:
            self.remove = []
        else:
            self.remove = remove
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
    def factory(*args_, **kwargs_):
        if LocaleOutput.subclass:
            return LocaleOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getInstall(self): return self.install
    def setInstall(self, value): self.install = value
    def addInstall(self, value): self.install.append(value)
    def insertInstall(self, index, value): self.install[index] = value
    def getGet_message(self): return self.get_message
    def setGet_message(self, value): self.get_message = value
    def addGet_message(self, value): self.get_message.append(value)
    def insertGet_message(self, index, value): self.get_message[index] = value
    def getRemove(self): return self.remove
    def setRemove(self, value): self.remove = value
    def addRemove(self, value): self.remove.append(value)
    def insertRemove(self, index, value): self.remove[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def export(self, outfile, level, name_='LocaleOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleOutput'):
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for install_ in self.getInstall():
            install_.export(outfile, level, name_='install')
        for get_message_ in self.getGet_message():
            get_message_.export(outfile, level, name_='get-message')
        for remove_ in self.getRemove():
            remove_.export(outfile, level, name_='remove')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = LocaleGetOutput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'install':
            obj_ = LocalInstallOutput.factory()
            obj_.build(child_)
            self.install.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-message':
            obj_ = LocaleGetMessageOutput.factory()
            obj_.build(child_)
            self.get_message.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove':
            obj_ = LocaleRemoveOutput.factory()
            obj_.build(child_)
            self.remove.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = LocaleEnableOutput.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = LocaleDisableOutput.factory()
            obj_.build(child_)
            self.disable.append(obj_)
# end class LocaleOutput


class LocaleGetInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LocaleGetInput.subclass:
            return LocaleGetInput.subclass(*args_, **kwargs_)
        else:
            return LocaleGetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LocaleGetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleGetInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleGetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = LocaleFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LocaleGetInput


class LocaleFilter:
    subclass = None
    def __init__(self, id=None):
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if LocaleFilter.subclass:
            return LocaleFilter.subclass(*args_, **kwargs_)
        else:
            return LocaleFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='LocaleFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleFilter'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleFilter'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class LocaleFilter


class LocaleGetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LocaleGetOutput.subclass:
            return LocaleGetOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleGetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LocaleGetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleGetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleGetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LocaleGetOutput


class LocaleInfo:
    subclass = None
    def __init__(self, id='', lang='', country='', used='', enabled=0):
        self.id = id
        self.lang = lang
        self.country = country
        self.used = used
        self.enabled = enabled
    def factory(*args_, **kwargs_):
        if LocaleInfo.subclass:
            return LocaleInfo.subclass(*args_, **kwargs_)
        else:
            return LocaleInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getLang(self): return self.lang
    def setLang(self, value): self.lang = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getUsed(self): return self.used
    def setUsed(self, value): self.used = value
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def export(self, outfile, level, name_='LocaleInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleInfo'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleInfo'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<lang>%s</lang>\n' % quote_xml(self.getLang()))
        showIndent(outfile, level)
        outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        showIndent(outfile, level)
        outfile.write('<used>%s</used>\n' % quote_xml(self.getUsed()))
        showIndent(outfile, level)
        outfile.write('<enabled>%d</enabled>\n' % self.getEnabled())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'lang':
            lang_ = ''
            for text__content_ in child_.childNodes:
                lang_ += text__content_.nodeValue
            self.lang = lang_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'used':
            used_ = ''
            for text__content_ in child_.childNodes:
                used_ += text__content_.nodeValue
            self.used = used_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.enabled = ival_
# end class LocaleInfo


class LocaleInstallInput:
    subclass = None
    def __init__(self, filename=''):
        self.filename = filename
    def factory(*args_, **kwargs_):
        if LocaleInstallInput.subclass:
            return LocaleInstallInput.subclass(*args_, **kwargs_)
        else:
            return LocaleInstallInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilename(self): return self.filename
    def setFilename(self, value): self.filename = value
    def export(self, outfile, level, name_='LocaleInstallInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleInstallInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleInstallInput'):
        showIndent(outfile, level)
        outfile.write('<filename>%s</filename>\n' % quote_xml(self.getFilename()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filename':
            filename_ = ''
            for text__content_ in child_.childNodes:
                filename_ += text__content_.nodeValue
            self.filename = filename_
# end class LocaleInstallInput


class LocalInstallOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if LocalInstallOutput.subclass:
            return LocalInstallOutput.subclass(*args_, **kwargs_)
        else:
            return LocalInstallOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='LocalInstallOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocalInstallOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocalInstallOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class LocalInstallOutput


class LocaleGetMessageInput:
    subclass = None
    def __init__(self, filter=None, id=''):
        self.filter = filter
        self.id = id
    def factory(*args_, **kwargs_):
        if LocaleGetMessageInput.subclass:
            return LocaleGetMessageInput.subclass(*args_, **kwargs_)
        else:
            return LocaleGetMessageInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='LocaleGetMessageInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleGetMessageInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleGetMessageInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = LocaleGetMessageFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
# end class LocaleGetMessageInput


class LocaleGetMessageFilter:
    subclass = None
    def __init__(self, key=None):
        if key is None:
            self.key = []
        else:
            self.key = key
    def factory(*args_, **kwargs_):
        if LocaleGetMessageFilter.subclass:
            return LocaleGetMessageFilter.subclass(*args_, **kwargs_)
        else:
            return LocaleGetMessageFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getKey(self): return self.key
    def setKey(self, value): self.key = value
    def addKey(self, value): self.key.append(value)
    def insertKey(self, index, value): self.key[index] = value
    def export(self, outfile, level, name_='LocaleGetMessageFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleGetMessageFilter'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleGetMessageFilter'):
        for key_ in self.getKey():
            showIndent(outfile, level)
            outfile.write('<key>%s</key>\n' % quote_xml(key_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'key':
            key_ = ''
            for text__content_ in child_.childNodes:
                key_ += text__content_.nodeValue
            self.addKey(key_)
# end class LocaleGetMessageFilter


class LocaleGetMessageOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LocaleGetMessageOutput.subclass:
            return LocaleGetMessageOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleGetMessageOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LocaleGetMessageOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleGetMessageOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleGetMessageOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = LocaleMessageResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LocaleGetMessageOutput


class LocaleDownloadInput:
    subclass = None
    def __init__(self, id=''):
        self.id = id
    def factory(*args_, **kwargs_):
        if LocaleDownloadInput.subclass:
            return LocaleDownloadInput.subclass(*args_, **kwargs_)
        else:
            return LocaleDownloadInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='LocaleDownloadInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleDownloadInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleDownloadInput'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
# end class LocaleDownloadInput


class LocaleDownloadOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if LocaleDownloadOutput.subclass:
            return LocaleDownloadOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleDownloadOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='LocaleDownloadOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleDownloadOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleDownloadOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class LocaleDownloadOutput


class LocaleRemoveInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LocaleRemoveInput.subclass:
            return LocaleRemoveInput.subclass(*args_, **kwargs_)
        else:
            return LocaleRemoveInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LocaleRemoveInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleRemoveInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleRemoveInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = LocaleFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LocaleRemoveInput


class LocaleRemoveOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LocaleRemoveOutput.subclass:
            return LocaleRemoveOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleRemoveOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LocaleRemoveOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleRemoveOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleRemoveOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = LocaleResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LocaleRemoveOutput


class LocaleEnableInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LocaleEnableInput.subclass:
            return LocaleEnableInput.subclass(*args_, **kwargs_)
        else:
            return LocaleEnableInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LocaleEnableInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleEnableInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleEnableInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = LocaleFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LocaleEnableInput


class LocaleEnableOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LocaleEnableOutput.subclass:
            return LocaleEnableOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleEnableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LocaleEnableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleEnableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleEnableOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = LocaleResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LocaleEnableOutput


class LocaleDisableInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LocaleDisableInput.subclass:
            return LocaleDisableInput.subclass(*args_, **kwargs_)
        else:
            return LocaleDisableInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LocaleDisableInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleDisableInput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleDisableInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = LocaleFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LocaleDisableInput


class LocaleDisableOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LocaleDisableOutput.subclass:
            return LocaleDisableOutput.subclass(*args_, **kwargs_)
        else:
            return LocaleDisableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LocaleDisableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleDisableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LocaleDisableOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = LocaleResultType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LocaleDisableOutput


class LocaleResultType(resultType):
    subclass = None
    def __init__(self, filter_id=None, id=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.filter_id = filter_id
        self.id = id
    def factory(*args_, **kwargs_):
        if LocaleResultType.subclass:
            return LocaleResultType.subclass(*args_, **kwargs_)
        else:
            return LocaleResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter_id(self): return self.filter_id
    def setFilter_id(self, value): self.filter_id = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def export(self, outfile, level, name_='LocaleResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleResultType'):
        resultType.exportAttributes(self, outfile, level, name_='LocaleResultType')
    def exportChildren(self, outfile, level, name_='LocaleResultType'):
        if self.filter_id is not None:
            showIndent(outfile, level)
            outfile.write('<filter-id>%s</filter-id>\n' % quote_xml(self.getFilter_id()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter-id':
            filter_id_ = ''
            for text__content_ in child_.childNodes:
                filter_id_ += text__content_.nodeValue
            self.filter_id = filter_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        resultType.buildChildren(self, child_, nodeName_)
# end class LocaleResultType


class LocaleMessageResultType(resultType):
    subclass = None
    def __init__(self, filter_id=None, id=None, message=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.filter_id = filter_id
        self.id = id
        self.message = message
    def factory(*args_, **kwargs_):
        if LocaleMessageResultType.subclass:
            return LocaleMessageResultType.subclass(*args_, **kwargs_)
        else:
            return LocaleMessageResultType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter_id(self): return self.filter_id
    def setFilter_id(self, value): self.filter_id = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getMessage(self): return self.message
    def setMessage(self, value): self.message = value
    def export(self, outfile, level, name_='LocaleMessageResultType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LocaleMessageResultType'):
        resultType.exportAttributes(self, outfile, level, name_='LocaleMessageResultType')
    def exportChildren(self, outfile, level, name_='LocaleMessageResultType'):
        if self.filter_id is not None:
            showIndent(outfile, level)
            outfile.write('<filter-id>%s</filter-id>\n' % quote_xml(self.getFilter_id()))
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        if self.message is not None:
            showIndent(outfile, level)
            outfile.write('<message>%s</message>\n' % quote_xml(self.getMessage()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter-id':
            filter_id_ = ''
            for text__content_ in child_.childNodes:
                filter_id_ += text__content_.nodeValue
            self.filter_id = filter_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'message':
            message_ = ''
            for text__content_ in child_.childNodes:
                message_ += text__content_.nodeValue
            self.message = message_
        resultType.buildChildren(self, child_, nodeName_)
# end class LocaleMessageResultType


class LogRotationInput:
    subclass = None
    def __init__(self, set=None, get=None, enable=None, disable=None, get_status=None):
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
    def factory(*args_, **kwargs_):
        if LogRotationInput.subclass:
            return LogRotationInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def export(self, outfile, level, name_='LogRotationInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationInput'):
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get-status')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = LogRotationSetInput.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = LogRotationGetInput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = LogRotationEnableInput.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = LogRotationDisableInput.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status':
            obj_ = LogRotationGetStatusInput.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
# end class LogRotationInput


class LogRotationOutput:
    subclass = None
    def __init__(self, set=None, get=None, enable=None, disable=None, get_status=None):
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if get_status is None:
            self.get_status = []
        else:
            self.get_status = get_status
    def factory(*args_, **kwargs_):
        if LogRotationOutput.subclass:
            return LogRotationOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getGet_status(self): return self.get_status
    def setGet_status(self, value): self.get_status = value
    def addGet_status(self, value): self.get_status.append(value)
    def insertGet_status(self, index, value): self.get_status[index] = value
    def export(self, outfile, level, name_='LogRotationOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationOutput'):
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for get_status_ in self.getGet_status():
            get_status_.export(outfile, level, name_='get-status')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = LogRotationSetOutput.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = LogRotationGetOutput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = LogRotationEnableOutput.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = LogRotationDisableOutput.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-status':
            obj_ = LogRotationGetStatusOutput.factory()
            obj_.build(child_)
            self.get_status.append(obj_)
# end class LogRotationOutput


class LogRotationSetInput:
    subclass = None
    def __init__(self, filter=None, settings=None):
        self.filter = filter
        self.settings = settings
    def factory(*args_, **kwargs_):
        if LogRotationSetInput.subclass:
            return LogRotationSetInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationSetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getSettings(self): return self.settings
    def setSettings(self, value): self.settings = value
    def export(self, outfile, level, name_='LogRotationSetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationSetInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationSetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.settings is not None:
            self.settings.export(outfile, level, name_='settings')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = logRotationFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'settings':
            obj_ = LogRotationSettingsType.factory()
            obj_.build(child_)
            self.setSettings(obj_)
# end class LogRotationSetInput


class LogRotationSettingsType:
    subclass = None
    def __init__(self, log_condition=None, log_max_num_files=None, log_compress=None, log_email=None):
        self.log_condition = log_condition
        self.log_max_num_files = log_max_num_files
        self.log_compress = log_compress
        self.log_email = log_email
    def factory(*args_, **kwargs_):
        if LogRotationSettingsType.subclass:
            return LogRotationSettingsType.subclass(*args_, **kwargs_)
        else:
            return LogRotationSettingsType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getLog_condition(self): return self.log_condition
    def setLog_condition(self, value): self.log_condition = value
    def getLog_max_num_files(self): return self.log_max_num_files
    def setLog_max_num_files(self, value): self.log_max_num_files = value
    def getLog_compress(self): return self.log_compress
    def setLog_compress(self, value): self.log_compress = value
    def getLog_email(self): return self.log_email
    def setLog_email(self, value): self.log_email = value
    def export(self, outfile, level, name_='LogRotationSettingsType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationSettingsType'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationSettingsType'):
        if self.log_condition is not None:
            self.log_condition.export(outfile, level, name_='log-condition')
        if self.log_max_num_files is not None:
            showIndent(outfile, level)
            outfile.write('<log-max-num-files>%s</log-max-num-files>\n' % quote_xml(self.getLog_max_num_files()))
        if self.log_compress is not None:
            showIndent(outfile, level)
            outfile.write('<log-compress>%s</log-compress>\n' % quote_xml(self.getLog_compress()))
        if self.log_email is not None:
            showIndent(outfile, level)
            outfile.write('<log-email>%s</log-email>\n' % quote_xml(self.getLog_email()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-condition':
            obj_ = LogRotationConditionType.factory()
            obj_.build(child_)
            self.setLog_condition(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-max-num-files':
            log_max_num_files_ = ''
            for text__content_ in child_.childNodes:
                log_max_num_files_ += text__content_.nodeValue
            self.log_max_num_files = log_max_num_files_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-compress':
            log_compress_ = ''
            for text__content_ in child_.childNodes:
                log_compress_ += text__content_.nodeValue
            self.log_compress = log_compress_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-email':
            log_email_ = ''
            for text__content_ in child_.childNodes:
                log_email_ += text__content_.nodeValue
            self.log_email = log_email_
# end class LogRotationSettingsType


class LogRotationConditionType:
    subclass = None
    def __init__(self, log_bysize=None, log_bytime=None):
        self.log_bysize = log_bysize
        self.log_bytime = log_bytime
    def factory(*args_, **kwargs_):
        if LogRotationConditionType.subclass:
            return LogRotationConditionType.subclass(*args_, **kwargs_)
        else:
            return LogRotationConditionType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getLog_bysize(self): return self.log_bysize
    def setLog_bysize(self, value): self.log_bysize = value
    def getLog_bytime(self): return self.log_bytime
    def setLog_bytime(self, value): self.log_bytime = value
    def export(self, outfile, level, name_='LogRotationConditionType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationConditionType'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationConditionType'):
        if self.log_bysize is not None:
            showIndent(outfile, level)
            outfile.write('<log-bysize>%s</log-bysize>\n' % quote_xml(self.getLog_bysize()))
        if self.log_bytime is not None:
            showIndent(outfile, level)
            outfile.write('<log-bytime>%s</log-bytime>\n' % quote_xml(self.getLog_bytime()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-bysize':
            log_bysize_ = ''
            for text__content_ in child_.childNodes:
                log_bysize_ += text__content_.nodeValue
            self.log_bysize = log_bysize_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-bytime':
            log_bytime_ = ''
            for text__content_ in child_.childNodes:
                log_bytime_ += text__content_.nodeValue
            self.log_bytime = log_bytime_
# end class LogRotationConditionType


class logRotationFilterType:
    subclass = None
    def __init__(self, domain_id=None, owner_id=None, domain_name=None, owner_login=None):
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if owner_id is None:
            self.owner_id = []
        else:
            self.owner_id = owner_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
        if owner_login is None:
            self.owner_login = []
        else:
            self.owner_login = owner_login
    def factory(*args_, **kwargs_):
        if logRotationFilterType.subclass:
            return logRotationFilterType.subclass(*args_, **kwargs_)
        else:
            return logRotationFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getOwner_id(self): return self.owner_id
    def setOwner_id(self, value): self.owner_id = value
    def addOwner_id(self, value): self.owner_id.append(value)
    def insertOwner_id(self, index, value): self.owner_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def getOwner_login(self): return self.owner_login
    def setOwner_login(self, value): self.owner_login = value
    def addOwner_login(self, value): self.owner_login.append(value)
    def insertOwner_login(self, index, value): self.owner_login[index] = value
    def export(self, outfile, level, name_='logRotationFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='logRotationFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='logRotationFilterType'):
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for owner_id_ in self.getOwner_id():
            showIndent(outfile, level)
            outfile.write('<owner-id>%s</owner-id>\n' % quote_xml(owner_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
        for owner_login_ in self.getOwner_login():
            showIndent(outfile, level)
            outfile.write('<owner-login>%s</owner-login>\n' % quote_xml(owner_login_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-id':
            owner_id_ = ''
            for text__content_ in child_.childNodes:
                owner_id_ += text__content_.nodeValue
            self.addOwner_id(owner_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'owner-login':
            owner_login_ = ''
            for text__content_ in child_.childNodes:
                owner_login_ += text__content_.nodeValue
            self.addOwner_login(owner_login_)
# end class logRotationFilterType


class LogRotationGetInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LogRotationGetInput.subclass:
            return LogRotationGetInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationGetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LogRotationGetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationGetInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationGetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = logRotationFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LogRotationGetInput


class LogRotationEnableInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LogRotationEnableInput.subclass:
            return LogRotationEnableInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationEnableInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LogRotationEnableInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationEnableInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationEnableInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = logRotationFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LogRotationEnableInput


class LogRotationDisableInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LogRotationDisableInput.subclass:
            return LogRotationDisableInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationDisableInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LogRotationDisableInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationDisableInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationDisableInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = logRotationFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LogRotationDisableInput


class LogRotationSetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LogRotationSetOutput.subclass:
            return LogRotationSetOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationSetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LogRotationSetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationSetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationSetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LogRotationSetOutput


class LogRotationGetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LogRotationGetOutput.subclass:
            return LogRotationGetOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationGetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LogRotationGetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationGetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationGetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LogRotationGetOutput


class LogRotationEnableOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LogRotationEnableOutput.subclass:
            return LogRotationEnableOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationEnableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LogRotationEnableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationEnableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationEnableOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LogRotationEnableOutput


class LogRotationDisableOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LogRotationDisableOutput.subclass:
            return LogRotationDisableOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationDisableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LogRotationDisableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationDisableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationDisableOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LogRotationDisableOutput


class LogRotationGetStatusInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if LogRotationGetStatusInput.subclass:
            return LogRotationGetStatusInput.subclass(*args_, **kwargs_)
        else:
            return LogRotationGetStatusInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='LogRotationGetStatusInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationGetStatusInput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationGetStatusInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = logRotationFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class LogRotationGetStatusInput


class LogRotationGetStatusOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if LogRotationGetStatusOutput.subclass:
            return LogRotationGetStatusOutput.subclass(*args_, **kwargs_)
        else:
            return LogRotationGetStatusOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='LogRotationGetStatusOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='LogRotationGetStatusOutput'):
        pass
    def exportChildren(self, outfile, level, name_='LogRotationGetStatusOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class LogRotationGetStatusOutput


class BackupInputType:
    subclass = None
    def __init__(self, get_remote_storage_settings=None, set_remote_storage_settings=None, backup_domain=None, backup_client=None, backup_reseller=None, backup_server=None, get_tasks_info=None, get_local_backup_list=None, import_file=None, download_file=None, get_supported_protocols=None, stop_backup=None, remove_file=None):
        if get_remote_storage_settings is None:
            self.get_remote_storage_settings = []
        else:
            self.get_remote_storage_settings = get_remote_storage_settings
        if set_remote_storage_settings is None:
            self.set_remote_storage_settings = []
        else:
            self.set_remote_storage_settings = set_remote_storage_settings
        if backup_domain is None:
            self.backup_domain = []
        else:
            self.backup_domain = backup_domain
        if backup_client is None:
            self.backup_client = []
        else:
            self.backup_client = backup_client
        if backup_reseller is None:
            self.backup_reseller = []
        else:
            self.backup_reseller = backup_reseller
        if backup_server is None:
            self.backup_server = []
        else:
            self.backup_server = backup_server
        if get_tasks_info is None:
            self.get_tasks_info = []
        else:
            self.get_tasks_info = get_tasks_info
        if get_local_backup_list is None:
            self.get_local_backup_list = []
        else:
            self.get_local_backup_list = get_local_backup_list
        if import_file is None:
            self.import_file = []
        else:
            self.import_file = import_file
        if download_file is None:
            self.download_file = []
        else:
            self.download_file = download_file
        if get_supported_protocols is None:
            self.get_supported_protocols = []
        else:
            self.get_supported_protocols = get_supported_protocols
        if stop_backup is None:
            self.stop_backup = []
        else:
            self.stop_backup = stop_backup
        if remove_file is None:
            self.remove_file = []
        else:
            self.remove_file = remove_file
    def factory(*args_, **kwargs_):
        if BackupInputType.subclass:
            return BackupInputType.subclass(*args_, **kwargs_)
        else:
            return BackupInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet_remote_storage_settings(self): return self.get_remote_storage_settings
    def setGet_remote_storage_settings(self, value): self.get_remote_storage_settings = value
    def addGet_remote_storage_settings(self, value): self.get_remote_storage_settings.append(value)
    def insertGet_remote_storage_settings(self, index, value): self.get_remote_storage_settings[index] = value
    def getSet_remote_storage_settings(self): return self.set_remote_storage_settings
    def setSet_remote_storage_settings(self, value): self.set_remote_storage_settings = value
    def addSet_remote_storage_settings(self, value): self.set_remote_storage_settings.append(value)
    def insertSet_remote_storage_settings(self, index, value): self.set_remote_storage_settings[index] = value
    def getBackup_domain(self): return self.backup_domain
    def setBackup_domain(self, value): self.backup_domain = value
    def addBackup_domain(self, value): self.backup_domain.append(value)
    def insertBackup_domain(self, index, value): self.backup_domain[index] = value
    def getBackup_client(self): return self.backup_client
    def setBackup_client(self, value): self.backup_client = value
    def addBackup_client(self, value): self.backup_client.append(value)
    def insertBackup_client(self, index, value): self.backup_client[index] = value
    def getBackup_reseller(self): return self.backup_reseller
    def setBackup_reseller(self, value): self.backup_reseller = value
    def addBackup_reseller(self, value): self.backup_reseller.append(value)
    def insertBackup_reseller(self, index, value): self.backup_reseller[index] = value
    def getBackup_server(self): return self.backup_server
    def setBackup_server(self, value): self.backup_server = value
    def addBackup_server(self, value): self.backup_server.append(value)
    def insertBackup_server(self, index, value): self.backup_server[index] = value
    def getGet_tasks_info(self): return self.get_tasks_info
    def setGet_tasks_info(self, value): self.get_tasks_info = value
    def addGet_tasks_info(self, value): self.get_tasks_info.append(value)
    def insertGet_tasks_info(self, index, value): self.get_tasks_info[index] = value
    def getGet_local_backup_list(self): return self.get_local_backup_list
    def setGet_local_backup_list(self, value): self.get_local_backup_list = value
    def addGet_local_backup_list(self, value): self.get_local_backup_list.append(value)
    def insertGet_local_backup_list(self, index, value): self.get_local_backup_list[index] = value
    def getImport_file(self): return self.import_file
    def setImport_file(self, value): self.import_file = value
    def addImport_file(self, value): self.import_file.append(value)
    def insertImport_file(self, index, value): self.import_file[index] = value
    def getDownload_file(self): return self.download_file
    def setDownload_file(self, value): self.download_file = value
    def addDownload_file(self, value): self.download_file.append(value)
    def insertDownload_file(self, index, value): self.download_file[index] = value
    def getGet_supported_protocols(self): return self.get_supported_protocols
    def setGet_supported_protocols(self, value): self.get_supported_protocols = value
    def addGet_supported_protocols(self, value): self.get_supported_protocols.append(value)
    def insertGet_supported_protocols(self, index, value): self.get_supported_protocols[index] = value
    def getStop_backup(self): return self.stop_backup
    def setStop_backup(self, value): self.stop_backup = value
    def addStop_backup(self, value): self.stop_backup.append(value)
    def insertStop_backup(self, index, value): self.stop_backup[index] = value
    def getRemove_file(self): return self.remove_file
    def setRemove_file(self, value): self.remove_file = value
    def addRemove_file(self, value): self.remove_file.append(value)
    def insertRemove_file(self, index, value): self.remove_file[index] = value
    def export(self, outfile, level, name_='BackupInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupInputType'):
        pass
    def exportChildren(self, outfile, level, name_='BackupInputType'):
        for get_remote_storage_settings_ in self.getGet_remote_storage_settings():
            get_remote_storage_settings_.export(outfile, level, name_='get-remote-storage-settings')
        for set_remote_storage_settings_ in self.getSet_remote_storage_settings():
            set_remote_storage_settings_.export(outfile, level, name_='set-remote-storage-settings')
        for backup_domain_ in self.getBackup_domain():
            backup_domain_.export(outfile, level, name_='backup-domain')
        for backup_client_ in self.getBackup_client():
            backup_client_.export(outfile, level, name_='backup-client')
        for backup_reseller_ in self.getBackup_reseller():
            backup_reseller_.export(outfile, level, name_='backup-reseller')
        for backup_server_ in self.getBackup_server():
            backup_server_.export(outfile, level, name_='backup-server')
        for get_tasks_info_ in self.getGet_tasks_info():
            get_tasks_info_.export(outfile, level, name_='get-tasks-info')
        for get_local_backup_list_ in self.getGet_local_backup_list():
            get_local_backup_list_.export(outfile, level, name_='get-local-backup-list')
        for import_file_ in self.getImport_file():
            import_file_.export(outfile, level, name_='import-file')
        for download_file_ in self.getDownload_file():
            download_file_.export(outfile, level, name_='download-file')
        for get_supported_protocols_ in self.getGet_supported_protocols():
            get_supported_protocols_.export(outfile, level, name_='get-supported-protocols')
        for stop_backup_ in self.getStop_backup():
            stop_backup_.export(outfile, level, name_='stop-backup')
        for remove_file_ in self.getRemove_file():
            remove_file_.export(outfile, level, name_='remove-file')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-remote-storage-settings':
            obj_ = BackupGetRemoteStorageSettingsInput.factory()
            obj_.build(child_)
            self.get_remote_storage_settings.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-remote-storage-settings':
            obj_ = BackupSetRemoteStorageInput.factory()
            obj_.build(child_)
            self.set_remote_storage_settings.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-domain':
            obj_ = BackupDomainInput.factory()
            obj_.build(child_)
            self.backup_domain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-client':
            obj_ = BackupClientInput.factory()
            obj_.build(child_)
            self.backup_client.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-reseller':
            obj_ = BackupResellerInput.factory()
            obj_.build(child_)
            self.backup_reseller.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-server':
            obj_ = BackupServerInput.factory()
            obj_.build(child_)
            self.backup_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-tasks-info':
            obj_ = BackupGetBackupStatusInput.factory()
            obj_.build(child_)
            self.get_tasks_info.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-local-backup-list':
            obj_ = BackupGetLocalBackupListInput.factory()
            obj_.build(child_)
            self.get_local_backup_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'import-file':
            obj_ = BackupImportFileInput.factory()
            obj_.build(child_)
            self.import_file.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'download-file':
            obj_ = BackupDownloadFileInput.factory()
            obj_.build(child_)
            self.download_file.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-protocols':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.get_supported_protocols.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stop-backup':
            obj_ = BackupStopInput.factory()
            obj_.build(child_)
            self.stop_backup.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove-file':
            obj_ = BackupRemoveFileInput.factory()
            obj_.build(child_)
            self.remove_file.append(obj_)
# end class BackupInputType


class BackupOutputType:
    subclass = None
    def __init__(self, get_remote_storage_settings=None, set_remote_storage_settings=None, backup_server=None, backup_reseller=None, backup_domain=None, backup_client=None, get_tasks_info=None, get_local_backup_list=None, import_file=None, download_file=None, get_supported_protocols=None, stop_backup=None, remove_file=None):
        if get_remote_storage_settings is None:
            self.get_remote_storage_settings = []
        else:
            self.get_remote_storage_settings = get_remote_storage_settings
        if set_remote_storage_settings is None:
            self.set_remote_storage_settings = []
        else:
            self.set_remote_storage_settings = set_remote_storage_settings
        if backup_server is None:
            self.backup_server = []
        else:
            self.backup_server = backup_server
        if backup_reseller is None:
            self.backup_reseller = []
        else:
            self.backup_reseller = backup_reseller
        if backup_domain is None:
            self.backup_domain = []
        else:
            self.backup_domain = backup_domain
        if backup_client is None:
            self.backup_client = []
        else:
            self.backup_client = backup_client
        if get_tasks_info is None:
            self.get_tasks_info = []
        else:
            self.get_tasks_info = get_tasks_info
        if get_local_backup_list is None:
            self.get_local_backup_list = []
        else:
            self.get_local_backup_list = get_local_backup_list
        if import_file is None:
            self.import_file = []
        else:
            self.import_file = import_file
        if download_file is None:
            self.download_file = []
        else:
            self.download_file = download_file
        if get_supported_protocols is None:
            self.get_supported_protocols = []
        else:
            self.get_supported_protocols = get_supported_protocols
        if stop_backup is None:
            self.stop_backup = []
        else:
            self.stop_backup = stop_backup
        if remove_file is None:
            self.remove_file = []
        else:
            self.remove_file = remove_file
    def factory(*args_, **kwargs_):
        if BackupOutputType.subclass:
            return BackupOutputType.subclass(*args_, **kwargs_)
        else:
            return BackupOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGet_remote_storage_settings(self): return self.get_remote_storage_settings
    def setGet_remote_storage_settings(self, value): self.get_remote_storage_settings = value
    def addGet_remote_storage_settings(self, value): self.get_remote_storage_settings.append(value)
    def insertGet_remote_storage_settings(self, index, value): self.get_remote_storage_settings[index] = value
    def getSet_remote_storage_settings(self): return self.set_remote_storage_settings
    def setSet_remote_storage_settings(self, value): self.set_remote_storage_settings = value
    def addSet_remote_storage_settings(self, value): self.set_remote_storage_settings.append(value)
    def insertSet_remote_storage_settings(self, index, value): self.set_remote_storage_settings[index] = value
    def getBackup_server(self): return self.backup_server
    def setBackup_server(self, value): self.backup_server = value
    def addBackup_server(self, value): self.backup_server.append(value)
    def insertBackup_server(self, index, value): self.backup_server[index] = value
    def getBackup_reseller(self): return self.backup_reseller
    def setBackup_reseller(self, value): self.backup_reseller = value
    def addBackup_reseller(self, value): self.backup_reseller.append(value)
    def insertBackup_reseller(self, index, value): self.backup_reseller[index] = value
    def getBackup_domain(self): return self.backup_domain
    def setBackup_domain(self, value): self.backup_domain = value
    def addBackup_domain(self, value): self.backup_domain.append(value)
    def insertBackup_domain(self, index, value): self.backup_domain[index] = value
    def getBackup_client(self): return self.backup_client
    def setBackup_client(self, value): self.backup_client = value
    def addBackup_client(self, value): self.backup_client.append(value)
    def insertBackup_client(self, index, value): self.backup_client[index] = value
    def getGet_tasks_info(self): return self.get_tasks_info
    def setGet_tasks_info(self, value): self.get_tasks_info = value
    def addGet_tasks_info(self, value): self.get_tasks_info.append(value)
    def insertGet_tasks_info(self, index, value): self.get_tasks_info[index] = value
    def getGet_local_backup_list(self): return self.get_local_backup_list
    def setGet_local_backup_list(self, value): self.get_local_backup_list = value
    def addGet_local_backup_list(self, value): self.get_local_backup_list.append(value)
    def insertGet_local_backup_list(self, index, value): self.get_local_backup_list[index] = value
    def getImport_file(self): return self.import_file
    def setImport_file(self, value): self.import_file = value
    def addImport_file(self, value): self.import_file.append(value)
    def insertImport_file(self, index, value): self.import_file[index] = value
    def getDownload_file(self): return self.download_file
    def setDownload_file(self, value): self.download_file = value
    def addDownload_file(self, value): self.download_file.append(value)
    def insertDownload_file(self, index, value): self.download_file[index] = value
    def getGet_supported_protocols(self): return self.get_supported_protocols
    def setGet_supported_protocols(self, value): self.get_supported_protocols = value
    def addGet_supported_protocols(self, value): self.get_supported_protocols.append(value)
    def insertGet_supported_protocols(self, index, value): self.get_supported_protocols[index] = value
    def getStop_backup(self): return self.stop_backup
    def setStop_backup(self, value): self.stop_backup = value
    def addStop_backup(self, value): self.stop_backup.append(value)
    def insertStop_backup(self, index, value): self.stop_backup[index] = value
    def getRemove_file(self): return self.remove_file
    def setRemove_file(self, value): self.remove_file = value
    def addRemove_file(self, value): self.remove_file.append(value)
    def insertRemove_file(self, index, value): self.remove_file[index] = value
    def export(self, outfile, level, name_='BackupOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='BackupOutputType'):
        for get_remote_storage_settings_ in self.getGet_remote_storage_settings():
            get_remote_storage_settings_.export(outfile, level, name_='get-remote-storage-settings')
        for set_remote_storage_settings_ in self.getSet_remote_storage_settings():
            set_remote_storage_settings_.export(outfile, level, name_='set-remote-storage-settings')
        for backup_server_ in self.getBackup_server():
            backup_server_.export(outfile, level, name_='backup-server')
        for backup_reseller_ in self.getBackup_reseller():
            backup_reseller_.export(outfile, level, name_='backup-reseller')
        for backup_domain_ in self.getBackup_domain():
            backup_domain_.export(outfile, level, name_='backup-domain')
        for backup_client_ in self.getBackup_client():
            backup_client_.export(outfile, level, name_='backup-client')
        for get_tasks_info_ in self.getGet_tasks_info():
            get_tasks_info_.export(outfile, level, name_='get-tasks-info')
        for get_local_backup_list_ in self.getGet_local_backup_list():
            get_local_backup_list_.export(outfile, level, name_='get-local-backup-list')
        for import_file_ in self.getImport_file():
            import_file_.export(outfile, level, name_='import-file')
        for download_file_ in self.getDownload_file():
            download_file_.export(outfile, level, name_='download-file')
        for get_supported_protocols_ in self.getGet_supported_protocols():
            get_supported_protocols_.export(outfile, level, name_='get-supported-protocols')
        for stop_backup_ in self.getStop_backup():
            stop_backup_.export(outfile, level, name_='stop-backup')
        for remove_file_ in self.getRemove_file():
            remove_file_.export(outfile, level, name_='remove-file')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-remote-storage-settings':
            obj_ = BackupGetRemoteStorageSettingsOutput.factory()
            obj_.build(child_)
            self.get_remote_storage_settings.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-remote-storage-settings':
            obj_ = BackupSetRemoteStorageSettingsOutput.factory()
            obj_.build(child_)
            self.set_remote_storage_settings.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-server':
            obj_ = BackupCommandOutput.factory()
            obj_.build(child_)
            self.backup_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-reseller':
            obj_ = BackupCommandOutput.factory()
            obj_.build(child_)
            self.backup_reseller.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-domain':
            obj_ = BackupCommandOutput.factory()
            obj_.build(child_)
            self.backup_domain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-client':
            obj_ = BackupCommandOutput.factory()
            obj_.build(child_)
            self.backup_client.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-tasks-info':
            obj_ = BackupGetBackupStatusOutput.factory()
            obj_.build(child_)
            self.get_tasks_info.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-local-backup-list':
            obj_ = BackupGetLocalBackupListOutput.factory()
            obj_.build(child_)
            self.get_local_backup_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'import-file':
            obj_ = BackupImportFileOutput.factory()
            obj_.build(child_)
            self.import_file.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'download-file':
            obj_ = BackupDownloadFileOutput.factory()
            obj_.build(child_)
            self.download_file.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-supported-protocols':
            obj_ = BackupGetSupportedProtocolsOutput.factory()
            obj_.build(child_)
            self.get_supported_protocols.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stop-backup':
            obj_ = BackupStopOutput.factory()
            obj_.build(child_)
            self.stop_backup.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remove-file':
            obj_ = BackupRemoveFileOutput.factory()
            obj_.build(child_)
            self.remove_file.append(obj_)
# end class BackupOutputType


class BackupRemoteStorage:
    subclass = None
    def __init__(self, protocol='', host=None, port=None, directory=None, login=None, password=None, passive_mode=None):
        self.protocol = protocol
        self.host = host
        self.port = port
        self.directory = directory
        self.login = login
        self.password = password
        self.passive_mode = passive_mode
    def factory(*args_, **kwargs_):
        if BackupRemoteStorage.subclass:
            return BackupRemoteStorage.subclass(*args_, **kwargs_)
        else:
            return BackupRemoteStorage(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getProtocol(self): return self.protocol
    def setProtocol(self, value): self.protocol = value
    def getHost(self): return self.host
    def setHost(self, value): self.host = value
    def getPort(self): return self.port
    def setPort(self, value): self.port = value
    def getDirectory(self): return self.directory
    def setDirectory(self, value): self.directory = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassive_mode(self): return self.passive_mode
    def setPassive_mode(self, value): self.passive_mode = value
    def export(self, outfile, level, name_='BackupRemoteStorage'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupRemoteStorage'):
        pass
    def exportChildren(self, outfile, level, name_='BackupRemoteStorage'):
        showIndent(outfile, level)
        outfile.write('<protocol>%s</protocol>\n' % quote_xml(self.getProtocol()))
        if self.host is not None:
            showIndent(outfile, level)
            outfile.write('<host>%s</host>\n' % quote_xml(self.getHost()))
        if self.port is not None:
            showIndent(outfile, level)
            outfile.write('<port>%s</port>\n' % quote_xml(self.getPort()))
        if self.directory is not None:
            showIndent(outfile, level)
            outfile.write('<directory>%s</directory>\n' % quote_xml(self.getDirectory()))
        if self.login is not None:
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.passive_mode is not None:
            showIndent(outfile, level)
            outfile.write('<passive-mode>%s</passive-mode>\n' % quote_xml(self.getPassive_mode()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'protocol':
            protocol_ = ''
            for text__content_ in child_.childNodes:
                protocol_ += text__content_.nodeValue
            self.protocol = protocol_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'host':
            host_ = ''
            for text__content_ in child_.childNodes:
                host_ += text__content_.nodeValue
            self.host = host_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'port':
            port_ = ''
            for text__content_ in child_.childNodes:
                port_ += text__content_.nodeValue
            self.port = port_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'directory':
            directory_ = ''
            for text__content_ in child_.childNodes:
                directory_ += text__content_.nodeValue
            self.directory = directory_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'passive-mode':
            passive_mode_ = ''
            for text__content_ in child_.childNodes:
                passive_mode_ += text__content_.nodeValue
            self.passive_mode = passive_mode_
# end class BackupRemoteStorage


class BackupDomainInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, local=None, remote=None, prefix=None, description='', split_size=None, only_hosting=None, only_mail=None, only_configuration=None):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.local = local
        self.remote = remote
        self.prefix = prefix
        self.description = description
        self.split_size = split_size
        self.only_hosting = only_hosting
        self.only_mail = only_mail
        self.only_configuration = only_configuration
    def factory(*args_, **kwargs_):
        if BackupDomainInput.subclass:
            return BackupDomainInput.subclass(*args_, **kwargs_)
        else:
            return BackupDomainInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getLocal(self): return self.local
    def setLocal(self, value): self.local = value
    def getRemote(self): return self.remote
    def setRemote(self, value): self.remote = value
    def getPrefix(self): return self.prefix
    def setPrefix(self, value): self.prefix = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getSplit_size(self): return self.split_size
    def setSplit_size(self, value): self.split_size = value
    def getOnly_hosting(self): return self.only_hosting
    def setOnly_hosting(self, value): self.only_hosting = value
    def getOnly_mail(self): return self.only_mail
    def setOnly_mail(self, value): self.only_mail = value
    def getOnly_configuration(self): return self.only_configuration
    def setOnly_configuration(self, value): self.only_configuration = value
    def export(self, outfile, level, name_='BackupDomainInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupDomainInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupDomainInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.local is not None:
            self.local.export(outfile, level, name_='local')
        if self.remote is not None:
            showIndent(outfile, level)
            outfile.write('<remote>%s</remote>\n' % quote_xml(self.getRemote()))
        if self.prefix is not None:
            showIndent(outfile, level)
            outfile.write('<prefix>%s</prefix>\n' % quote_xml(self.getPrefix()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        if self.split_size is not None:
            showIndent(outfile, level)
            outfile.write('<split-size>%s</split-size>\n' % quote_xml(self.getSplit_size()))
        if self.only_hosting is not None:
            showIndent(outfile, level)
            outfile.write('<only-hosting>%s</only-hosting>\n' % quote_xml(self.getOnly_hosting()))
        if self.only_mail is not None:
            showIndent(outfile, level)
            outfile.write('<only-mail>%s</only-mail>\n' % quote_xml(self.getOnly_mail()))
        if self.only_configuration is not None:
            showIndent(outfile, level)
            outfile.write('<only-configuration>%s</only-configuration>\n' % quote_xml(self.getOnly_configuration()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLocal(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remote':
            remote_ = ''
            for text__content_ in child_.childNodes:
                remote_ += text__content_.nodeValue
            self.remote = remote_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefix':
            prefix_ = ''
            for text__content_ in child_.childNodes:
                prefix_ += text__content_.nodeValue
            self.prefix = prefix_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'split-size':
            split_size_ = ''
            for text__content_ in child_.childNodes:
                split_size_ += text__content_.nodeValue
            self.split_size = split_size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-hosting':
            only_hosting_ = ''
            for text__content_ in child_.childNodes:
                only_hosting_ += text__content_.nodeValue
            self.only_hosting = only_hosting_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-mail':
            only_mail_ = ''
            for text__content_ in child_.childNodes:
                only_mail_ += text__content_.nodeValue
            self.only_mail = only_mail_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-configuration':
            only_configuration_ = ''
            for text__content_ in child_.childNodes:
                only_configuration_ += text__content_.nodeValue
            self.only_configuration = only_configuration_
# end class BackupDomainInput


class BackupClientInput:
    subclass = None
    def __init__(self, client_id=None, client_login=None, local=None, remote=None, prefix=None, description='', split_size=None, only_hosting=None, only_mail=None, only_configuration=None):
        self.client_id = client_id
        self.client_login = client_login
        self.local = local
        self.remote = remote
        self.prefix = prefix
        self.description = description
        self.split_size = split_size
        self.only_hosting = only_hosting
        self.only_mail = only_mail
        self.only_configuration = only_configuration
    def factory(*args_, **kwargs_):
        if BackupClientInput.subclass:
            return BackupClientInput.subclass(*args_, **kwargs_)
        else:
            return BackupClientInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getLocal(self): return self.local
    def setLocal(self, value): self.local = value
    def getRemote(self): return self.remote
    def setRemote(self, value): self.remote = value
    def getPrefix(self): return self.prefix
    def setPrefix(self, value): self.prefix = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getSplit_size(self): return self.split_size
    def setSplit_size(self, value): self.split_size = value
    def getOnly_hosting(self): return self.only_hosting
    def setOnly_hosting(self, value): self.only_hosting = value
    def getOnly_mail(self): return self.only_mail
    def setOnly_mail(self, value): self.only_mail = value
    def getOnly_configuration(self): return self.only_configuration
    def setOnly_configuration(self, value): self.only_configuration = value
    def export(self, outfile, level, name_='BackupClientInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupClientInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupClientInput'):
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.local is not None:
            self.local.export(outfile, level, name_='local')
        if self.remote is not None:
            showIndent(outfile, level)
            outfile.write('<remote>%s</remote>\n' % quote_xml(self.getRemote()))
        if self.prefix is not None:
            showIndent(outfile, level)
            outfile.write('<prefix>%s</prefix>\n' % quote_xml(self.getPrefix()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        if self.split_size is not None:
            showIndent(outfile, level)
            outfile.write('<split-size>%s</split-size>\n' % quote_xml(self.getSplit_size()))
        if self.only_hosting is not None:
            showIndent(outfile, level)
            outfile.write('<only-hosting>%s</only-hosting>\n' % quote_xml(self.getOnly_hosting()))
        if self.only_mail is not None:
            showIndent(outfile, level)
            outfile.write('<only-mail>%s</only-mail>\n' % quote_xml(self.getOnly_mail()))
        if self.only_configuration is not None:
            showIndent(outfile, level)
            outfile.write('<only-configuration>%s</only-configuration>\n' % quote_xml(self.getOnly_configuration()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLocal(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remote':
            remote_ = ''
            for text__content_ in child_.childNodes:
                remote_ += text__content_.nodeValue
            self.remote = remote_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefix':
            prefix_ = ''
            for text__content_ in child_.childNodes:
                prefix_ += text__content_.nodeValue
            self.prefix = prefix_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'split-size':
            split_size_ = ''
            for text__content_ in child_.childNodes:
                split_size_ += text__content_.nodeValue
            self.split_size = split_size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-hosting':
            only_hosting_ = ''
            for text__content_ in child_.childNodes:
                only_hosting_ += text__content_.nodeValue
            self.only_hosting = only_hosting_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-mail':
            only_mail_ = ''
            for text__content_ in child_.childNodes:
                only_mail_ += text__content_.nodeValue
            self.only_mail = only_mail_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-configuration':
            only_configuration_ = ''
            for text__content_ in child_.childNodes:
                only_configuration_ += text__content_.nodeValue
            self.only_configuration = only_configuration_
# end class BackupClientInput


class BackupGetRemoteStorageSettingsInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, protocol=''):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.protocol = protocol
    def factory(*args_, **kwargs_):
        if BackupGetRemoteStorageSettingsInput.subclass:
            return BackupGetRemoteStorageSettingsInput.subclass(*args_, **kwargs_)
        else:
            return BackupGetRemoteStorageSettingsInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getProtocol(self): return self.protocol
    def setProtocol(self, value): self.protocol = value
    def export(self, outfile, level, name_='BackupGetRemoteStorageSettingsInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetRemoteStorageSettingsInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetRemoteStorageSettingsInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        showIndent(outfile, level)
        outfile.write('<protocol>%s</protocol>\n' % quote_xml(self.getProtocol()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'protocol':
            protocol_ = ''
            for text__content_ in child_.childNodes:
                protocol_ += text__content_.nodeValue
            self.protocol = protocol_
# end class BackupGetRemoteStorageSettingsInput


class BackupGetRemoteStorageSettingsOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupGetRemoteStorageSettingsOutput.subclass:
            return BackupGetRemoteStorageSettingsOutput.subclass(*args_, **kwargs_)
        else:
            return BackupGetRemoteStorageSettingsOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupGetRemoteStorageSettingsOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetRemoteStorageSettingsOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetRemoteStorageSettingsOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupGetRemoteStorageSettingsOutput


class BackupSetRemoteStorageInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, settings=None):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.settings = settings
    def factory(*args_, **kwargs_):
        if BackupSetRemoteStorageInput.subclass:
            return BackupSetRemoteStorageInput.subclass(*args_, **kwargs_)
        else:
            return BackupSetRemoteStorageInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getSettings(self): return self.settings
    def setSettings(self, value): self.settings = value
    def export(self, outfile, level, name_='BackupSetRemoteStorageInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupSetRemoteStorageInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupSetRemoteStorageInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        if self.settings is not None:
            self.settings.export(outfile, level, name_='settings')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'settings':
            obj_ = BackupRemoteStorage.factory()
            obj_.build(child_)
            self.setSettings(obj_)
# end class BackupSetRemoteStorageInput


class BackupSetRemoteStorageSettingsOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupSetRemoteStorageSettingsOutput.subclass:
            return BackupSetRemoteStorageSettingsOutput.subclass(*args_, **kwargs_)
        else:
            return BackupSetRemoteStorageSettingsOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupSetRemoteStorageSettingsOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupSetRemoteStorageSettingsOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupSetRemoteStorageSettingsOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupSetRemoteStorageSettingsOutput


class BackupCommandOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupCommandOutput.subclass:
            return BackupCommandOutput.subclass(*args_, **kwargs_)
        else:
            return BackupCommandOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupCommandOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupCommandOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupCommandOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupCommandOutput


class BackiupClientOutput:
    subclass = None
    def __init__(self, result=None, task_id=''):
        self.result = result
        self.task_id = task_id
    def factory(*args_, **kwargs_):
        if BackiupClientOutput.subclass:
            return BackiupClientOutput.subclass(*args_, **kwargs_)
        else:
            return BackiupClientOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def getTask_id(self): return self.task_id
    def setTask_id(self, value): self.task_id = value
    def export(self, outfile, level, name_='BackiupClientOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackiupClientOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackiupClientOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
        showIndent(outfile, level)
        outfile.write('<task-id>%s</task-id>\n' % quote_xml(self.getTask_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'task-id':
            task_id_ = ''
            for text__content_ in child_.childNodes:
                task_id_ += text__content_.nodeValue
            self.task_id = task_id_
# end class BackiupClientOutput


class BackupGetBackupStatusInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, task_id=None):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.task_id = task_id
    def factory(*args_, **kwargs_):
        if BackupGetBackupStatusInput.subclass:
            return BackupGetBackupStatusInput.subclass(*args_, **kwargs_)
        else:
            return BackupGetBackupStatusInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getTask_id(self): return self.task_id
    def setTask_id(self, value): self.task_id = value
    def export(self, outfile, level, name_='BackupGetBackupStatusInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetBackupStatusInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetBackupStatusInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        if self.task_id is not None:
            showIndent(outfile, level)
            outfile.write('<task-id>%s</task-id>\n' % quote_xml(self.getTask_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'task-id':
            task_id_ = ''
            for text__content_ in child_.childNodes:
                task_id_ += text__content_.nodeValue
            self.task_id = task_id_
# end class BackupGetBackupStatusInput


class BackupGetBackupStatusOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if BackupGetBackupStatusOutput.subclass:
            return BackupGetBackupStatusOutput.subclass(*args_, **kwargs_)
        else:
            return BackupGetBackupStatusOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='BackupGetBackupStatusOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetBackupStatusOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetBackupStatusOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class BackupGetBackupStatusOutput


class BackupStopInput:
    subclass = None
    def __init__(self, task_id=''):
        self.task_id = task_id
    def factory(*args_, **kwargs_):
        if BackupStopInput.subclass:
            return BackupStopInput.subclass(*args_, **kwargs_)
        else:
            return BackupStopInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getTask_id(self): return self.task_id
    def setTask_id(self, value): self.task_id = value
    def export(self, outfile, level, name_='BackupStopInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupStopInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupStopInput'):
        showIndent(outfile, level)
        outfile.write('<task-id>%s</task-id>\n' % quote_xml(self.getTask_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'task-id':
            task_id_ = ''
            for text__content_ in child_.childNodes:
                task_id_ += text__content_.nodeValue
            self.task_id = task_id_
# end class BackupStopInput


class BackupStopOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupStopOutput.subclass:
            return BackupStopOutput.subclass(*args_, **kwargs_)
        else:
            return BackupStopOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupStopOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupStopOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupStopOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupStopOutput


class BackupFile:
    subclass = None
    def __init__(self, name='', creation_date='', description='', size='', not_backup=None):
        self.name = name
        self.creation_date = creation_date
        self.description = description
        self.size = size
        self.not_backup = not_backup
    def factory(*args_, **kwargs_):
        if BackupFile.subclass:
            return BackupFile.subclass(*args_, **kwargs_)
        else:
            return BackupFile(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getCreation_date(self): return self.creation_date
    def setCreation_date(self, value): self.creation_date = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getSize(self): return self.size
    def setSize(self, value): self.size = value
    def getNot_backup(self): return self.not_backup
    def setNot_backup(self, value): self.not_backup = value
    def export(self, outfile, level, name_='BackupFile'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupFile'):
        pass
    def exportChildren(self, outfile, level, name_='BackupFile'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<creation-date>%s</creation-date>\n' % quote_xml(self.getCreation_date()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        showIndent(outfile, level)
        outfile.write('<size>%s</size>\n' % quote_xml(self.getSize()))
        if self.not_backup is not None:
            showIndent(outfile, level)
            outfile.write('<not-backup>%s</not-backup>\n' % quote_xml(self.getNot_backup()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'creation-date':
            creation_date_ = ''
            for text__content_ in child_.childNodes:
                creation_date_ += text__content_.nodeValue
            self.creation_date = creation_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'size':
            size_ = ''
            for text__content_ in child_.childNodes:
                size_ += text__content_.nodeValue
            self.size = size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'not-backup':
            not_backup_ = ''
            for text__content_ in child_.childNodes:
                not_backup_ += text__content_.nodeValue
            self.not_backup = not_backup_
# end class BackupFile


class BackupGetLocalBackupListInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
    def factory(*args_, **kwargs_):
        if BackupGetLocalBackupListInput.subclass:
            return BackupGetLocalBackupListInput.subclass(*args_, **kwargs_)
        else:
            return BackupGetLocalBackupListInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def export(self, outfile, level, name_='BackupGetLocalBackupListInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetLocalBackupListInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetLocalBackupListInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
# end class BackupGetLocalBackupListInput


class BackupGetLocalBackupListOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupGetLocalBackupListOutput.subclass:
            return BackupGetLocalBackupListOutput.subclass(*args_, **kwargs_)
        else:
            return BackupGetLocalBackupListOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupGetLocalBackupListOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetLocalBackupListOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetLocalBackupListOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupGetLocalBackupListOutput


class BackupImportFileInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, tmp_filename=''):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.tmp_filename = tmp_filename
    def factory(*args_, **kwargs_):
        if BackupImportFileInput.subclass:
            return BackupImportFileInput.subclass(*args_, **kwargs_)
        else:
            return BackupImportFileInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getTmp_filename(self): return self.tmp_filename
    def setTmp_filename(self, value): self.tmp_filename = value
    def export(self, outfile, level, name_='BackupImportFileInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupImportFileInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupImportFileInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        showIndent(outfile, level)
        outfile.write('<tmp-filename>%s</tmp-filename>\n' % quote_xml(self.getTmp_filename()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'tmp-filename':
            tmp_filename_ = ''
            for text__content_ in child_.childNodes:
                tmp_filename_ += text__content_.nodeValue
            self.tmp_filename = tmp_filename_
# end class BackupImportFileInput


class BackupImportFileOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupImportFileOutput.subclass:
            return BackupImportFileOutput.subclass(*args_, **kwargs_)
        else:
            return BackupImportFileOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupImportFileOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupImportFileOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupImportFileOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupImportFileOutput


class BackupDownloadFileInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, filename=''):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.filename = filename
    def factory(*args_, **kwargs_):
        if BackupDownloadFileInput.subclass:
            return BackupDownloadFileInput.subclass(*args_, **kwargs_)
        else:
            return BackupDownloadFileInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getFilename(self): return self.filename
    def setFilename(self, value): self.filename = value
    def export(self, outfile, level, name_='BackupDownloadFileInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupDownloadFileInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupDownloadFileInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        showIndent(outfile, level)
        outfile.write('<filename>%s</filename>\n' % quote_xml(self.getFilename()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filename':
            filename_ = ''
            for text__content_ in child_.childNodes:
                filename_ += text__content_.nodeValue
            self.filename = filename_
# end class BackupDownloadFileInput


class BackupDownloadFileOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupDownloadFileOutput.subclass:
            return BackupDownloadFileOutput.subclass(*args_, **kwargs_)
        else:
            return BackupDownloadFileOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupDownloadFileOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupDownloadFileOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupDownloadFileOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupDownloadFileOutput


class BackupClientOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupClientOutput.subclass:
            return BackupClientOutput.subclass(*args_, **kwargs_)
        else:
            return BackupClientOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupClientOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupClientOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupClientOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupClientOutput


class BackupGetSupportedProtocolsOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupGetSupportedProtocolsOutput.subclass:
            return BackupGetSupportedProtocolsOutput.subclass(*args_, **kwargs_)
        else:
            return BackupGetSupportedProtocolsOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupGetSupportedProtocolsOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetSupportedProtocolsOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetSupportedProtocolsOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupGetSupportedProtocolsOutput


class BackupType:
    subclass = None
    def __init__(self, file=None):
        if file is None:
            self.file = []
        else:
            self.file = file
    def factory(*args_, **kwargs_):
        if BackupType.subclass:
            return BackupType.subclass(*args_, **kwargs_)
        else:
            return BackupType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFile(self): return self.file
    def setFile(self, value): self.file = value
    def addFile(self, value): self.file.append(value)
    def insertFile(self, index, value): self.file[index] = value
    def export(self, outfile, level, name_='BackupType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupType'):
        pass
    def exportChildren(self, outfile, level, name_='BackupType'):
        for file_ in self.getFile():
            file_.export(outfile, level, name_='file')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'file':
            obj_ = BackupFile.factory()
            obj_.build(child_)
            self.file.append(obj_)
# end class BackupType


class BackupGetBackupProcessesInput:
    subclass = None
    def __init__(self, domain=None, client=None, reseller=None):
        self.domain = domain
        self.client = client
        self.reseller = reseller
    def factory(*args_, **kwargs_):
        if BackupGetBackupProcessesInput.subclass:
            return BackupGetBackupProcessesInput.subclass(*args_, **kwargs_)
        else:
            return BackupGetBackupProcessesInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain(self): return self.domain
    def setDomain(self, value): self.domain = value
    def getClient(self): return self.client
    def setClient(self, value): self.client = value
    def getReseller(self): return self.reseller
    def setReseller(self, value): self.reseller = value
    def export(self, outfile, level, name_='BackupGetBackupProcessesInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetBackupProcessesInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetBackupProcessesInput'):
        if self.domain is not None:
            self.domain.export(outfile, level, name_='domain')
        if self.client is not None:
            self.client.export(outfile, level, name_='client')
        if self.reseller is not None:
            self.reseller.export(outfile, level, name_='reseller')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setDomain(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setClient(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setReseller(obj_)
# end class BackupGetBackupProcessesInput


class BackupGetBackupProcessesOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupGetBackupProcessesOutput.subclass:
            return BackupGetBackupProcessesOutput.subclass(*args_, **kwargs_)
        else:
            return BackupGetBackupProcessesOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupGetBackupProcessesOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupGetBackupProcessesOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupGetBackupProcessesOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupGetBackupProcessesOutput


class BackupRemoveFileInput:
    subclass = None
    def __init__(self, domain_id=None, domain_name=None, client_id=None, client_login=None, reseller_id=None, reseller_login=None, server=None, filename=''):
        self.domain_id = domain_id
        self.domain_name = domain_name
        self.client_id = client_id
        self.client_login = client_login
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.server = server
        self.filename = filename
    def factory(*args_, **kwargs_):
        if BackupRemoveFileInput.subclass:
            return BackupRemoveFileInput.subclass(*args_, **kwargs_)
        else:
            return BackupRemoveFileInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def getClient_id(self): return self.client_id
    def setClient_id(self, value): self.client_id = value
    def getClient_login(self): return self.client_login
    def setClient_login(self, value): self.client_login = value
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def getFilename(self): return self.filename
    def setFilename(self, value): self.filename = value
    def export(self, outfile, level, name_='BackupRemoveFileInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupRemoveFileInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupRemoveFileInput'):
        if self.domain_id is not None:
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        if self.domain_name is not None:
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(self.getDomain_name()))
        if self.client_id is not None:
            showIndent(outfile, level)
            outfile.write('<client-id>%s</client-id>\n' % quote_xml(self.getClient_id()))
        if self.client_login is not None:
            showIndent(outfile, level)
            outfile.write('<client-login>%s</client-login>\n' % quote_xml(self.getClient_login()))
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.server is not None:
            showIndent(outfile, level)
            outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
        showIndent(outfile, level)
        outfile.write('<filename>%s</filename>\n' % quote_xml(self.getFilename()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.domain_name = domain_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-id':
            client_id_ = ''
            for text__content_ in child_.childNodes:
                client_id_ += text__content_.nodeValue
            self.client_id = client_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-login':
            client_login_ = ''
            for text__content_ in child_.childNodes:
                client_login_ += text__content_.nodeValue
            self.client_login = client_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filename':
            filename_ = ''
            for text__content_ in child_.childNodes:
                filename_ += text__content_.nodeValue
            self.filename = filename_
# end class BackupRemoveFileInput


class BackupRemoveFileOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if BackupRemoveFileOutput.subclass:
            return BackupRemoveFileOutput.subclass(*args_, **kwargs_)
        else:
            return BackupRemoveFileOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='BackupRemoveFileOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupRemoveFileOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupRemoveFileOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class BackupRemoveFileOutput


class BackupResellerInput:
    subclass = None
    def __init__(self, reseller_id=None, reseller_login=None, local=None, remote=None, prefix=None, description='', split_size=None, only_hosting=None, only_mail=None, only_configuration=None):
        self.reseller_id = reseller_id
        self.reseller_login = reseller_login
        self.local = local
        self.remote = remote
        self.prefix = prefix
        self.description = description
        self.split_size = split_size
        self.only_hosting = only_hosting
        self.only_mail = only_mail
        self.only_configuration = only_configuration
    def factory(*args_, **kwargs_):
        if BackupResellerInput.subclass:
            return BackupResellerInput.subclass(*args_, **kwargs_)
        else:
            return BackupResellerInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getReseller_login(self): return self.reseller_login
    def setReseller_login(self, value): self.reseller_login = value
    def getLocal(self): return self.local
    def setLocal(self, value): self.local = value
    def getRemote(self): return self.remote
    def setRemote(self, value): self.remote = value
    def getPrefix(self): return self.prefix
    def setPrefix(self, value): self.prefix = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getSplit_size(self): return self.split_size
    def setSplit_size(self, value): self.split_size = value
    def getOnly_hosting(self): return self.only_hosting
    def setOnly_hosting(self, value): self.only_hosting = value
    def getOnly_mail(self): return self.only_mail
    def setOnly_mail(self, value): self.only_mail = value
    def getOnly_configuration(self): return self.only_configuration
    def setOnly_configuration(self, value): self.only_configuration = value
    def export(self, outfile, level, name_='BackupResellerInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupResellerInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupResellerInput'):
        if self.reseller_id is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.reseller_login is not None:
            showIndent(outfile, level)
            outfile.write('<reseller-login>%s</reseller-login>\n' % quote_xml(self.getReseller_login()))
        if self.local is not None:
            self.local.export(outfile, level, name_='local')
        if self.remote is not None:
            showIndent(outfile, level)
            outfile.write('<remote>%s</remote>\n' % quote_xml(self.getRemote()))
        if self.prefix is not None:
            showIndent(outfile, level)
            outfile.write('<prefix>%s</prefix>\n' % quote_xml(self.getPrefix()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        if self.split_size is not None:
            showIndent(outfile, level)
            outfile.write('<split-size>%s</split-size>\n' % quote_xml(self.getSplit_size()))
        if self.only_hosting is not None:
            showIndent(outfile, level)
            outfile.write('<only-hosting>%s</only-hosting>\n' % quote_xml(self.getOnly_hosting()))
        if self.only_mail is not None:
            showIndent(outfile, level)
            outfile.write('<only-mail>%s</only-mail>\n' % quote_xml(self.getOnly_mail()))
        if self.only_configuration is not None:
            showIndent(outfile, level)
            outfile.write('<only-configuration>%s</only-configuration>\n' % quote_xml(self.getOnly_configuration()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-login':
            reseller_login_ = ''
            for text__content_ in child_.childNodes:
                reseller_login_ += text__content_.nodeValue
            self.reseller_login = reseller_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLocal(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remote':
            remote_ = ''
            for text__content_ in child_.childNodes:
                remote_ += text__content_.nodeValue
            self.remote = remote_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefix':
            prefix_ = ''
            for text__content_ in child_.childNodes:
                prefix_ += text__content_.nodeValue
            self.prefix = prefix_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'split-size':
            split_size_ = ''
            for text__content_ in child_.childNodes:
                split_size_ += text__content_.nodeValue
            self.split_size = split_size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-hosting':
            only_hosting_ = ''
            for text__content_ in child_.childNodes:
                only_hosting_ += text__content_.nodeValue
            self.only_hosting = only_hosting_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-mail':
            only_mail_ = ''
            for text__content_ in child_.childNodes:
                only_mail_ += text__content_.nodeValue
            self.only_mail = only_mail_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-configuration':
            only_configuration_ = ''
            for text__content_ in child_.childNodes:
                only_configuration_ += text__content_.nodeValue
            self.only_configuration = only_configuration_
# end class BackupResellerInput


class BackupServerInput:
    subclass = None
    def __init__(self, local=None, remote=None, prefix=None, description='', split_size=None, only_hosting=None, only_mail=None, only_configuration=None):
        self.local = local
        self.remote = remote
        self.prefix = prefix
        self.description = description
        self.split_size = split_size
        self.only_hosting = only_hosting
        self.only_mail = only_mail
        self.only_configuration = only_configuration
    def factory(*args_, **kwargs_):
        if BackupServerInput.subclass:
            return BackupServerInput.subclass(*args_, **kwargs_)
        else:
            return BackupServerInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getLocal(self): return self.local
    def setLocal(self, value): self.local = value
    def getRemote(self): return self.remote
    def setRemote(self, value): self.remote = value
    def getPrefix(self): return self.prefix
    def setPrefix(self, value): self.prefix = value
    def getDescription(self): return self.description
    def setDescription(self, value): self.description = value
    def getSplit_size(self): return self.split_size
    def setSplit_size(self, value): self.split_size = value
    def getOnly_hosting(self): return self.only_hosting
    def setOnly_hosting(self, value): self.only_hosting = value
    def getOnly_mail(self): return self.only_mail
    def setOnly_mail(self, value): self.only_mail = value
    def getOnly_configuration(self): return self.only_configuration
    def setOnly_configuration(self, value): self.only_configuration = value
    def export(self, outfile, level, name_='BackupServerInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupServerInput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupServerInput'):
        if self.local is not None:
            self.local.export(outfile, level, name_='local')
        if self.remote is not None:
            showIndent(outfile, level)
            outfile.write('<remote>%s</remote>\n' % quote_xml(self.getRemote()))
        if self.prefix is not None:
            showIndent(outfile, level)
            outfile.write('<prefix>%s</prefix>\n' % quote_xml(self.getPrefix()))
        showIndent(outfile, level)
        outfile.write('<description>%s</description>\n' % quote_xml(self.getDescription()))
        if self.split_size is not None:
            showIndent(outfile, level)
            outfile.write('<split-size>%s</split-size>\n' % quote_xml(self.getSplit_size()))
        if self.only_hosting is not None:
            showIndent(outfile, level)
            outfile.write('<only-hosting>%s</only-hosting>\n' % quote_xml(self.getOnly_hosting()))
        if self.only_mail is not None:
            showIndent(outfile, level)
            outfile.write('<only-mail>%s</only-mail>\n' % quote_xml(self.getOnly_mail()))
        if self.only_configuration is not None:
            showIndent(outfile, level)
            outfile.write('<only-configuration>%s</only-configuration>\n' % quote_xml(self.getOnly_configuration()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'local':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLocal(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'remote':
            remote_ = ''
            for text__content_ in child_.childNodes:
                remote_ += text__content_.nodeValue
            self.remote = remote_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'prefix':
            prefix_ = ''
            for text__content_ in child_.childNodes:
                prefix_ += text__content_.nodeValue
            self.prefix = prefix_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'description':
            description_ = ''
            for text__content_ in child_.childNodes:
                description_ += text__content_.nodeValue
            self.description = description_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'split-size':
            split_size_ = ''
            for text__content_ in child_.childNodes:
                split_size_ += text__content_.nodeValue
            self.split_size = split_size_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-hosting':
            only_hosting_ = ''
            for text__content_ in child_.childNodes:
                only_hosting_ += text__content_.nodeValue
            self.only_hosting = only_hosting_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-mail':
            only_mail_ = ''
            for text__content_ in child_.childNodes:
                only_mail_ += text__content_.nodeValue
            self.only_mail = only_mail_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'only-configuration':
            only_configuration_ = ''
            for text__content_ in child_.childNodes:
                only_configuration_ += text__content_.nodeValue
            self.only_configuration = only_configuration_
# end class BackupServerInput


class BackupServerOutput:
    subclass = None
    def __init__(self, result=None, task_id=''):
        self.result = result
        self.task_id = task_id
    def factory(*args_, **kwargs_):
        if BackupServerOutput.subclass:
            return BackupServerOutput.subclass(*args_, **kwargs_)
        else:
            return BackupServerOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def getTask_id(self): return self.task_id
    def setTask_id(self, value): self.task_id = value
    def export(self, outfile, level, name_='BackupServerOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupServerOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupServerOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
        showIndent(outfile, level)
        outfile.write('<task-id>%s</task-id>\n' % quote_xml(self.getTask_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'task-id':
            task_id_ = ''
            for text__content_ in child_.childNodes:
                task_id_ += text__content_.nodeValue
            self.task_id = task_id_
# end class BackupServerOutput


class BackupResellerOutput:
    subclass = None
    def __init__(self, result=None, task_id=''):
        self.result = result
        self.task_id = task_id
    def factory(*args_, **kwargs_):
        if BackupResellerOutput.subclass:
            return BackupResellerOutput.subclass(*args_, **kwargs_)
        else:
            return BackupResellerOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def getTask_id(self): return self.task_id
    def setTask_id(self, value): self.task_id = value
    def export(self, outfile, level, name_='BackupResellerOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='BackupResellerOutput'):
        pass
    def exportChildren(self, outfile, level, name_='BackupResellerOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
        showIndent(outfile, level)
        outfile.write('<task-id>%s</task-id>\n' % quote_xml(self.getTask_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'task-id':
            task_id_ = ''
            for text__content_ in child_.childNodes:
                task_id_ += text__content_.nodeValue
            self.task_id = task_id_
# end class BackupResellerOutput


class SSOInput:
    subclass = None
    def __init__(self, enable=None, disable=None, register=None, set_default_idp=None, get_default_idp=None, restore_default_idp=None, set_branded_idp=None, get_branded_idp=None, del_branded_idp=None, add_delegation_rule=None, del_delegation_rule=None, get_prefs=None):
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if register is None:
            self.register = []
        else:
            self.register = register
        if set_default_idp is None:
            self.set_default_idp = []
        else:
            self.set_default_idp = set_default_idp
        if get_default_idp is None:
            self.get_default_idp = []
        else:
            self.get_default_idp = get_default_idp
        if restore_default_idp is None:
            self.restore_default_idp = []
        else:
            self.restore_default_idp = restore_default_idp
        if set_branded_idp is None:
            self.set_branded_idp = []
        else:
            self.set_branded_idp = set_branded_idp
        if get_branded_idp is None:
            self.get_branded_idp = []
        else:
            self.get_branded_idp = get_branded_idp
        if del_branded_idp is None:
            self.del_branded_idp = []
        else:
            self.del_branded_idp = del_branded_idp
        if add_delegation_rule is None:
            self.add_delegation_rule = []
        else:
            self.add_delegation_rule = add_delegation_rule
        if del_delegation_rule is None:
            self.del_delegation_rule = []
        else:
            self.del_delegation_rule = del_delegation_rule
        if get_prefs is None:
            self.get_prefs = []
        else:
            self.get_prefs = get_prefs
    def factory(*args_, **kwargs_):
        if SSOInput.subclass:
            return SSOInput.subclass(*args_, **kwargs_)
        else:
            return SSOInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getRegister(self): return self.register
    def setRegister(self, value): self.register = value
    def addRegister(self, value): self.register.append(value)
    def insertRegister(self, index, value): self.register[index] = value
    def getSet_default_idp(self): return self.set_default_idp
    def setSet_default_idp(self, value): self.set_default_idp = value
    def addSet_default_idp(self, value): self.set_default_idp.append(value)
    def insertSet_default_idp(self, index, value): self.set_default_idp[index] = value
    def getGet_default_idp(self): return self.get_default_idp
    def setGet_default_idp(self, value): self.get_default_idp = value
    def addGet_default_idp(self, value): self.get_default_idp.append(value)
    def insertGet_default_idp(self, index, value): self.get_default_idp[index] = value
    def getRestore_default_idp(self): return self.restore_default_idp
    def setRestore_default_idp(self, value): self.restore_default_idp = value
    def addRestore_default_idp(self, value): self.restore_default_idp.append(value)
    def insertRestore_default_idp(self, index, value): self.restore_default_idp[index] = value
    def getSet_branded_idp(self): return self.set_branded_idp
    def setSet_branded_idp(self, value): self.set_branded_idp = value
    def addSet_branded_idp(self, value): self.set_branded_idp.append(value)
    def insertSet_branded_idp(self, index, value): self.set_branded_idp[index] = value
    def getGet_branded_idp(self): return self.get_branded_idp
    def setGet_branded_idp(self, value): self.get_branded_idp = value
    def addGet_branded_idp(self, value): self.get_branded_idp.append(value)
    def insertGet_branded_idp(self, index, value): self.get_branded_idp[index] = value
    def getDel_branded_idp(self): return self.del_branded_idp
    def setDel_branded_idp(self, value): self.del_branded_idp = value
    def addDel_branded_idp(self, value): self.del_branded_idp.append(value)
    def insertDel_branded_idp(self, index, value): self.del_branded_idp[index] = value
    def getAdd_delegation_rule(self): return self.add_delegation_rule
    def setAdd_delegation_rule(self, value): self.add_delegation_rule = value
    def addAdd_delegation_rule(self, value): self.add_delegation_rule.append(value)
    def insertAdd_delegation_rule(self, index, value): self.add_delegation_rule[index] = value
    def getDel_delegation_rule(self): return self.del_delegation_rule
    def setDel_delegation_rule(self, value): self.del_delegation_rule = value
    def addDel_delegation_rule(self, value): self.del_delegation_rule.append(value)
    def insertDel_delegation_rule(self, index, value): self.del_delegation_rule[index] = value
    def getGet_prefs(self): return self.get_prefs
    def setGet_prefs(self, value): self.get_prefs = value
    def addGet_prefs(self, value): self.get_prefs.append(value)
    def insertGet_prefs(self, index, value): self.get_prefs[index] = value
    def export(self, outfile, level, name_='SSOInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOInput'):
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for register_ in self.getRegister():
            register_.export(outfile, level, name_='register')
        for set_default_idp_ in self.getSet_default_idp():
            set_default_idp_.export(outfile, level, name_='set-default-idp')
        for get_default_idp_ in self.getGet_default_idp():
            get_default_idp_.export(outfile, level, name_='get-default-idp')
        for restore_default_idp_ in self.getRestore_default_idp():
            restore_default_idp_.export(outfile, level, name_='restore-default-idp')
        for set_branded_idp_ in self.getSet_branded_idp():
            set_branded_idp_.export(outfile, level, name_='set-branded-idp')
        for get_branded_idp_ in self.getGet_branded_idp():
            get_branded_idp_.export(outfile, level, name_='get-branded-idp')
        for del_branded_idp_ in self.getDel_branded_idp():
            del_branded_idp_.export(outfile, level, name_='del-branded-idp')
        for add_delegation_rule_ in self.getAdd_delegation_rule():
            add_delegation_rule_.export(outfile, level, name_='add-delegation-rule')
        for del_delegation_rule_ in self.getDel_delegation_rule():
            del_delegation_rule_.export(outfile, level, name_='del-delegation-rule')
        for get_prefs_ in self.getGet_prefs():
            get_prefs_.export(outfile, level, name_='get-prefs')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'register':
            obj_ = SSORegisterInput.factory()
            obj_.build(child_)
            self.register.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default-idp':
            obj_ = SSOSetDefaultRelayInput.factory()
            obj_.build(child_)
            self.set_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-default-idp':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.get_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-default-idp':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.restore_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-branded-idp':
            obj_ = SSOSetRelayInput.factory()
            obj_.build(child_)
            self.set_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-branded-idp':
            obj_ = SSOGetRelayInput.factory()
            obj_.build(child_)
            self.get_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-branded-idp':
            obj_ = SSODelRelayInput.factory()
            obj_.build(child_)
            self.del_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-delegation-rule':
            obj_ = SSOAddDelegrationRuleInput.factory()
            obj_.build(child_)
            self.add_delegation_rule.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-delegation-rule':
            obj_ = SSODelDelegationRuleInput.factory()
            obj_.build(child_)
            self.del_delegation_rule.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-prefs':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.get_prefs.append(obj_)
# end class SSOInput


class SSOSetPrefsInput:
    subclass = None
    def __init__(self, server=''):
        self.server = server
    def factory(*args_, **kwargs_):
        if SSOSetPrefsInput.subclass:
            return SSOSetPrefsInput.subclass(*args_, **kwargs_)
        else:
            return SSOSetPrefsInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def export(self, outfile, level, name_='SSOSetPrefsInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOSetPrefsInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOSetPrefsInput'):
        showIndent(outfile, level)
        outfile.write('<server>%s</server>\n' % quote_xml(self.getServer()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            server_ = ''
            for text__content_ in child_.childNodes:
                server_ += text__content_.nodeValue
            self.server = server_
# end class SSOSetPrefsInput


class SSOOutput:
    subclass = None
    def __init__(self, enable=None, disable=None, register=None, get_prefs=None, set_default_idp=None, get_default_idp=None, restore_default_idp=None, set_branded_idp=None, get_branded_idp=None, del_branded_idp=None, add_delegation_rule=None, del_delegation_rule=None):
        if enable is None:
            self.enable = []
        else:
            self.enable = enable
        if disable is None:
            self.disable = []
        else:
            self.disable = disable
        if register is None:
            self.register = []
        else:
            self.register = register
        if get_prefs is None:
            self.get_prefs = []
        else:
            self.get_prefs = get_prefs
        if set_default_idp is None:
            self.set_default_idp = []
        else:
            self.set_default_idp = set_default_idp
        if get_default_idp is None:
            self.get_default_idp = []
        else:
            self.get_default_idp = get_default_idp
        if restore_default_idp is None:
            self.restore_default_idp = []
        else:
            self.restore_default_idp = restore_default_idp
        if set_branded_idp is None:
            self.set_branded_idp = []
        else:
            self.set_branded_idp = set_branded_idp
        if get_branded_idp is None:
            self.get_branded_idp = []
        else:
            self.get_branded_idp = get_branded_idp
        if del_branded_idp is None:
            self.del_branded_idp = []
        else:
            self.del_branded_idp = del_branded_idp
        if add_delegation_rule is None:
            self.add_delegation_rule = []
        else:
            self.add_delegation_rule = add_delegation_rule
        if del_delegation_rule is None:
            self.del_delegation_rule = []
        else:
            self.del_delegation_rule = del_delegation_rule
    def factory(*args_, **kwargs_):
        if SSOOutput.subclass:
            return SSOOutput.subclass(*args_, **kwargs_)
        else:
            return SSOOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getEnable(self): return self.enable
    def setEnable(self, value): self.enable = value
    def addEnable(self, value): self.enable.append(value)
    def insertEnable(self, index, value): self.enable[index] = value
    def getDisable(self): return self.disable
    def setDisable(self, value): self.disable = value
    def addDisable(self, value): self.disable.append(value)
    def insertDisable(self, index, value): self.disable[index] = value
    def getRegister(self): return self.register
    def setRegister(self, value): self.register = value
    def addRegister(self, value): self.register.append(value)
    def insertRegister(self, index, value): self.register[index] = value
    def getGet_prefs(self): return self.get_prefs
    def setGet_prefs(self, value): self.get_prefs = value
    def addGet_prefs(self, value): self.get_prefs.append(value)
    def insertGet_prefs(self, index, value): self.get_prefs[index] = value
    def getSet_default_idp(self): return self.set_default_idp
    def setSet_default_idp(self, value): self.set_default_idp = value
    def addSet_default_idp(self, value): self.set_default_idp.append(value)
    def insertSet_default_idp(self, index, value): self.set_default_idp[index] = value
    def getGet_default_idp(self): return self.get_default_idp
    def setGet_default_idp(self, value): self.get_default_idp = value
    def addGet_default_idp(self, value): self.get_default_idp.append(value)
    def insertGet_default_idp(self, index, value): self.get_default_idp[index] = value
    def getRestore_default_idp(self): return self.restore_default_idp
    def setRestore_default_idp(self, value): self.restore_default_idp = value
    def addRestore_default_idp(self, value): self.restore_default_idp.append(value)
    def insertRestore_default_idp(self, index, value): self.restore_default_idp[index] = value
    def getSet_branded_idp(self): return self.set_branded_idp
    def setSet_branded_idp(self, value): self.set_branded_idp = value
    def addSet_branded_idp(self, value): self.set_branded_idp.append(value)
    def insertSet_branded_idp(self, index, value): self.set_branded_idp[index] = value
    def getGet_branded_idp(self): return self.get_branded_idp
    def setGet_branded_idp(self, value): self.get_branded_idp = value
    def addGet_branded_idp(self, value): self.get_branded_idp.append(value)
    def insertGet_branded_idp(self, index, value): self.get_branded_idp[index] = value
    def getDel_branded_idp(self): return self.del_branded_idp
    def setDel_branded_idp(self, value): self.del_branded_idp = value
    def addDel_branded_idp(self, value): self.del_branded_idp.append(value)
    def insertDel_branded_idp(self, index, value): self.del_branded_idp[index] = value
    def getAdd_delegation_rule(self): return self.add_delegation_rule
    def setAdd_delegation_rule(self, value): self.add_delegation_rule = value
    def addAdd_delegation_rule(self, value): self.add_delegation_rule.append(value)
    def insertAdd_delegation_rule(self, index, value): self.add_delegation_rule[index] = value
    def getDel_delegation_rule(self): return self.del_delegation_rule
    def setDel_delegation_rule(self, value): self.del_delegation_rule = value
    def addDel_delegation_rule(self, value): self.del_delegation_rule.append(value)
    def insertDel_delegation_rule(self, index, value): self.del_delegation_rule[index] = value
    def export(self, outfile, level, name_='SSOOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOOutput'):
        for enable_ in self.getEnable():
            enable_.export(outfile, level, name_='enable')
        for disable_ in self.getDisable():
            disable_.export(outfile, level, name_='disable')
        for register_ in self.getRegister():
            register_.export(outfile, level, name_='register')
        for get_prefs_ in self.getGet_prefs():
            get_prefs_.export(outfile, level, name_='get-prefs')
        for set_default_idp_ in self.getSet_default_idp():
            set_default_idp_.export(outfile, level, name_='set-default-idp')
        for get_default_idp_ in self.getGet_default_idp():
            get_default_idp_.export(outfile, level, name_='get-default-idp')
        for restore_default_idp_ in self.getRestore_default_idp():
            restore_default_idp_.export(outfile, level, name_='restore-default-idp')
        for set_branded_idp_ in self.getSet_branded_idp():
            set_branded_idp_.export(outfile, level, name_='set-branded-idp')
        for get_branded_idp_ in self.getGet_branded_idp():
            get_branded_idp_.export(outfile, level, name_='get-branded-idp')
        for del_branded_idp_ in self.getDel_branded_idp():
            del_branded_idp_.export(outfile, level, name_='del-branded-idp')
        for add_delegation_rule_ in self.getAdd_delegation_rule():
            add_delegation_rule_.export(outfile, level, name_='add-delegation-rule')
        for del_delegation_rule_ in self.getDel_delegation_rule():
            del_delegation_rule_.export(outfile, level, name_='del-delegation-rule')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enable':
            obj_ = SSOEnableOutput.factory()
            obj_.build(child_)
            self.enable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disable':
            obj_ = SSODisableOutput.factory()
            obj_.build(child_)
            self.disable.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'register':
            obj_ = SSORegisterOutput.factory()
            obj_.build(child_)
            self.register.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-prefs':
            obj_ = SSOGetPrefsOutput.factory()
            obj_.build(child_)
            self.get_prefs.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-default-idp':
            obj_ = SSOSetDefaultRelayOutput.factory()
            obj_.build(child_)
            self.set_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-default-idp':
            obj_ = SSOGetDefaultRelayOutput.factory()
            obj_.build(child_)
            self.get_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'restore-default-idp':
            obj_ = SSORestoreDefaultRelayOutput.factory()
            obj_.build(child_)
            self.restore_default_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-branded-idp':
            obj_ = SSOSetRelayOutput.factory()
            obj_.build(child_)
            self.set_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-branded-idp':
            obj_ = SSOGetRelayOutput.factory()
            obj_.build(child_)
            self.get_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-branded-idp':
            obj_ = SSODelRelayOutput.factory()
            obj_.build(child_)
            self.del_branded_idp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-delegation-rule':
            obj_ = SSOAddDelegationRuleOutput.factory()
            obj_.build(child_)
            self.add_delegation_rule.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del-delegation-rule':
            obj_ = SSODelDelegationRuleOutput.factory()
            obj_.build(child_)
            self.del_delegation_rule.append(obj_)
# end class SSOOutput


class SSOEnableOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOEnableOutput.subclass:
            return SSOEnableOutput.subclass(*args_, **kwargs_)
        else:
            return SSOEnableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOEnableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOEnableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOEnableOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOEnableOutput


class SSODisableOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSODisableOutput.subclass:
            return SSODisableOutput.subclass(*args_, **kwargs_)
        else:
            return SSODisableOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSODisableOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODisableOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSODisableOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSODisableOutput


class SSOPrefs:
    subclass = None
    def __init__(self, idp_url=None, enabled='', application_id=None):
        self.idp_url = idp_url
        self.enabled = enabled
        self.application_id = application_id
    def factory(*args_, **kwargs_):
        if SSOPrefs.subclass:
            return SSOPrefs.subclass(*args_, **kwargs_)
        else:
            return SSOPrefs(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def getEnabled(self): return self.enabled
    def setEnabled(self, value): self.enabled = value
    def getApplication_id(self): return self.application_id
    def setApplication_id(self, value): self.application_id = value
    def export(self, outfile, level, name_='SSOPrefs'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOPrefs'):
        pass
    def exportChildren(self, outfile, level, name_='SSOPrefs'):
        if self.idp_url is not None:
            showIndent(outfile, level)
            outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(self.getIdp_url()))
        showIndent(outfile, level)
        outfile.write('<enabled>%s</enabled>\n' % quote_xml(self.getEnabled()))
        if self.application_id is not None:
            showIndent(outfile, level)
            outfile.write('<application-id>%s</application-id>\n' % quote_xml(self.getApplication_id()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.idp_url = idp_url_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'enabled':
            enabled_ = ''
            for text__content_ in child_.childNodes:
                enabled_ += text__content_.nodeValue
            self.enabled = enabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'application-id':
            application_id_ = ''
            for text__content_ in child_.childNodes:
                application_id_ += text__content_.nodeValue
            self.application_id = application_id_
# end class SSOPrefs


class SSOSetDefaultRelayInput:
    subclass = None
    def __init__(self, idp_url=''):
        self.idp_url = idp_url
    def factory(*args_, **kwargs_):
        if SSOSetDefaultRelayInput.subclass:
            return SSOSetDefaultRelayInput.subclass(*args_, **kwargs_)
        else:
            return SSOSetDefaultRelayInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def export(self, outfile, level, name_='SSOSetDefaultRelayInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOSetDefaultRelayInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOSetDefaultRelayInput'):
        showIndent(outfile, level)
        outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(self.getIdp_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.idp_url = idp_url_
# end class SSOSetDefaultRelayInput


class SSOSetRelayInput:
    subclass = None
    def __init__(self, idp_url='', http_request_domain=''):
        self.idp_url = idp_url
        self.http_request_domain = http_request_domain
    def factory(*args_, **kwargs_):
        if SSOSetRelayInput.subclass:
            return SSOSetRelayInput.subclass(*args_, **kwargs_)
        else:
            return SSOSetRelayInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def getHttp_request_domain(self): return self.http_request_domain
    def setHttp_request_domain(self, value): self.http_request_domain = value
    def export(self, outfile, level, name_='SSOSetRelayInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOSetRelayInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOSetRelayInput'):
        showIndent(outfile, level)
        outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(self.getIdp_url()))
        showIndent(outfile, level)
        outfile.write('<http-request-domain>%s</http-request-domain>\n' % quote_xml(self.getHttp_request_domain()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.idp_url = idp_url_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http-request-domain':
            http_request_domain_ = ''
            for text__content_ in child_.childNodes:
                http_request_domain_ += text__content_.nodeValue
            self.http_request_domain = http_request_domain_
# end class SSOSetRelayInput


class SSOGetRelayInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SSOGetRelayInput.subclass:
            return SSOGetRelayInput.subclass(*args_, **kwargs_)
        else:
            return SSOGetRelayInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SSOGetRelayInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOGetRelayInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOGetRelayInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SSOGetRelayFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SSOGetRelayInput


class SSOGetRelayFilter:
    subclass = None
    def __init__(self, http_request_domain=None):
        if http_request_domain is None:
            self.http_request_domain = []
        else:
            self.http_request_domain = http_request_domain
    def factory(*args_, **kwargs_):
        if SSOGetRelayFilter.subclass:
            return SSOGetRelayFilter.subclass(*args_, **kwargs_)
        else:
            return SSOGetRelayFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getHttp_request_domain(self): return self.http_request_domain
    def setHttp_request_domain(self, value): self.http_request_domain = value
    def addHttp_request_domain(self, value): self.http_request_domain.append(value)
    def insertHttp_request_domain(self, index, value): self.http_request_domain[index] = value
    def export(self, outfile, level, name_='SSOGetRelayFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOGetRelayFilter'):
        pass
    def exportChildren(self, outfile, level, name_='SSOGetRelayFilter'):
        for http_request_domain_ in self.getHttp_request_domain():
            showIndent(outfile, level)
            outfile.write('<http-request-domain>%s</http-request-domain>\n' % quote_xml(http_request_domain_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http-request-domain':
            http_request_domain_ = ''
            for text__content_ in child_.childNodes:
                http_request_domain_ += text__content_.nodeValue
            self.addHttp_request_domain(http_request_domain_)
# end class SSOGetRelayFilter


class SSODelRelayInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SSODelRelayInput.subclass:
            return SSODelRelayInput.subclass(*args_, **kwargs_)
        else:
            return SSODelRelayInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SSODelRelayInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODelRelayInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSODelRelayInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SSODelRelayFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SSODelRelayInput


class SSOSetDefaultRelayOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOSetDefaultRelayOutput.subclass:
            return SSOSetDefaultRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSOSetDefaultRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOSetDefaultRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOSetDefaultRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOSetDefaultRelayOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOSetDefaultRelayOutput


class SSOGetDefaultRelayOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOGetDefaultRelayOutput.subclass:
            return SSOGetDefaultRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSOGetDefaultRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOGetDefaultRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOGetDefaultRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOGetDefaultRelayOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOGetDefaultRelayOutput


class SSORestoreDefaultRelayOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSORestoreDefaultRelayOutput.subclass:
            return SSORestoreDefaultRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSORestoreDefaultRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSORestoreDefaultRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSORestoreDefaultRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSORestoreDefaultRelayOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSORestoreDefaultRelayOutput


class SSOSetRelayOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOSetRelayOutput.subclass:
            return SSOSetRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSOSetRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOSetRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOSetRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOSetRelayOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOSetRelayOutput


class SSOGetRelayOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SSOGetRelayOutput.subclass:
            return SSOGetRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSOGetRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SSOGetRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOGetRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOGetRelayOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SSOGetRelayOutput


class SSOBrangingRecord:
    subclass = None
    def __init__(self, idp_url='', http_request_domain=''):
        self.idp_url = idp_url
        self.http_request_domain = http_request_domain
    def factory(*args_, **kwargs_):
        if SSOBrangingRecord.subclass:
            return SSOBrangingRecord.subclass(*args_, **kwargs_)
        else:
            return SSOBrangingRecord(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def getHttp_request_domain(self): return self.http_request_domain
    def setHttp_request_domain(self, value): self.http_request_domain = value
    def export(self, outfile, level, name_='SSOBrangingRecord'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOBrangingRecord'):
        pass
    def exportChildren(self, outfile, level, name_='SSOBrangingRecord'):
        showIndent(outfile, level)
        outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(self.getIdp_url()))
        showIndent(outfile, level)
        outfile.write('<http-request-domain>%s</http-request-domain>\n' % quote_xml(self.getHttp_request_domain()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.idp_url = idp_url_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http-request-domain':
            http_request_domain_ = ''
            for text__content_ in child_.childNodes:
                http_request_domain_ += text__content_.nodeValue
            self.http_request_domain = http_request_domain_
# end class SSOBrangingRecord


class SSODelRelayOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SSODelRelayOutput.subclass:
            return SSODelRelayOutput.subclass(*args_, **kwargs_)
        else:
            return SSODelRelayOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SSODelRelayOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODelRelayOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSODelRelayOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SSODelRelayOutput


class SSODelRelayFilter:
    subclass = None
    def __init__(self, idp_url=None, http_request_domain=None):
        if idp_url is None:
            self.idp_url = []
        else:
            self.idp_url = idp_url
        if http_request_domain is None:
            self.http_request_domain = []
        else:
            self.http_request_domain = http_request_domain
    def factory(*args_, **kwargs_):
        if SSODelRelayFilter.subclass:
            return SSODelRelayFilter.subclass(*args_, **kwargs_)
        else:
            return SSODelRelayFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def addIdp_url(self, value): self.idp_url.append(value)
    def insertIdp_url(self, index, value): self.idp_url[index] = value
    def getHttp_request_domain(self): return self.http_request_domain
    def setHttp_request_domain(self, value): self.http_request_domain = value
    def addHttp_request_domain(self, value): self.http_request_domain.append(value)
    def insertHttp_request_domain(self, index, value): self.http_request_domain[index] = value
    def export(self, outfile, level, name_='SSODelRelayFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODelRelayFilter'):
        pass
    def exportChildren(self, outfile, level, name_='SSODelRelayFilter'):
        for idp_url_ in self.getIdp_url():
            showIndent(outfile, level)
            outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(idp_url_))
        for http_request_domain_ in self.getHttp_request_domain():
            showIndent(outfile, level)
            outfile.write('<http-request-domain>%s</http-request-domain>\n' % quote_xml(http_request_domain_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.addIdp_url(idp_url_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'http-request-domain':
            http_request_domain_ = ''
            for text__content_ in child_.childNodes:
                http_request_domain_ += text__content_.nodeValue
            self.addHttp_request_domain(http_request_domain_)
# end class SSODelRelayFilter


class SSORegisterInput:
    subclass = None
    def __init__(self, idp_url=''):
        self.idp_url = idp_url
    def factory(*args_, **kwargs_):
        if SSORegisterInput.subclass:
            return SSORegisterInput.subclass(*args_, **kwargs_)
        else:
            return SSORegisterInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIdp_url(self): return self.idp_url
    def setIdp_url(self, value): self.idp_url = value
    def export(self, outfile, level, name_='SSORegisterInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSORegisterInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSORegisterInput'):
        showIndent(outfile, level)
        outfile.write('<idp-url>%s</idp-url>\n' % quote_xml(self.getIdp_url()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'idp-url':
            idp_url_ = ''
            for text__content_ in child_.childNodes:
                idp_url_ += text__content_.nodeValue
            self.idp_url = idp_url_
# end class SSORegisterInput


class SSORegisterOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSORegisterOutput.subclass:
            return SSORegisterOutput.subclass(*args_, **kwargs_)
        else:
            return SSORegisterOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSORegisterOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSORegisterOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSORegisterOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSORegisterOutput


class SSOAddDelegrationRuleInput:
    subclass = None
    def __init__(self, sp_id='', sp_login='', plesk_login=''):
        self.sp_id = sp_id
        self.sp_login = sp_login
        self.plesk_login = plesk_login
    def factory(*args_, **kwargs_):
        if SSOAddDelegrationRuleInput.subclass:
            return SSOAddDelegrationRuleInput.subclass(*args_, **kwargs_)
        else:
            return SSOAddDelegrationRuleInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSp_id(self): return self.sp_id
    def setSp_id(self, value): self.sp_id = value
    def getSp_login(self): return self.sp_login
    def setSp_login(self, value): self.sp_login = value
    def getPlesk_login(self): return self.plesk_login
    def setPlesk_login(self, value): self.plesk_login = value
    def export(self, outfile, level, name_='SSOAddDelegrationRuleInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOAddDelegrationRuleInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOAddDelegrationRuleInput'):
        showIndent(outfile, level)
        outfile.write('<sp-id>%s</sp-id>\n' % quote_xml(self.getSp_id()))
        showIndent(outfile, level)
        outfile.write('<sp-login>%s</sp-login>\n' % quote_xml(self.getSp_login()))
        showIndent(outfile, level)
        outfile.write('<plesk-login>%s</plesk-login>\n' % quote_xml(self.getPlesk_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sp-id':
            sp_id_ = ''
            for text__content_ in child_.childNodes:
                sp_id_ += text__content_.nodeValue
            self.sp_id = sp_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sp-login':
            sp_login_ = ''
            for text__content_ in child_.childNodes:
                sp_login_ += text__content_.nodeValue
            self.sp_login = sp_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk-login':
            plesk_login_ = ''
            for text__content_ in child_.childNodes:
                plesk_login_ += text__content_.nodeValue
            self.plesk_login = plesk_login_
# end class SSOAddDelegrationRuleInput


class SSODelDelegationRuleInput:
    subclass = None
    def __init__(self, sp_id='', sp_login='', plesk_login=''):
        self.sp_id = sp_id
        self.sp_login = sp_login
        self.plesk_login = plesk_login
    def factory(*args_, **kwargs_):
        if SSODelDelegationRuleInput.subclass:
            return SSODelDelegationRuleInput.subclass(*args_, **kwargs_)
        else:
            return SSODelDelegationRuleInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSp_id(self): return self.sp_id
    def setSp_id(self, value): self.sp_id = value
    def getSp_login(self): return self.sp_login
    def setSp_login(self, value): self.sp_login = value
    def getPlesk_login(self): return self.plesk_login
    def setPlesk_login(self, value): self.plesk_login = value
    def export(self, outfile, level, name_='SSODelDelegationRuleInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODelDelegationRuleInput'):
        pass
    def exportChildren(self, outfile, level, name_='SSODelDelegationRuleInput'):
        showIndent(outfile, level)
        outfile.write('<sp-id>%s</sp-id>\n' % quote_xml(self.getSp_id()))
        showIndent(outfile, level)
        outfile.write('<sp-login>%s</sp-login>\n' % quote_xml(self.getSp_login()))
        showIndent(outfile, level)
        outfile.write('<plesk-login>%s</plesk-login>\n' % quote_xml(self.getPlesk_login()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sp-id':
            sp_id_ = ''
            for text__content_ in child_.childNodes:
                sp_id_ += text__content_.nodeValue
            self.sp_id = sp_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sp-login':
            sp_login_ = ''
            for text__content_ in child_.childNodes:
                sp_login_ += text__content_.nodeValue
            self.sp_login = sp_login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'plesk-login':
            plesk_login_ = ''
            for text__content_ in child_.childNodes:
                plesk_login_ += text__content_.nodeValue
            self.plesk_login = plesk_login_
# end class SSODelDelegationRuleInput


class SSOAddDelegationRuleOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOAddDelegationRuleOutput.subclass:
            return SSOAddDelegationRuleOutput.subclass(*args_, **kwargs_)
        else:
            return SSOAddDelegationRuleOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOAddDelegationRuleOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOAddDelegationRuleOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOAddDelegationRuleOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOAddDelegationRuleOutput


class SSODelDelegationRuleOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSODelDelegationRuleOutput.subclass:
            return SSODelDelegationRuleOutput.subclass(*args_, **kwargs_)
        else:
            return SSODelDelegationRuleOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSODelDelegationRuleOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSODelDelegationRuleOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSODelDelegationRuleOutput'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSODelDelegationRuleOutput


class SSOGetPrefsOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SSOGetPrefsOutput.subclass:
            return SSOGetPrefsOutput.subclass(*args_, **kwargs_)
        else:
            return SSOGetPrefsOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SSOGetPrefsOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SSOGetPrefsOutput'):
        pass
    def exportChildren(self, outfile, level, name_='SSOGetPrefsOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SSOGetPrefsOutput


class ProtectedDirInput:
    subclass = None
    def __init__(self, add=None, delete=None, set=None, get=None, add_user=None, set_user=None, delete_user=None, get_user=None, get_pd_location_descriptor=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if delete is None:
            self.delete = []
        else:
            self.delete = delete
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if add_user is None:
            self.add_user = []
        else:
            self.add_user = add_user
        if set_user is None:
            self.set_user = []
        else:
            self.set_user = set_user
        if delete_user is None:
            self.delete_user = []
        else:
            self.delete_user = delete_user
        if get_user is None:
            self.get_user = []
        else:
            self.get_user = get_user
        if get_pd_location_descriptor is None:
            self.get_pd_location_descriptor = []
        else:
            self.get_pd_location_descriptor = get_pd_location_descriptor
    def factory(*args_, **kwargs_):
        if ProtectedDirInput.subclass:
            return ProtectedDirInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getDelete(self): return self.delete
    def setDelete(self, value): self.delete = value
    def addDelete(self, value): self.delete.append(value)
    def insertDelete(self, index, value): self.delete[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getAdd_user(self): return self.add_user
    def setAdd_user(self, value): self.add_user = value
    def addAdd_user(self, value): self.add_user.append(value)
    def insertAdd_user(self, index, value): self.add_user[index] = value
    def getSet_user(self): return self.set_user
    def setSet_user(self, value): self.set_user = value
    def addSet_user(self, value): self.set_user.append(value)
    def insertSet_user(self, index, value): self.set_user[index] = value
    def getDelete_user(self): return self.delete_user
    def setDelete_user(self, value): self.delete_user = value
    def addDelete_user(self, value): self.delete_user.append(value)
    def insertDelete_user(self, index, value): self.delete_user[index] = value
    def getGet_user(self): return self.get_user
    def setGet_user(self, value): self.get_user = value
    def addGet_user(self, value): self.get_user.append(value)
    def insertGet_user(self, index, value): self.get_user[index] = value
    def getGet_pd_location_descriptor(self): return self.get_pd_location_descriptor
    def setGet_pd_location_descriptor(self, value): self.get_pd_location_descriptor = value
    def addGet_pd_location_descriptor(self, value): self.get_pd_location_descriptor.append(value)
    def insertGet_pd_location_descriptor(self, index, value): self.get_pd_location_descriptor[index] = value
    def export(self, outfile, level, name_='ProtectedDirInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirInput'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for delete_ in self.getDelete():
            delete_.export(outfile, level, name_='delete')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for add_user_ in self.getAdd_user():
            add_user_.export(outfile, level, name_='add-user')
        for set_user_ in self.getSet_user():
            set_user_.export(outfile, level, name_='set-user')
        for delete_user_ in self.getDelete_user():
            delete_user_.export(outfile, level, name_='delete-user')
        for get_user_ in self.getGet_user():
            get_user_.export(outfile, level, name_='get-user')
        for get_pd_location_descriptor_ in self.getGet_pd_location_descriptor():
            get_pd_location_descriptor_.export(outfile, level, name_='get-pd-location-descriptor')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ProtectedDirAddInput.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete':
            obj_ = ProtectedDirDeleteInput.factory()
            obj_.build(child_)
            self.delete.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ProtectedDirSetInput.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ProtectedDirGetInput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-user':
            obj_ = ProtectedDirAddUserInput.factory()
            obj_.build(child_)
            self.add_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-user':
            obj_ = ProtectedDirSetUserInput.factory()
            obj_.build(child_)
            self.set_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete-user':
            obj_ = ProtectedDirDeleteUserInput.factory()
            obj_.build(child_)
            self.delete_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-user':
            obj_ = ProtectedDirGetUserInput.factory()
            obj_.build(child_)
            self.get_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-pd-location-descriptor':
            obj_ = ProtectedDirGetLocationDescriptor.factory()
            obj_.build(child_)
            self.get_pd_location_descriptor.append(obj_)
# end class ProtectedDirInput


class ProtectedDirAddInput:
    subclass = None
    def __init__(self, domain_id='', name='', header=None, location=None):
        self.domain_id = domain_id
        self.name = name
        self.header = header
        self.location = location
    def factory(*args_, **kwargs_):
        if ProtectedDirAddInput.subclass:
            return ProtectedDirAddInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirAddInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getHeader(self): return self.header
    def setHeader(self, value): self.header = value
    def getLocation(self): return self.location
    def setLocation(self, value): self.location = value
    def export(self, outfile, level, name_='ProtectedDirAddInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirAddInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirAddInput'):
        showIndent(outfile, level)
        outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(self.getDomain_id()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.header is not None:
            showIndent(outfile, level)
            outfile.write('<header>%s</header>\n' % quote_xml(self.getHeader()))
        if self.location is not None:
            self.location.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'header':
            header_ = ''
            for text__content_ in child_.childNodes:
                header_ += text__content_.nodeValue
            self.header = header_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'location':
            obj_ = location.factory()
            obj_.build(child_)
            self.setLocation(obj_)
# end class ProtectedDirAddInput


class ProtectedDirSetInput:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if ProtectedDirSetInput.subclass:
            return ProtectedDirSetInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirSetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='ProtectedDirSetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirSetInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirSetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level, name_='values')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = ProtectedDir.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class ProtectedDirSetInput


class ProtectedDir:
    subclass = None
    def __init__(self, name=None, header=None, location=None):
        self.name = name
        self.header = header
        self.location = location
    def factory(*args_, **kwargs_):
        if ProtectedDir.subclass:
            return ProtectedDir.subclass(*args_, **kwargs_)
        else:
            return ProtectedDir(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getHeader(self): return self.header
    def setHeader(self, value): self.header = value
    def getLocation(self): return self.location
    def setLocation(self, value): self.location = value
    def export(self, outfile, level, name_='ProtectedDir'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDir'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDir'):
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.header is not None:
            showIndent(outfile, level)
            outfile.write('<header>%s</header>\n' % quote_xml(self.getHeader()))
        if self.location is not None:
            self.location.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'header':
            header_ = ''
            for text__content_ in child_.childNodes:
                header_ += text__content_.nodeValue
            self.header = header_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'location':
            obj_ = location.factory()
            obj_.build(child_)
            self.setLocation(obj_)
# end class ProtectedDir


class ProtectedDirLocation:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if ProtectedDirLocation.subclass:
            return ProtectedDirLocation.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirLocation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='ProtectedDirLocation'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirLocation'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirLocation'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class ProtectedDirLocation


class ProtectedDirUser:
    subclass = None
    def __init__(self, id=None, login=None, password=None, password_type=None):
        self.id = id
        self.login = login
        self.password = password
        self.password_type = password_type
    def factory(*args_, **kwargs_):
        if ProtectedDirUser.subclass:
            return ProtectedDirUser.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirUser(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def export(self, outfile, level, name_='ProtectedDirUser'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirUser'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirUser'):
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        if self.login is not None:
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password-type>%s</password-type>\n' % quote_xml(self.getPassword_type()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password-type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
# end class ProtectedDirUser


class ProtectedDirAddUserInput:
    subclass = None
    def __init__(self, pd_id='', login='', password='', password_type=None):
        self.pd_id = pd_id
        self.login = login
        self.password = password
        self.password_type = password_type
    def factory(*args_, **kwargs_):
        if ProtectedDirAddUserInput.subclass:
            return ProtectedDirAddUserInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirAddUserInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPd_id(self): return self.pd_id
    def setPd_id(self, value): self.pd_id = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def export(self, outfile, level, name_='ProtectedDirAddUserInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirAddUserInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirAddUserInput'):
        showIndent(outfile, level)
        outfile.write('<pd-id>%s</pd-id>\n' % quote_xml(self.getPd_id()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password-type>%s</password-type>\n' % quote_xml(self.getPassword_type()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pd-id':
            pd_id_ = ''
            for text__content_ in child_.childNodes:
                pd_id_ += text__content_.nodeValue
            self.pd_id = pd_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password-type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
# end class ProtectedDirAddUserInput


class ProtectedDirDeleteUserInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ProtectedDirDeleteUserInput.subclass:
            return ProtectedDirDeleteUserInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirDeleteUserInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ProtectedDirDeleteUserInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirDeleteUserInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirDeleteUserInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ProtectedDirDeleteUserInput


class ProtectedDirOutput:
    subclass = None
    def __init__(self, add=None, set=None, delete=None, add_user=None, set_user=None, delete_user=None, get=None, get_user=None, get_pd_location_descriptor=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if delete is None:
            self.delete = []
        else:
            self.delete = delete
        if add_user is None:
            self.add_user = []
        else:
            self.add_user = add_user
        if set_user is None:
            self.set_user = []
        else:
            self.set_user = set_user
        if delete_user is None:
            self.delete_user = []
        else:
            self.delete_user = delete_user
        if get is None:
            self.get = []
        else:
            self.get = get
        if get_user is None:
            self.get_user = []
        else:
            self.get_user = get_user
        if get_pd_location_descriptor is None:
            self.get_pd_location_descriptor = []
        else:
            self.get_pd_location_descriptor = get_pd_location_descriptor
    def factory(*args_, **kwargs_):
        if ProtectedDirOutput.subclass:
            return ProtectedDirOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getDelete(self): return self.delete
    def setDelete(self, value): self.delete = value
    def addDelete(self, value): self.delete.append(value)
    def insertDelete(self, index, value): self.delete[index] = value
    def getAdd_user(self): return self.add_user
    def setAdd_user(self, value): self.add_user = value
    def addAdd_user(self, value): self.add_user.append(value)
    def insertAdd_user(self, index, value): self.add_user[index] = value
    def getSet_user(self): return self.set_user
    def setSet_user(self, value): self.set_user = value
    def addSet_user(self, value): self.set_user.append(value)
    def insertSet_user(self, index, value): self.set_user[index] = value
    def getDelete_user(self): return self.delete_user
    def setDelete_user(self, value): self.delete_user = value
    def addDelete_user(self, value): self.delete_user.append(value)
    def insertDelete_user(self, index, value): self.delete_user[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getGet_user(self): return self.get_user
    def setGet_user(self, value): self.get_user = value
    def addGet_user(self, value): self.get_user.append(value)
    def insertGet_user(self, index, value): self.get_user[index] = value
    def getGet_pd_location_descriptor(self): return self.get_pd_location_descriptor
    def setGet_pd_location_descriptor(self, value): self.get_pd_location_descriptor = value
    def addGet_pd_location_descriptor(self, value): self.get_pd_location_descriptor.append(value)
    def insertGet_pd_location_descriptor(self, index, value): self.get_pd_location_descriptor[index] = value
    def export(self, outfile, level, name_='ProtectedDirOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirOutput'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for delete_ in self.getDelete():
            delete_.export(outfile, level, name_='delete')
        for add_user_ in self.getAdd_user():
            add_user_.export(outfile, level, name_='add-user')
        for set_user_ in self.getSet_user():
            set_user_.export(outfile, level, name_='set-user')
        for delete_user_ in self.getDelete_user():
            delete_user_.export(outfile, level, name_='delete-user')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for get_user_ in self.getGet_user():
            get_user_.export(outfile, level, name_='get-user')
        for get_pd_location_descriptor_ in self.getGet_pd_location_descriptor():
            get_pd_location_descriptor_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ProtectedDirAddOutput.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ProtectedDirSetOutput.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete':
            obj_ = ProtectedDirDeleteOutput.factory()
            obj_.build(child_)
            self.delete.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-user':
            obj_ = ProtectedDirAddUserOutput.factory()
            obj_.build(child_)
            self.add_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set-user':
            obj_ = ProtectedDirSetUserOutput.factory()
            obj_.build(child_)
            self.set_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'delete-user':
            obj_ = ProtectedDirDeleteUserOutput.factory()
            obj_.build(child_)
            self.delete_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ProtectedDirGetOutput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-user':
            obj_ = ProtectedDirGetUserOutput.factory()
            obj_.build(child_)
            self.get_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-pd-location-descriptor':
            obj_ = get_pd_location_descriptor.factory()
            obj_.build(child_)
            self.get_pd_location_descriptor.append(obj_)
# end class ProtectedDirOutput


class ProtectedDirAddOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirAddOutput.subclass:
            return ProtectedDirAddOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirAddOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ProtectedDirAddOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirAddOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirAddOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ProtectedDirAddOutput


class ProtectedDirGetUserOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirGetUserOutput.subclass:
            return ProtectedDirGetUserOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirGetUserOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirGetUserOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirGetUserOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirGetUserOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirGetUserOutput


class ProtectedDirFilter:
    subclass = None
    def __init__(self, id=None, domain_id=None, domain_name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if domain_id is None:
            self.domain_id = []
        else:
            self.domain_id = domain_id
        if domain_name is None:
            self.domain_name = []
        else:
            self.domain_name = domain_name
    def factory(*args_, **kwargs_):
        if ProtectedDirFilter.subclass:
            return ProtectedDirFilter.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def addDomain_id(self, value): self.domain_id.append(value)
    def insertDomain_id(self, index, value): self.domain_id[index] = value
    def getDomain_name(self): return self.domain_name
    def setDomain_name(self, value): self.domain_name = value
    def addDomain_name(self, value): self.domain_name.append(value)
    def insertDomain_name(self, index, value): self.domain_name[index] = value
    def export(self, outfile, level, name_='ProtectedDirFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirFilter'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirFilter'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for domain_id_ in self.getDomain_id():
            showIndent(outfile, level)
            outfile.write('<domain-id>%s</domain-id>\n' % quote_xml(domain_id_))
        for domain_name_ in self.getDomain_name():
            showIndent(outfile, level)
            outfile.write('<domain-name>%s</domain-name>\n' % quote_xml(domain_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.addDomain_id(domain_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-name':
            domain_name_ = ''
            for text__content_ in child_.childNodes:
                domain_name_ += text__content_.nodeValue
            self.addDomain_name(domain_name_)
# end class ProtectedDirFilter


class ProtectedDirGetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirGetOutput.subclass:
            return ProtectedDirGetOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirGetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirGetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirGetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirGetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirGetOutput


class ProtectedDirLocationProperty:
    subclass = None
    def __init__(self, name='', value=0):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if ProtectedDirLocationProperty.subclass:
            return ProtectedDirLocationProperty.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirLocationProperty(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='ProtectedDirLocationProperty'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirLocationProperty'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirLocationProperty'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%d</value>\n' % self.getValue())
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            if child_.firstChild:
                sval_ = child_.firstChild.nodeValue
                if sval_ in ('true', '1'):
                    ival_ = 1
                elif sval_ in ('false', '0'):
                    ival_ = 0
                else:
                    raise ValueError('requires boolean -- %s' % child_.toxml())
                self.value = ival_
# end class ProtectedDirLocationProperty


class ProtectedDirSetUserInput:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if ProtectedDirSetUserInput.subclass:
            return ProtectedDirSetUserInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirSetUserInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='ProtectedDirSetUserInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirSetUserInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirSetUserInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level, name_='values')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = ProtectedDirUser.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class ProtectedDirSetUserInput


class ProtectedDirUserFilter:
    subclass = None
    def __init__(self, pd_id=None, id=None):
        if pd_id is None:
            self.pd_id = []
        else:
            self.pd_id = pd_id
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if ProtectedDirUserFilter.subclass:
            return ProtectedDirUserFilter.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirUserFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPd_id(self): return self.pd_id
    def setPd_id(self, value): self.pd_id = value
    def addPd_id(self, value): self.pd_id.append(value)
    def insertPd_id(self, index, value): self.pd_id[index] = value
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def export(self, outfile, level, name_='ProtectedDirUserFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirUserFilter'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirUserFilter'):
        for pd_id_ in self.getPd_id():
            showIndent(outfile, level)
            outfile.write('<pd-id>%s</pd-id>\n' % quote_xml(pd_id_))
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pd-id':
            pd_id_ = ''
            for text__content_ in child_.childNodes:
                pd_id_ += text__content_.nodeValue
            self.addPd_id(pd_id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
# end class ProtectedDirUserFilter


class ProtectedDirGetInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ProtectedDirGetInput.subclass:
            return ProtectedDirGetInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirGetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ProtectedDirGetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirGetInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirGetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ProtectedDirGetInput


class ProtectedDirDeleteInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ProtectedDirDeleteInput.subclass:
            return ProtectedDirDeleteInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirDeleteInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ProtectedDirDeleteInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirDeleteInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirDeleteInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ProtectedDirDeleteInput


class ProtectedDirGetLocationDescriptor:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ProtectedDirGetLocationDescriptor.subclass:
            return ProtectedDirGetLocationDescriptor.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirGetLocationDescriptor(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ProtectedDirGetLocationDescriptor'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirGetLocationDescriptor'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirGetLocationDescriptor'):
        if self.filter is not None:
            self.filter.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = filter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ProtectedDirGetLocationDescriptor


class ProtectedDirAddUserOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirAddUserOutput.subclass:
            return ProtectedDirAddUserOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirAddUserOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ProtectedDirAddUserOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirAddUserOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirAddUserOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ProtectedDirAddUserOutput


class ProtectedDirSetUserOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirSetUserOutput.subclass:
            return ProtectedDirSetUserOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirSetUserOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirSetUserOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirSetUserOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirSetUserOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirSetUserOutput


class ProtectedDirDeleteUserOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirDeleteUserOutput.subclass:
            return ProtectedDirDeleteUserOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirDeleteUserOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirDeleteUserOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirDeleteUserOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirDeleteUserOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirDeleteUserOutput


class ProtectedDirGetUserInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ProtectedDirGetUserInput.subclass:
            return ProtectedDirGetUserInput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirGetUserInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ProtectedDirGetUserInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirGetUserInput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirGetUserInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ProtectedDirUserFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ProtectedDirGetUserInput


class ProtectedDirSetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirSetOutput.subclass:
            return ProtectedDirSetOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirSetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirSetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirSetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirSetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirSetOutput


class ProtectedDirDeleteOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ProtectedDirDeleteOutput.subclass:
            return ProtectedDirDeleteOutput.subclass(*args_, **kwargs_)
        else:
            return ProtectedDirDeleteOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ProtectedDirDeleteOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ProtectedDirDeleteOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ProtectedDirDeleteOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ProtectedDirDeleteOutput


class SubdomainInputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None, rename=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if rename is None:
            self.rename = []
        else:
            self.rename = rename
    def factory(*args_, **kwargs_):
        if SubdomainInputType.subclass:
            return SubdomainInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getRename(self): return self.rename
    def setRename(self, value): self.rename = value
    def addRename(self, value): self.rename.append(value)
    def insertRename(self, index, value): self.rename[index] = value
    def export(self, outfile, level, name_='SubdomainInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for rename_ in self.getRename():
            rename_.export(outfile, level, name_='rename')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = SubdomainAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = SubdomainGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = SubdomainDeleteInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = SubdomainSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rename':
            obj_ = SubdomainRenameInputType.factory()
            obj_.build(child_)
            self.rename.append(obj_)
# end class SubdomainInputType


class SubdomainOutputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None, rename=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
        if rename is None:
            self.rename = []
        else:
            self.rename = rename
    def factory(*args_, **kwargs_):
        if SubdomainOutputType.subclass:
            return SubdomainOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getRename(self): return self.rename
    def setRename(self, value): self.rename = value
    def addRename(self, value): self.rename.append(value)
    def insertRename(self, index, value): self.rename[index] = value
    def export(self, outfile, level, name_='SubdomainOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for rename_ in self.getRename():
            rename_.export(outfile, level, name_='rename')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = SubdomainAddOutputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = SubdomainGetOutputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = SubdomainDelOutputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = SubdomainSetOutputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'rename':
            obj_ = SubdomainRenameOutputType.factory()
            obj_.build(child_)
            self.rename.append(obj_)
# end class SubdomainOutputType


class SubdomainPropertyType:
    subclass = None
    def __init__(self, name='', value=''):
        self.name = name
        self.value = value
    def factory(*args_, **kwargs_):
        if SubdomainPropertyType.subclass:
            return SubdomainPropertyType.subclass(*args_, **kwargs_)
        else:
            return SubdomainPropertyType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getValue(self): return self.value
    def setValue(self, value): self.value = value
    def export(self, outfile, level, name_='SubdomainPropertyType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainPropertyType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainPropertyType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        showIndent(outfile, level)
        outfile.write('<value>%s</value>\n' % quote_xml(self.getValue()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'value':
            value_ = ''
            for text__content_ in child_.childNodes:
                value_ += text__content_.nodeValue
            self.value = value_
# end class SubdomainPropertyType


class SubdomainFilterType:
    subclass = None
    def __init__(self, id=None, name=None, parent_name=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
        if parent_name is None:
            self.parent_name = []
        else:
            self.parent_name = parent_name
    def factory(*args_, **kwargs_):
        if SubdomainFilterType.subclass:
            return SubdomainFilterType.subclass(*args_, **kwargs_)
        else:
            return SubdomainFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def getParent_name(self): return self.parent_name
    def setParent_name(self, value): self.parent_name = value
    def addParent_name(self, value): self.parent_name.append(value)
    def insertParent_name(self, index, value): self.parent_name[index] = value
    def export(self, outfile, level, name_='SubdomainFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
        for parent_name_ in self.getParent_name():
            showIndent(outfile, level)
            outfile.write('<parent-name>%s</parent-name>\n' % quote_xml(parent_name_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'parent-name':
            parent_name_ = ''
            for text__content_ in child_.childNodes:
                parent_name_ += text__content_.nodeValue
            self.addParent_name(parent_name_)
# end class SubdomainFilterType


class SubdomainSetInputType:
    subclass = None
    def __init__(self, filter=None, property=None):
        self.filter = filter
        if property is None:
            self.property = []
        else:
            self.property = property
    def factory(*args_, **kwargs_):
        if SubdomainSetInputType.subclass:
            return SubdomainSetInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def export(self, outfile, level, name_='SubdomainSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SubdomainFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = SubdomainPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
# end class SubdomainSetInputType


class SubdomainDeleteInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SubdomainDeleteInputType.subclass:
            return SubdomainDeleteInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainDeleteInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SubdomainDeleteInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainDeleteInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainDeleteInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SubdomainFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SubdomainDeleteInputType


class SubdomainGetInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if SubdomainGetInputType.subclass:
            return SubdomainGetInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='SubdomainGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = SubdomainFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class SubdomainGetInputType


class SubdomainAddOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SubdomainAddOutputType.subclass:
            return SubdomainAddOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainAddOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SubdomainAddOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainAddOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainAddOutputType'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SubdomainAddOutputType


class SubdomainGetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SubdomainGetOutputType.subclass:
            return SubdomainGetOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainGetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SubdomainGetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainGetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainGetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SubdomainGetOutputType


class SubdomainObjectType:
    subclass = None
    def __init__(self, parent='', name='', home=None, property=None):
        self.parent = parent
        self.name = name
        self.home = home
        if property is None:
            self.property = []
        else:
            self.property = property
    def factory(*args_, **kwargs_):
        if SubdomainObjectType.subclass:
            return SubdomainObjectType.subclass(*args_, **kwargs_)
        else:
            return SubdomainObjectType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getParent(self): return self.parent
    def setParent(self, value): self.parent = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getHome(self): return self.home
    def setHome(self, value): self.home = value
    def getProperty(self): return self.property
    def setProperty(self, value): self.property = value
    def addProperty(self, value): self.property.append(value)
    def insertProperty(self, index, value): self.property[index] = value
    def export(self, outfile, level, name_='SubdomainObjectType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainObjectType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainObjectType'):
        showIndent(outfile, level)
        outfile.write('<parent>%s</parent>\n' % quote_xml(self.getParent()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.home is not None:
            showIndent(outfile, level)
            outfile.write('<home>%s</home>\n' % quote_xml(self.getHome()))
        for property_ in self.getProperty():
            property_.export(outfile, level, name_='property')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'parent':
            parent_ = ''
            for text__content_ in child_.childNodes:
                parent_ += text__content_.nodeValue
            self.parent = parent_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'home':
            home_ = ''
            for text__content_ in child_.childNodes:
                home_ += text__content_.nodeValue
            self.home = home_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'property':
            obj_ = SubdomainPropertyType.factory()
            obj_.build(child_)
            self.property.append(obj_)
# end class SubdomainObjectType


class SubdomainDelOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SubdomainDelOutputType.subclass:
            return SubdomainDelOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainDelOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SubdomainDelOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainDelOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainDelOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SubdomainDelOutputType


class SubdomainSetOutputType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if SubdomainSetOutputType.subclass:
            return SubdomainSetOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainSetOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='SubdomainSetOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainSetOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainSetOutputType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultFilterType.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class SubdomainSetOutputType


class SubdomainRenameInputType:
    subclass = None
    def __init__(self, id='', name=''):
        self.id = id
        self.name = name
    def factory(*args_, **kwargs_):
        if SubdomainRenameInputType.subclass:
            return SubdomainRenameInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainRenameInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='SubdomainRenameInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainRenameInputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainRenameInputType'):
        showIndent(outfile, level)
        outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
# end class SubdomainRenameInputType


class SubdomainRenameOutputType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if SubdomainRenameOutputType.subclass:
            return SubdomainRenameOutputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainRenameOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='SubdomainRenameOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainRenameOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='SubdomainRenameOutputType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class SubdomainRenameOutputType


class ResellerInput:
    subclass = None
    def __init__(self, add=None, set=None, get=None, ddel=None, ippool_add_ip=None, ippool_del_ip=None, ippool_set_ip=None, app_pool_set_pkg=None, cform_buttons_list=None, get_limit_descriptor=None, get_permission_descriptor=None, convert_to_client=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if ippool_add_ip is None:
            self.ippool_add_ip = []
        else:
            self.ippool_add_ip = ippool_add_ip
        if ippool_del_ip is None:
            self.ippool_del_ip = []
        else:
            self.ippool_del_ip = ippool_del_ip
        if ippool_set_ip is None:
            self.ippool_set_ip = []
        else:
            self.ippool_set_ip = ippool_set_ip
        if app_pool_set_pkg is None:
            self.app_pool_set_pkg = []
        else:
            self.app_pool_set_pkg = app_pool_set_pkg
        if cform_buttons_list is None:
            self.cform_buttons_list = []
        else:
            self.cform_buttons_list = cform_buttons_list
        if get_limit_descriptor is None:
            self.get_limit_descriptor = []
        else:
            self.get_limit_descriptor = get_limit_descriptor
        if get_permission_descriptor is None:
            self.get_permission_descriptor = []
        else:
            self.get_permission_descriptor = get_permission_descriptor
        if convert_to_client is None:
            self.convert_to_client = []
        else:
            self.convert_to_client = convert_to_client
    def factory(*args_, **kwargs_):
        if ResellerInput.subclass:
            return ResellerInput.subclass(*args_, **kwargs_)
        else:
            return ResellerInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getIppool_add_ip(self): return self.ippool_add_ip
    def setIppool_add_ip(self, value): self.ippool_add_ip = value
    def addIppool_add_ip(self, value): self.ippool_add_ip.append(value)
    def insertIppool_add_ip(self, index, value): self.ippool_add_ip[index] = value
    def getIppool_del_ip(self): return self.ippool_del_ip
    def setIppool_del_ip(self, value): self.ippool_del_ip = value
    def addIppool_del_ip(self, value): self.ippool_del_ip.append(value)
    def insertIppool_del_ip(self, index, value): self.ippool_del_ip[index] = value
    def getIppool_set_ip(self): return self.ippool_set_ip
    def setIppool_set_ip(self, value): self.ippool_set_ip = value
    def addIppool_set_ip(self, value): self.ippool_set_ip.append(value)
    def insertIppool_set_ip(self, index, value): self.ippool_set_ip[index] = value
    def getApp_pool_set_pkg(self): return self.app_pool_set_pkg
    def setApp_pool_set_pkg(self, value): self.app_pool_set_pkg = value
    def addApp_pool_set_pkg(self, value): self.app_pool_set_pkg.append(value)
    def insertApp_pool_set_pkg(self, index, value): self.app_pool_set_pkg[index] = value
    def getCform_buttons_list(self): return self.cform_buttons_list
    def setCform_buttons_list(self, value): self.cform_buttons_list = value
    def addCform_buttons_list(self, value): self.cform_buttons_list.append(value)
    def insertCform_buttons_list(self, index, value): self.cform_buttons_list[index] = value
    def getGet_limit_descriptor(self): return self.get_limit_descriptor
    def setGet_limit_descriptor(self, value): self.get_limit_descriptor = value
    def addGet_limit_descriptor(self, value): self.get_limit_descriptor.append(value)
    def insertGet_limit_descriptor(self, index, value): self.get_limit_descriptor[index] = value
    def getGet_permission_descriptor(self): return self.get_permission_descriptor
    def setGet_permission_descriptor(self, value): self.get_permission_descriptor = value
    def addGet_permission_descriptor(self, value): self.get_permission_descriptor.append(value)
    def insertGet_permission_descriptor(self, index, value): self.get_permission_descriptor[index] = value
    def getConvert_to_client(self): return self.convert_to_client
    def setConvert_to_client(self, value): self.convert_to_client = value
    def addConvert_to_client(self, value): self.convert_to_client.append(value)
    def insertConvert_to_client(self, index, value): self.convert_to_client[index] = value
    def export(self, outfile, level, name_='ResellerInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerInput'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for ippool_add_ip_ in self.getIppool_add_ip():
            ippool_add_ip_.export(outfile, level, name_='ippool-add-ip')
        for ippool_del_ip_ in self.getIppool_del_ip():
            ippool_del_ip_.export(outfile, level, name_='ippool-del-ip')
        for ippool_set_ip_ in self.getIppool_set_ip():
            ippool_set_ip_.export(outfile, level, name_='ippool-set-ip')
        for app_pool_set_pkg_ in self.getApp_pool_set_pkg():
            app_pool_set_pkg_.export(outfile, level, name_='app-pool-set-pkg')
        for cform_buttons_list_ in self.getCform_buttons_list():
            cform_buttons_list_.export(outfile, level)
        for get_limit_descriptor_ in self.getGet_limit_descriptor():
            get_limit_descriptor_.export(outfile, level)
        for get_permission_descriptor_ in self.getGet_permission_descriptor():
            get_permission_descriptor_.export(outfile, level)
        for convert_to_client_ in self.getConvert_to_client():
            convert_to_client_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ResellerAddInput.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ResellerSetInput.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ResellerGetInput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ResellerDelInput.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-add-ip':
            obj_ = ResellerIpPoolOperation.factory()
            obj_.build(child_)
            self.ippool_add_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-del-ip':
            obj_ = ResellerIpPoolDelInput.factory()
            obj_.build(child_)
            self.ippool_del_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-set-ip':
            obj_ = ipPoolResellerSet.factory()
            obj_.build(child_)
            self.ippool_set_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'app-pool-set-pkg':
            obj_ = AppPoolResellerSet.factory()
            obj_.build(child_)
            self.app_pool_set_pkg.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cform-buttons-list':
            obj_ = cform_buttons_list.factory()
            obj_.build(child_)
            self.cform_buttons_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-limit-descriptor':
            obj_ = get_limit_descriptor.factory()
            obj_.build(child_)
            self.get_limit_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-permission-descriptor':
            obj_ = get_permission_descriptor.factory()
            obj_.build(child_)
            self.get_permission_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'convert-to-client':
            obj_ = convert_to_client.factory()
            obj_.build(child_)
            self.convert_to_client.append(obj_)
# end class ResellerInput


class ResellerAddInput:
    subclass = None
    def __init__(self, gen_info=None, add_packages_to_app_pool=None, limits=None, permissions=None, template_id=None, template_name=None, sbnet_user=None):
        self.gen_info = gen_info
        self.add_packages_to_app_pool = add_packages_to_app_pool
        self.limits = limits
        self.permissions = permissions
        self.template_id = template_id
        self.template_name = template_name
        self.sbnet_user = sbnet_user
    def factory(*args_, **kwargs_):
        if ResellerAddInput.subclass:
            return ResellerAddInput.subclass(*args_, **kwargs_)
        else:
            return ResellerAddInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getAdd_packages_to_app_pool(self): return self.add_packages_to_app_pool
    def setAdd_packages_to_app_pool(self, value): self.add_packages_to_app_pool = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getTemplate_id(self): return self.template_id
    def setTemplate_id(self, value): self.template_id = value
    def getTemplate_name(self): return self.template_name
    def setTemplate_name(self, value): self.template_name = value
    def getSbnet_user(self): return self.sbnet_user
    def setSbnet_user(self, value): self.sbnet_user = value
    def export(self, outfile, level, name_='ResellerAddInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerAddInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerAddInput'):
        if self.gen_info is not None:
            self.gen_info.export(outfile, level, name_='gen-info')
        if self.add_packages_to_app_pool is not None:
            self.add_packages_to_app_pool.export(outfile, level, name_='add-packages-to-app-pool')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.template_id is not None:
            showIndent(outfile, level)
            outfile.write('<template-id>%s</template-id>\n' % quote_xml(self.getTemplate_id()))
        if self.template_name is not None:
            showIndent(outfile, level)
            outfile.write('<template-name>%s</template-name>\n' % quote_xml(self.getTemplate_name()))
        if self.sbnet_user is not None:
            showIndent(outfile, level)
            outfile.write('<sbnet-user>%s</sbnet-user>\n' % quote_xml(self.getSbnet_user()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen-info':
            obj_ = ResellerAddGenInfo.factory()
            obj_.build(child_)
            self.setGen_info(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add-packages-to-app-pool':
            obj_ = ResellerAddPackagesToPool.factory()
            obj_.build(child_)
            self.setAdd_packages_to_app_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = ResellerLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'template-id':
            template_id_ = ''
            for text__content_ in child_.childNodes:
                template_id_ += text__content_.nodeValue
            self.template_id = template_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'template-name':
            template_name_ = ''
            for text__content_ in child_.childNodes:
                template_name_ += text__content_.nodeValue
            self.template_name = template_name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sbnet-user':
            sbnet_user_ = ''
            for text__content_ in child_.childNodes:
                sbnet_user_ += text__content_.nodeValue
            self.sbnet_user = sbnet_user_
# end class ResellerAddInput


class ResellerAddPackagesToPool:
    subclass = None
    def __init__(self, package_id=None):
        if package_id is None:
            self.package_id = []
        else:
            self.package_id = package_id
    def factory(*args_, **kwargs_):
        if ResellerAddPackagesToPool.subclass:
            return ResellerAddPackagesToPool.subclass(*args_, **kwargs_)
        else:
            return ResellerAddPackagesToPool(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getPackage_id(self): return self.package_id
    def setPackage_id(self, value): self.package_id = value
    def addPackage_id(self, value): self.package_id.append(value)
    def insertPackage_id(self, index, value): self.package_id[index] = value
    def export(self, outfile, level, name_='ResellerAddPackagesToPool'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerAddPackagesToPool'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerAddPackagesToPool'):
        for package_id_ in self.getPackage_id():
            showIndent(outfile, level)
            outfile.write('<package-id>%s</package-id>\n' % quote_xml(package_id_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'package-id':
            package_id_ = ''
            for text__content_ in child_.childNodes:
                package_id_ += text__content_.nodeValue
            self.addPackage_id(package_id_)
# end class ResellerAddPackagesToPool


class ResellerSetInput:
    subclass = None
    def __init__(self, filter=None, values=None):
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if ResellerSetInput.subclass:
            return ResellerSetInput.subclass(*args_, **kwargs_)
        else:
            return ResellerSetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='ResellerSetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerSetInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerSetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.values is not None:
            self.values.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerSelectionFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = values.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class ResellerSetInput


class ResellerSelectionFilter:
    subclass = None
    def __init__(self, id=None, login=None, guid=None, all=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if login is None:
            self.login = []
        else:
            self.login = login
        if guid is None:
            self.guid = []
        else:
            self.guid = guid
        self.all = all
    def factory(*args_, **kwargs_):
        if ResellerSelectionFilter.subclass:
            return ResellerSelectionFilter.subclass(*args_, **kwargs_)
        else:
            return ResellerSelectionFilter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def addLogin(self, value): self.login.append(value)
    def insertLogin(self, index, value): self.login[index] = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def addGuid(self, value): self.guid.append(value)
    def insertGuid(self, index, value): self.guid[index] = value
    def getAll(self): return self.all
    def setAll(self, value): self.all = value
    def export(self, outfile, level, name_='ResellerSelectionFilter'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerSelectionFilter'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerSelectionFilter'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for login_ in self.getLogin():
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(login_))
        for guid_ in self.getGuid():
            showIndent(outfile, level)
            outfile.write('<guid>%s</guid>\n' % quote_xml(guid_))
        if self.all is not None:
            self.all.export(outfile, level, name_='all')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.addLogin(login_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            guid_ = ''
            for text__content_ in child_.childNodes:
                guid_ += text__content_.nodeValue
            self.addGuid(guid_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'all':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setAll(obj_)
# end class ResellerSelectionFilter


class ResellerGetInput:
    subclass = None
    def __init__(self, filter=None, dataset=None):
        self.filter = filter
        self.dataset = dataset
    def factory(*args_, **kwargs_):
        if ResellerGetInput.subclass:
            return ResellerGetInput.subclass(*args_, **kwargs_)
        else:
            return ResellerGetInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getDataset(self): return self.dataset
    def setDataset(self, value): self.dataset = value
    def export(self, outfile, level, name_='ResellerGetInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerGetInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerGetInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.dataset is not None:
            self.dataset.export(outfile, level, name_='dataset')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerSelectionFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dataset':
            obj_ = ResellerDataset.factory()
            obj_.build(child_)
            self.setDataset(obj_)
# end class ResellerGetInput


class ResellerDelInput:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ResellerDelInput.subclass:
            return ResellerDelInput.subclass(*args_, **kwargs_)
        else:
            return ResellerDelInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ResellerDelInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerDelInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerDelInput'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerSelectionFilter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ResellerDelInput


class ResellerIp:
    subclass = None
    def __init__(self, ip_address='', ip_type=''):
        self.ip_address = ip_address
        self.ip_type = ip_type
    def factory(*args_, **kwargs_):
        if ResellerIp.subclass:
            return ResellerIp.subclass(*args_, **kwargs_)
        else:
            return ResellerIp(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def getIp_type(self): return self.ip_type
    def setIp_type(self, value): self.ip_type = value
    def export(self, outfile, level, name_='ResellerIp'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerIp'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerIp'):
        showIndent(outfile, level)
        outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(self.getIp_address()))
        showIndent(outfile, level)
        outfile.write('<ip-type>%s</ip-type>\n' % quote_xml(self.getIp_type()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.ip_address = ip_address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-type':
            ip_type_ = ''
            for text__content_ in child_.childNodes:
                ip_type_ += text__content_.nodeValue
            self.ip_type = ip_type_
# end class ResellerIp


class ResellerLimits:
    subclass = None
    def __init__(self, resource_policy=None, limit=None):
        self.resource_policy = resource_policy
        if limit is None:
            self.limit = []
        else:
            self.limit = limit
    def factory(*args_, **kwargs_):
        if ResellerLimits.subclass:
            return ResellerLimits.subclass(*args_, **kwargs_)
        else:
            return ResellerLimits(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResource_policy(self): return self.resource_policy
    def setResource_policy(self, value): self.resource_policy = value
    def getLimit(self): return self.limit
    def setLimit(self, value): self.limit = value
    def addLimit(self, value): self.limit.append(value)
    def insertLimit(self, index, value): self.limit[index] = value
    def export(self, outfile, level, name_='ResellerLimits'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerLimits'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerLimits'):
        if self.resource_policy is not None:
            self.resource_policy.export(outfile, level)
        for limit_ in self.getLimit():
            limit_.export(outfile, level, name_='limit')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'resource-policy':
            obj_ = resource_policy.factory()
            obj_.build(child_)
            self.setResource_policy(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limit':
            obj_ = PleskLimitType.factory()
            obj_.build(child_)
            self.limit.append(obj_)
# end class ResellerLimits


class ResellerDataset:
    subclass = None
    def __init__(self, gen_info=None, stat=None, permissions=None, limits=None, ippool=None):
        self.gen_info = gen_info
        self.stat = stat
        self.permissions = permissions
        self.limits = limits
        self.ippool = ippool
    def factory(*args_, **kwargs_):
        if ResellerDataset.subclass:
            return ResellerDataset.subclass(*args_, **kwargs_)
        else:
            return ResellerDataset(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getIppool(self): return self.ippool
    def setIppool(self, value): self.ippool = value
    def export(self, outfile, level, name_='ResellerDataset'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerDataset'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerDataset'):
        if self.gen_info is not None:
            showIndent(outfile, level)
            outfile.write('<gen-info>%s</gen-info>\n' % quote_xml(self.getGen_info()))
        if self.stat is not None:
            showIndent(outfile, level)
            outfile.write('<stat>%s</stat>\n' % quote_xml(self.getStat()))
        if self.permissions is not None:
            showIndent(outfile, level)
            outfile.write('<permissions>%s</permissions>\n' % quote_xml(self.getPermissions()))
        if self.limits is not None:
            self.limits.export(outfile, level)
        if self.ippool is not None:
            showIndent(outfile, level)
            outfile.write('<ippool>%s</ippool>\n' % quote_xml(self.getIppool()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen-info':
            gen_info_ = ''
            for text__content_ in child_.childNodes:
                gen_info_ += text__content_.nodeValue
            self.gen_info = gen_info_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            stat_ = ''
            for text__content_ in child_.childNodes:
                stat_ += text__content_.nodeValue
            self.stat = stat_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            permissions_ = ''
            for text__content_ in child_.childNodes:
                permissions_ += text__content_.nodeValue
            self.permissions = permissions_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = limits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool':
            ippool_ = ''
            for text__content_ in child_.childNodes:
                ippool_ += text__content_.nodeValue
            self.ippool = ippool_
# end class ResellerDataset


class ResellerAddGenInfo:
    subclass = None
    def __init__(self, cname=None, pname='', login='', passwd='', status=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, locale=None):
        self.cname = cname
        self.pname = pname
        self.login = login
        self.passwd = passwd
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
    def factory(*args_, **kwargs_):
        if ResellerAddGenInfo.subclass:
            return ResellerAddGenInfo.subclass(*args_, **kwargs_)
        else:
            return ResellerAddGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPasswd(self): return self.passwd
    def setPasswd(self, value): self.passwd = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def export(self, outfile, level, name_='ResellerAddGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerAddGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerAddGenInfo'):
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        showIndent(outfile, level)
        outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<passwd>%s</passwd>\n' % quote_xml(self.getPasswd()))
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.locale is not None:
            showIndent(outfile, level)
            outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'passwd':
            passwd_ = ''
            for text__content_ in child_.childNodes:
                passwd_ += text__content_.nodeValue
            self.passwd = passwd_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
# end class ResellerAddGenInfo


class ResellerSetGenInfo:
    subclass = None
    def __init__(self, cname=None, pname=None, login=None, passwd=None, status=None, phone=None, fax=None, email=None, address=None, city=None, state=None, pcode=None, country=None, locale=None, guid=None):
        self.cname = cname
        self.pname = pname
        self.login = login
        self.passwd = passwd
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
        self.guid = guid
    def factory(*args_, **kwargs_):
        if ResellerSetGenInfo.subclass:
            return ResellerSetGenInfo.subclass(*args_, **kwargs_)
        else:
            return ResellerSetGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getPasswd(self): return self.passwd
    def setPasswd(self, value): self.passwd = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def export(self, outfile, level, name_='ResellerSetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerSetGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerSetGenInfo'):
        if self.cname is not None:
            showIndent(outfile, level)
            outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        if self.pname is not None:
            showIndent(outfile, level)
            outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        if self.login is not None:
            showIndent(outfile, level)
            outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        if self.passwd is not None:
            showIndent(outfile, level)
            outfile.write('<passwd>%s</passwd>\n' % quote_xml(self.getPasswd()))
        if self.status is not None:
            showIndent(outfile, level)
            outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        if self.phone is not None:
            showIndent(outfile, level)
            outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        if self.fax is not None:
            showIndent(outfile, level)
            outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        if self.email is not None:
            showIndent(outfile, level)
            outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        if self.address is not None:
            showIndent(outfile, level)
            outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        if self.city is not None:
            showIndent(outfile, level)
            outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        if self.state is not None:
            showIndent(outfile, level)
            outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        if self.pcode is not None:
            showIndent(outfile, level)
            outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        if self.country is not None:
            showIndent(outfile, level)
            outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        if self.locale is not None:
            showIndent(outfile, level)
            outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
        if self.guid is not None:
            self.guid.export(outfile, level, name_='guid')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'passwd':
            passwd_ = ''
            for text__content_ in child_.childNodes:
                passwd_ += text__content_.nodeValue
            self.passwd = passwd_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setGuid(obj_)
# end class ResellerSetGenInfo


class ResellerIpPoolOperation:
    subclass = None
    def __init__(self, reseller_id='', ip=None):
        self.reseller_id = reseller_id
        if ip is None:
            self.ip = []
        else:
            self.ip = ip
    def factory(*args_, **kwargs_):
        if ResellerIpPoolOperation.subclass:
            return ResellerIpPoolOperation.subclass(*args_, **kwargs_)
        else:
            return ResellerIpPoolOperation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def addIp(self, value): self.ip.append(value)
    def insertIp(self, index, value): self.ip[index] = value
    def export(self, outfile, level, name_='ResellerIpPoolOperation'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerIpPoolOperation'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerIpPoolOperation'):
        showIndent(outfile, level)
        outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        for ip_ in self.getIp():
            ip_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = ip.factory()
            obj_.build(child_)
            self.ip.append(obj_)
# end class ResellerIpPoolOperation


class ResellerIpPoolDelInput:
    subclass = None
    def __init__(self, reseller_id='', ip_address=None):
        self.reseller_id = reseller_id
        if ip_address is None:
            self.ip_address = []
        else:
            self.ip_address = ip_address
    def factory(*args_, **kwargs_):
        if ResellerIpPoolDelInput.subclass:
            return ResellerIpPoolDelInput.subclass(*args_, **kwargs_)
        else:
            return ResellerIpPoolDelInput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def addIp_address(self, value): self.ip_address.append(value)
    def insertIp_address(self, index, value): self.ip_address[index] = value
    def export(self, outfile, level, name_='ResellerIpPoolDelInput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerIpPoolDelInput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerIpPoolDelInput'):
        showIndent(outfile, level)
        outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        for ip_address_ in self.getIp_address():
            showIndent(outfile, level)
            outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(ip_address_))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.addIp_address(ip_address_)
# end class ResellerIpPoolDelInput


class ipPoolResellerSet:
    subclass = None
    def __init__(self, reseller_id='', filter=None, values=None):
        self.reseller_id = reseller_id
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if ipPoolResellerSet.subclass:
            return ipPoolResellerSet.subclass(*args_, **kwargs_)
        else:
            return ipPoolResellerSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='ipPoolResellerSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ipPoolResellerSet'):
        pass
    def exportChildren(self, outfile, level, name_='ipPoolResellerSet'):
        showIndent(outfile, level)
        outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.filter is not None:
            self.filter.export(outfile, level)
        if self.values is not None:
            self.values.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = filter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = values.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class ipPoolResellerSet


class AppPoolResellerSet:
    subclass = None
    def __init__(self, reseller_id='', filter=None, values=None):
        self.reseller_id = reseller_id
        self.filter = filter
        self.values = values
    def factory(*args_, **kwargs_):
        if AppPoolResellerSet.subclass:
            return AppPoolResellerSet.subclass(*args_, **kwargs_)
        else:
            return AppPoolResellerSet(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getReseller_id(self): return self.reseller_id
    def setReseller_id(self, value): self.reseller_id = value
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getValues(self): return self.values
    def setValues(self, value): self.values = value
    def export(self, outfile, level, name_='AppPoolResellerSet'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='AppPoolResellerSet'):
        pass
    def exportChildren(self, outfile, level, name_='AppPoolResellerSet'):
        showIndent(outfile, level)
        outfile.write('<reseller-id>%s</reseller-id>\n' % quote_xml(self.getReseller_id()))
        if self.filter is not None:
            self.filter.export(outfile, level)
        if self.values is not None:
            self.values.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-id':
            reseller_id_ = ''
            for text__content_ in child_.childNodes:
                reseller_id_ += text__content_.nodeValue
            self.reseller_id = reseller_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = filter.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'values':
            obj_ = values.factory()
            obj_.build(child_)
            self.setValues(obj_)
# end class AppPoolResellerSet


class ResellerOutput:
    subclass = None
    def __init__(self, add=None, set=None, get=None, ddel=None, ippool_add_ip=None, ippool_del_ip=None, ippool_set_ip=None, app_pool_set_pkg=None, cform_buttons_list=None, get_limit_descriptor=None, get_permission_descriptor=None, convert_to_client=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if set is None:
            self.set = []
        else:
            self.set = set
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if ippool_add_ip is None:
            self.ippool_add_ip = []
        else:
            self.ippool_add_ip = ippool_add_ip
        if ippool_del_ip is None:
            self.ippool_del_ip = []
        else:
            self.ippool_del_ip = ippool_del_ip
        if ippool_set_ip is None:
            self.ippool_set_ip = []
        else:
            self.ippool_set_ip = ippool_set_ip
        if app_pool_set_pkg is None:
            self.app_pool_set_pkg = []
        else:
            self.app_pool_set_pkg = app_pool_set_pkg
        if cform_buttons_list is None:
            self.cform_buttons_list = []
        else:
            self.cform_buttons_list = cform_buttons_list
        if get_limit_descriptor is None:
            self.get_limit_descriptor = []
        else:
            self.get_limit_descriptor = get_limit_descriptor
        if get_permission_descriptor is None:
            self.get_permission_descriptor = []
        else:
            self.get_permission_descriptor = get_permission_descriptor
        if convert_to_client is None:
            self.convert_to_client = []
        else:
            self.convert_to_client = convert_to_client
    def factory(*args_, **kwargs_):
        if ResellerOutput.subclass:
            return ResellerOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getIppool_add_ip(self): return self.ippool_add_ip
    def setIppool_add_ip(self, value): self.ippool_add_ip = value
    def addIppool_add_ip(self, value): self.ippool_add_ip.append(value)
    def insertIppool_add_ip(self, index, value): self.ippool_add_ip[index] = value
    def getIppool_del_ip(self): return self.ippool_del_ip
    def setIppool_del_ip(self, value): self.ippool_del_ip = value
    def addIppool_del_ip(self, value): self.ippool_del_ip.append(value)
    def insertIppool_del_ip(self, index, value): self.ippool_del_ip[index] = value
    def getIppool_set_ip(self): return self.ippool_set_ip
    def setIppool_set_ip(self, value): self.ippool_set_ip = value
    def addIppool_set_ip(self, value): self.ippool_set_ip.append(value)
    def insertIppool_set_ip(self, index, value): self.ippool_set_ip[index] = value
    def getApp_pool_set_pkg(self): return self.app_pool_set_pkg
    def setApp_pool_set_pkg(self, value): self.app_pool_set_pkg = value
    def addApp_pool_set_pkg(self, value): self.app_pool_set_pkg.append(value)
    def insertApp_pool_set_pkg(self, index, value): self.app_pool_set_pkg[index] = value
    def getCform_buttons_list(self): return self.cform_buttons_list
    def setCform_buttons_list(self, value): self.cform_buttons_list = value
    def addCform_buttons_list(self, value): self.cform_buttons_list.append(value)
    def insertCform_buttons_list(self, index, value): self.cform_buttons_list[index] = value
    def getGet_limit_descriptor(self): return self.get_limit_descriptor
    def setGet_limit_descriptor(self, value): self.get_limit_descriptor = value
    def addGet_limit_descriptor(self, value): self.get_limit_descriptor.append(value)
    def insertGet_limit_descriptor(self, index, value): self.get_limit_descriptor[index] = value
    def getGet_permission_descriptor(self): return self.get_permission_descriptor
    def setGet_permission_descriptor(self, value): self.get_permission_descriptor = value
    def addGet_permission_descriptor(self, value): self.get_permission_descriptor.append(value)
    def insertGet_permission_descriptor(self, index, value): self.get_permission_descriptor[index] = value
    def getConvert_to_client(self): return self.convert_to_client
    def setConvert_to_client(self, value): self.convert_to_client = value
    def addConvert_to_client(self, value): self.convert_to_client.append(value)
    def insertConvert_to_client(self, index, value): self.convert_to_client[index] = value
    def export(self, outfile, level, name_='ResellerOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerOutput'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for set_ in self.getSet():
            set_.export(outfile, level)
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level)
        for ippool_add_ip_ in self.getIppool_add_ip():
            ippool_add_ip_.export(outfile, level, name_='ippool-add-ip')
        for ippool_del_ip_ in self.getIppool_del_ip():
            ippool_del_ip_.export(outfile, level, name_='ippool-del-ip')
        for ippool_set_ip_ in self.getIppool_set_ip():
            ippool_set_ip_.export(outfile, level, name_='ippool-set-ip')
        for app_pool_set_pkg_ in self.getApp_pool_set_pkg():
            app_pool_set_pkg_.export(outfile, level, name_='app-pool-set-pkg')
        for cform_buttons_list_ in self.getCform_buttons_list():
            cform_buttons_list_.export(outfile, level, name_='cform-buttons-list')
        for get_limit_descriptor_ in self.getGet_limit_descriptor():
            get_limit_descriptor_.export(outfile, level, name_='get-limit-descriptor')
        for get_permission_descriptor_ in self.getGet_permission_descriptor():
            get_permission_descriptor_.export(outfile, level, name_='get-permission-descriptor')
        for convert_to_client_ in self.getConvert_to_client():
            convert_to_client_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ResellerAddOutput.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = set.factory()
            obj_.build(child_)
            self.set.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ResellerGetOutput.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ddel.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-add-ip':
            obj_ = ResellerIpPoolOperationOutput.factory()
            obj_.build(child_)
            self.ippool_add_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-del-ip':
            obj_ = ResellerIpPoolOperationOutput.factory()
            obj_.build(child_)
            self.ippool_del_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool-set-ip':
            obj_ = ResellerIpPoolOperationOutput.factory()
            obj_.build(child_)
            self.ippool_set_ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'app-pool-set-pkg':
            obj_ = ResellerAppPoolSetOutput.factory()
            obj_.build(child_)
            self.app_pool_set_pkg.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cform-buttons-list':
            obj_ = ResellerCFormButtonsListOutput.factory()
            obj_.build(child_)
            self.cform_buttons_list.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-limit-descriptor':
            obj_ = ResellerDescriptorOutput.factory()
            obj_.build(child_)
            self.get_limit_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get-permission-descriptor':
            obj_ = ResellerDescriptorOutput.factory()
            obj_.build(child_)
            self.get_permission_descriptor.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'convert-to-client':
            obj_ = convert_to_client.factory()
            obj_.build(child_)
            self.convert_to_client.append(obj_)
# end class ResellerOutput


class ResellerAddOutput:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ResellerAddOutput.subclass:
            return ResellerAddOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerAddOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ResellerAddOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerAddOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerAddOutput'):
        if self.result is not None:
            self.result.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ResellerAddOutput


class ResellerGetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerGetOutput.subclass:
            return ResellerGetOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerGetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerGetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerGetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerGetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerGetOutput


class ResellerData:
    subclass = None
    def __init__(self, gen_info=None, stat=None, permissions=None, limits=None, ippool=None, sbnet_user=None):
        self.gen_info = gen_info
        self.stat = stat
        self.permissions = permissions
        self.limits = limits
        self.ippool = ippool
        self.sbnet_user = sbnet_user
    def factory(*args_, **kwargs_):
        if ResellerData.subclass:
            return ResellerData.subclass(*args_, **kwargs_)
        else:
            return ResellerData(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getGen_info(self): return self.gen_info
    def setGen_info(self, value): self.gen_info = value
    def getStat(self): return self.stat
    def setStat(self, value): self.stat = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getIppool(self): return self.ippool
    def setIppool(self, value): self.ippool = value
    def getSbnet_user(self): return self.sbnet_user
    def setSbnet_user(self, value): self.sbnet_user = value
    def export(self, outfile, level, name_='ResellerData'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerData'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerData'):
        if self.gen_info is not None:
            self.gen_info.export(outfile, level, name_='gen-info')
        if self.stat is not None:
            self.stat.export(outfile, level, name_='stat')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.ippool is not None:
            self.ippool.export(outfile, level, name_='ippool')
        if self.sbnet_user is not None:
            showIndent(outfile, level)
            outfile.write('<sbnet-user>%s</sbnet-user>\n' % quote_xml(self.getSbnet_user()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'gen-info':
            obj_ = ResellerGetGenInfo.factory()
            obj_.build(child_)
            self.setGen_info(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'stat':
            obj_ = ResellerStatType.factory()
            obj_.build(child_)
            self.setStat(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = ResellerLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ippool':
            obj_ = ipPoolType.factory()
            obj_.build(child_)
            self.setIppool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sbnet-user':
            sbnet_user_ = ''
            for text__content_ in child_.childNodes:
                sbnet_user_ += text__content_.nodeValue
            self.sbnet_user = sbnet_user_
# end class ResellerData


class ResellerGetGenInfo:
    subclass = None
    def __init__(self, cr_date='', cname='', pname='', login='', status='', phone='', fax='', email='', address='', city='', state='', pcode='', country='', locale='', password=None, password_type=None, guid=None):
        self.cr_date = cr_date
        self.cname = cname
        self.pname = pname
        self.login = login
        self.status = status
        self.phone = phone
        self.fax = fax
        self.email = email
        self.address = address
        self.city = city
        self.state = state
        self.pcode = pcode
        self.country = country
        self.locale = locale
        self.password = password
        self.password_type = password_type
        self.guid = guid
    def factory(*args_, **kwargs_):
        if ResellerGetGenInfo.subclass:
            return ResellerGetGenInfo.subclass(*args_, **kwargs_)
        else:
            return ResellerGetGenInfo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCr_date(self): return self.cr_date
    def setCr_date(self, value): self.cr_date = value
    def getCname(self): return self.cname
    def setCname(self, value): self.cname = value
    def getPname(self): return self.pname
    def setPname(self, value): self.pname = value
    def getLogin(self): return self.login
    def setLogin(self, value): self.login = value
    def getStatus(self): return self.status
    def setStatus(self, value): self.status = value
    def getPhone(self): return self.phone
    def setPhone(self, value): self.phone = value
    def getFax(self): return self.fax
    def setFax(self, value): self.fax = value
    def getEmail(self): return self.email
    def setEmail(self, value): self.email = value
    def getAddress(self): return self.address
    def setAddress(self, value): self.address = value
    def getCity(self): return self.city
    def setCity(self, value): self.city = value
    def getState(self): return self.state
    def setState(self, value): self.state = value
    def getPcode(self): return self.pcode
    def setPcode(self, value): self.pcode = value
    def getCountry(self): return self.country
    def setCountry(self, value): self.country = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def getPassword(self): return self.password
    def setPassword(self, value): self.password = value
    def getPassword_type(self): return self.password_type
    def setPassword_type(self, value): self.password_type = value
    def getGuid(self): return self.guid
    def setGuid(self, value): self.guid = value
    def export(self, outfile, level, name_='ResellerGetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerGetGenInfo'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerGetGenInfo'):
        showIndent(outfile, level)
        outfile.write('<cr-date>%s</cr-date>\n' % quote_xml(self.getCr_date()))
        showIndent(outfile, level)
        outfile.write('<cname>%s</cname>\n' % quote_xml(self.getCname()))
        showIndent(outfile, level)
        outfile.write('<pname>%s</pname>\n' % quote_xml(self.getPname()))
        showIndent(outfile, level)
        outfile.write('<login>%s</login>\n' % quote_xml(self.getLogin()))
        showIndent(outfile, level)
        outfile.write('<status>%s</status>\n' % quote_xml(self.getStatus()))
        showIndent(outfile, level)
        outfile.write('<phone>%s</phone>\n' % quote_xml(self.getPhone()))
        showIndent(outfile, level)
        outfile.write('<fax>%s</fax>\n' % quote_xml(self.getFax()))
        showIndent(outfile, level)
        outfile.write('<email>%s</email>\n' % quote_xml(self.getEmail()))
        showIndent(outfile, level)
        outfile.write('<address>%s</address>\n' % quote_xml(self.getAddress()))
        showIndent(outfile, level)
        outfile.write('<city>%s</city>\n' % quote_xml(self.getCity()))
        showIndent(outfile, level)
        outfile.write('<state>%s</state>\n' % quote_xml(self.getState()))
        showIndent(outfile, level)
        outfile.write('<pcode>%s</pcode>\n' % quote_xml(self.getPcode()))
        showIndent(outfile, level)
        outfile.write('<country>%s</country>\n' % quote_xml(self.getCountry()))
        showIndent(outfile, level)
        outfile.write('<locale>%s</locale>\n' % quote_xml(self.getLocale()))
        if self.password is not None:
            showIndent(outfile, level)
            outfile.write('<password>%s</password>\n' % quote_xml(self.getPassword()))
        if self.password_type is not None:
            showIndent(outfile, level)
            outfile.write('<password-type>%s</password-type>\n' % quote_xml(self.getPassword_type()))
        if self.guid is not None:
            showIndent(outfile, level)
            outfile.write('<guid>%s</guid>\n' % quote_xml(self.getGuid()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cr-date':
            cr_date_ = ''
            for text__content_ in child_.childNodes:
                cr_date_ += text__content_.nodeValue
            self.cr_date = cr_date_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'cname':
            cname_ = ''
            for text__content_ in child_.childNodes:
                cname_ += text__content_.nodeValue
            self.cname = cname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pname':
            pname_ = ''
            for text__content_ in child_.childNodes:
                pname_ += text__content_.nodeValue
            self.pname = pname_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'login':
            login_ = ''
            for text__content_ in child_.childNodes:
                login_ += text__content_.nodeValue
            self.login = login_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'status':
            status_ = ''
            for text__content_ in child_.childNodes:
                status_ += text__content_.nodeValue
            self.status = status_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'phone':
            phone_ = ''
            for text__content_ in child_.childNodes:
                phone_ += text__content_.nodeValue
            self.phone = phone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fax':
            fax_ = ''
            for text__content_ in child_.childNodes:
                fax_ += text__content_.nodeValue
            self.fax = fax_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'email':
            email_ = ''
            for text__content_ in child_.childNodes:
                email_ += text__content_.nodeValue
            self.email = email_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'address':
            address_ = ''
            for text__content_ in child_.childNodes:
                address_ += text__content_.nodeValue
            self.address = address_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'city':
            city_ = ''
            for text__content_ in child_.childNodes:
                city_ += text__content_.nodeValue
            self.city = city_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'state':
            state_ = ''
            for text__content_ in child_.childNodes:
                state_ += text__content_.nodeValue
            self.state = state_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'pcode':
            pcode_ = ''
            for text__content_ in child_.childNodes:
                pcode_ += text__content_.nodeValue
            self.pcode = pcode_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'country':
            country_ = ''
            for text__content_ in child_.childNodes:
                country_ += text__content_.nodeValue
            self.country = country_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            locale_ = ''
            for text__content_ in child_.childNodes:
                locale_ += text__content_.nodeValue
            self.locale = locale_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password':
            password_ = ''
            for text__content_ in child_.childNodes:
                password_ += text__content_.nodeValue
            self.password = password_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'password-type':
            password_type_ = ''
            for text__content_ in child_.childNodes:
                password_type_ += text__content_.nodeValue
            self.password_type = password_type_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'guid':
            guid_ = ''
            for text__content_ in child_.childNodes:
                guid_ += text__content_.nodeValue
            self.guid = guid_
# end class ResellerGetGenInfo


class ResellerStatType:
    subclass = None
    def __init__(self, active_clients='', active_domains='', subdomains='', domain_aliases='', disk_space='', web_users='', data_bases='', postboxs='', mbox_quota='', redirects='', mail_groups='', mail_resps='', mail_lists='', webapps='', traffic='', traffic_prevday=''):
        self.active_clients = active_clients
        self.active_domains = active_domains
        self.subdomains = subdomains
        self.domain_aliases = domain_aliases
        self.disk_space = disk_space
        self.web_users = web_users
        self.data_bases = data_bases
        self.postboxs = postboxs
        self.mbox_quota = mbox_quota
        self.redirects = redirects
        self.mail_groups = mail_groups
        self.mail_resps = mail_resps
        self.mail_lists = mail_lists
        self.webapps = webapps
        self.traffic = traffic
        self.traffic_prevday = traffic_prevday
    def factory(*args_, **kwargs_):
        if ResellerStatType.subclass:
            return ResellerStatType.subclass(*args_, **kwargs_)
        else:
            return ResellerStatType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getActive_clients(self): return self.active_clients
    def setActive_clients(self, value): self.active_clients = value
    def getActive_domains(self): return self.active_domains
    def setActive_domains(self, value): self.active_domains = value
    def getSubdomains(self): return self.subdomains
    def setSubdomains(self, value): self.subdomains = value
    def getDomain_aliases(self): return self.domain_aliases
    def setDomain_aliases(self, value): self.domain_aliases = value
    def getDisk_space(self): return self.disk_space
    def setDisk_space(self, value): self.disk_space = value
    def getWeb_users(self): return self.web_users
    def setWeb_users(self, value): self.web_users = value
    def getData_bases(self): return self.data_bases
    def setData_bases(self, value): self.data_bases = value
    def getPostboxs(self): return self.postboxs
    def setPostboxs(self, value): self.postboxs = value
    def getMbox_quota(self): return self.mbox_quota
    def setMbox_quota(self, value): self.mbox_quota = value
    def getRedirects(self): return self.redirects
    def setRedirects(self, value): self.redirects = value
    def getMail_groups(self): return self.mail_groups
    def setMail_groups(self, value): self.mail_groups = value
    def getMail_resps(self): return self.mail_resps
    def setMail_resps(self, value): self.mail_resps = value
    def getMail_lists(self): return self.mail_lists
    def setMail_lists(self, value): self.mail_lists = value
    def getWebapps(self): return self.webapps
    def setWebapps(self, value): self.webapps = value
    def getTraffic(self): return self.traffic
    def setTraffic(self, value): self.traffic = value
    def getTraffic_prevday(self): return self.traffic_prevday
    def setTraffic_prevday(self, value): self.traffic_prevday = value
    def export(self, outfile, level, name_='ResellerStatType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerStatType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerStatType'):
        showIndent(outfile, level)
        outfile.write('<active-clients>%s</active-clients>\n' % quote_xml(self.getActive_clients()))
        showIndent(outfile, level)
        outfile.write('<active-domains>%s</active-domains>\n' % quote_xml(self.getActive_domains()))
        showIndent(outfile, level)
        outfile.write('<subdomains>%s</subdomains>\n' % quote_xml(self.getSubdomains()))
        showIndent(outfile, level)
        outfile.write('<domain-aliases>%s</domain-aliases>\n' % quote_xml(self.getDomain_aliases()))
        showIndent(outfile, level)
        outfile.write('<disk-space>%s</disk-space>\n' % quote_xml(self.getDisk_space()))
        showIndent(outfile, level)
        outfile.write('<web-users>%s</web-users>\n' % quote_xml(self.getWeb_users()))
        showIndent(outfile, level)
        outfile.write('<data-bases>%s</data-bases>\n' % quote_xml(self.getData_bases()))
        showIndent(outfile, level)
        outfile.write('<postboxs>%s</postboxs>\n' % quote_xml(self.getPostboxs()))
        showIndent(outfile, level)
        outfile.write('<mbox-quota>%s</mbox-quota>\n' % quote_xml(self.getMbox_quota()))
        showIndent(outfile, level)
        outfile.write('<redirects>%s</redirects>\n' % quote_xml(self.getRedirects()))
        showIndent(outfile, level)
        outfile.write('<mail-groups>%s</mail-groups>\n' % quote_xml(self.getMail_groups()))
        showIndent(outfile, level)
        outfile.write('<mail-resps>%s</mail-resps>\n' % quote_xml(self.getMail_resps()))
        showIndent(outfile, level)
        outfile.write('<mail-lists>%s</mail-lists>\n' % quote_xml(self.getMail_lists()))
        showIndent(outfile, level)
        outfile.write('<webapps>%s</webapps>\n' % quote_xml(self.getWebapps()))
        showIndent(outfile, level)
        outfile.write('<traffic>%s</traffic>\n' % quote_xml(self.getTraffic()))
        showIndent(outfile, level)
        outfile.write('<traffic-prevday>%s</traffic-prevday>\n' % quote_xml(self.getTraffic_prevday()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'active-clients':
            active_clients_ = ''
            for text__content_ in child_.childNodes:
                active_clients_ += text__content_.nodeValue
            self.active_clients = active_clients_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'active-domains':
            active_domains_ = ''
            for text__content_ in child_.childNodes:
                active_domains_ += text__content_.nodeValue
            self.active_domains = active_domains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdomains':
            subdomains_ = ''
            for text__content_ in child_.childNodes:
                subdomains_ += text__content_.nodeValue
            self.subdomains = subdomains_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-aliases':
            domain_aliases_ = ''
            for text__content_ in child_.childNodes:
                domain_aliases_ += text__content_.nodeValue
            self.domain_aliases = domain_aliases_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disk-space':
            disk_space_ = ''
            for text__content_ in child_.childNodes:
                disk_space_ += text__content_.nodeValue
            self.disk_space = disk_space_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'web-users':
            web_users_ = ''
            for text__content_ in child_.childNodes:
                web_users_ += text__content_.nodeValue
            self.web_users = web_users_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'data-bases':
            data_bases_ = ''
            for text__content_ in child_.childNodes:
                data_bases_ += text__content_.nodeValue
            self.data_bases = data_bases_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'postboxs':
            postboxs_ = ''
            for text__content_ in child_.childNodes:
                postboxs_ += text__content_.nodeValue
            self.postboxs = postboxs_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mbox-quota':
            mbox_quota_ = ''
            for text__content_ in child_.childNodes:
                mbox_quota_ += text__content_.nodeValue
            self.mbox_quota = mbox_quota_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'redirects':
            redirects_ = ''
            for text__content_ in child_.childNodes:
                redirects_ += text__content_.nodeValue
            self.redirects = redirects_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail-groups':
            mail_groups_ = ''
            for text__content_ in child_.childNodes:
                mail_groups_ += text__content_.nodeValue
            self.mail_groups = mail_groups_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail-resps':
            mail_resps_ = ''
            for text__content_ in child_.childNodes:
                mail_resps_ += text__content_.nodeValue
            self.mail_resps = mail_resps_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail-lists':
            mail_lists_ = ''
            for text__content_ in child_.childNodes:
                mail_lists_ += text__content_.nodeValue
            self.mail_lists = mail_lists_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webapps':
            webapps_ = ''
            for text__content_ in child_.childNodes:
                webapps_ += text__content_.nodeValue
            self.webapps = webapps_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic':
            traffic_ = ''
            for text__content_ in child_.childNodes:
                traffic_ += text__content_.nodeValue
            self.traffic = traffic_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'traffic-prevday':
            traffic_prevday_ = ''
            for text__content_ in child_.childNodes:
                traffic_prevday_ += text__content_.nodeValue
            self.traffic_prevday = traffic_prevday_
# end class ResellerStatType


class ResellerCFormButtonsListOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerCFormButtonsListOutput.subclass:
            return ResellerCFormButtonsListOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerCFormButtonsListOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerCFormButtonsListOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerCFormButtonsListOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerCFormButtonsListOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerCFormButtonsListOutput


class ResellerDescriptorOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerDescriptorOutput.subclass:
            return ResellerDescriptorOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerDescriptorOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerDescriptorOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerDescriptorOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerDescriptorOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerDescriptorOutput


class ResellerIpPoolOperationOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerIpPoolOperationOutput.subclass:
            return ResellerIpPoolOperationOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerIpPoolOperationOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerIpPoolOperationOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerIpPoolOperationOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerIpPoolOperationOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerIpPoolOperationOutput


class ResellerAppPoolSetOutput:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerAppPoolSetOutput.subclass:
            return ResellerAppPoolSetOutput.subclass(*args_, **kwargs_)
        else:
            return ResellerAppPoolSetOutput(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerAppPoolSetOutput'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerAppPoolSetOutput'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerAppPoolSetOutput'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerAppPoolSetOutput


class ResellerTemplateInputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if ResellerTemplateInputType.subclass:
            return ResellerTemplateInputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='ResellerTemplateInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateInputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ResellerTemplateAddInputType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ResellerTemplateGetInputType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ResellerTemplateDelInputType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ResellerTemplateSetInputType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class ResellerTemplateInputType


class ResellerTemplateAddInputType:
    subclass = None
    def __init__(self, name='', limits=None, permissions=None, ip_pool=None, preferences=None):
        self.name = name
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
    def factory(*args_, **kwargs_):
        if ResellerTemplateAddInputType.subclass:
            return ResellerTemplateAddInputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def export(self, outfile, level, name_='ResellerTemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateAddInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateAddInputType'):
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = ResellerLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = ResellerTemplateIpPoolType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = ResellerTemplatePreferencesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
# end class ResellerTemplateAddInputType


class ResellerTemplateGetInputType:
    subclass = None
    def __init__(self, filter=None, limits=None, permissions=None, ip_pool=None, preferences=None):
        self.filter = filter
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
    def factory(*args_, **kwargs_):
        if ResellerTemplateGetInputType.subclass:
            return ResellerTemplateGetInputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateGetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def export(self, outfile, level, name_='ResellerTemplateGetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateGetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateGetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
# end class ResellerTemplateGetInputType


class ResellerTemplateDelInputType:
    subclass = None
    def __init__(self, filter=None):
        self.filter = filter
    def factory(*args_, **kwargs_):
        if ResellerTemplateDelInputType.subclass:
            return ResellerTemplateDelInputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateDelInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def export(self, outfile, level, name_='ResellerTemplateDelInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateDelInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateDelInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
# end class ResellerTemplateDelInputType


class ResellerTemplateSetInputType:
    subclass = None
    def __init__(self, filter=None, limits=None, permissions=None, ip_pool=None, preferences=None):
        self.filter = filter
        self.limits = limits
        self.permissions = permissions
        self.ip_pool = ip_pool
        self.preferences = preferences
    def factory(*args_, **kwargs_):
        if ResellerTemplateSetInputType.subclass:
            return ResellerTemplateSetInputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateSetInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getFilter(self): return self.filter
    def setFilter(self, value): self.filter = value
    def getLimits(self): return self.limits
    def setLimits(self, value): self.limits = value
    def getPermissions(self): return self.permissions
    def setPermissions(self, value): self.permissions = value
    def getIp_pool(self): return self.ip_pool
    def setIp_pool(self, value): self.ip_pool = value
    def getPreferences(self): return self.preferences
    def setPreferences(self, value): self.preferences = value
    def export(self, outfile, level, name_='ResellerTemplateSetInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateSetInputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateSetInputType'):
        if self.filter is not None:
            self.filter.export(outfile, level, name_='filter')
        if self.limits is not None:
            self.limits.export(outfile, level, name_='limits')
        if self.permissions is not None:
            self.permissions.export(outfile, level, name_='permissions')
        if self.ip_pool is not None:
            self.ip_pool.export(outfile, level, name_='ip-pool')
        if self.preferences is not None:
            self.preferences.export(outfile, level, name_='preferences')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'filter':
            obj_ = ResellerTemplateFilterType.factory()
            obj_.build(child_)
            self.setFilter(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'limits':
            obj_ = ResellerLimits.factory()
            obj_.build(child_)
            self.setLimits(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'permissions':
            obj_ = clientPerms.factory()
            obj_.build(child_)
            self.setPermissions(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-pool':
            obj_ = ResellerTemplateIpPoolType.factory()
            obj_.build(child_)
            self.setIp_pool(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'preferences':
            obj_ = ResellerTemplatePreferencesType.factory()
            obj_.build(child_)
            self.setPreferences(obj_)
# end class ResellerTemplateSetInputType


class ResellerTemplateFilterType:
    subclass = None
    def __init__(self, id=None, name=None, all=None):
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
        self.all = all
    def factory(*args_, **kwargs_):
        if ResellerTemplateFilterType.subclass:
            return ResellerTemplateFilterType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateFilterType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def addId(self, value): self.id.append(value)
    def insertId(self, index, value): self.id[index] = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def addName(self, value): self.name.append(value)
    def insertName(self, index, value): self.name[index] = value
    def getAll(self): return self.all
    def setAll(self, value): self.all = value
    def export(self, outfile, level, name_='ResellerTemplateFilterType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateFilterType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateFilterType'):
        for id_ in self.getId():
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(id_))
        for name_ in self.getName():
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(name_))
        if self.all is not None:
            self.all.export(outfile, level, name_='all')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.addId(id_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.addName(name_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'all':
            obj_ = NoneType.factory()
            obj_.build(child_)
            self.setAll(obj_)
# end class ResellerTemplateFilterType


class ResellerTemplateIpPoolType:
    subclass = None
    def __init__(self, ip_address=None, allocate_ip=None):
        if ip_address is None:
            self.ip_address = []
        else:
            self.ip_address = ip_address
        self.allocate_ip = allocate_ip
    def factory(*args_, **kwargs_):
        if ResellerTemplateIpPoolType.subclass:
            return ResellerTemplateIpPoolType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateIpPoolType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getIp_address(self): return self.ip_address
    def setIp_address(self, value): self.ip_address = value
    def addIp_address(self, value): self.ip_address.append(value)
    def insertIp_address(self, index, value): self.ip_address[index] = value
    def getAllocate_ip(self): return self.allocate_ip
    def setAllocate_ip(self, value): self.allocate_ip = value
    def export(self, outfile, level, name_='ResellerTemplateIpPoolType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateIpPoolType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateIpPoolType'):
        for ip_address_ in self.getIp_address():
            showIndent(outfile, level)
            outfile.write('<ip-address>%s</ip-address>\n' % quote_xml(ip_address_))
        if self.allocate_ip is not None:
            showIndent(outfile, level)
            outfile.write('<allocate-ip>%s</allocate-ip>\n' % quote_xml(self.getAllocate_ip()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip-address':
            ip_address_ = ''
            for text__content_ in child_.childNodes:
                ip_address_ += text__content_.nodeValue
            self.addIp_address(ip_address_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'allocate-ip':
            allocate_ip_ = ''
            for text__content_ in child_.childNodes:
                allocate_ip_ += text__content_.nodeValue
            self.allocate_ip = allocate_ip_
# end class ResellerTemplateIpPoolType


class ResellerTemplateOutputType:
    subclass = None
    def __init__(self, add=None, get=None, ddel=None, set=None):
        if add is None:
            self.add = []
        else:
            self.add = add
        if get is None:
            self.get = []
        else:
            self.get = get
        if ddel is None:
            self.ddel = []
        else:
            self.ddel = ddel
        if set is None:
            self.set = []
        else:
            self.set = set
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputType.subclass:
            return ResellerTemplateOutputType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getAdd(self): return self.add
    def setAdd(self, value): self.add = value
    def addAdd(self, value): self.add.append(value)
    def insertAdd(self, index, value): self.add[index] = value
    def getGet(self): return self.get
    def setGet(self, value): self.get = value
    def addGet(self, value): self.get.append(value)
    def insertGet(self, index, value): self.get[index] = value
    def getDel(self): return self.ddel
    def setDel(self, value): self.ddel = value
    def addDel(self, value): self.ddel.append(value)
    def insertDel(self, index, value): self.ddel[index] = value
    def getSet(self): return self.set
    def setSet(self, value): self.set = value
    def addSet(self, value): self.set.append(value)
    def insertSet(self, index, value): self.set[index] = value
    def export(self, outfile, level, name_='ResellerTemplateOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputType'):
        for add_ in self.getAdd():
            add_.export(outfile, level, name_='add')
        for get_ in self.getGet():
            get_.export(outfile, level, name_='get')
        for del_ in self.getDel():
            del_.export(outfile, level, name_='del')
        for set_ in self.getSet():
            set_.export(outfile, level, name_='set')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'add':
            obj_ = ResellerTemplateOutputAddType.factory()
            obj_.build(child_)
            self.add.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'get':
            obj_ = ResellerTemplateOutputGetType.factory()
            obj_.build(child_)
            self.get.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'del':
            obj_ = ResellerTemplateOutputDelType.factory()
            obj_.build(child_)
            self.ddel.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'set':
            obj_ = ResellerTemplateOutputSetType.factory()
            obj_.build(child_)
            self.set.append(obj_)
# end class ResellerTemplateOutputType


class ResellerTemplateOutputAddType:
    subclass = None
    def __init__(self, result=None):
        self.result = result
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputAddType.subclass:
            return ResellerTemplateOutputAddType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputAddType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def export(self, outfile, level, name_='ResellerTemplateOutputAddType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputAddType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputAddType'):
        if self.result is not None:
            self.result.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ResellerTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.setResult(obj_)
# end class ResellerTemplateOutputAddType


class ResellerTemplateOutputResulttype(resultType):
    subclass = None
    def __init__(self, id=None, name=None, status='', errcode=None, errtext=None):
        resultType.__init__(self, status, errcode, errtext)
        self.id = id
        self.name = name
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputResulttype.subclass:
            return ResellerTemplateOutputResulttype.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputResulttype(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getId(self): return self.id
    def setId(self, value): self.id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def export(self, outfile, level, name_='ResellerTemplateOutputResulttype'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputResulttype'):
        resultType.exportAttributes(self, outfile, level, name_='ResellerTemplateOutputResulttype')
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputResulttype'):
        if self.id is not None:
            showIndent(outfile, level)
            outfile.write('<id>%s</id>\n' % quote_xml(self.getId()))
        if self.name is not None:
            showIndent(outfile, level)
            outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        resultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        resultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'id':
            id_ = ''
            for text__content_ in child_.childNodes:
                id_ += text__content_.nodeValue
            self.id = id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        resultType.buildChildren(self, child_, nodeName_)
# end class ResellerTemplateOutputResulttype


class ResellerTemplateOutputGetType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputGetType.subclass:
            return ResellerTemplateOutputGetType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputGetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerTemplateOutputGetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputGetType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputGetType'):
        for result_ in self.getResult():
            result_.export(outfile, level)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = result.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerTemplateOutputGetType


class ResellerTemplateOutputSetType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputSetType.subclass:
            return ResellerTemplateOutputSetType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputSetType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerTemplateOutputSetType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputSetType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputSetType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ResellerTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerTemplateOutputSetType


class ResellerTemplateOutputDelType:
    subclass = None
    def __init__(self, result=None):
        if result is None:
            self.result = []
        else:
            self.result = result
    def factory(*args_, **kwargs_):
        if ResellerTemplateOutputDelType.subclass:
            return ResellerTemplateOutputDelType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplateOutputDelType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getResult(self): return self.result
    def setResult(self, value): self.result = value
    def addResult(self, value): self.result.append(value)
    def insertResult(self, index, value): self.result[index] = value
    def export(self, outfile, level, name_='ResellerTemplateOutputDelType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplateOutputDelType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplateOutputDelType'):
        for result_ in self.getResult():
            result_.export(outfile, level, name_='result')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'result':
            obj_ = ResellerTemplateOutputResulttype.factory()
            obj_.build(child_)
            self.result.append(obj_)
# end class ResellerTemplateOutputDelType


class ResellerTemplatePreferencesType:
    subclass = None
    def __init__(self, sbnet_user=None):
        self.sbnet_user = sbnet_user
    def factory(*args_, **kwargs_):
        if ResellerTemplatePreferencesType.subclass:
            return ResellerTemplatePreferencesType.subclass(*args_, **kwargs_)
        else:
            return ResellerTemplatePreferencesType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getSbnet_user(self): return self.sbnet_user
    def setSbnet_user(self, value): self.sbnet_user = value
    def export(self, outfile, level, name_='ResellerTemplatePreferencesType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResellerTemplatePreferencesType'):
        pass
    def exportChildren(self, outfile, level, name_='ResellerTemplatePreferencesType'):
        if self.sbnet_user is not None:
            showIndent(outfile, level)
            outfile.write('<sbnet-user>%s</sbnet-user>\n' % quote_xml(self.getSbnet_user()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sbnet-user':
            sbnet_user_ = ''
            for text__content_ in child_.childNodes:
                sbnet_user_ += text__content_.nodeValue
            self.sbnet_user = sbnet_user_
# end class ResellerTemplatePreferencesType


class ResponsePacketType:
    subclass = None
    def __init__(self, version=None, certificate=None, client=None, db_server=None, dns=None, domain=None, subdomain=None, domain_alias=None, event_log=None, ip=None, mail=None, migration_agent=None, migration=None, secret_key=None, server=None, siteapp=None, spamfilter=None, ui=None, upload=None, desktop=None, domain_template=None, client_template=None, webuser=None, maillist=None, virtdir=None, database=None, ftp_user=None, session=None, updater=None, locale=None, log_rotation=None, backup_manager=None, sso=None, protected_dir=None, reseller=None, reseller_template=None, system=None, output=None):
        self.version = version
        if certificate is None:
            self.certificate = []
        else:
            self.certificate = certificate
        if client is None:
            self.client = []
        else:
            self.client = client
        if db_server is None:
            self.db_server = []
        else:
            self.db_server = db_server
        if dns is None:
            self.dns = []
        else:
            self.dns = dns
        if domain is None:
            self.domain = []
        else:
            self.domain = domain
        if subdomain is None:
            self.subdomain = []
        else:
            self.subdomain = subdomain
        if domain_alias is None:
            self.domain_alias = []
        else:
            self.domain_alias = domain_alias
        if event_log is None:
            self.event_log = []
        else:
            self.event_log = event_log
        if ip is None:
            self.ip = []
        else:
            self.ip = ip
        if mail is None:
            self.mail = []
        else:
            self.mail = mail
        if migration_agent is None:
            self.migration_agent = []
        else:
            self.migration_agent = migration_agent
        if migration is None:
            self.migration = []
        else:
            self.migration = migration
        if secret_key is None:
            self.secret_key = []
        else:
            self.secret_key = secret_key
        if server is None:
            self.server = []
        else:
            self.server = server
        if siteapp is None:
            self.siteapp = []
        else:
            self.siteapp = siteapp
        if spamfilter is None:
            self.spamfilter = []
        else:
            self.spamfilter = spamfilter
        if ui is None:
            self.ui = []
        else:
            self.ui = ui
        if upload is None:
            self.upload = []
        else:
            self.upload = upload
        if desktop is None:
            self.desktop = []
        else:
            self.desktop = desktop
        if domain_template is None:
            self.domain_template = []
        else:
            self.domain_template = domain_template
        if client_template is None:
            self.client_template = []
        else:
            self.client_template = client_template
        if webuser is None:
            self.webuser = []
        else:
            self.webuser = webuser
        if maillist is None:
            self.maillist = []
        else:
            self.maillist = maillist
        if virtdir is None:
            self.virtdir = []
        else:
            self.virtdir = virtdir
        if database is None:
            self.database = []
        else:
            self.database = database
        if ftp_user is None:
            self.ftp_user = []
        else:
            self.ftp_user = ftp_user
        if session is None:
            self.session = []
        else:
            self.session = session
        if updater is None:
            self.updater = []
        else:
            self.updater = updater
        if locale is None:
            self.locale = []
        else:
            self.locale = locale
        if log_rotation is None:
            self.log_rotation = []
        else:
            self.log_rotation = log_rotation
        if backup_manager is None:
            self.backup_manager = []
        else:
            self.backup_manager = backup_manager
        if sso is None:
            self.sso = []
        else:
            self.sso = sso
        if protected_dir is None:
            self.protected_dir = []
        else:
            self.protected_dir = protected_dir
        if reseller is None:
            self.reseller = []
        else:
            self.reseller = reseller
        if reseller_template is None:
            self.reseller_template = []
        else:
            self.reseller_template = reseller_template
        self.system = system
        self.output = output
    def factory(*args_, **kwargs_):
        if ResponsePacketType.subclass:
            return ResponsePacketType.subclass(*args_, **kwargs_)
        else:
            return ResponsePacketType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getCertificate(self): return self.certificate
    def setCertificate(self, value): self.certificate = value
    def addCertificate(self, value): self.certificate.append(value)
    def insertCertificate(self, index, value): self.certificate[index] = value
    def getClient(self): return self.client
    def setClient(self, value): self.client = value
    def addClient(self, value): self.client.append(value)
    def insertClient(self, index, value): self.client[index] = value
    def getDb_server(self): return self.db_server
    def setDb_server(self, value): self.db_server = value
    def addDb_server(self, value): self.db_server.append(value)
    def insertDb_server(self, index, value): self.db_server[index] = value
    def getDns(self): return self.dns
    def setDns(self, value): self.dns = value
    def addDns(self, value): self.dns.append(value)
    def insertDns(self, index, value): self.dns[index] = value
    def getDomain(self): return self.domain
    def setDomain(self, value): self.domain = value
    def addDomain(self, value): self.domain.append(value)
    def insertDomain(self, index, value): self.domain[index] = value
    def getSubdomain(self): return self.subdomain
    def setSubdomain(self, value): self.subdomain = value
    def addSubdomain(self, value): self.subdomain.append(value)
    def insertSubdomain(self, index, value): self.subdomain[index] = value
    def getDomain_alias(self): return self.domain_alias
    def setDomain_alias(self, value): self.domain_alias = value
    def addDomain_alias(self, value): self.domain_alias.append(value)
    def insertDomain_alias(self, index, value): self.domain_alias[index] = value
    def getEvent_log(self): return self.event_log
    def setEvent_log(self, value): self.event_log = value
    def addEvent_log(self, value): self.event_log.append(value)
    def insertEvent_log(self, index, value): self.event_log[index] = value
    def getIp(self): return self.ip
    def setIp(self, value): self.ip = value
    def addIp(self, value): self.ip.append(value)
    def insertIp(self, index, value): self.ip[index] = value
    def getMail(self): return self.mail
    def setMail(self, value): self.mail = value
    def addMail(self, value): self.mail.append(value)
    def insertMail(self, index, value): self.mail[index] = value
    def getMigration_agent(self): return self.migration_agent
    def setMigration_agent(self, value): self.migration_agent = value
    def addMigration_agent(self, value): self.migration_agent.append(value)
    def insertMigration_agent(self, index, value): self.migration_agent[index] = value
    def getMigration(self): return self.migration
    def setMigration(self, value): self.migration = value
    def addMigration(self, value): self.migration.append(value)
    def insertMigration(self, index, value): self.migration[index] = value
    def getSecret_key(self): return self.secret_key
    def setSecret_key(self, value): self.secret_key = value
    def addSecret_key(self, value): self.secret_key.append(value)
    def insertSecret_key(self, index, value): self.secret_key[index] = value
    def getServer(self): return self.server
    def setServer(self, value): self.server = value
    def addServer(self, value): self.server.append(value)
    def insertServer(self, index, value): self.server[index] = value
    def getSiteapp(self): return self.siteapp
    def setSiteapp(self, value): self.siteapp = value
    def addSiteapp(self, value): self.siteapp.append(value)
    def insertSiteapp(self, index, value): self.siteapp[index] = value
    def getSpamfilter(self): return self.spamfilter
    def setSpamfilter(self, value): self.spamfilter = value
    def addSpamfilter(self, value): self.spamfilter.append(value)
    def insertSpamfilter(self, index, value): self.spamfilter[index] = value
    def getUi(self): return self.ui
    def setUi(self, value): self.ui = value
    def addUi(self, value): self.ui.append(value)
    def insertUi(self, index, value): self.ui[index] = value
    def getUpload(self): return self.upload
    def setUpload(self, value): self.upload = value
    def addUpload(self, value): self.upload.append(value)
    def insertUpload(self, index, value): self.upload[index] = value
    def getDesktop(self): return self.desktop
    def setDesktop(self, value): self.desktop = value
    def addDesktop(self, value): self.desktop.append(value)
    def insertDesktop(self, index, value): self.desktop[index] = value
    def getDomain_template(self): return self.domain_template
    def setDomain_template(self, value): self.domain_template = value
    def addDomain_template(self, value): self.domain_template.append(value)
    def insertDomain_template(self, index, value): self.domain_template[index] = value
    def getClient_template(self): return self.client_template
    def setClient_template(self, value): self.client_template = value
    def addClient_template(self, value): self.client_template.append(value)
    def insertClient_template(self, index, value): self.client_template[index] = value
    def getWebuser(self): return self.webuser
    def setWebuser(self, value): self.webuser = value
    def addWebuser(self, value): self.webuser.append(value)
    def insertWebuser(self, index, value): self.webuser[index] = value
    def getMaillist(self): return self.maillist
    def setMaillist(self, value): self.maillist = value
    def addMaillist(self, value): self.maillist.append(value)
    def insertMaillist(self, index, value): self.maillist[index] = value
    def getVirtdir(self): return self.virtdir
    def setVirtdir(self, value): self.virtdir = value
    def addVirtdir(self, value): self.virtdir.append(value)
    def insertVirtdir(self, index, value): self.virtdir[index] = value
    def getDatabase(self): return self.database
    def setDatabase(self, value): self.database = value
    def addDatabase(self, value): self.database.append(value)
    def insertDatabase(self, index, value): self.database[index] = value
    def getFtp_user(self): return self.ftp_user
    def setFtp_user(self, value): self.ftp_user = value
    def addFtp_user(self, value): self.ftp_user.append(value)
    def insertFtp_user(self, index, value): self.ftp_user[index] = value
    def getSession(self): return self.session
    def setSession(self, value): self.session = value
    def addSession(self, value): self.session.append(value)
    def insertSession(self, index, value): self.session[index] = value
    def getUpdater(self): return self.updater
    def setUpdater(self, value): self.updater = value
    def addUpdater(self, value): self.updater.append(value)
    def insertUpdater(self, index, value): self.updater[index] = value
    def getLocale(self): return self.locale
    def setLocale(self, value): self.locale = value
    def addLocale(self, value): self.locale.append(value)
    def insertLocale(self, index, value): self.locale[index] = value
    def getLog_rotation(self): return self.log_rotation
    def setLog_rotation(self, value): self.log_rotation = value
    def addLog_rotation(self, value): self.log_rotation.append(value)
    def insertLog_rotation(self, index, value): self.log_rotation[index] = value
    def getBackup_manager(self): return self.backup_manager
    def setBackup_manager(self, value): self.backup_manager = value
    def addBackup_manager(self, value): self.backup_manager.append(value)
    def insertBackup_manager(self, index, value): self.backup_manager[index] = value
    def getSso(self): return self.sso
    def setSso(self, value): self.sso = value
    def addSso(self, value): self.sso.append(value)
    def insertSso(self, index, value): self.sso[index] = value
    def getProtected_dir(self): return self.protected_dir
    def setProtected_dir(self, value): self.protected_dir = value
    def addProtected_dir(self, value): self.protected_dir.append(value)
    def insertProtected_dir(self, index, value): self.protected_dir[index] = value
    def getReseller(self): return self.reseller
    def setReseller(self, value): self.reseller = value
    def addReseller(self, value): self.reseller.append(value)
    def insertReseller(self, index, value): self.reseller[index] = value
    def getReseller_template(self): return self.reseller_template
    def setReseller_template(self, value): self.reseller_template = value
    def addReseller_template(self, value): self.reseller_template.append(value)
    def insertReseller_template(self, index, value): self.reseller_template[index] = value
    def getSystem(self): return self.system
    def setSystem(self, value): self.system = value
    def getOutput(self): return self.output
    def setOutput(self, value): self.output = value
    def getVersion(self): return self.version
    def setVersion(self, value): self.version = value
    def export(self, outfile, level, name_='ResponsePacketType'):
        showIndent(outfile, level)
        outfile.write('<%s' % (name_, ))
        self.exportAttributes(outfile, level, name_='ResponsePacketType')
        outfile.write('>')
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='ResponsePacketType'):
        if self.getVersion() is not None:
            outfile.write(' version="%s"' % (quote_attrib(self.getVersion()), ))
    def exportChildren(self, outfile, level, name_='ResponsePacketType'):
        for certificate_ in self.getCertificate():
            certificate_.export(outfile, level, name_='certificate')
        for client_ in self.getClient():
            client_.export(outfile, level, name_='client')
        for db_server_ in self.getDb_server():
            db_server_.export(outfile, level, name_='db_server')
        for dns_ in self.getDns():
            dns_.export(outfile, level, name_='dns')
        for domain_ in self.getDomain():
            domain_.export(outfile, level, name_='domain')
        for subdomain_ in self.getSubdomain():
            subdomain_.export(outfile, level, name_='subdomain')
        for domain_alias_ in self.getDomain_alias():
            domain_alias_.export(outfile, level, name_='domain_alias')
        for event_log_ in self.getEvent_log():
            event_log_.export(outfile, level, name_='event_log')
        for ip_ in self.getIp():
            ip_.export(outfile, level, name_='ip')
        for mail_ in self.getMail():
            mail_.export(outfile, level, name_='mail')
        for migration_agent_ in self.getMigration_agent():
            migration_agent_.export(outfile, level, name_='migration_agent')
        for migration_ in self.getMigration():
            migration_.export(outfile, level, name_='migration')
        for secret_key_ in self.getSecret_key():
            secret_key_.export(outfile, level, name_='secret_key')
        for server_ in self.getServer():
            server_.export(outfile, level, name_='server')
        for siteapp_ in self.getSiteapp():
            siteapp_.export(outfile, level, name_='siteapp')
        for spamfilter_ in self.getSpamfilter():
            spamfilter_.export(outfile, level, name_='spamfilter')
        for ui_ in self.getUi():
            ui_.export(outfile, level, name_='ui')
        for upload_ in self.getUpload():
            upload_.export(outfile, level, name_='upload')
        for desktop_ in self.getDesktop():
            desktop_.export(outfile, level, name_='desktop')
        for domain_template_ in self.getDomain_template():
            domain_template_.export(outfile, level, name_='domain-template')
        for client_template_ in self.getClient_template():
            client_template_.export(outfile, level, name_='client-template')
        for webuser_ in self.getWebuser():
            webuser_.export(outfile, level, name_='webuser')
        for maillist_ in self.getMaillist():
            maillist_.export(outfile, level, name_='maillist')
        for virtdir_ in self.getVirtdir():
            virtdir_.export(outfile, level, name_='virtdir')
        for database_ in self.getDatabase():
            database_.export(outfile, level, name_='database')
        for ftp_user_ in self.getFtp_user():
            ftp_user_.export(outfile, level, name_='ftp-user')
        for session_ in self.getSession():
            session_.export(outfile, level, name_='session')
        for updater_ in self.getUpdater():
            updater_.export(outfile, level, name_='updater')
        for locale_ in self.getLocale():
            locale_.export(outfile, level, name_='locale')
        for log_rotation_ in self.getLog_rotation():
            log_rotation_.export(outfile, level, name_='log-rotation')
        for backup_manager_ in self.getBackup_manager():
            backup_manager_.export(outfile, level, name_='backup-manager')
        for sso_ in self.getSso():
            sso_.export(outfile, level, name_='sso')
        for protected_dir_ in self.getProtected_dir():
            protected_dir_.export(outfile, level, name_='protected-dir')
        for reseller_ in self.getReseller():
            reseller_.export(outfile, level, name_='reseller')
        for reseller_template_ in self.getReseller_template():
            reseller_template_.export(outfile, level, name_='reseller-template')
        if self.system is not None:
            self.system.export(outfile, level, name_='system')
        if self.output is not None:
            showIndent(outfile, level)
            outfile.write('<output>%s</output>\n' % quote_xml(self.getOutput()))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('version'):
            self.version = attrs.get('version').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'certificate':
            obj_ = CertificateResponseType.factory()
            obj_.build(child_)
            self.certificate.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client':
            obj_ = ClientResponseType.factory()
            obj_.build(child_)
            self.client.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'db_server':
            obj_ = DatabaseServerResponseType.factory()
            obj_.build(child_)
            self.db_server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dns':
            obj_ = DNSResponseType.factory()
            obj_.build(child_)
            self.dns.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain':
            obj_ = DomainResponseType.factory()
            obj_.build(child_)
            self.domain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'subdomain':
            obj_ = SubdomainOutputType.factory()
            obj_.build(child_)
            self.subdomain.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_alias':
            obj_ = DomainAliasResponseType.factory()
            obj_.build(child_)
            self.domain_alias.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'event_log':
            obj_ = EventLogResponseType.factory()
            obj_.build(child_)
            self.event_log.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ip':
            obj_ = IpResponseType.factory()
            obj_.build(child_)
            self.ip.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'mail':
            obj_ = MailResponseType.factory()
            obj_.build(child_)
            self.mail.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migration_agent':
            obj_ = MigrationAgentOutputType.factory()
            obj_.build(child_)
            self.migration_agent.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'migration':
            obj_ = MigrationOutputType.factory()
            obj_.build(child_)
            self.migration.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'secret_key':
            obj_ = SecretKeyResponseType.factory()
            obj_.build(child_)
            self.secret_key.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'server':
            obj_ = ServerOperatorType.factory()
            obj_.build(child_)
            self.server.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'siteapp':
            obj_ = SiteAppResponseType.factory()
            obj_.build(child_)
            self.siteapp.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'spamfilter':
            obj_ = SpamFilterOutputType.factory()
            obj_.build(child_)
            self.spamfilter.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ui':
            obj_ = UIResponseType.factory()
            obj_.build(child_)
            self.ui.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'upload':
            obj_ = UploadOutputType.factory()
            obj_.build(child_)
            self.upload.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'desktop':
            obj_ = DesktopOutputPacketType.factory()
            obj_.build(child_)
            self.desktop.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain-template':
            obj_ = DomainTemplateOutputType.factory()
            obj_.build(child_)
            self.domain_template.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'client-template':
            obj_ = ClientTemplateOutputType.factory()
            obj_.build(child_)
            self.client_template.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'webuser':
            obj_ = WebUserOutputType.factory()
            obj_.build(child_)
            self.webuser.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'maillist':
            obj_ = MailistOutputType.factory()
            obj_.build(child_)
            self.maillist.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'virtdir':
            obj_ = VDirOutputType.factory()
            obj_.build(child_)
            self.virtdir.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'database':
            obj_ = DatabaseOutputType.factory()
            obj_.build(child_)
            self.database.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ftp-user':
            obj_ = FtpUserOutputType.factory()
            obj_.build(child_)
            self.ftp_user.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'session':
            obj_ = SessionOutputType.factory()
            obj_.build(child_)
            self.session.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'updater':
            obj_ = AutoinstallerOutputType.factory()
            obj_.build(child_)
            self.updater.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'locale':
            obj_ = LocaleOutput.factory()
            obj_.build(child_)
            self.locale.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'log-rotation':
            obj_ = LogRotationOutput.factory()
            obj_.build(child_)
            self.log_rotation.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'backup-manager':
            obj_ = BackupOutputType.factory()
            obj_.build(child_)
            self.backup_manager.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sso':
            obj_ = SSOOutput.factory()
            obj_.build(child_)
            self.sso.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'protected-dir':
            obj_ = ProtectedDirOutput.factory()
            obj_.build(child_)
            self.protected_dir.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller':
            obj_ = ResellerOutput.factory()
            obj_.build(child_)
            self.reseller.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'reseller-template':
            obj_ = ResellerTemplateOutputType.factory()
            obj_.build(child_)
            self.reseller_template.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'system':
            obj_ = resultType.factory()
            obj_.build(child_)
            self.setSystem(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'output':
            output_ = ''
            for text__content_ in child_.childNodes:
                output_ += text__content_.nodeValue
            self.output = output_
# end class ResponsePacketType


class SubdomainAddInputType(SubdomainObjectType):
    subclass = None
    def __init__(self, parent='', name='', home=None, property=None, valueOf_=''):
        SubdomainObjectType.__init__(self, parent, name, home, property)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if SubdomainAddInputType.subclass:
            return SubdomainAddInputType.subclass(*args_, **kwargs_)
        else:
            return SubdomainAddInputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='SubdomainAddInputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='SubdomainAddInputType'):
        SubdomainObjectType.exportAttributes(self, outfile, level, name_='SubdomainAddInputType')
    def exportChildren(self, outfile, level, name_='SubdomainAddInputType'):
        SubdomainObjectType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        SubdomainObjectType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        SubdomainObjectType.buildChildren(self, child_, nodeName_)
# end class SubdomainAddInputType


class DomainTemplateDeleteOutputType(DomainTemplateResultType):
    subclass = None
    def __init__(self, result=None, valueOf_=''):
        DomainTemplateResultType.__init__(self, result)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DomainTemplateDeleteOutputType.subclass:
            return DomainTemplateDeleteOutputType.subclass(*args_, **kwargs_)
        else:
            return DomainTemplateDeleteOutputType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, name_='DomainTemplateDeleteOutputType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='DomainTemplateDeleteOutputType'):
        DomainTemplateResultType.exportAttributes(self, outfile, level, name_='DomainTemplateDeleteOutputType')
    def exportChildren(self, outfile, level, name_='DomainTemplateDeleteOutputType'):
        DomainTemplateResultType.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        DomainTemplateResultType.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        DomainTemplateResultType.buildChildren(self, child_, nodeName_)
# end class DomainTemplateDeleteOutputType


class aliasInfoType(Settings):
    subclass = None
    def __init__(self, domain_id='', name='', ascii_name=None, status=None, pref=None, manage_dns=None):
        Settings.__init__(self, status, pref, manage_dns)
        self.domain_id = domain_id
        self.name = name
        self.ascii_name = ascii_name
    def factory(*args_, **kwargs_):
        if aliasInfoType.subclass:
            return aliasInfoType.subclass(*args_, **kwargs_)
        else:
            return aliasInfoType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getDomain_id(self): return self.domain_id
    def setDomain_id(self, value): self.domain_id = value
    def getName(self): return self.name
    def setName(self, value): self.name = value
    def getAscii_name(self): return self.ascii_name
    def setAscii_name(self, value): self.ascii_name = value
    def export(self, outfile, level, name_='aliasInfoType'):
        showIndent(outfile, level)
        outfile.write('<%s>' % name_)
        outfile.write('\n')
        self.exportChildren(outfile, level + 1, name_)
        showIndent(outfile, level)
        outfile.write('</%s>\n' % name_)
    def exportAttributes(self, outfile, level, name_='aliasInfoType'):
        Settings.exportAttributes(self, outfile, level, name_='aliasInfoType')
    def exportChildren(self, outfile, level, name_='aliasInfoType'):
        showIndent(outfile, level)
        outfile.write('<domain_id>%s</domain_id>\n' % quote_xml(self.getDomain_id()))
        showIndent(outfile, level)
        outfile.write('<name>%s</name>\n' % quote_xml(self.getName()))
        if self.ascii_name is not None:
            showIndent(outfile, level)
            outfile.write('<ascii-name>%s</ascii-name>\n' % quote_xml(self.getAscii_name()))
        Settings.exportChildren(self, outfile, level, name_)
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        Settings.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'domain_id':
            domain_id_ = ''
            for text__content_ in child_.childNodes:
                domain_id_ += text__content_.nodeValue
            self.domain_id = domain_id_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'name':
            name_ = ''
            for text__content_ in child_.childNodes:
                name_ += text__content_.nodeValue
            self.name = name_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ascii-name':
            ascii_name_ = ''
            for text__content_ in child_.childNodes:
                ascii_name_ += text__content_.nodeValue
            self.ascii_name = ascii_name_
        Settings.buildChildren(self, child_, nodeName_)
# end class aliasInfoType


